/* ====================================================== */
/*                        TESTAPP.CPP                     */
/*               (C) 1993 Thomas Wlfer & toolbox         */
/*              Compiler: Microsoft Visual C++ 1.0        */
/*             Testprogramm fr die Klasse xcfgfile       */
/* ====================================================== */

//
// demonstriert werden die folgenden Fhigkeiten:
//
// -- Iterieren ber Tags
// -- Iterieren ber Keys
// -- Lesen von vorhandenen / nicht vorhandenen Keys
// -- Schreiben in vorhandene / nicht vorhandene Tags
//

#include <afxcoll.h>
#include "xcfgfile.h"
#include <iostream.h>

void main (void)
{

  // Name der zu bearbeitenden Ini-Datei
  CString szFile("test.ini");

  // kurze Warnung
  cout << "In der aktuellen Implementierung mu \
die Inidatei vorhanden sein"
       << endl << "ansonsten wird eine CFileException \
geworfen" << endl;

  // Instanziieren eines XCfgFiles
  XCfgFile cfg(szFile);

  CString  szValue, szKey;
  TRY
  {
    // Iterieren ber alle Tags und deren Eintrge
    if (cfg.GetFirstTag(szValue))
    {
      cout << szValue << endl;
      if (cfg.GetFirstEntry(szValue, szKey))
      {
        cout << "  " << szKey << endl;
        while( cfg.GetNextEntry(szValue, szKey))
          cout << "  " << szKey << endl;
      }

      while(cfg.GetNextTag(szValue))
      {
        cout << szValue << endl;
        if ( cfg.GetFirstEntry(szValue, szKey))
        {
          cout << "  " << szKey << endl;
          while (cfg.GetNextEntry(szValue, szKey))
            cout << "  " << szKey << endl;
        }
      }
    }

    // Versuch, einen nicht vorhandenen Key zu lesen
    CString sz;

    if (! cfg.GetString("TAG", "stringKey", "empty", sz))
      cout << "key: stringKey ist nicht vorhanden" << endl;
    else
      cout << "string:" << sz << endl;

     // Schreiben in ein neues Tag
     cfg.WriteString("NewTag", "keyFromNewTag" , "aValue");

    // Schreiben in ein vorhandenes Tag
    cfg.WriteString("NewTag", "key2FromNewTag" ,
                    "TagNowThere");

    cfg.Flush();
  }

  CATCH( CException, theException )
  {
    if (theException ->
        IsKindOf(RUNTIME_CLASS(CMemoryException)))
       cout << "Memory exception detected (Out Of Mem)!"
            << endl;

    if (theException ->
        IsKindOf(RUNTIME_CLASS(CFileException)))
         cout << "File exception detected (cause in \
theException -> m_cause)!" << endl;

    if (theException ->
        IsKindOf(RUNTIME_CLASS(CNotSupportedException)))
         cout << "Unsupported exception detected (Invalid \
format)!" << endl;
  } END_CATCH

}

/* ====================================================== */
/*                    Ende von TESTAPP.CPP                */
