(* ====================================================== *)
(*                       DBSTRUED.PAS                     *)
(*                   dBase-Struktur-Editor                *)
(*             1993 Peter Fliesges & DMV-Verlag          *)
(*        Compiler: Borland Pascal 7.0, Windows Target    *)
(* ====================================================== *)

{$DEFINE WithKBHook}

PROGRAM dBStruEd;

USES
  WinTypes, WinProcs, OWindows, ODialogs, OStdDlgs,
  Strings,  WinDos,   Win31,    BWCC,     dbEngine;

{$R DBSTRUED.RES}

CONST
  AppName  : pChar = 'DlgApp';
  EdLen            = 80;

  id_FileNameShade = 100;  (* Konstanten fr die Dialog- *)
  id_EDFileName    = 101;  (* Elemente                   *)
  id_STShade       = 102;
  id_STFields      = 103;
  id_STFree        = 104;
  id_LBShade       = 106;
  id_LB            = 107;
  id_RBShade       = 108;
  id_RB            = 109;
  id_FldNameShade  = 114;
  id_EDFldName     = 115;
  id_SizeShade     = 116;
  id_EDSize        = 117;
  id_DecShade      = 118;
  id_EDDec         = 119;
  id_AddField      = 120;
  id_DelField      = 121;
  id_New           = 122;
  id_Load          = 123;
  id_Save          = 124;
  id_SaveAs        = 125;
  id_About         = 126;
  id_Quit          = 127;

TYPE
  pDlgWin = ^tDlgWin;
  tDlgWin = OBJECT(tDlgWindow)
    (* Objektfelder *)
    EDFileName       : pEdit;
    STFields, STFree : pStatic;
    LB               : pListBox;
    RB               : ARRAY[0..4] OF pRadioButton;
    EDFldName,
    EDSize,
    EDDec            : pEdit;
    zFileName        : ARRAY[0..fsPathName] OF CHAR;
    NewFields        : ARRAY[0..255] OF ^TFieldDescr;
    NewDataSize      : WORD;
    NewNumFields     : INTEGER;
    NewHeader        : tHeader;
    f                : File;
    IsDirty,
    IsNewFile        : BOOLEAN;
    (* Methoden *)
    CONSTRUCTOR Init(aParent: pWindowsObject;
                     aTitle : pChar);
    DESTRUCTOR  Done;                VIRTUAL;
    PROCEDURE   SetupWindow;         VIRTUAL;
    FUNCTION    GetClassName: pChar; VIRTUAL;
    PROCEDURE   GetWindowClass(VAR aWndClass: tWndClass);
      VIRTUAL;
    FUNCTION    CanClose : BOOLEAN;  VIRTUAL;
    PROCEDURE   wmCommand(VAR Msg: tMessage);
      VIRTUAL   wm_First + wm_Command;
    PROCEDURE   WMInitMenu(VAR Msg: tMessage);
      VIRTUAL   wm_First + wm_InitMenu;

    PROCEDURE   IDAddField(VAR Msg: tMessage);
      VIRTUAL   id_First + id_AddField;
    PROCEDURE   IDDelField(VAR Msg: tMessage);
      VIRTUAL   id_First + id_DelField;
    PROCEDURE   IDNew(VAR Msg: tMessage);
      VIRTUAL   id_First + id_New;
    PROCEDURE   IDLoad(VAR Msg: tMessage);
      VIRTUAL   id_First + id_Load;
    PROCEDURE   IDSave(VAR Msg: tMessage);
      VIRTUAL   id_First + id_Save;
    PROCEDURE   IDSaveAs(VAR Msg: tMessage);
      VIRTUAL   id_First + id_SaveAs;
    PROCEDURE   IDAbout(VAR Msg: tMessage);
      VIRTUAL   id_First + id_About;
    PROCEDURE   IDQuit(VAR Msg: tMessage);
      VIRTUAL   id_First + id_Quit;
    (* Sonstiges *)
    PROCEDURE   FillHeader;
    PROCEDURE   InitFieldDesc;
    PROCEDURE   DisposeFieldDesc;
    PROCEDURE   Load;
    PROCEDURE   Save;
    PROCEDURE   Actualize1;
    PROCEDURE   Actualize2;
    PROCEDURE   Actualize3;
    PROCEDURE   ActualizeFree;
  END;

TYPE
  tDlgApp = OBJECT(tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;  (*tDlgApp*)

{$IFDEF WithKBHook}
VAR (* global *)
  FPHook : tFarProc;                      (* KeyboardHook *)
  Hook   : hWnd;
{$ENDIF}

(* ================ Ende der Deklarationen ============== *)


{$IFDEF WithKBHook}
  (* Globale Funktion *)
  FUNCTION KBHook(Code   : INTEGER;
                  wParam : WORD;
                  lParam : LongInt) : LongInt; EXPORT;
  (* Nachricht kommt zweimal: beim Drcken und Loslassen. *)
  (* Daher HiWord von lParam auswerten.                   *)
  VAR
    S : ARRAY[0..255] OF CHAR;
  BEGIN
    IF (HiWord(lParam) AND $4000) <> 0 THEN BEGIN
      IF GetKeyState(vk_Control) < 0 THEN BEGIN
        CASE wParam OF
          Ord('N'): SendMessage(GetActiveWindow,
                                wm_Command,
                                id_AddField, 0);
          Ord('U'): SendMessage(GetActiveWindow,
                                wm_Command,
                                id_DelField, 0);
        END;
      END;
    END;
    KBHook := CallNextHookEx(Hook, Code, wParam, lParam);
  END;
{$ENDIF}

(* ====================================================== *)

FUNCTION RemoveSpaces(aBuf : pChar) : pChar;
(* Hilfsfunktion; entfernt alle Leerzeichen               *)
VAR
  Pos1, Pos2 : INTEGER;
BEGIN
  Pos1 := 0;
  Pos2 := Pos1;
  WHILE (aBuf[Pos1] <> #0) DO BEGIN
    IF aBuf[Pos1] <> ' ' THEN BEGIN
      aBuf[Pos2] := aBuf[Pos1];
      Inc(Pos2);
    END;
    Inc(Pos1);
  END;
  aBuf[Pos2] := #0;
  RemoveSpaces := @aBuf;
END;

(* ====================================================== *)
(*                      tDlgWin                           *)
(* ====================================================== *)

CONSTRUCTOR tDlgWin.Init(aParent : pWindowsObject;
                         aTitle  : pChar);
VAR
  i : INTEGER;
BEGIN
  (* Zuerst ursprngliche Methode *)
  tDlgWindow.Init(aParent, aTitle);
  (* Ressourcen verknpfen *)
  EDFileName := New(pEdit, InitResource(@Self,
                    id_EDFileName, fsPathName));
  STFields   := New(pStatic, InitResource(@Self,
                    id_STFields, 3));
  STFree     := New(pStatic, InitResource(@Self, id_STFree,
                    4));
  LB         := New(pListBox, InitResource(@Self, id_LB));
  FOR i := 0 TO 4 DO
    RB[i] := New(pRadioButton, InitResource(@Self,
                                            id_RB + i));
  EDFldName := New(pEdit, InitResource(@Self, id_EDFldName,
                                       10 + 1));
  EDSize    := New(pEdit, InitResource(@Self, id_EDSize,
                                       3 + 1));
  EDDec     := New(pEdit, InitResource(@Self, id_EDDec,
                                       2 + 1));

  (* Variablen initialisieren *)
  zFileName[0] := #0;
  NewNumFields := 0;
  IsDirty      := FALSE;
  IsNewFile    := TRUE;

  {$IFDEF WithKBHook}        (* Tastaturabfrage ber Hook *)
  FPHook := MakeProcInstance(@KBHook, hInstance);
  Hook   := SetWindowsHookEx(wh_Keyboard, tHookProc(FPHook),
                             hInstance, 0);
  {$ENDIF}
END;

DESTRUCTOR tDlgWin.Done;
BEGIN
  {$IFDEF WithKBHook}                   (* Hook freigeben *)
  UnhookWindowsHookEx(Hook);
  FreeProcInstance(FPHook);
  {$ENDIF}
  (* Zuletzt ursprngliche Methode *)
  INHERITED Done;
END;

PROCEDURE tDlgWin.SetupWindow;
VAR
  i : INTEGER;
BEGIN
  (* Zuerst ursprngliche Methode *)
  tDlgWindow.SetupWindow;
  (* Anfangseinstellung der Dialogelemente *)
  FOR i := 100 TO 119 DO
    EnableWindow(GetItemHandle(i), FALSE);
END;

FUNCTION tDlgWin.GetClassName: pChar;
BEGIN
  GetClassName := 'BorDlgWin';
END;

PROCEDURE tDlgWin.GetWindowClass(VAR aWndClass: tWndClass);
BEGIN
  (* Zuerst ursprngliche Methode *)
  tDlgWindow.GetWindowClass(aWndClass);
  (* Icon zuordnen *)
  aWndClass.hIcon := LoadIcon(hInstance, 'DlgWinIcon');
END;  

FUNCTION tDlgWin.CanClose : BOOLEAN;
VAR
  Reply : INTEGER;
  S     : ARRAY[0..EdLen] OF CHAR;
BEGIN
  CanClose := TRUE;
  IF LB^.GetCount < 1 THEN Exit;
  IF IsDirty THEN BEGIN
    StrCopy(S, #13#10'Daten nicht gesichert!');
    StrCat(S, #13#10'Trotzdem fortfahren?');
    Reply := MessageBox(hWindow, S, 'Warnung',
      mb_YesNo OR mb_IconQuestion OR mb_DefButton2);
    IF Reply = id_No THEN CanClose := FALSE;
  END;
END;

PROCEDURE tDlgWin.wmCommand(VAR Msg: tMessage);
BEGIN
  tDlgWindow.wmCommand(Msg);
  (* Dateiname wurde gendert *)
  IF Msg.wParam = id_EDFileName THEN
    IF HiWord(Msg.lParam) = en_Change THEN
      EDFileName^.GetText(zFileName, fsPathName);
  (* ListBox-Auswahl wurde gendert *)
  IF Msg.wParam = id_LB THEN
    IF HiWord(Msg.lParam) = lbn_SelChange THEN Actualize1;

  (* RadioButtons wurden gedrckt *)
  IF (Msg.wParam >= id_RB) AND (Msg.wParam <= id_RB+4) THEN
    IF HiWord(Msg.lParam) = bn_Clicked THEN Actualize2;

  (* Feldname wurde gendert *)
  IF Msg.wParam = id_EDFldName THEN
    IF HiWord(Msg.lParam) = en_Change THEN
      IF GetFocus = EDFldName^.hWindow THEN Actualize3;

  (* Feldgre wurde gendert *)
  IF Msg.wParam = id_EDSize THEN
    IF HiWord(Msg.lParam) = en_Change THEN
      IF GetFocus = EDSize^.hWindow THEN Actualize3;

  (* Feld Dec wurde gendert *)
  IF Msg.wParam = id_EDDec THEN
    IF HiWord(Msg.lParam) = en_Change THEN
      IF GetFocus = EDDec^.hWindow THEN Actualize3;
END;

PROCEDURE tDlgWin.WMInitMenu(VAR Msg: tMessage);
VAR
  Foc        : hWnd;
  i, Len     : INTEGER;
  Sel        : LongInt;
  MenuStatus : WORD;
BEGIN
  DefWndProc(Msg);
  Foc := GetFocus;
  IF (Foc = EDFileName^.hWindow) OR
     (Foc = EDFldName^.hWindow)  OR
     (Foc = EDSize^.hWindow)     OR
     (Foc = EDDec^.hWindow) THEN BEGIN
    (* Rckgngig *)
    i := SendMessage(Foc, em_CanUndo, 0, 0);
    IF i <> 0 THEN
      MenuStatus := mf_Enabled
    ELSE
      MenuStatus := mf_Disabled OR mf_Grayed;
    EnableMenuItem(GetMenu(hWindow), cm_EditUndo,
                   mf_ByCommand OR MenuStatus);
    (* Ausschneiden/Kopieren *)
    Sel := SendMessage(Foc, em_GetSel, 0, 0);
    IF HiWord(Sel) - LoWord(Sel) = 0 THEN
      MenuStatus := mf_Disabled OR mf_Grayed
    ELSE
      MenuStatus := mf_Enabled;
    FOR i := 24320 TO 24321 DO
      EnableMenuItem(GetMenu(hWindow), i,
                     mf_ByCommand OR MenuStatus);
    (* Einfgen *)
    IF IsClipboardFormatAvailable(cf_Text) THEN
      MenuStatus := mf_Enabled
    ELSE
      MenuStatus := mf_Disabled OR mf_Grayed;
    EnableMenuItem(GetMenu(hWindow), 24322,
                   mf_ByCommand OR MenuStatus);
    (* Lschen *)
    Len := SendMessage(Foc, em_LineLength, 0, 0);
    IF Len > 0 THEN
     MenuStatus := mf_Enabled
    ELSE
      MenuStatus := mf_Disabled OR mf_Grayed;
    EnableMenuItem(GetMenu(hWindow), 24324,
                   mf_ByCommand OR MenuStatus);
  END ELSE
    FOR i := 24320 TO 24325 DO
      EnableMenuItem(GetMenu(hWindow), i,
                     mf_ByCommand OR mf_Disabled OR
                     mf_Grayed);
END;

PROCEDURE tDlgWin.IDAddField(VAR Msg: tMessage);
VAR
  S1, S2  : ARRAY[0..EdLen] OF CHAR;
  i, Idx  : INTEGER;
  V, Code : INTEGER;
BEGIN
  IF zFileName[0] = #0 THEN Exit;
  STFree^.GetText(S1, EdLen);
  Val(S1, V, Code);
  IF V < 10 THEN BEGIN
   MessageBeep(0);
   MessageBox(0, #13#10'Maximale Datensatzgre 4000 Bytes',
              'Hinweis', mb_OK OR mb_IconExclamation);
   Exit;
  END;
  Inc(NewNumFields);
  IF NewNumFields > 255 THEN BEGIN
    MessageBeep(0);
    MessageBox(0, #13#10'Max. 255 Felder', 'Hinweis',
               mb_OK OR mb_IconExclamation);
    Dec(NewNumFields);
    Exit;
  END;
  FillChar(S1, 30, ' ');
  S1[30]:= #0;
  Str(NewNumFields, S2);
  STFields^.SetText(S2);
  Str(NewNumFields:3, S2);
  StrMove(S1, S2, 3);
  StrMove(S1 + 5, 'Feld', 4);
  Str(NewNumFields, S2);
  StrMove(S1 + 9, S2, StrLen(S2));
  StrMove(S1 + 17, 'C', 1);
  StrMove(S1 + 23, '10', 2);
  StrMove(S1 + 29, '0', 1);

  Idx := LB^.GetSelIndex;
  Idx := LB^.InsertString(S1, Succ(Idx));

  (* Liste neu durchnumerieren *)
  FOR i := 0 (* Idx *) TO Pred(LB^.GetCount) DO BEGIN
    LB^.GetString(S1, i);
    Str(Succ(i):3, S2);
    StrMove(S1, S2, 3);
    LB^.DeleteString(i);
    LB^.InsertString(S1, i);
  END;
  LB^.SetSelIndex(Idx);
  Actualize1;
  IF NewNumFields = 1 THEN BEGIN
    EnableWindow(GetItemHandle(id_DelField), TRUE);
    EnableWindow(GetItemHandle(id_Save),     TRUE);
    EnableWindow(GetItemHandle(id_SaveAs),   TRUE);
    EnableMenuItem(GetMenu(hWindow), id_DelField,
                   mf_ByCommand OR mf_Enabled);
    EnableMenuItem(GetMenu(hWindow), id_Save,
                   mf_ByCommand OR mf_Enabled);
    EnableMenuItem(GetMenu(hWindow), id_SaveAs,
                   mf_ByCommand OR mf_Enabled);
  END;

  SendMessage(GetItemHandle(id_AddField), bm_SetStyle,
              bs_PushButton, 1);
  SendMessage(GetItemHandle(id_DelField), bm_SetStyle,
              bs_PushButton, 1);
  SetFocus(GetItemHandle(id_RB));
  IsDirty := TRUE;
END;

PROCEDURE tDlgWin.IDDelField(VAR Msg : tMessage);
VAR
  Idx, i : INTEGER;
  S1, S2 : ARRAY[0..EdLen] OF CHAR;
BEGIN
  IF NewNumFields < 1 THEN Exit;
  Idx := LB^.GetSelIndex;
  Idx := Pred(LB^.DeleteString(Idx));

  (* Liste neu durchnumerieren *)
  FOR Idx := 0 TO Pred(LB^.GetCount) DO BEGIN
    LB^.GetString(S1, Idx);
    Str(Succ(Idx):3, S2);
    StrMove(S1, S2, 3);
    LB^.DeleteString(Idx);
    LB^.InsertString(S1, Idx);
  END;
  LB^.SetSelIndex(0);
  Dec(NewNumFields);
  Str(NewNumFields, S1);
  STFields^.SetText(S1);
  Actualize1;
  SendMessage(GetItemHandle(id_DelField), bm_SetStyle,
              bs_PushButton, 1);

  IF NewNumFields = 0 THEN BEGIN
    EnableWindow(GetItemHandle(id_DelField), FALSE);
    EnableWindow(GetItemHandle(id_Save),     FALSE);
    EnableWindow(GetItemHandle(id_SaveAs),   FALSE);
    EnableMenuItem(GetMenu(hWindow), id_DelField,
                   mf_ByCommand OR mf_Disabled OR
                   mf_Grayed);
    EnableMenuItem(GetMenu(hWindow), id_Save,   mf_ByCommand
                                             OR mf_Disabled
                                             OR mf_Grayed);
    EnableMenuItem(GetMenu(hWindow), id_SaveAs, mf_ByCommand
                                             OR mf_Disabled
                                             OR mf_Grayed);
    SendMessage(GetItemHandle(id_AddField), bm_SetStyle,
                bs_DefPushButton, 1);
    SetFocus(GetItemHandle(id_AddField));
    IsDirty := FALSE;
  END ELSE BEGIN
    SetFocus(LB^.hWindow);
    IsDirty := TRUE;
  END;
END;

PROCEDURE tDlgWin.IDNew(VAR Msg: tMessage);
VAR
  i : INTEGER;
BEGIN
  IF NOT CanClose THEN Exit;
  StrCopy(zFileName, 'NoName.DBF');
  EDFileName^.SetText(zFileName);
  LB^.ClearList;
  NewNumFields := 0;
  STFields^.SetText('0');
  STFree^.SetText('4000');

  IF NOT IsWindowEnabled(GetItemHandle(100)) THEN
    FOR i := 100 TO 115 DO
      EnableWindow(GetItemHandle(i), TRUE);

  EnableWindow(GetItemHandle(id_AddField), TRUE);
  EnableMenuItem(GetMenu(hWindow), id_AddField,
                 mf_ByCommand OR mf_Enabled);
  SendMessage(GetItemHandle(id_AddField),
              bm_SetStyle, bs_DefPushButton, 1);
  SendMessage(GetItemHandle(id_New),
              bm_SetStyle, bs_PushButton, 1);
  SetFocus(GetItemHandle(id_AddField));
  EnableWindow(GetItemHandle(id_DelField), FALSE);
  EnableMenuItem(GetMenu(hWindow), id_DelField,
                 mf_ByCommand OR mf_Disabled OR mf_Grayed);
  FOR i := id_Save TO id_SaveAs DO BEGIN
    EnableWindow(GetDlgItem(hWindow, i), FALSE);
    EnableMenuItem(GetMenu(hWindow), i, mf_ByCommand OR
                                        mf_Disabled  OR
                                        mf_Grayed);
  END;
  IsDirty   := FALSE;
  IsNewFile := TRUE;
END;  

PROCEDURE tDlgWin.IDLoad(VAR Msg : tMessage);
VAR
  i : INTEGER;
BEGIN
  IF CanClose THEN BEGIN
    IF Application^.ExecDialog(New(pFileDialog,
                                   Init(@Self,
                                   pChar(sd_FileOpen),
                                   StrCopy(zFileName,
                                   '*.DBF')))) = id_OK THEN
      Load;
  END;
END;

PROCEDURE tDlgWin.IDSave(VAR Msg: tMessage);
BEGIN
  IF IsNewFile THEN IDSaveAs(Msg)
               ELSE Save;
END;

PROCEDURE tDlgWin.IDSaveAs(VAR Msg: tMessage);
BEGIN
  IF IsNewFile THEN StrCopy(zFileName, 'NONAME.DBF');
  IF Application^.ExecDialog(New(pFileDialog, Init
                            (@Self, pChar(sd_FileSave),
                            zFileName))) = id_OK THEN
    Save;
END;

PROCEDURE tDlgWin.IDQuit(VAR Msg: tMessage);
BEGIN
  (* PostQuitMessage(0); gibt Ressourcen nicht frei! *)
  SendMessage(hWindow, wm_SysCommand, sc_Close, 0);
END;

PROCEDURE tDlgWin.IDAbout(VAR Msg: tMessage);
BEGIN
  Application^.ExecDialog(New(pDialog,
                              Init(@Self, 'About')));
END;

(* ------------------ Sonstige Methoden ----------------- *)

PROCEDURE tDlgWin.FillHeader;
VAR
  Y, M, D, DOW : WORD;
BEGIN
  (* Mit #0 vorbelegen *)
  FillChar(NewHeader, SizeOf(NewHeader), #0);

  WITH NewHeader DO BEGIN
    (* Versionsnummer *)
    FirstByte := 3;
    (* Datum der letzten Aktualisierung *)
    GetDate(Y, M, D, DOW);
    WITH Date DO BEGIN
      Year  := Byte(Y - 1900);
      Month := Byte(M);
      Day   := Byte(D);
    END;
    (* Vorspanngre berechnen *)
    HeaderSize := Word(32                   (* fr Header *)
                       + NewNumFields * 32 + 1(* fr $0D *));
    (* Satzgre wird bei InitFieldDesc ermittelt *)
  END;
END;

PROCEDURE tDlgWin.InitFieldDesc;
VAR
  i, V, Code : INTEGER;
  S1, S2     : ARRAY[0..EdLen] OF CHAR;
BEGIN
  (* Sollte nicht vorkommen: *)
  IF LB^.GetCount <> NewNumFields THEN BEGIN
    MessageBox(0, 'LB^.GetCount <> NewNumFields', 'Fehler!',
               1);
    Exit;
  END;
  NewDataSize := 1;                    (* 1 fr LschByte *)
  FOR i := 1 TO NewNumFields DO BEGIN
    New(NewFields[i]);
    (* Mit #0 vorbelegen *)
    FillChar(NewFields[i]^, SizeOf(NewFields[i]^), #0);

    LB^.GetString(S1, Pred(i));
    WITH NewFields[i]^ DO BEGIN
      
      StrMove(S2, StrUpper(S1 + 5), 10);      (* FeldName *)
      RemoveSpaces(S2);
      StrCopy(@FldName, S2);
      Typ   := S1[17];                        (* Typ      *)
      StrMove(S2, S1 + 22, 3);                (* Lnge    *)
      S2[3] := #0;
      RemoveSpaces(S2);
      Val(S2, V, Code);
      Size  := V;
      Inc(NewDataSize, V);
      StrMove(S2, S1 + 28, 2);          (* Dezimalstellen *)
      S2[2] := #0;
      RemoveSpaces(S2);
      Val(S2, V, Code);
      Dec   := V;
    END;
  END;  
  NewHeader.DataSize := NewDataSize;
END;

PROCEDURE tDlgWin.DisposeFieldDesc;
VAR
  i : INTEGER;
BEGIN
  FOR i := 1 TO NewNumFields DO Dispose(NewFields[i]);
END;

PROCEDURE tDlgWin.Load;
VAR
  DBO    : TDBObject;
  S1, S2 : ARRAY[0..EdLen] OF CHAR;
  i      : INTEGER;
BEGIN
  DBO.Open(zFileName);
  IF DBO.DBFError THEN BEGIN
    MessageBeep(0);
    MessageBox(0, #13#10'Probleme beim ffnen!' +
                  #13#10'Keine dBase-Datei!', 'Fehler',
                  mb_OK OR mb_IconExclamation);
    Exit;
  END;
  IF NOT IsWindowEnabled(GetItemHandle(100)) THEN BEGIN
    FOR i := 100 TO 115 DO
      EnableWindow(GetItemHandle(i), TRUE);
    InvalidateRect(hWindow, NIL, TRUE);
  END;
  LB^.ClearList;
   (* nicht proportiale Schrift im Feld *)
   SendMessage(LB^.hWindow, wm_SetFont,
               GetStockObject(ANSI_FIXED_Font),1);
  FOR i := 1 TO DBO.NumFields DO BEGIN
    FillChar(S1, 30, ' ');
    S1[30] := #0;
    Str(i:3, S2);
    StrMove(S1, S2, 3);
    StrMove(S1 + 5, DBO.Field(i), StrLen(DBO.Field(i)));
    S1[17] := DBO.FieldType(i);
    Str(DBO.FieldLength(i):3, S2);
    StrMove(S1 + 22, S2, 3);
    Str(DBO.Fields[i]^.Dec:2, S2);
    StrMove(S1 + 28, S2, 2);
    LB^.AddString(S1);
  END;
  LB^.SetSelIndex(0);
  NewNumFields := DBO.NumFields;
  DBO.Close;
  EDFileName^.SetText(zFileName);
  Str(NewNumFields, S2);
  STFields^.SetText(S2);
  SetFocus(LB^.hWindow);
  Actualize1;
  FOR i := id_AddField TO id_DelField DO BEGIN
    EnableWindow(GetItemHandle(i), TRUE);
    EnableMenuItem(GetMenu(hWindow), i, mf_ByCommand OR
                                        mf_Enabled);
  END;
  FOR i := id_Save TO id_SaveAs DO BEGIN
    EnableWindow(GetItemHandle(i), TRUE);
    EnableMenuItem(GetMenu(hWindow), i, mf_ByCommand OR
                                        mf_Enabled);
  END;
  SendMessage(GetItemHandle(id_Load), bm_SetStyle,
              bs_PushButton, 1);
  IsDirty   := FALSE;
  IsNewFile := FALSE;
END;

PROCEDURE tDlgWin.Save;
VAR
  i       : INTEGER;
  Buf     : ARRAY[0..255] OF CHAR;
  PS      : ARRAY[0..fsPathName] OF CHAR;
  S       : ARRAY[0..255] OF CHAR;
  V, Code : INTEGER;
BEGIN
  STFree^.GetText(S, EdLen);
  Val(S, V, Code);
  IF V > 4000 THEN BEGIN
    MessageBeep(0);
    MessageBox(0, #13#10'Maximale Datensatzgre 4000 Bytes'
                  + '. Krzen Sie die Feldlngen!',
                  'Hinweis', mb_OK OR mb_IconExclamation);
    Exit;
  END;
  FileSearch(PS, zFileName, '.');
  IF PS[0] <> #0 THEN BEGIN
    StrCopy(S, 'Datei ');
    StrCat(S, PS);
    StrCat(S, #13#10'bereits vorhanden.'#13#10);
    StrCat(S, 'Daten gehen verloren!'#13#10);
    StrCat(S, 'Trotzdem berschreiben?');
    IF MessageBox(0, S, 'Warnung', mb_YesNo OR
                  mb_IconQuestion           OR
                  mb_DefButton2) <> id_Yes THEN
      Exit;
  END;
  EDFileName^.SetText(zFileName);
  FillHeader;
  InitFieldDesc;
  Assign(f, zFileName);
  {$I-}
  Rewrite(f, 1);
  {$I+}
  BlockWrite(f, NewHeader, 32);
  FOR i := 1 TO NewNumFields DO
    BlockWrite(f, NewFields[i]^, SizeOf(NewFields[i]^));
  Buf[0] := Chr($0D);
  Buf[1] := Chr($1A);
  BlockWrite(f, Buf, 2);
  Close(f);
  DisposeFieldDesc;
  IsDirty   := FALSE;
  IsNewFile := FALSE;
END;

PROCEDURE tDlgWin.Actualize1;
VAR
  i, Idx : INTEGER;
  S1, S2 : ARRAY[0..EdLen] OF CHAR;
BEGIN
  IF NewNumFields = 0 THEN BEGIN
    (* 'C' als Default *)
    RB[0]^.SetCheck(1);
    FOR i := 1 TO 4 DO RB[i]^.SetCheck(0);
    EDFldName^.SetText('');
    EDSize^.SetText('');
    EDDec^.SetText('');
    EnableWindow(GetDlgItem(hWindow, id_EDDec), FALSE);
    EnableWindow(GetDlgItem(hWindow, id_DecShade), FALSE);
  END ELSE BEGIN
    Idx := LB^.GetSelIndex;
    LB^.GetString(S1, Idx);
    FOR i := 0 TO 4 DO
      RB[i]^.SetCheck(0);
    CASE S1[17] OF
      'C': RB[0]^.SetCheck(1);
      'N': RB[1]^.SetCheck(1);
      'D': RB[2]^.SetCheck(1);
      'L': RB[3]^.SetCheck(1);
      'M': RB[4]^.SetCheck(1);
    END;
    StrLCopy(S2, S1 + 5, 10);
    RemoveSpaces(S2);
    EDFldName^.SetText(S2);
    StrLCopy(S2, S1 + 22, 3);
    RemoveSpaces(S2);
    EDSize^.SetText(S2);
    IF S1[17] = 'N' THEN BEGIN
      StrLCopy(S2, S1 + 28, 2);
      RemoveSpaces(S2);
      EDDec^.SetText(S2);
      EnableWindow(GetItemHandle(id_EDDec),    TRUE);
      EnableWindow(GetItemHandle(id_DecShade), TRUE);
    END ELSE BEGIN
      EDDec^.SetText('0');
      EnableWindow(GetItemHandle(id_EDDec),    FALSE);
      EnableWindow(GetItemHandle(id_DecShade), FALSE);
    END;
    IF S1[17] IN ['D', 'L', 'M'] THEN BEGIN
      CASE S1[17] OF
        'D': StrCopy(S2, '8');
        'L': StrCopy(S2, '1');
        'M': StrCopy(S2, '10');
      END; 
      EDSize^.SetText(S2);
      EnableWindow(GetItemHandle(id_EDSize), FALSE);
      EnableWindow(GetItemHandle(id_SizeShade), FALSE);
    END ELSE BEGIN
      EnableWindow(GetItemHandle(id_EDSize), TRUE);
      EnableWindow(GetItemHandle(id_SizeShade), TRUE);
    END;
  END;
  ActualizeFree;
END; 

PROCEDURE tDlgWin.Actualize2;                      (* Typ *)
VAR
  i, Idx : INTEGER;
  S      : ARRAY[0..EdLen] OF CHAR;
BEGIN
  IF NewNumFields < 1 THEN Exit;
  FOR i := 0 TO 4 DO 
    IF RB[i]^.GetCheck = bf_Checked THEN Break;
  Idx := LB^.GetSelIndex;
  LB^.GetString(S, Idx);
  CASE i OF
    0: BEGIN
         IF S[17] <> 'C' THEN BEGIN
           S[17] := 'C';
           StrMove(S + 22, ' 10    0', 8);
         END;
       END;
    1: BEGIN
         IF S[17] <> 'N' THEN BEGIN
           S[17] := 'N';
           StrMove(S + 22, ' 10    2', 8);
         END;
       END;
    2: BEGIN
         IF S[17] <> 'D' THEN BEGIN
           S[17] := 'D';
           StrMove(S + 22, '  8    0', 8);
         END;
       END;
    3: BEGIN
         IF S[17] <> 'L' THEN BEGIN
           S[17] := 'L';
           StrMove(S + 22, '  1    0', 8);
         END;
       END;
    4: BEGIN
         IF S[17] <> 'M' THEN BEGIN
           S[17] := 'M';
           StrMove(S + 22, ' 10    0', 8);
         END;
       END;
  END;
  LB^.DeleteString(Idx);
  LB^.InsertString(S, Idx);
  LB^.SetSelIndex(Idx);
  Actualize1;
  IsDirty := TRUE;
END;

PROCEDURE tDlgWin.Actualize3;
VAR
  i, Idx  : INTEGER;
  S1, S2  : ARRAY[0..EdLen] OF CHAR;
  V, Code : INTEGER;
BEGIN
  IF NewNumFields = 0 THEN Exit;
  Idx := LB^.GetSelIndex;
  LB^.GetString(S1, Idx);
  (* FeldName *)
  StrMove(S1 + 5, '          ', 10);
  EDFldName^.GetText(S2, 10 + 1);
  RemoveSpaces(S2);
  (* ggf. auf gltigen Feldnamen prfen *)
  StrMove(S1 + 5, S2, StrLen(S2));
  (* Lnge *)
  EDSize^.GetText(S2, 3 + 1);
  CASE S1[17] OF
    'C': BEGIN
            Val(S2, V, Code);
            IF V > 254 THEN V := 254;
            Str(V:3, S2);
         END;
    'N': BEGIN
           Val(S2, V, Code);
           IF V > 20 THEN V := 20;
           IF V <  0 THEN V :=  0;
           Str(V:3, S2);
         END;
    'D': StrCopy(S2, '  8');
    'L': StrCopy(S2, '  1');
    'M': StrCopy(S2, ' 10');
  END;
  StrMove(S1 + 22, S2, 3);
  (* Dezimalstellen *)
  IF S1[17] = 'N' THEN BEGIN
    EDDec^.GetText(S2, 2 + 1);
    Val(S2, V, Code);
    IF V > 18 THEN V := 18;
    IF V <  0 THEN V :=  0;
    Str(V:2, S2);
  END ELSE BEGIN
    StrCopy(S2, ' 0');
  END;
  StrMove(S1 + 28, S2, 2);

  LB^.DeleteString(Idx);
  LB^.InsertString(S1, Idx);
  LB^.SetSelIndex(Idx);
  ActualizeFree;
  IsDirty := TRUE;
END;

PROCEDURE TDlgWin.ActualizeFree;
VAR
  Idx, n  : INTEGER;
  V, Code : INTEGER;
  S1, S2  : ARRAY[0..EdLen] OF CHAR;
BEGIN
  n := 4000;
  FOR Idx := 0 TO Pred(LB^.GetCount) DO BEGIN
    LB^.GetString(S1, Idx);
    StrMove(S2, S1 + 22, 3);
    S2[3] := #0;
    Val(S2, V, Code);
    Dec(n, V);
  END;  (*for*)
  Str(n, S1);
  STFree^.SetText(S1);
  IF n <= 0 THEN BEGIN
   MessageBeep(0);
   MessageBox(0, #13#10'Maximale Datensatzgre 4000 Bytes',
                 'Hinweis', mb_OK OR mb_IconExclamation);
   Exit;
  END;
END;

(* ====================================================== *)
(*                        tDlgApp                         *)
(* ====================================================== *)

PROCEDURE tDlgApp.InitMainWindow;
BEGIN
  MainWindow := New(PDlgWin, Init(NIL, 'CreateDlg'));
END;

(* ======================================================== *)

VAR
  DlgApp : tDlgApp;

BEGIN
  DlgApp.Init(AppName);
  DlgApp.Run;
  DlgApp.Done;
END.

(* ====================================================== *)
(*                   Ende von DBSTRUED.PAS                *)

