(*========================================================*)
(*                      DBWINED.PAS                       *)
(*           1993, 1994 Andreas Kosch & DMV-Verlag       *)
(*   unter Verwendung der dBase-Unit aus toolbox 4'93     *)
(*     Compiler: Borland Pascal 7.0, Windows Target       *)
(*========================================================*)

PROGRAM dBWin;

{$A+,B-,D+,F-,G+,I+,N-,R-,S+,V+,W+,X+}
{$C MOVEABLE DISCARDABLE}
{$R DBWINED.RES}

USES
  WinTypes, WinProcs, Strings, OWindows, ODialogs, OStdDlgs,
  Validate, dBEngine, BWCC;

CONST
  cm_dBInfo   = 101;  (* Dialogfenster anzeigen           *)
  cm_CloseAll = 105;  (* alle Childfenster schlieen      *)
  cm_Inc      = 111;  (* nchster Datensatz               *)
  cm_Dec      = 112;  (* vorheriger Datensatz             *)
  cm_Top      = 113;  (* erster Datensatz                 *)
  cm_Bottom   = 114;  (* letzter Datensatz                *)
  cm_Neu      = 115;  (* Append - Datensatz anhngen      *)
  cm_Delete   = 116;  (* Lschmarkierung setzen           *)
  cm_Find     = 117;  (* Datensatz suchen                 *)
  cm_Save     = 118;  (* Datensatz speichern              *)
  cm_Pack     = 119;  (* Tabelle komprimieren             *)
  cm_RecBtn   = 199;  (* ID-Startwert fr SmartIcons      *)
  cm_StruEd   = 211;  (* Menpunkt Struktureditor         *)
  cm_ABtn     = 221;  (* Append-Button                    *)
  cm_SBtn     = 222;  (* Save-Button                      *)
  cm_Such     = 223;  (* Find-Button                      *)
  cm_Hilfe    = 901;  (* leer                             *)
  cm_Info     = 999;  (* Info-MessageBox                  *)
  id_Datei    = 102;  (* Steuerelement-IDs im Dlgfenster  *)
  id_Satzanz  = 103;
  id_Satzlen  = 104;
  id_FeldAnz  = 106;
  id_S1       = 301;  (* SpeedBar-Datensatznummer         *)
  id_LB       = 401;
  id_ST       = 1000;
  id_ED       = 1500;
  id_EDFind   = 1501; (* FindDlg                          *)
  id_LBFind   = 1502; (* FindDlg                          *)

TYPE
  pToolButton = ^tToolButton;
  tToolButton = OBJECT(tButton)
    CONSTRUCTOR Init(aParent     : pWindowsObject;
                     AnID        : INTEGER;
                     aText       : pChar;
                     x, y, w, h  : INTEGER;
                     IsDefault   : BOOLEAN);
    FUNCTION    GetClassName : pChar;               VIRTUAL;
  END;

  (* Ownerdraw-Buttons *)
  pXButton = ^tXButton;
  tXButton = OBJECT(tButton)
    CONSTRUCTOR Init(aParent     : pWindowsObject;
                     AnID        : INTEGER;
                     aText       : pChar;
                     x, y, w, h  : INTEGER;
                     IsDefault   : BOOLEAN);
    FUNCTION    GetClassName: pChar;                VIRTUAL;
  END;

  pToolStatic = ^tToolStatic;
  tToolStatic = OBJECT(tStatic)
    CONSTRUCTOR Init(aParent     : pWindowsObject;
                     AnID        : INTEGER;
                     aTitle      : pChar;
                     x, y, w, h  : INTEGER;
                     aTextLen    : WORD);
    FUNCTION    GetClassName: pChar;                VIRTUAL;
  END;

  pBorStat = ^tBorStat;
  tBorStat = OBJECT(tStatic)
    FUNCTION    GetClassName: pChar;                VIRTUAL;
  END;

  pFldEdit = ^tFldEdit;
  tFldEdit = OBJECT(tEdit)
    (* Tabulator + Cursor Up/Down umleiten *)
    PROCEDURE wmKeyDown(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_KeyDown;
    PROCEDURE wmKillFocus(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_KillFocus;
  END;

  tMDIApp = OBJECT(tApplication)
    PROCEDURE InitMainWindow;                       VIRTUAL;
  END;

  pdBaseDlg = ^tdBaseDlg;
  tdBaseDlg = OBJECT(tDialog)
    (* Strukturanzeige der Tabelle *)
    LB  : pListBox;
    CONSTRUCTOR Init(aParent: pWindowsObject; aName: pChar);
    PROCEDURE   SetupWindow;                        VIRTUAL;
    PROCEDURE   Anzeige(Ziel: INTEGER; Wert: LongInt);
    PROCEDURE   Zeige;
  END;

  pFindDlg = ^tFindDlg;
  tFindDlg = OBJECT(tDialog)
    (* Auswahl des Suchfeldes *)
    LBFind : pListBox;
    (* Eingabe des Suchbegriffes *)
    edFind : pEdit;
    CONSTRUCTOR Init(aParent : pWindowsObject;
                     aName   : pChar);
    PROCEDURE   SetupWindow;                        VIRTUAL;
    PROCEDURE   Ok(VAR Msg: tMessage);
      VIRTUAL id_First + id_OK;
  END;

  pTableWin = ^tTableWin;
  tTableWin = OBJECT(tWindow)
    St: ARRAY[1..256] OF pStatic;(* Anzeige der Feldnamen *)
    Ed: ARRAY[1..256] OF pFldEdit; (* Tabellenfeld-Editor *)
    szTable  : ARRAY[0..79] OF CHAR;  (* Name der Tabelle *)
    DB       : pDBObject;              (* Datenbankobjekt *)
    Puffer   : ARRAY[1..1024] OF BYTE; (* Suchbegriff     *)
    szSuche  : ARRAY[0..20] OF CHAR; (* Position Feldname *)
    bFldIndex: BYTE;
    iFelder  : INTEGER;              (* Anzahl der Felder *)
    CONSTRUCTOR Init(aParent  : pWindowsObject;
                     FileName : pChar);
    DESTRUCTOR Done;                                VIRTUAL;
    PROCEDURE  SetupWindow;                         VIRTUAL;
    PROCEDURE  GetWindowClass(VAR aWndClass: tWndClass);
                                                    VIRTUAL;
    FUNCTION   GetClassName: pChar;                 VIRTUAL;
    (* Feldwechsel mit Tabulator + Cursortasten *)
    PROCEDURE  wmKeyDown(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_KeyDown;
    PROCEDURE  wmSetFocus(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_SetFocus;
    (* Antwortmethoden auf die Menauswahl *)
    PROCEDURE  cmInc(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Inc;
    PROCEDURE  cmDec(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Dec;
    PROCEDURE  cmBottom(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Bottom;
    PROCEDURE  cmTop(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Top;
    PROCEDURE  cmNeu(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Neu;
    PROCEDURE  cmDelete(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Delete;
    PROCEDURE  cmFind(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Find;
    PROCEDURE  cmSave(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Save;
    PROCEDURE  cmPack(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Pack;
    PROCEDURE  cmDBInfo(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_dBInfo;
    PROCEDURE  SatzAnzeige;
    PROCEDURE  StatusAnzeige;

  END;

  pMDIWin = ^tMDIWin;
  tMDIWin = OBJECT(tMDIWindow)
    (* SmartIcon-Button in der Speedbar *)
    pRecBtn      : ARRAY[1..4] OF pXButton;
    (* beschriftete Button in der Speedbar *)
    pABtn,
    pSBtn,
    pSuchBtn,
    pExitBtn     : pToolButton;
    (* Anzeige der Datensatz-Nr. in der SpeedBar *)
    pS1          : pToolStatic;
   (* Handle auf ein geffnetes Fenster vom Typ pTableWin *)
    dBaseFenster : pWindowsObject;
    (* CONSTRUCTOR ldt SmartIcon-Button-Bitmaps *)
    CONSTRUCTOR Init(aTitle : pChar; aMenu : hMenu);
    (* DESTRUCTOR entfernt Bitmap *)
    DESTRUCTOR  Done;                               VIRTUAL;
    PROCEDURE   SetupWindow;                        VIRTUAL;
    FUNCTION    GetClassName: pChar;                VIRTUAL;
    PROCEDURE   GetWindowClass(VAR aWndClass: tWndClass);
      VIRTUAL;
    FUNCTION    CreateChild: pWindowsObject;        VIRTUAL;
    PROCEDURE   wmSize(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_Size;
    PROCEDURE   cmCloseAll(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_CloseAll;
    PROCEDURE   cmInfo(VAR Msg: tMessage);
      VIRTUAL cm_First + cm_Info;
    PROCEDURE   SendWM(id :WORD);
    (* auf SpeedBar-Button-Anwahl antworten *)
    PROCEDURE   wmCommand(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_Command;
    (* Ownerdraw-Methode *)
    PROCEDURE   wmDrawItem(VAR Msg: tMessage);
      VIRTUAL wm_First + wm_DrawItem;
    PROCEDURE cmStruEd;       (* Struktureditor ausfhren *)
      VIRTUAL cm_First + cm_StruEd;
    PROCEDURE cmHelp;
      VIRTUAL cm_First + cm_Hilfe;
  END;

VAR
  (* Daten fr Ownerdraw-Buttons *)
  ItemStruct : tDrawItemStruct;
  (* Handle auf Button-Bitmap *)
  Picture    : hBitmap;
  CaretWin   : hWnd;
(* ====================================================== *)
(*                Methoden von tToolButton                *)
(* ====================================================== *)

CONSTRUCTOR tToolButton.Init;
BEGIN
  INHERITED Init(aParent, AnID, aText,
                 x, y, w, h, IsDefault);
  (* die Button-Leiste ist kein MDIChild *)
  SetFlags(wb_MDIChild, FALSE);
END;

(* Trotz BWCC soll die Gre der Buttons frei definierbar *)
(* sein!                                                  *)
FUNCTION tToolButton.GetClassName;
BEGIN
  GetClassName := 'Button';
END;

(* ====================================================== *)
(*                 Methoden von tXButton                  *)
(* ====================================================== *)

(* Damit die Buttons in der Speedbarleiste durch eigene   *)
(* Bitmaps dargestellt werden knnen, mu der Fensterstil *)
(* bs_OwnerDraw aktiviert werden. Die Buttons werden als  *)
(* weie Flche dargestellt und mssen vom Programm       *)
(* selbst gezeichnet werden. Dazu wird die Nachricht      *)
(* wm_DrawItem ausgewertet.                               *)
CONSTRUCTOR tXButton.Init;
BEGIN
  INHERITED Init(aParent, AnID, aText, x,y,w,h,IsDefault);
  Attr.Style := ws_Child OR ws_Visible OR bs_OwnerDraw;
  (* die Button-Leiste ist kein MDIChild *)
  SetFlags(wb_MDIChild, FALSE);
END;

FUNCTION tXButton.GetClassName;
BEGIN
  GetClassName := 'Button';
END;

(* ====================================================== *)
(*              Methoden von tToolStatic                  *)
(* ====================================================== *)

CONSTRUCTOR tToolStatic.Init;
BEGIN
  INHERITED Init(aParent, AnID, aTitle, x, y, w, h,
                 aTextLen);
  SetFlags(wb_MDIChild, FALSE);
END;

FUNCTION tToolStatic.GetClassName;
BEGIN
  GetClassName := 'borstatic';            (* Borland-Stil *)
END;

(* ====================================================== *)
(*                 Methoden von tBorStatic                *)
(* ====================================================== *)

FUNCTION tBorStat.GetClassName;
BEGIN
  GetClassName := 'borstatic';            (* Borland-Stil *)
END;

(* ====================================================== *)
(*                 Methoden von tFldEdit                  *)
(* ====================================================== *)

(* Die Tasten vk_Tab, vk_Down, vk_Up sollen nicht im      *)
(* fokussierten tFldEdit-Feld bearbeitet werden, da       *)
(* mit diesen Tasten der Wechsel der Datenfelder          *)
(* realisiert werden soll. Mit dem berschreiben der      *)
(* WMKeyDown-Methode werden die Botschaften fr diese     *)
(* Tasten zum bergeordneten Fenster weitergeleitet.      *)
PROCEDURE tFldEdit.wmKeyDown;
BEGIN
  IF Msg.wParam IN [vk_Tab, vk_Down, vk_Up] THEN
       SendMessage(Parent^.hWindow, wm_KeyDown,
                   Msg.wParam, Msg.lParam)
  ELSE DefWndProc(Msg);
END;

PROCEDURE tFldEdit.wmKillFocus(VAR Msg: tMessage);
BEGIN
  CaretWin := hWindow;
  tEdit.wmKillFocus(Msg);  
END;

(* ====================================================== *)
(*                 Methoden von tDBaseDlg                 *)
(* ====================================================== *)

CONSTRUCTOR tdBaseDlg.Init;
BEGIN
  INHERITED Init(aParent, aName);
  (* Listbox fr die Strukturanzeige der Tabelle *)
  New(LB, InitResource(@Self, id_LB));
END;

PROCEDURE tdBaseDlg.SetupWindow;
BEGIN
  INHERITED SetupWindow;
  Zeige;
END;

PROCEDURE tdBaseDlg.Anzeige;
VAR
  szTmp : ARRAY[0..20] OF CHAR;
BEGIN
  Str(Wert, szTmp);
  SetDlgItemText(hWindow, Ziel, szTmp);
END;

PROCEDURE tdBaseDlg.Zeige;
VAR
  i, iTmp  : INTEGER;
  sz1, sz2 : ARRAY[0..80] OF CHAR;
BEGIN
  (* Dateiname der dBase-Tabelle anzeigen *)
  SetDlgItemText(hWindow, id_Datei,
                 pTableWin(Parent)^.szTable);
  (* Die Schriftart in der ListBox soll eine              *)
  (* nichtproportionale Schrift sein:                     *)
  SendMessage(LB^.hWindow, wm_SetFont,
              GetStockObject(ANSI_Fixed_Font),1);
  (* Anzeige der restlichen Werte *)
  WITH pTableWin(Parent)^.DB^ DO BEGIN
    Anzeige(id_Satzanz, RecCount);
    Anzeige(id_Satzlen, Header.DataSize);
    Anzeige(id_FeldAnz, FldCount);
    FOR i := 1 TO FldCount DO BEGIN
      WITH Fields[i]^ DO BEGIN
        Str(i:3, sz1);
        StrCat(sz1, '  ');
        StrPCopy(sz2, FldName);
        StrCat(sz1, sz2);
        FOR iTmp := 1 TO 14 - StrLen(sz2) DO
          StrCat(sz1, #32);
        StrPCopy(sz2, Typ);
        StrCat(sz1, sz2);
        Str(INTEGER(Size):8, sz2);
        StrCat(sz1, sz2);
        Str(INTEGER(Dec):6, sz2);
        StrCat(sz1, sz2);
        LB^.AddString(sz1)
      END;
    END;
  END;
  LB^.SetSelIndex(0);
END;

(* ====================================================== *)
(*                  Methoden von tFindDlg                 *)
(* ====================================================== *)

CONSTRUCTOR tFindDlg.Init;
BEGIN
  INHERITED Init(aParent, aName);
  New(LBFind, InitResource(@Self, id_LBFind));
  New(edFind, InitResource(@Self, id_EDFind, 15));
END;

PROCEDURE tFindDlg.SetupWindow;
VAR
  szTmp : ARRAY[0..20] OF CHAR;
  i     : INTEGER;
BEGIN
  INHERITED SetupWindow;
  WITH pTableWin(Parent)^.DB^ DO BEGIN
    FOR i := 1 TO FldCount DO BEGIN
      StrPCopy(szTmp, Fields[i]^.FldName);
      LBFind^.AddString(szTmp);
    END;
  END;
  LBFind^.SetSelIndex(0);
END;

PROCEDURE tFindDlg.Ok;
VAR
  szTmp : ARRAY[0..16] OF CHAR;
BEGIN
  edFind^.GetText(szTmp, 15);
  StrCopy(pTableWin(Parent)^.szSuche, szTmp);
  pTableWin(Parent)^.bFldIndex := LBFind^.GetSelIndex;
  EndDlg(id_OK);
END;

(* ====================================================== *)
(*                  Methoden von tTableWin                *)
(* ====================================================== *)

CONSTRUCTOR tTableWin.Init;
VAR
  iTemp, iMax, i : INTEGER;
  FldLen         : INTEGER;
  szTmp          : ARRAY[0..11] OF CHAR;
BEGIN
  INHERITED Init(aParent, FileName);
  Attr.Style := Attr.Style OR ws_VScroll;
  Scroller := New(pScroller, Init(@Self, 8, 15, 80, 400));
  StrCopy(szTable, FileName);
  DB := New(pDBObject);
  DB^.Open(szTable);
  iFelder := DB^.FldCount;
  FOR i := 1 TO iFelder DO BEGIN
    St[i] := New(pBorStat, Init(@Self, id_ST + i,
                 DB^.Field(i), 20,
                 i * 30 - 20, 100, 30, 10));
    IF DB^.FieldType(i)='D' THEN
      FldLen := DB^.FieldLength(i) + 2
    ELSE
      FldLen := DB^.FieldLength(i);
    Ed[i] := New(pFldEdit, Init(@Self, id_ED + i,
                 '', 130, i * 30 - 25,
                 FldLen * 10 + 8, 25, FldLen + 1, FALSE));
    IF DB^.FieldType(i) = 'L' THEN
      Ed[i]^.Attr.Style := Ed[i]^.Attr.Style OR
                           es_UpperCase;
    IF DB^.FieldType(i) = 'D' THEN
      Ed[i]^.SetValidator(New(pPXPictureValidator,
                              Init('##.##.####,  .  .',
                              TRUE)));
    IF FldLen > iMax THEN iMax := FldLen + 1;
  END;
  CaretWin := 0;
END;

DESTRUCTOR tTableWin.Done;
BEGIN
  DB^.Close;
  Dispose(DB);
  INHERITED Done;
END;

PROCEDURE tTableWin.SetupWindow;
BEGIN
  INHERITED SetupWindow;
  SatzAnzeige;
  StatusAnzeige;
END;

FUNCTION tTableWin.GetClassName;
BEGIN
  GetClassName := 'tTableWin';
END;

PROCEDURE tTableWin.GetWindowClass;
BEGIN
  INHERITED GetWindowClass(aWndClass);
  (* hellgrauer Fensterhintergrund *)
  aWndClass.hbrBackground := GetStockObject(LtGray_Brush);
END;

PROCEDURE tTableWin.wmKeyDown;
VAR
  hAktuell : hWnd;
  iAktuell : INTEGER;
  iTmp     : INTEGER;
BEGIN
  CASE Msg.wParam OF
  vk_Tab,
  vk_Down: BEGIN
             hAktuell := GetFocus;
             FOR iTmp := 1 TO iFelder DO
               IF hAktuell = Ed[iTmp]^.hWindow THEN
                 iAktuell := iTmp;
               IF iAktuell < iFelder THEN Inc(iAktuell);
               SetFocus(Ed[iAktuell]^.hWindow);
               Ed[iAktuell]^.SetSelection(0, 255);
           END;
  vk_Up  : BEGIN
             hAktuell := GetFocus;
             FOR iTmp := 1 TO iFelder DO
               IF hAktuell = Ed[iTmp]^.hWindow THEN
                 iAktuell := iTmp;
               IF iAktuell > 1 THEN Dec(iAktuell);
               SetFocus(Ed[iAktuell]^.hWindow);
               Ed[iAktuell]^.SetSelection(0, 255);
           END;
  END;
END;

PROCEDURE tTableWin.wmSetFocus(VAR Msg: tMessage);
BEGIN
  IF CaretWin <> 0 THEN SetFocus(CaretWin);
END;

PROCEDURE tTableWin.SatzAnzeige;
VAR
  i   : INTEGER;
  Buf : ARRAY [0..255] OF CHAR;
BEGIN
  IF DB^.RecCount > 0  THEN
    DB^.Go(DB^.RecNo)
  ELSE
    FillChar(DB^.Buf4001^, DB^.RecSize, #0);
  FOR i := 1 TO DB^.FldCount DO BEGIN
    DB^.GetField(i, Buf);
    (* rechte Leerzeichen entfernen *)
    DB^.Trim(Buf);
    Ed[i]^.SetText(Buf);
  END;
  SetFocus(Ed[1]^.hWindow);
  Ed[1]^.SetSelection(0, Ed[1]^.GetLineLength(0));
END;

PROCEDURE tTableWin.StatusAnzeige;
VAR
  szTmp  : ARRAY[0..50] OF CHAR;
  szTmp2 : ARRAY[0..10] OF CHAR;
  lRecNo : LongInt;
  lRec   : LongInt;
BEGIN
  lRecNo := DB^.RecNo;
  lRec   := DB^.Header.NumRec;
  wvSprintF(szTmp, 'Datensatz : %7u ', lRecNo);
  wvSprintF(szTmp2, 'von %u', lRec);
  StrCat(szTmp, szTmp2);
  pMDIWin(Parent)^.pS1^.SetText(szTmp);
END;

PROCEDURE tTableWin.cmInc;
BEGIN
  DB^.Skip;
  SatzAnzeige;
  StatusAnzeige;
END;

PROCEDURE tTableWin.cmDec;
BEGIN
  IF DB^.RecNo > 1 THEN DB^.Go(DB^.RecNo - 1);
  SatzAnzeige;
  StatusAnzeige;
END;

PROCEDURE tTableWin.cmBottom;
BEGIN
  DB^.GoBottom;
  SatzAnzeige;
  StatusAnzeige;
END;

PROCEDURE tTableWin.cmTop;
BEGIN
  DB^.GoTop;
  SatzAnzeige;
  StatusAnzeige;
END;

PROCEDURE tTableWin.cmFind;
BEGIN
 IF Application^.ExecDialog(New(pFindDlg,
    Init(@Self, 'FINDDLG'))) = id_OK THEN BEGIN
   DB^.GoTop;
   DB^.Locate(bFldIndex + 1, szSuche);
   SatzAnzeige;
   StatusAnzeige;
 END;
END;

PROCEDURE tTableWin.cmNeu;
BEGIN
  DB^.Append;
  SatzAnzeige;
  StatusAnzeige;
END;

PROCEDURE tTableWin.cmSave;
VAR
  i     : INTEGER;
  s, sd : ARRAY [0..255] OF CHAR;
BEGIN
  IF DB^.RecCount < 1 THEN BEGIN
    MessageBeep(0);
    Exit;
  END;
  FOR i := 1 TO DB^.FldCount DO BEGIN
    IF DB^.FieldType(i) = 'D' THEN BEGIN
      Ed[i]^.GetText(sd, DB^.FieldLength(i) + 3);
      Move(sd[6], s[0], 4);
      Move(sd[3], s[4], 2);
      Move(sd[0], s[6], 2);
      s[8] := #0;
    END ELSE
      Ed[i]^.GetText(s, DB^.FieldLength(i) + 1);
    DB^.PutField(i, s);
  END;
  SatzAnzeige;
  StatusAnzeige;
END;

PROCEDURE tTableWin.cmDelete;
BEGIN
  IF MessageBox(hWindow,
     'Soll dieser Datensatz als gelscht markiert werden?',
     'dBase-Editor', mb_IconQuestion) = id_OK THEN BEGIN
    DB^.Delete;
    SatzAnzeige;
    StatusAnzeige;
  END;
END;

PROCEDURE tTableWin.cmPack;
BEGIN
  IF MessageBox(hWindow,
     'Markierte Datenstze lschen ?',
     'dBase-Editor', mb_IconQuestion + mb_YesNo) = id_OK THEN BEGIN
    DB^.Pack;
    SatzAnzeige;
    StatusAnzeige;
  END;
END;

PROCEDURE tTableWin.cmDBInfo;
BEGIN
  Application^.ExecDialog(New(pdBaseDlg,
                          Init(@Self, 'dBaseDlg')));
END;

(* ====================================================== *)
(*                  Methoden von tMDIWin                  *)
(* ====================================================== *)

CONSTRUCTOR tMDIWin.Init;
BEGIN
  INHERITED Init(aTitle, aMenu);
  (* Bitmap 120x30 mit den vier Schaltflchen laden *)
  Picture := LoadBitmap(hInstance, 'SmartIcons');
END;

DESTRUCTOR tMDIWin.Done;
BEGIN
  (* Bitmap mit den SmartIcons lschen *)
  DeleteObject(Picture);
  INHERITED Done;
END;

PROCEDURE tMDIWin.SetupWindow;
VAR
  aRect    : tRect;
  NewChild : pTableWin;
  i        : INTEGER;
BEGIN
  INHERITED SetupWindow;
  dBaseFenster := NIL;
  FOR i := 1 TO 4 DO BEGIN
    pRecBtn[i] := New(pXButton,Init(@Self,
                      cm_RecBtn + i ,
                      '', i * 30, 2, 30, 25, FALSE));
    pRecBtn[i]^.Create;
  END;
  pABtn := New(pToolButton, Init(@Self, cm_ABtn,
               'Append', 160, 2, 60, 25, FALSE));
  pABtn^.Create;
  pSBtn := New(pToolButton, Init(@Self, cm_SBtn,
               'Save', 220, 2, 60, 25, FALSE));
  pSBtn^.Create;
  pSuchBtn := New(pToolButton, Init(@Self, cm_Such,
                  'Find', 280, 2, 50, 25, FALSE));
  pSuchBtn^.Create;
  pExitBtn := New(pToolButton, Init(@Self,
                  cm_Exit - id_First + cm_First,
                  'Exit', 550, 2, 50, 25, TRUE));
  pExitBtn^.Create;
  pS1 := New(pToolStatic, Init(@Self, id_S1,
             'Keine Datenbank aktiv',
             350, 8, 200, 20, 49)); 

  pS1^.Create;
END;

FUNCTION tMDIWin.GetClassName;
BEGIN
  GetClassName := 'dBMDIWin';
END;

PROCEDURE tMDIWin.GetWindowClass;
BEGIN
  INHERITED GetWindowClass(aWndClass);
  aWndClass.hbrBackground := 1;
END;

PROCEDURE tMDIWin.wmSize;
BEGIN
  INHERITED wmSize(Msg);
  IF (ClientWnd <> NIL) AND (ClientWnd^.hWindow <> 0) THEN
    MoveWindow(ClientWnd^.hWindow, 0, 30,
               Msg.lParamLo,Msg.lParamHi - 30, TRUE);
END;

FUNCTION tMDIWin.CreateChild: pWindowsObject;
VAR
  szPfad: ARRAY[0..80] OF CHAR;
BEGIN
  StrPCopy(szPfad, '*.dbf');
  IF Application^.ExecDialog(New(pFileDialog,Init(@Self,
     MakeIntResource(sd_FileOpen),
     szPfad))) = id_OK THEN BEGIN
    dBaseFenster := New(pTableWin, Init(@Self, szPfad));
    CreateChild  := Application^.MakeWindow(dBaseFenster);
  END;
END;

PROCEDURE tMDIWin.wmCommand;
BEGIN
  CASE Msg.wParam OF
    200    : SendWM(cm_Top);
    201    : SendWM(cm_Dec);
    202    : SendWM(cm_Inc);
    203    : SendWM(cm_Bottom);
    cm_ABtn: SendWM(cm_Neu);
    cm_SBtn: SendWM(cm_Save);
    cm_Such: SendWM(cm_Find);
  END;
  INHERITED wmCommand(Msg);
END;

PROCEDURE tMDIWin.SendWM(id: WORD);
VAR
  dBWnd : hWnd;
BEGIN
  IF Assigned(dBaseFenster) THEN BEGIN
   dBWnd := GetActiveWindow;
   PostMessage(dBWnd, wm_Command, id, 0);
   SetFocus(hWindow);
  END;
END;

PROCEDURE tMDIWin.cmCloseAll;
BEGIN
  dBaseFenster := NIL;
  pS1^.SetText('Keine Datenbank aktiv');
  INHERITED CloseChildren;
END;

PROCEDURE tMDIWin.cmInfo;
BEGIN
  MessageBox(hWindow, #13#10' 1993, 94 Andreas Kosch &&' + 
                      '                       DMV-Verlag',
                      'dBase-Editor', mb_IconInformation);
END;
PROCEDURE tMDIWin.cmStruEd;
BEGIN
  IF WinExec('dbStruEd.EXE', sw_ShowNormal) < 32 THEN
    MessageBox(hWindow,
               #13#10#10'Struktureditor nicht gefunden!',
               'dBase-Editor', mb_IconExclamation + mb_OK);

END;

PROCEDURE tMDIWin.cmHelp;
BEGIN
  MessageBox(hWindow,
             'Eine Hilfe ist in dieser Version noch' +
             ' nicht implementiert!',
             'dBase-Editor',
             mb_IconInformation + mb_OK);

END;

PROCEDURE tMDIWin.wmDrawItem;
VAR
  MemDC : hDC;
  BM    : tBitmap;
BEGIN
  ItemStruct := pDrawItemStruct(Msg.lParam)^;
  IF ItemStruct.hWndItem = pRecBtn[1]^.hWindow THEN BEGIN
    CASE ItemStruct.ItemAction OF
    oda_DrawEntire:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 0, 0,
               SrcCopy);
        DeleteDC(MemDC);
      END;
    oda_Select:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 0, 25,
               SrcCopy);
        DeleteDC(MemDC);
      END;
    END;
  END;
  IF ItemStruct.hWndItem = pRecBtn[2]^.hWindow THEN BEGIN
    CASE ItemStruct.ItemAction OF
    oda_DrawEntire:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 30, 0,
               SrcCopy);
        DeleteDC(MemDC)
      END;
    oda_Select:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 30, 25,
               SrcCopy);
        DeleteDC(MemDC);
      END;
    END;
  END;
  IF ItemStruct.hWndItem = pRecBtn[3]^.hWindow THEN BEGIN
    CASE ItemStruct.ItemAction OF
    oda_DrawEntire:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 60, 0,
               SrcCopy);
        DeleteDC(MemDC);
      END;
      oda_Select:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 60, 25,
               SrcCopy);
        DeleteDC(MemDC);
      END;
    END;
  END;
  IF ItemStruct.hWndItem = pRecBtn[4]^.hWindow THEN BEGIN
    CASE ItemStruct.ItemAction OF
    oda_DrawEntire:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 90, 0,
               SrcCopy);
        DeleteDC(MemDC)
      END;
      oda_Select:
      BEGIN
        MemDC := CreateCompatibleDC(ItemStruct.hDC);
        SelectObject(MemDC, Picture);
        BitBlt(ItemStruct.hDC, 0, 0, 30, 25, MemDC, 90, 25,
               SrcCopy);
        DeleteDC(MemDC);
      END;
    END;
  END;
END;

(* ====================================================== *)
(*           Erzeugen des MDI-Rahmenfensters              *)
(* ====================================================== *)

PROCEDURE tMDIApp.InitMainWindow;
BEGIN
  MainWindow := New(pMDIWin,
                    Init('dBase-Editor fr Windows ',
                    LoadMenu(hInstance,'MAINMENU')));

END;

VAR
  hLib   : tHandle;
  MDIApp : tMDIApp;

BEGIN
  hLib := LoadLibrary('BWCC.DLL');
  IF hLib < 32 THEN RunError;
  CmdShow := sw_ShowMaximized;
  MDIApp.Init('dBWin');
  MDIApp.Run;
  MDIApp.Done;
  FreeLibrary(hLib);
END.

(*========================================================*)
(*                  Ende von DBWINED.PAS                  *)
