// dlgbox.cpp
//
// klassenverhalten der Dialogbox klasse
// ACHTUNG ! Das Beispiel verwendet einen Windows-font
//           und erwartet diesem im Verzeichnis
//           c:\windows\system. Befindet sich der font
//           dort nicht, kann der verwendete Font/Pfad
//           in Zeile 619 geaendert werden.
//
// update: 1.0 29-apr-93 tw

#include <graph.h>
#include <dos.h>
#include <afxcoll.h>
#include <malloc.h>
#include "dlgbox.h"
#include "dlgbox.inl"
#include "mouse.h"     
#include <stdio.h>
#include <stdlib.h>

#pragma warning ( disable: 4135 ) 

// Wnd erzeugen
XWnd::XWnd( const point2dGK pntUpperLeft, short id, const char * pszCaption )
{
   m_xUpperLeft = pntUpperLeft.x;
   m_yUpperLeft = pntUpperLeft.y;
   m_id = id;
   m_strCaption = pszCaption;
   m_cxCaption = _getgtextextent( m_strCaption );
}

// Wnd erzeugen
void 
XWnd::Create( const point2dGK pntUpperLeft, short id, const char * pszCaption )
{
   m_xUpperLeft = pntUpperLeft.x;
   m_yUpperLeft = pntUpperLeft.y;
   m_id = id;
   m_strCaption = pszCaption;
   m_cxCaption = _getgtextextent( m_strCaption );
}

// Button erzeugen
XButton::XButton( const point2dGK pntUpperLeft, short id, const char * pszCaption,
                  BOOL fIsChecked )
   : XWnd( pntUpperLeft, id, pszCaption )
{
   m_fIsChecked = fIsChecked;
}
         
void 
XButton::Caption( const char * pszCaption )
{  
   m_strCaption = pszCaption;
}
         
void 
XButton::OnPaint() const
{
   _setviewport( X(), Y(), X()+Length(), Y()+Heigth() );
   _setvieworg( X(), Y() );
}

void 
XButton::Caption( short x, short y ) const
{
   _moveto( x, y );
   _outgtext( m_strCaption );
}

BOOL 
XButton::CheckState() const
{
   return m_fIsChecked;
}

void 
XButton::CheckState( BOOL fCheck )
{
   m_fIsChecked = fCheck;
}

XButton * 
XButton::GotHit( short x, short y )
{
   if ( x > m_xUpperLeft && x < m_xUpperLeft+m_cx )
      if ( y > m_yUpperLeft && y < m_yUpperLeft+m_cy )
         return this;

   return 0;
}    

/* static */ short XWnd::m_cxChar; 
/* static */ short XWnd::m_cyChar;
/* static */ const short XWnd::m_cxTxtBorder = 3;
/* static */ const short XWnd::m_cyTxtBorder = 3;

/* static */ short XWnd::m_colBtnFace = 7;       // GRAU
/* static */ short XWnd::m_colBtnShadow = 8;     // DUNKELGRAU;   
/* static */ short XWnd::m_colBtnHilight = 15;   // WEISS;   
/* static */ short XWnd::m_colBtnFrame = 0;      // SCHWARZ;   


const short cxAdditionalBorder = 6;
const short cyAdditionalBorder = 6;

XPushButton::XPushButton( const point2dGK pntUpperLeft, short id, const char * pszCaption )
   : XButton ( pntUpperLeft, id, pszCaption )
{
   m_cx = m_cxCaption + 2 * m_cxTxtBorder + cxAdditionalBorder;
   m_cy = m_cyChar + 2 * m_cyTxtBorder + cyAdditionalBorder;
}

void
XPushButton::OnPaint() const
{
   XButton::OnPaint();

   // schwarzer Rahmen
   _setcolor( m_colBtnFrame );
   _moveto( 0, 0 );
   _lineto( Length(), 0);
   _lineto( Length(), Heigth() );
   _lineto( 0, Heigth() );
   _lineto( 0, 0 );

   // Caption 
   Caption( 2*m_cxTxtBorder, 2*m_cyTxtBorder );

   // graue Umrandung
   _setcolor( m_colBtnFace );
   _setpixel( 0, 0);
   _setpixel( Length(), 0 );
   _setpixel( Length(), Heigth() );
   _setpixel( 0, Heigth() );

   // weisse Bereiche
   _setcolor( m_colBtnHilight );
   _moveto( 1, m_cy-2 );
   _lineto( 1, 1 );
   _lineto( m_cx-2, 1 );
   _moveto( 2, m_cy-3 );
   _lineto( 2, 2 );
   _lineto( m_cx-3, 2 );

   // dunkelgraue Bereiche
   _setcolor( m_colBtnShadow );
   _moveto( 1, m_cy-1 );
   _lineto( m_cx-1, m_cy-1 );
   _lineto( m_cx-1, 1 );
   _moveto( 2, m_cy-2 );
   _lineto( m_cx-2, m_cy-2 );
   _lineto( m_cx-2, 2 );

}

void 
XPushButton::OnBtnDown()
{
   XButton::OnPaint();

   _setcolor( m_colBtnFace );
   _moveto( 1, m_cy-2 );
   _lineto( 1, 1 );
   _lineto( m_cx-2, 1 );
   _moveto( 2, m_cy-3 );
   _lineto( 2, 2 );
   _lineto( m_cx-3, 2 );

   _moveto( 1, m_cy-1 );
   _lineto( m_cx-1, m_cy-1 );
   _lineto( m_cx-1, 1 );
   _moveto( 2, m_cy-2 );
   _lineto( m_cx-2, m_cy-2 );
   _lineto( m_cx-2, 2 );

   // vorigen Caption loeschen
   Caption( 3+m_cxTxtBorder, 3+m_cyTxtBorder );

   _setcolor( m_colBtnFrame );
   Caption( 3+m_cxTxtBorder+2, 3+m_cyTxtBorder+2 );

   // schatten-Bereiche
   _setcolor( m_colBtnShadow );
   _moveto( 1, m_cy-1 );
   _lineto( 1, 1 );
   _lineto( m_cx-1, 1 );

}

void 
XPushButton::OnBtnUp() const
{
   // alten Caption entfernen
   _setcolor( m_colBtnFace );
   Caption( 3+m_cxTxtBorder+2, 3+m_cyTxtBorder+2 );

   // neuen Caption ausgebene
   _setcolor( m_colBtnFrame );
   Caption( 3+m_cxTxtBorder, 3+m_cyTxtBorder );

   // weisse Bereiche ausgeben
   _setcolor( m_colBtnHilight );
   _moveto( 1, m_cy-2 );
   _lineto( 1, 1 );
   _lineto( m_cx-2, 1 );
   _moveto( 2, m_cy-3 );
   _lineto( 2, 2 );
   _lineto( m_cx-3, 2 );

   // dunkelgraue Bereiche
   _setcolor( m_colBtnShadow );
   _moveto( 1, m_cy-1 );
   _lineto( m_cx-1, m_cy-1 );
   _lineto( m_cx-1, 1 );
   _moveto( 2, m_cy-2 );
   _lineto( m_cx-2, m_cy-2 );
   _lineto( m_cx-2, 2 );

}

XUpArrowButton::XUpArrowButton( const point2dGK pntUpperLeft, short id )
   : XPushButton ( pntUpperLeft, id, "^" )
{} 

XUpArrowButton::~XUpArrowButton()
{}

XStatic::XStatic( const point2dGK pntUpperLeft, short id, const char * pszCaption )
   : XButton ( pntUpperLeft, id, pszCaption )
{
   m_cx = m_cxCaption;
   m_cy = m_cyChar + 2 * m_cyTxtBorder;
}

void 
XStatic::OnPaint() const
{
   XButton::OnPaint();

   _setcolor( m_colBtnFrame );
   Caption( 0, m_cyTxtBorder );
}


XRadioButton::XRadioButton( const point2dGK pntUpperLeft, short id, const char * pszCaption,
                            BOOL fIsChecked )
   : XButton( pntUpperLeft, id, pszCaption, fIsChecked )
{
   m_cx = m_cxCaption + 2 * m_cxTxtBorder + 2 * m_cxChar;
   m_cy = m_cyChar + 2 * m_cyTxtBorder;

}

void 
XRadioButton::OnPaint() const
{
   XButton::OnPaint();

   _setcolor( m_colBtnFrame );

   // radiobox ausgeben
   short yBegin = (m_cyChar-m_cxChar) / 2;
   short yEnd = yBegin+m_cxChar;
   _ellipse( _GBORDER, 0, yBegin, m_cxChar, yEnd );

   // checkmark ausgeben
   if ( CheckState() )
   {
      short yMid = yEnd-yBegin;
      short xMid = m_cxChar / 2;

      _setpixel( xMid, yMid );
      _setpixel( xMid+1, yMid );
      _setpixel( xMid-1, yMid );
      _setpixel( xMid, yMid+1 );
      _setpixel( xMid, yMid-1 );
   }

   // caption ausgeben
   Caption( 2*m_cxChar, 0 );
}

void 
XRadioButton::OnBtnDown()
{
   XButton::OnPaint();

   CheckState( ! CheckState() );

   if ( CheckState() )
      _setcolor( m_colBtnFrame );
   else
      _setcolor( m_colBtnFace );

   short yBegin = (m_cyChar-m_cxChar) / 2;
   short yEnd = yBegin+m_cxChar;
   short yMid = yEnd-yBegin;
   short xMid = m_cxChar / 2;

   _setpixel( xMid, yMid );
   _setpixel( xMid+1, yMid );
   _setpixel( xMid-1, yMid );
   _setpixel( xMid, yMid+1 );
   _setpixel( xMid, yMid-1 );

}


XCheckButton::XCheckButton( const point2dGK pntUpperLeft, short id, const char * pszCaption,
                            BOOL fIsChecked )
   : XButton( pntUpperLeft, id, pszCaption, fIsChecked )
{
   m_cx = m_cxCaption + 2 * m_cxTxtBorder + 2 * m_cxChar;
   m_cy = m_cyChar + 2 * m_cyTxtBorder;
}


void 
XCheckButton::OnPaint() const
{
   XButton::OnPaint();

   _setcolor( m_colBtnFrame );

   // checkbox ausgeben
   short yBegin = (m_cyChar-m_cxChar) / 2;
   short yEnd = yBegin+m_cxChar;
   _moveto( 0, yBegin );
   _lineto( m_cxChar, yBegin );
   _lineto( m_cxChar, yEnd );
   _lineto( 0, yEnd );
   _lineto( 0, yBegin );

   // checkmark ausgeben
   if ( CheckState() )
   {
      _moveto( 0, yBegin);
      _lineto( m_cxChar, yEnd );
      _moveto( 0, yEnd );
      _lineto( m_cxChar, yBegin );
   }

   // caption ausgeben
   Caption( 2*m_cxChar, 0 );
}

void 
XCheckButton::OnBtnDown()
{
   XButton::OnPaint();
   CheckState( ! CheckState() );

   if ( CheckState() )
      _setcolor( m_colBtnFrame );
   else
      _setcolor( m_colBtnFace );

   // checkbox ausgeben
   short yBegin = (m_cyChar-m_cxChar) / 2;
   short yEnd = yBegin+m_cxChar;
   yBegin++;
   yEnd--;
   short xBegin = 1;
   short xEnd = m_cxChar-1;
   _moveto( xBegin, yBegin );
   _lineto( xEnd, yEnd );
   _moveto( xBegin, yEnd );
   _lineto( xEnd, yBegin );

}


XGroupBox::XGroupBox( const point2dGK pntUpperLeft, short id, const char * pszCaption )
   : XButton( pntUpperLeft, id, pszCaption )
{
   // Die Groesse wird in AddButton berechnet, sodas sie der Groesse der
   // hinzugefuegten buttons entspricht
   m_cx = m_cxCaption;
   m_cy = m_cyChar + m_cyTxtBorder;
}

XGroupBox::~XGroupBox()
{
   POSITION pos = m_lstButtons.GetHeadPosition();
   while ( pos != NULL )
   {
      delete m_lstButtons.GetNext( pos );
   }
   m_lstButtons.RemoveAll();

}

void 
XGroupBox::AddButton( XButton * pNewButton )
{
   m_lstButtons.AddTail( pNewButton );
   if ( pNewButton->Length() > m_cx )
      m_cx = pNewButton->Length() + 2*m_cxTxtBorder ;
   m_cy += ( m_cyChar + m_cyTxtBorder );
}
      
BOOL 
XGroupBox::GetDlgItemCheckState( short idDlgItem ) const
{
   POSITION pos = m_lstButtons.GetHeadPosition();
   while ( pos != NULL )
   {
      XButton * pButton = (XButton*)m_lstButtons.GetNext(pos);
      if ( pButton->ID() == idDlgItem )
         return pButton->CheckState();
   }
   return FALSE;
}   
      
XButton * 
XGroupBox::GotHit( short x, short y)
{
   // nachsehen, ob wir in der group box sind
   if ( ! XButton::GotHit( x, y ))
      return 0;

   // ok, die groupbox wurde getroffen
   // gilt dies auch fuer einen button in der box ?
   POSITION pos = m_lstButtons.GetHeadPosition();
   while( pos != NULL )
   {
      XButton * pButton = (XButton*)(m_lstButtons.GetNext( pos ));
      if ( pButton = pButton->GotHit( x, y ))
      {
         return pButton;
      }
   }
   return 0;
}

void 
XGroupBox::OnPaint() const
{
   // alle buttons der Group ausgeben
   POSITION pos = m_lstButtons.GetHeadPosition();
   while( pos != NULL )
   {
      XButton * pButton = (XButton*)(m_lstButtons.GetNext( pos ));
      pButton->OnPaint();
   }

   // Gruppenrahmen ausgeben
   XButton::OnPaint();

   _setcolor( m_colBtnFrame );
   _moveto( 0, m_cyChar/2 );
   _lineto( m_cx, m_cyChar/2 );
   _lineto( m_cx, m_cy );
   _lineto( 0, m_cy );
   _lineto( 0, m_cyChar/2 );

   // caption ausgeben
   _setcolor( m_colBtnFace );
   _moveto( m_cxChar, m_cyChar/2 );
   _lineto( m_cxChar + m_cxCaption, m_cyChar/2 );

   _setcolor( m_colBtnFrame );
   Caption( m_cxChar, 0 );

}

void
XGroupBox::OnBtnDown()
{}

void
XGroupBox::OnBtnUp() const
{}

XRadioBox::XRadioBox( const point2dGK pntUpperLeft, short id, const char * pszCaption )
      : XGroupBox( pntUpperLeft, id, pszCaption )
{}
   
XButton *
XRadioBox::GotHit( short x, short y)
{
   XButton * pButton = XGroupBox::GotHit( x, y );
   
   Mouse aMouse;

   if ( pButton )
   {
      if ( ! pButton->CheckState() )
      {
         // deselektieren des aktuellen buttons
         POSITION pos = m_lstButtons.GetHeadPosition();
         while ( pos != NULL )
         {
            XButton * pButtonOne = (XButton*)(m_lstButtons.GetNext( pos ));
            if ( pButtonOne->CheckState() )
            {
               aMouse.ShowCursor( Mouse::CursorHide );
               pButtonOne->OnBtnDown();
               aMouse.ShowCursor( Mouse::CursorShow );
            }
         }

         // Selektierten button anschalten
         aMouse.ShowCursor( Mouse::CursorHide );
         pButton->OnBtnDown();
         aMouse.ShowCursor( Mouse::CursorShow );
      }
   }
   return 0;
}


// container fuer alle buttons in einem dialog
XButtonList::~XButtonList()
{
   POSITION pos = GetHeadPosition();
   while ( pos != NULL )
   {
      delete GetNext( pos );
   }
   RemoveAll();
}

void
XButtonList::Add( XButton * pButton )
{
   AddTail( pButton );
}

void
XButtonList::OnPaint()
{
   POSITION pos = GetHeadPosition();
   while ( pos != NULL )
   {
      XButton * pButton =(XButton*) GetNext( pos );
      pButton->OnPaint();
   }
}

XButton *
XButtonList::GotHit( short x, short y )
{
   POSITION pos = GetHeadPosition();
   while ( pos != NULL )
   {
      XButton * pButton = (XButton*)GetNext( pos );
      if ( pButton = pButton->GotHit( x, y ) )
         return pButton;
   }
   return 0;
}


XDialogBox::XDialogBox( const point2dGK wndPos, const point2dGK wndSize,
                        short id, const char * pszCaption,
                        BOOL(*pDlgProc)(XButton *pButton, XDialogBox * pDlgBoxCurrent ) )
   : XWnd( wndPos, id, pszCaption )
{
   m_xLowerRight = m_xUpperLeft + wndSize.x;
   m_yLowerRight = m_yUpperLeft + wndSize.y;
   m_cx = wndSize.x;
   m_cy = wndSize.y; 
   m_pDlgProc = pDlgProc;
}

XDialogBox::~XDialogBox()
{
   _setviewport( m_xUpperLeft, m_yUpperLeft, m_xLowerRight, m_yLowerRight );
   _putimage( 0, 0, m_pImage, _GPSET );
   _hfree( m_pImage );
   _unregisterfonts();
   // hier sollte noch der alte viewport wiederhergestellt werden
}
   
void
XDialogBox::AddItem( XButton * pButton )
{
   m_lstButtons.Add( pButton );
   pButton->OnPaint();
}
   
BOOL
XDialogBox::GetDlgItemCheckState( short idDlgItem, short idDlgItemGroup ) const
{
   // buttons iterieren - wenn der richtige id gefunden 
   // wird - checkstate ermitteln. wenn eine Gruppe ange-
   // geben wurde, diese gruppe iterieren
   POSITION pos = m_lstButtons.GetHeadPosition();
   while ( pos != NULL )
   {
      XButton * pButton = (XButton*)m_lstButtons.GetNext( pos );

      if ( idDlgItemGroup )   // durchsuchen einer Gruppe ?
      {
         if ( pButton->ID() == idDlgItemGroup )   // ist dies die gewuenschte gruppe ?
         {
            XGroupBox * pGroup = (XGroupBox*)pButton;
            return pGroup->GetDlgItemCheckState( idDlgItem );
         }
      }
      else  
      {
         if ( pButton->ID() == idDlgItem )
         {
            return pButton->CheckState();
         }
      }
   }

   return FALSE;

}

// Dies ist der Pfad auf den zu verwendenden Font: In diesem
// Fall nehmen wir natuerlich den Font, den Windows
// auch verwendet.
static const char BASED_CODE szFntPath[] = "c:\\windows\\system\\vgasys.fon";

// pszFont - nachtraeglich eingefuegt, damit auch ueber
// Kommandozeile der Pfad auf den font angegeben werden kann
BOOL
XDialogBox::Create( const char * pszFont )
{
   long cbImageSize = (size_t) _imagesize( m_xUpperLeft, m_yUpperLeft,
                                           m_xLowerRight, m_yLowerRight );
   m_pImage = (char __huge *)_halloc( cbImageSize, sizeof(char) );
   if ( m_pImage == (char __huge *)NULL )
   {
      return FALSE;
   }

   const char * pszUseFnt = ( pszFont ) ? pszFont : szFntPath;

   short nRet = _registerfonts( pszUseFnt  );
   if ( nRet < 0 )
   {
      exit(printf("Font: %s nicht gefunden.\nAufruf: dialog <fontfile>\n", pszUseFnt ));
   }
   nRet = _setfont( "h12w8b"); 

   if ( nRet < 0 )
   {
      ASSERT( FALSE );
   }
   struct _fontinfo fntInfo;
   _getfontinfo( &fntInfo );

   m_cxChar = _getgtextextent("A");
   m_cyChar = fntInfo.pixheight;

   _getimage( m_xUpperLeft, m_yUpperLeft, m_xLowerRight, m_yLowerRight, m_pImage );
   _setviewport( m_xUpperLeft, m_yUpperLeft, m_xLowerRight, m_yLowerRight );
   _setvieworg( m_xUpperLeft, m_yUpperLeft );
   _clearscreen( _GVIEWPORT );

   _setcolor( m_colBtnHilight );

   _moveto( 0, 0 );
   _lineto( m_cx, 0 );
   _lineto( m_cx, m_cy );
   _lineto( 0, m_cy );
   _lineto( 0,0 );

   _setcolor( m_colBtnFace );
   _floodfill( 1, 1, 2 );

   _setcolor( m_colBtnFrame );
   _moveto( 0, 0 );
   _lineto( m_cx, 0 );
   _lineto( m_cx, m_cy );
   _lineto( 0, m_cy );
   _lineto( 0,0 );

   _setcolor( m_colBtnHilight );
   _moveto( 3, 3 );
   _lineto( m_cx-3, 3 );
   _lineto( m_cx-3, m_cy-3 );
   _lineto( 3, m_cy-3 );
   _lineto( 3, 3 );

   _setcolor( m_colBtnFrame );
   _moveto( 4, 4+4+m_cyChar );
   _lineto( m_cx-4, 4+4+m_cyChar );

   // laenge des strings ermitteln
   int cxTitle = _getgtextextent( m_strCaption );;


   int cxOffset = m_cx - ( 2*4  );
   cxOffset -= cxTitle;
   cxOffset /= 2;                            
   _moveto( cxOffset + ( 2*4 ), 4 );
   _outgtext( m_strCaption );

   m_lstButtons.OnPaint();
   return TRUE;

}


// SEHR simple - liefert keine items aus group boxes
XButton * 
XDialogBox::GetDlgItem( const short idDlgItem ) const
{
   POSITION pos = m_lstButtons.GetHeadPosition();
   while ( pos != NULL )
   {
      XButton * pButton = (XButton*)m_lstButtons.GetNext( pos );

      if ( pButton->ID() == idDlgItem )
      {
          return pButton;
      }
   }

   ASSERT( FALSE ); 
   return 0;
}


BOOL
XDialogBox::DoModal() 
{
   Mouse aMouse;
   aMouse.ShowCursor( Mouse::CursorShow );

   BOOL fDone = FALSE,
        fRetVal = TRUE;

   while ( ! fDone )
   {
      if ( aMouse.ButtonPressed() )
      {
         XButton * pButton = m_lstButtons.GotHit(  aMouse.XLastPressed(),  aMouse.YLastPressed() );

         if ( ! pButton )
            continue;

         aMouse.ShowCursor( Mouse::CursorHide );
         pButton->OnBtnDown();
         aMouse.ShowCursor( Mouse::CursorShow );
                                    
         aMouse.WaitForBtnRelease();

         aMouse.ShowCursor( Mouse::CursorHide );
         pButton->OnBtnUp();   
         
         
         // user-definierts processing, marke SDK
         if ( m_pDlgProc )
            (*m_pDlgProc)( pButton, this );
         
         aMouse.ShowCursor( Mouse::CursorShow );

         if ( pButton->ID()==IDOK || pButton->ID()==IDCANCEL )
         {
            fRetVal = pButton->ID()==IDOK ? TRUE : FALSE;
            fDone = TRUE;
         }
      }
   }

   aMouse.ShowCursor( Mouse::CursorHide );
   return fRetVal;
}

      
