// mouse.cpp
// einfache mouse-interface funktionen fuer die Dialogbox
// update: 1.00 29-Apr-93 tw

#include <graph.h>
#include <dos.h>
#include <afxcoll.h>  
#include <malloc.h>
#include "dlgbox.h"
#include "dlgbox.inl"
#include "mouse.h"

/* static */ int Mouse::m_cInstances = 0;


Mouse::Mouse()  
{         
   //   if not already done
   if ( ! m_cInstances )
   {
      union _REGS in;
      union _REGS out;
      in.x.ax = Mouse::Init;         
      _int86( MouseDrvInterrupt, &in, &out );
   }
   m_cInstances++;      
}  

Mouse::~Mouse() 
{
#pragma message ("Mouse Destruktor noch implementieren")
   // m_cInstances--;
   // An dieser Stelle sollte man u.u. noch den
   // Maustreiber deinitialisieren, falls keine
   // Instanz von Mouse mehr vorhanden ist...
}
   
void 
Mouse::ShowCursor( const int MouseDrvCursorStatus ) const
{
   union _REGS in;
   union _REGS out;
   in.x.ax = MouseDrvCursorStatus;
   _int86( MouseDrvInterrupt, &in, &out );
}

BOOL 
Mouse::ButtonPressed()
{
   union _REGS in, out;
   in.x.ax = Mouse::GetState;
   _int86( MouseDrvInterrupt, &in, &out );
   if (out.x.bx & MouseDrvBtnPressed)
   {  
      m_xLastPressed = out.x.cx;         
      m_yLastPressed = out.x.dx;
      return TRUE;

   }
   else
   {
      return FALSE;
   }
}

void 
Mouse::WaitForBtnRelease() const
{
   BOOL fDoneWaitRelease = FALSE;
   union _REGS inWaitRelease;
   union _REGS outWaitRelease;
   inWaitRelease.x.ax = Mouse::GetState;

   while( ! fDoneWaitRelease )
   {
      _int86( MouseDrvInterrupt, &inWaitRelease, &outWaitRelease );
      if ( ! ( outWaitRelease.x.bx & MouseDrvBtnPressed ) )
         fDoneWaitRelease = TRUE;
   }
}  
