(* ====================================================== *)
(*                       APFEL.PAS                        *)
(*              Copyright (C) 1993 toolbox                *)
(*          Compiler: Borland/Turbo Pascal 7.0            *)
(* ====================================================== *)
{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y-}
{$M 16384,0,655360}

PROGRAM Apfelmaennchen;

USES
  Crt, Dos, Graph;

VAR
  RealStep, ImagStep,
  RealPart, ImagPart,
  zr, zs, ImagSqr       : Single;
  XAsp, YAsp            : WORD;
  MaxX, MaxY,
  MaxC, CStep,
  Test, x, y,
  GraphDriver, GraphMode,
  Color, Mag            : INTEGER;

CONST
  RealStart  : Single  = -2.267;
  RealEnd    : Single  =  1.125;
  ImagStart  : Single  = -1.125;
  MaxInter   : INTEGER = 320;

FUNCTION Iterate(re, im: SINGLE): INTEGER;
VAR
  x, y,
  x2, y2 : Single;
  k      : INTEGER;
BEGIN
  x  := 0;
  y  := 0;
  x2 := y;
  y2 := 0;
  k  := 0;
  REPEAT
    y  := 2 * x * y + im;
    x  := x2 - y2 + re;
    x2 := Sqr(x);
    y2 := Sqr(y);
    Inc (k);
  UNTIL (x2 + y2 > 4) OR (k >= MaxInter);
  Iterate := k;
END;

BEGIN
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  IF GraphResult = grOk THEN BEGIN
    Mag := 1;
    IF ParamCount > 0 THEN BEGIN
      Val(ParamStr(1), Mag, Test);
      IF (Test = 0) OR (Mag < 1) THEN Mag := 1;
    END;
    GetAspectRatio(XAsp, YAsp);
    MaxX     := GetMaxX;
    MaxY     := GetMaxY;
    MaxC     := GetMaxColor + 1;
    CStep    := MaxInter DIV MaxC;
    RealStep := (RealEnd - RealStart) / MaxX;
    ImagStep := RealStep * YAsp / XAsp;
    y        := 0;
    ImagPart := ImagStart;
    WHILE y <= MaxY DO BEGIN
      RealPart := RealStart;
      ImagSqr := Sqr(ImagPart);
      x := 0;
      WHILE x <= MaxX DO BEGIN
        zr := Sqr(RealPart) + ImagSqr;
        zs := Sqrt(zr - 0.5 * RealPart + 0.0625);
        IF (16 * zr * zs > 5 * zs - 4 * RealPart + 1) AND
           (Sqr(RealPart+1) + ImagSqr > 0.0625) THEN
          Color := Iterate(RealPart, ImagPart)
        ELSE
          Color := MaxInter;
        PutPixel(x, y, MaxC * CStep - Color);
        Inc(x, Mag);
        RealPart := RealPart + RealStep * Mag;
      END;
      IF KeyPressed THEN
        IF ReadKey = #27 THEN BEGIN
          CloseGraph; Halt;
      END;
      Inc(y, Mag);
      ImagPart := ImagPart + ImagStep * Mag;
    END;
    Write(^G);
    ReadKey;
    CloseGraph;
  END ELSE
    WriteLn('Fehler bei der Initialisierung der Grafik!');
END.

(* ====================================================== *)
(*                 Ende von APFEL.PAS                     *)
