(* ====================================================== *)
(*                      FEIGBAUM.PAS                      *)
(*             Copyright (C) 1993 toolbox                 *)
(*         Compiler: Turbo/Borland Pascal 7.0             *)
(* ====================================================== *)
{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}

PROGRAM FeigenBaum;

USES
  Crt, Dos, Graph;

VAR
  MaxX,
  MaxY:        integer;

FUNCTION Calculate(population, kopplung: DOUBLE): DOUBLE;
BEGIN
  Calculate := population + kopplung *
               population * (1 - population);
END;

PROCEDURE Plot(xkoo, ykoo, left,
               right, bottom, top: DOUBLE);
BEGIN
  Putpixel(ROUND(MaxX * (xkoo - left) / (right - left)),
           ROUND(MaxY * (ykoo - top) / (bottom - top)), 7);
END;

VAR
  GraphDriver,
  GraphMode      : INTEGER;
  population,
  left, right,
  bottom, top,
  delta,
  kopplung       :       DOUBLE;
  invisible,
  visible,
  i, j           : INTEGER;

BEGIN
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  MaxX      := GetMaxX;
  MaxY      := GetMaxY;
  left      := 1.8;
  right     := 3.0;
  bottom    := 1.5;
  top       := 0;
  invisible := 50;
  visible   := 50;
  SettextStyle(0,0,1);
  OutTextXY(10, GetMaxY - TextHeight('Pp'),
            'Funktion: f(p) = p + k * p * (1 - p)');
  delta := (right - left) / MaxX;
  FOR i := 0 TO MaxX DO BEGIN
    kopplung   := left + i * delta;
    population := 0.3;
    FOR j := 1 TO invisible DO
      population := Calculate(population,kopplung);
    FOR j := 1 TO visible DO BEGIN
      Plot(kopplung, population, left, right, top, bottom);
      population := Calculate(population, kopplung);
    END;
  END;
  ReadKey;
  CloseGraph;
END.

(* ====================================================== *)
(*                  Ende von FEIGBAUM.PAS                 *)
