(* ====================================================== *)
(*                        HUEPFER.PAS                     *)
(*          Copyright (C) 1990, 1993, 1994 toolbox        *)
(* ====================================================== *)
{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}
PROGRAM Huepfer;
USES
  Crt, Dos, Graph;

FUNCTION Sign(VAR x: Double): INTEGER;
BEGIN
  IF x < 0 THEN Sign := -1 ELSE Sign := 1;
END;

VAR
  XCtr, YCtr, Iterations,
  GraphDriver, GraphMode , i,
  test, Version, Col, MaxCol : INTEGER;
  a, b, c, x, y, xHelp       : Double;
  ch                         : CHAR;

FUNCTION NumStr(Num: Double): STRING;
VAR
  s: STRING;
BEGIN
  Str(num:10:10, s);
  (*  Fhrende Leerstellen abtrennen:        *)
  WHILE s[1] = ' ' DO Delete(s, 1, 1);
  (*  Nachlaufende Nullen abschneiden:       *)
  WHILE s[Byte(s[0])] = '0' DO Dec(s[0]);
  (*  Evtl. berflssigen Punkt abschneiden: *)
  IF s[Byte(s[0])] = '.' THEN Dec(s[0]);
  NumStr := s;
END;

PROCEDURE Paint;
VAR
  c: INTEGER;
BEGIN
  Randomize;
  c := Random(Col) + 1;
  PutPixel(Round(x) + XCtr, Round(y) + YCtr, c);
END;

BEGIN
  Iterations := 20000;
  ClrScr;
  WriteLn('Das Programm arbeitet in vier Varianten,');
  Write('whlen Sie [1..4]: ');
  REPEAT
    ch := ReadKey;
  UNTIL ch IN ['1'..'4'];
  WriteLn(ch, ^J);

  Write('Erste  Konstante:  '); ReadLn(a);
  Write('Zweite Konstante:  '); ReadLn(b);
  Write('Dritte Konstante:  '); ReadLn(c);
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  XCtr   := GetMaxX DIV 2;
  YCtr   := GetMaxY DIV 2;
  Col    := GetMaxColor;
  MaxCol := Col;
  x      := 0;
  y      := 0;
  OutTextXY(10, GetMaxY - 10, 'Hpfer Variante ' + ch +
                ' mit a = ' + NumStr(a) + ', b = ' +
                NumStr(b) + ', c = ' + NumStr(c) + '.' );
  CASE ch OF
    '1': FOR i := 1 TO Iterations DO BEGIN
           Paint;
           xHelp := y - Sign(x) * Sqrt(Abs(b * x - c));
           y := a - x;
           x := xHelp;
           Col := Round(x) MOD MaxCol;
           IF Col = 0 THEN Inc(Col);
         END;
    '2': FOR i := 1 TO Iterations DO BEGIN
           Paint;
           xHelp := y - Sign(x) * Sqrt(Abs(b * c - x));
           y := a - x;
           x := xHelp;
           Col := Round(x) MOD MaxCol;
           IF Col = 0 THEN Inc(Col);
         END;
    '3': FOR i := 1 TO Iterations DO BEGIN
           Paint;
           xHelp := y - Sign(x) * Cos(b * x - c);
           y := a - x;
           x := xHelp;
           Col := Round(x) * Round(y) MOD MaxCol;
           IF Col = 0 THEN Inc(Col);
         END;
    '4': FOR i := 1 TO Iterations DO BEGIN
           Paint;
           xHelp := y - b * Sin(c * x);
           y     := a - x;
           x     := xHelp;
           Col   := Round(x - y) MOD MaxCol;
           IF Col = 0 THEN Inc(Col);
         END;
  END;
  Write(^G);
  ReadKey;
  CloseGraph;
END.

(* ====================================================== *)
(*                     Ende von HUEPFER.PAS               *)

