(* ====================================================== *)
(*                      KRISTALL.PAS                      *)
(*            Copyright (C) 1989, 1993 toolbox            *)
(*           Compiler: Turbo/Borland Pascal 7.0           *)
(*      Modula-Version von M. Uphoff in toolbox 9'89      *)
(* ====================================================== *)
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-}
{$M $FFF1,0,$FFFF}

PROGRAM Kristall;

USES
  Crt, Dos, Graph;

VAR
  ColTab                    : ARRAY[0..3] OF WORD;
  Generator,  xm, ym, Param : INTEGER;
  Standard                  : BOOLEAN;

PROCEDURE PlotDots(xPos, yPos, Color: INTEGER);
VAR
  i: INTEGER;
BEGIN
  IF Standard THEN FOR i := 1 TO Param DO BEGIN
    PutPixel(xm + xPos + i - 1, ym + yPos + i - 1, Color);
    PutPixel(xm - xPos - i + 1, ym + yPos + i - 1, Color);
    PutPixel(xm + xPos + i - 1, ym - yPos - i + 1, Color);
    PutPixel(xm - xPos - i + 1, ym - yPos - i + 1, Color);
    IF Param <> 1 THEN BEGIN
      PutPixel(xm - xPos - i + 1, ym + yPos - i + 1, Color);
      PutPixel(xm + xPos + i - 1, ym + yPos - i + 1, Color);
      PutPixel(xm - xPos - i + 1, ym - yPos + i - 1, Color);
      PutPixel(xm + xPos + i - 1, ym - yPos + i - 1, Color);
    END;
  END ELSE BEGIN
    PutPixel(xm + xPos{+2}, ym + yPos{+2}, Color);
    PutPixel(xm - xPos - 2, ym + yPos{+2}, Color);
    PutPixel(xm + xPos{+2}, ym - yPos - 2, Color);
    PutPixel(xm - xPos - 2, ym - yPos - 2, Color);
  END;
END;

FUNCTION Neighbours(xPos, yPos, Color: INTEGER): INTEGER;
VAR
  num: INTEGER;
BEGIN
  num  := 0;
  xPos := xm + xPos;
  yPos := ym + yPos;
  IF GetPixel(xPos, yPos - Param) = Color THEN Inc(num);
  IF GetPixel(xPos, yPos + Param) = Color THEN Inc(num);
  IF GetPixel(xPos + Param, yPos) = Color THEN Inc(num);
  IF GetPixel(xPos - Param, yPos) = Color THEN Inc(num);
  Neighbours := num;
END;

PROCEDURE SetDot;
VAR
  xPos, yPos, i: INTEGER;
BEGIN
  FOR i := 0 TO Generator DO
    FOR xPos := 0 TO i DO BEGIN
      yPos := i - xPos;
      IF GetPixel(xm + xPos, ym + yPos) = 0 THEN
        IF Neighbours(xPos, yPos, ColTab[1]) = 1 THEN
          PlotDots(xPos, yPos, ColTab[0]);
    END;
END;

PROCEDURE EraseDot;
VAR
  xPos, yPos, i: INTEGER;
BEGIN
  FOR i := Generator DOWNTO 0 DO
    FOR xPos := 0 TO i DO BEGIN
      yPos := i - xPos;
      IF GetPixel(xm + xPos, ym + yPos) = ColTab[2] THEN
        PlotDots(xPos, yPos, 0);
    END;
END;

VAR
  GraphDriver, GraphMode: INTEGER;

BEGIN
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  SetBkColor(EGABlue);
  ClearDevice;
  IF GraphResult = grOk THEN BEGIN
    xm          := (GetMaxX + 1) DIV 2;
    ym          := (GetMaxY + 1) DIV 2;
    ColTab[3]   := 0;
    ColTab[0]   := LightGreen;
    ColTab[1]   := LightRed;
    ColTab[2]   := Yellow;
    Standard    := TRUE;
    PutPixel(xm, ym, ColTab[0]);
    IF ParamCount = 0 THEN Param := 1
    ELSE BEGIN
      Val(ParamStr(1), Param, Generator);
      IF (Generator <> 0) THEN Param := 1;
      IF Param = 0 THEN BEGIN
        Standard := FALSE;
        Param    := 1;
      END;
      Param := Abs(Param);
    END;
    Generator := 0;
    REPEAT
      ColTab[3] := ColTab[2];
      ColTab[2] := ColTab[1];
      ColTab[1] := ColTab[0];
      ColTab[0] := ColTab[3];
      IF Generator < (ym - Param) THEN
        Inc(Generator, Param);
      SetDot;
      EraseDot;
    UNTIL KeyPressed;
    CloseGraph;
  END ELSE
    WriteLn('Fehler bei der Initialisierung der Grafik!');
END.

(* ====================================================== *)
(*                 Ende von KRISTALL.PAS                  *)
