(* ====================================================== *)
(*                       MANDALA.PAS                      *)
(*         Copyright (C) 1991, 1993, 1994 toolbox         *)
(*           Compiler: Turbo/Borland Pascal 7.0           *)
(* ====================================================== *)
{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}

PROGRAM Mandala;

USES
  Crt, Dos, Graph, PCXTools;

VAR
  PCXFileName : PathStr;
  GraphDriver,
  GraphMode   : INTEGER;

PROCEDURE SavePicture;
VAR
  Dir  : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
BEGIN
  PCXTools.XMin   := 0;
  PCXTools.XMax   := GetMaxX;
  PCXTools.YMin   := 0;
  PCXTools.YMax   := GetMaxY;
  PCXTools.Screen := 0;
  PCXTools.Col    := GetMaxColor;
  FSplit(PCXFileName, Dir, Name, Ext);
  IF Ext = '' THEN PCXFileName := PCXFileName + '.PCX';
  BGItoPCX(GraphDriver, GraphMode, PCXFileName);
END;

FUNCTION CoTan(VAR x: Double): Double;
VAR
  h: Double;
BEGIN
  h := cos(x);
  IF h = 0 THEN
    CoTan := 0
  ELSE BEGIN
    h := sin(x) / h;
    IF h = 0 THEN CoTan := MaxLongInt * 1.5
             ELSE CoTan := 1 / (sin(x) / cos(x));
  END;
END;

VAR
 XCtr, YCtr            : INTEGER;
 x, y, Color           : INTEGER;
 Param                 : ARRAY[1..4] OF Double;
 xs, ph, px            : Double;

BEGIN
  IF ParamCount > 0 THEN PCXFileName := ParamStr(1)
                    ELSE PCXFileName := 'MANDALA.PCX';
{$IFDEF SuperVGA}
  GraphDriver := InstallUserDriver('SVGA', NIL);
  GraphMode := 0;
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  IF GraphResult <> 0 THEN {$ENDIF} BEGIN
    DetectGraph(GraphDriver, GraphMode);
    InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  END;
  SetBKColor(GetMaxColor);
  ClearViewPort;
  XCtr := GetMaxX DIV 2;
  YCtr := GetMaxY DIV 2;
  Randomize;
  Param[1] := Random(GetMaxX) / Pi;   (* Alle vier        *)
  Param[2] := Random + 1.0;           (* Parameter per    *)
  Param[3] := Random(GetMaxY);        (* Zufallsgenerator *)
  Param[4] := Random;                 (* generieren       *)
  FOR y := 0 TO YCtr + 1 DO BEGIN
    FOR x := 0 TO XCtr + 1 DO BEGIN
      px    := (Param[2] * ((x+0.1) / Param[1]) + Param[4]);
      ph    := CoTan(px);
      Color := GetMaxColor - (Round(Abs(Param[3] * ph)) )
               MOD GetMaxColor;
      PutPixel(XCtr + x, YCtr + y, Color);     (* 4 Pixel *)
      PutPixel(XCtr + x, YCtr - y, Color);     (* setzen  *)
      PutPixel(XCtr - x, YCtr + y, Color);
      PutPixel(XCtr - x, YCtr - y, Color);
    END;
    Param[2] := Param[2] - 0.01;
    Param[3] := Param[3] - 1.00;
    Param[4] := Param[4] + 0.04;
    IF KeyPressed THEN IF ReadKey = #27 THEN BEGIN
      Write(^G);
      CloseGraph;
      Halt;
    END;
  END;
  IF GraphDriver <= VGA THEN SavePicture;
  Write(^G);
  ReadKey;
  CloseGraph;
END.

(* ====================================================== *)
(*                   Ende von MANDALA.PAS                 *)
