(* ====================================================== *)
(*                      MANDEL.PAS                        *)
(*          Erzeugt MANDEL.BIN fr JULIA.PAS              *)
(*         Compiler: Turbo/Borland Pascal 7.0             *)
(* ====================================================== *)
(* Die von diesem Programm erzeigte Datei mandel.bin    *)
(* mu fr julia.pas mit BINOBJ konvertiert werden:     *)
(* BINOBJ MANDEL MANDEL MandelPicProc                     *)
(* ====================================================== *)
{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}
PROGRAM GenerateMandel;

USES
  Dos, Crt, Graph;

CONST
  FSize : LongInt = 0;

VAR
  a, b, x, y, z          : Double;
  f                      : File OF INTEGER;
  GraphDriver, GraphMode,
  MaxX, MaxY, CtrX, CtrY,
  i, j, k, u, v          : INTEGER;
  FSizeRec               : RECORD
                             Lo, Hi: INTEGER;
                           END ABSOLUTE FSize;
BEGIN
  DirectVideo := TRUE;
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  IF GraphResult = grOk THEN BEGIN
    MaxX := GetMaxX;
    MaxY := GetMaxY;
    SetColor(GetMaxColor);
    Assign(f, 'MANDEL.BIN');
    Rewrite(f);
    Write(f, MaxX, MaxY);
    Write(f, FSizeRec.Lo);            (* Platz freihalten *)
    CtrX := MaxX DIV 2;
    CtrY := MaxY DIV 2;
    SetTextStyle(DefaultFont, HorizDir, 1);
    OutTextXY(0, 0, 'Bitte warten');
    FOR j := -CtrX TO CtrX DO BEGIN
      a := j * 1.6 / CtrX;
      FOR k := 0 TO CtrY DO BEGIN
        b := k * 1.2 / CtrY;
        x := 0;  y := 0; i := 0;
        WHILE (i < 100) AND ((x * x + y * y) < 4) DO BEGIN
          z := x * x - y * y + a;
          y := 2 * x * y + b;
          x := z;
          Inc(i);
        END;
        IF (i >= 20) AND (i < 100) THEN BEGIN
          u := j + CtrX;
          v := k + CtrY;
          Write(f, u, v);
          PutPixel(u, v, GetMaxColor);
          PutPixel(u, CtrY - k, GetMaxColor);
        END;
      END;
    END;
    FSize := FileSize(f);
    Seek(f, 2);            (* dritter Record in der Datei *)
    Write(f, Integer(FSizeRec.Lo));
    Close(f);
    Write(^G);
    CloseGraph;
  END ELSE WriteLn('Grafik-Initialisierungsfehler!');
END.

(* ====================================================== *)
(*                    Ende von MANDEL.PAS                 *)
