(* ====================================================== *)
(*                      SPIRALE.PAS                       *)
(*               Copyright (C) 1993 toolbox               *)
(*           Compiler: Turbo/Borland Pascal 7.0           *)
(* ====================================================== *)
{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}

PROGRAM Spirale;

USES
  Dos, Crt, Graph;

VAR
  MaxColor    : INTEGER;
  i, x, y     : WORD;
  c           : BYTE;
  r           : Double;
  Pal         : PaletteType;
  col0        : ShortInt;
  GraphDriver,
  GraphMode   : INTEGER;

BEGIN
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  IF GraphResult = grOk THEN BEGIN
    DirectVideo := FALSE;
    MaxColor    := GetMaxColor;
    c := 0;
    FOR i := 0 TO 700 DO BEGIN
      c := (c + 1) MOD MaxColor + 1;
      IF c = 0 THEN c := 1;
      r := i / 10;
      x := Trunc(r * Cos(r) * 3) + (GetMaxX + 1) DIV 2;
      y := Trunc(r * Sin(r) * 3) + (GetMaxY + 1) DIV 2;
      SetFillStyle(SolidFill, c);
      Bar(x, y, x + 16, y + 16);
      Delay(10);
    END;
    GetDefaultPalette(pal);
    REPEAT
      col0 := Pal.Colors[MaxColor + 1];
      FOR i := MaxColor DOWNTO 1 DO BEGIN
        IF MaxColor < 16 THEN Delay(10);
        Pal.Colors[Succ(i)] := Pal.Colors[i];
      END;
      Pal.Colors[1] := col0;
      SetAllPalette(Pal);
    UNTIL KeyPressed;
    ReadKey;
    CloseGraph;
  END ELSE WriteLn('Grafik-Initialisierungsfehler!');
END.

(* ====================================================== *)
(*                   Ende von SPIRALE.PAS                 *)
