(* ====================================================== *)
(*                        TRIANGEL.PAS                    *)
(*                Copyright (C) 1993 toolbox              *)
(*           Compiler: Turbo/Borland Pascal 7.0           *)
(* ====================================================== *)
{$A+,B-,D+,E-,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}
PROGRAM Sierpinsky;

USES
  Crt, Dos, Graph;

TYPE
  tLine = ARRAY[0..479] OF INTEGER;

VAR
  r1, r2      : tLine;
  MaxX, MaxY,
  XPos, YPos,
  Divisor     : INTEGER;
  GraphDriver,
  GraphMode   : INTEGER;

BEGIN
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, GetEnv('BGIPATH'));
  IF GraphResult = grOk THEN BEGIN
    MaxX := GetMaxX + 1;
    MaxY := GetMaxY + 1;
    REPEAT
      ClearDevice;
      DirectVideo := FALSE;
      GotoXY(1, 1);
      Write(' Bitte den Divisor eingeben (Integerzahl): ');
      ReadLn(Divisor);
      ClearDevice;
      DirectVideo := TRUE;
      IF Divisor > 0 THEN BEGIN
        CheckBreak := FALSE;
        FOR XPos := 1 TO MaxY DO r1[XPos] := 1;
        r2[0] := Blue;
        FOR YPos := 1 TO MaxY DO
          FOR XPos := 1 TO (MaxX DIV 4) DO BEGIN
            r2[XPos] := (r2[XPos - 1] +
                           r1[XPos]) MOD Divisor;
            r1[XPos] := r2[XPos];
            IF r2[XPos] = 0 THEN BEGIN
              PutPixel(XPos * 2 + (GetMaxX DIV 4),
                       YPos - 1, Blue);
              PutPixel(XPos * 2 + (GetMaxX DIV 4) + 1,
                       YPos - 1, Cyan)
            END;
          END;
        ReadKey;
      END;
    UNTIL Divisor < 1;
    CloseGraph;
  END ELSE
    Write('Fehler bei der Initialisierung der Grafik');
END.

(* ====================================================== *)
(*                 Ende von TRIANGEL.PAS                  *)
