(*========================================================*)
(*                        RTFGEN.PAS                      *)
(*     (C) 1992 Dave Baldwin, CompuServe ID #76327,53     *)
(*       Compiler: Borland Pascal 7.0, Windows Target     *)
{*      Verndert fr Turbo Pascal r Window 1.5 1993     *}
(*========================================================*)
{$A+,B-,D-,F-,G+,I-,N-,R-,S-,V-,W+,X+}
UNIT RTFGen;

INTERFACE

PROCEDURE DoIt(who : STRING);

IMPLEMENTATION

USES
  WinTypes, WinProcs, Strings;

CONST
  TwipsPerSpace                = 120;
  DefaultFont     : STRING[6]  = '2';
  DefaultFontSize : STRING[10] = '20';
  ParaChar        : CHAR       = '`';
  Tokenleng                    = 28;
  Tab                          = #9;
  MaxRes                       = 13;
TYPE
  Symb = (
    OtherChar, Comma, Colon, SemiColon, LBrack, RBrack,
    Dot, Slash, LlBrack, RrBrack, OtherPunct, Ident, EolSy,
    Space, ParaSy, TabSy, BuildTagSy, TopicSy, TitleSy,
    KeyWordSy, BrowseSy, TopicStart, TopicEnd, DocStartSy,
    DocEndSy, CommandSy, BMCSy, BMLSy, BMRSy, FontCommand,
    Number, BlockStartSy, BlockEndSy);
  SymString = STRING[14];

VAR
  Sy, SaveSy : Symb;

CONST
  ResWord : ARRAY[1..MaxRes] OF SymString = (
    '\buildtag', '\topic', '\title', '\keyword', '\browse',
    '\bmc', '\bml', '\bmr', '\docstart', '\docend', '\tab',
    '\blockstart', '\blockend');
  ResSy : ARRAY[1..MaxRes] OF Symb = (
    BuildTagSy, TopicSy, TitleSy, KeyWordSy, BrowseSy,
    BMCSy, BMLSy, BMRSy, DocStartSy, DocEndSy, TabSy,
    BlockStartSy, BlockEndSy);

TYPE
  TokenString = STRING[Tokenleng];
  String127   = STRING[127];
  Filestring  = STRING[64];
  PairType    = ARRAY[0..1] OF CHAR;

VAR
  BrackCount, LineNo, Chi, ErrCount: INTEGER;
  Pair                             : WORD;
  Spair                            : PairType ABSOLUTE Pair;
  LCh                              : CHAR ABSOLUTE Pair;
  UCh                              : CHAR;
  St                               : String127;
  ErrFlag, EofInf,
  InInclude, InTopic               : BOOLEAN;
  SourceName                       : Filestring;
  IncF, Inf, OutF, HpjF            : Text;
  InBuff, OutBuff                  : ARRAY[1..1000] OF CHAR;
  VALUE                            : LongInt;
  LcToken                          : TokenString;
  OutString, GlobalHeader,
  TopicHeader                      : STRING;
  BlockHeader                      : ARRAY[1..4] OF STRING;
  BIndex                           : INTEGER;
  IncFileName                      : STRING;
  IncCounter                       : INTEGER;

PROCEDURE Error(ii : INTEGER; s : String127);
VAR
  NewS      : String127;
  TempS     : STRING;
  ErrorTemp : ARRAY[0..256] OF CHAR;
BEGIN
  TempS := s;
  Str(LineNo, NewS);
  NewS  := NewS + ' Error';
  TempS := NewS + ' ' + TempS;
  IF s[0] > #0  THEN NewS := NewS + ', ' + s;
  StrPCopy(ErrorTemp, TempS);
  MessageBox(0, ErrorTemp, 'Error', mb_OK);
  ErrCount := Succ(ErrCount);
  IF ErrCount > 6 THEN BEGIN
    MessageBox(0, 'Too many Errors', 'Error', mb_OK);
    Halt;
  END;
  ErrFlag := TRUE;
END;

FUNCTION Positn(Pat, Src : STRING; i : INTEGER) : INTEGER;
VAR
  n : INTEGER;
BEGIN
  IF i < 1 THEN i := 1;
  Delete(Src, 1, i - 1);
  n := Pos(Pat, Src);
  IF n = 0 THEN Positn := 0 ELSE Positn := n + i - 1;
END;

PROCEDURE OutFile(s : STRING);
VAR
  WriteIt : BOOLEAN;
  Leng, i : INTEGER;
BEGIN
  i := 0;
  REPEAT
    i := Positn('{', s, i + 1);
    IF (i > 0) THEN
      IF NOT ((i > 1) AND (s[i - 1] = '\')) THEN
        Inc(BrackCount);
  UNTIL i = 0;
  REPEAT
    i := Positn('}', s, i + 1);
    IF (i > 0) THEN
      IF NOT ((i > 1) AND (s[i - 1] = '\')) THEN
        Dec(BrackCount);
  UNTIL i = 0;

  Leng := Length(OutString)+Length(s);
  WriteIt := (Leng >= 75) AND
             (OutString[Length(OutString)] <> ' ') OR
             (Leng >= 200);
  IF WriteIt THEN BEGIN
    WriteLn(OutF, OutString);
    OutString := s;
  END ELSE OutString := OutString+s;
END;

PROCEDURE Flush;
BEGIN
  IF Length(OutString) > 0 THEN BEGIN
    WriteLn(OutF, OutString);
    OutString := '';
  END;
END;

PROCEDURE GetCh;
VAR
  Comment : BOOLEAN;

  PROCEDURE GetchBasic;
  BEGIN
    IF Chi <= Ord(St[0]) THEN BEGIN
      Pair := MemW[DSeg : Ofs(St[Chi])];
      IF (LCh = Tab) AND NOT InTopic THEN LCh := ' ';
      UCh := UpCase(LCh);
      Chi := Chi + 1;
    END ELSE IF NOT EoF(Inf) THEN BEGIN
      ReadLn(Inf, St);
      Inc(LineNo);
      St  := St + ^M;
      Chi := 1;
      GetCh;
    END ELSE BEGIN
      EofInf:=TRUE;
      IF Comment THEN BEGIN
        MessageBox(0, 'Open Comment at End of Input File',
                      'Error', mb_OK);
        Halt;
      END;
    END;
  END;

BEGIN
  REPEAT
    IF EofInf THEN BEGIN
      MessageBox(0, 'Unexpected End of Input File',
                    'Error', mb_OK);
      Halt;
    END;
    Comment := FALSE;
    GetchBasic;
    IF (Spair = '(*') THEN BEGIN
      Comment := TRUE;
      REPEAT
        GetchBasic;
      UNTIL Spair = '*)';
      GetchBasic;
    END;
  UNTIL NOT Comment;
END;

FUNCTION IsPair : BOOLEAN;
CONST
  Limit = 8;
  pa : ARRAY[1..Limit] OF PairType = (
     '[[', ']]', '\[', '\]', '\\', '\`', '\{', '\}');
VAR
  i   : INTEGER;
  was : PairType;
BEGIN
  IsPair := FALSE;
  FOR i := 1 TO Limit DO IF pa[i] = Spair THEN BEGIN
    was    := Spair;
    Sy     := OtherPunct;
    IsPair := TRUE;
    GetCh;
    CASE i OF
      5, 7, 8 : LcToken := was;
      1       : Sy      := LlBrack;
      2       : Sy      := RrBrack;
      ELSE      LcToken := LCh;
    END;
    GetCh;
    Exit;
  END;
END;

FUNCTION GetNumber : BOOLEAN;
VAR
  Done : BOOLEAN;
  Code : INTEGER;
BEGIN
  CASE UCh OF
    '0' .. '9' : LcToken := '';
    ELSE         GetNumber := FALSE; Exit;
  END;
  GetNumber := TRUE;
  Sy        := Number;
  Done      := FALSE;
  IF NOT EofInf THEN
    WHILE NOT Done DO
      CASE UCh OF
        '0'..'9' : BEGIN
                     LcToken := LcToken+UCh;
                     GetCh;
                   END;
        ELSE       Done := TRUE;
      END;

  Val(LcToken, VALUE, Code);
END;

FUNCTION GetCommand : BOOLEAN;
LABEL
  _Next;
CONST
  MaxFC = 10;
  FontCommands : ARRAY[1..MaxFC] OF STRING[6] =
    ('f', 'fs', 'b', 'i', 'strike', 'ul', 'ulw', 'uld',
     'uldb', 'plain');
VAR
  Done      : BOOLEAN;
  i         : INTEGER;
  AlphaOnly : TokenString;
BEGIN
  GetCommand := FALSE;
  IF UCh <> '\' THEN Exit;
  GetCommand := TRUE;
  Sy         := CommandSy;
  LcToken    := LCh;
  AlphaOnly  := '';
  GetCh;
  Done       := FALSE;
  IF NOT EofInf THEN BEGIN
    WHILE NOT Done DO
      CASE LCh OF
        'a'..'z' : BEGIN
                     IF Length(LcToken)<Tokenleng THEN BEGIN
                       Inc(LcToken[0]);
                       LcToken[Length(LcToken)] := LCh;
                       Inc(AlphaOnly[0]);
                       AlphaOnly[Length(AlphaOnly)] := LCh;
                     END;
                     GetCh;
                   END;
        ELSE       Done := TRUE;
      END;
    IF LCh = '-' THEN BEGIN
      IF Length(LcToken) < Tokenleng THEN BEGIN
        Inc(LcToken[0]);
        LcToken[Length(LcToken)] := LCh;
      END;
      GetCh;
    END;
    Done := FALSE;
    WHILE NOT Done DO
      CASE LCh OF
        '0'..'9' : BEGIN
                     IF Length(LcToken)<Tokenleng THEN BEGIN
                       Inc(LcToken[0]);
                       LcToken[Length(LcToken)] := LCh;
                     END;
                     GetCh;
                   END;
      ELSE         Done := TRUE;
    END;
  END;

  FOR i := 1 TO MaxRes DO
    IF LcToken = ResWord[i] THEN BEGIN
      Sy := ResSy[i];
      GOTO _Next;
    END;

  IF NOT InTopic THEN FOR i := 1 TO MaxFC DO
    IF AlphaOnly = FontCommands[i] THEN BEGIN
      Sy := FontCommand;
      GOTO _Next;
    END;
_Next:

  IF Length(LcToken) < Tokenleng THEN BEGIN
    Inc(LcToken[0]);
    LcToken[Length(LcToken)] := ' ';
  END;
  IF UCh = ' ' THEN GetCh;
END;

FUNCTION GetIdent : BOOLEAN;
VAR
  Done : BOOLEAN;
  i    : INTEGER;
BEGIN
  GetIdent := FALSE;
  CASE UCh OF
    'A'..'Z', '_' : {nothing};
    ELSE            Exit;
  END;
  GetIdent := TRUE;
  Sy       := Ident;
  LcToken  := LCh;
  GetCh;
  Done     := FALSE;
  IF NOT EofInf THEN WHILE NOT Done DO
    CASE UCh OF
      'A'..'Z',
      '0'..'9',
      '_'     : BEGIN
                  IF Length(LcToken) < Tokenleng THEN BEGIN
                    Inc(LcToken[0]);
                    LcToken[Length(LcToken)] := LCh;
                  END;
                  GetCh;
                END;
      ELSE      Done := TRUE;
  END;
END;

FUNCTION GetTopicEnd : BOOLEAN;
BEGIN
  GetTopicEnd := FALSE;
  IF UCh <> #45 THEN Exit;
  IF Pos(#45#45#45#45, St) <> 1 THEN Exit;
  Chi := Length(St) + 1;
  IF NOT EofInf THEN GetCh;
  GetTopicEnd := TRUE;
  IF NOT InTopic THEN
    Error(Chi, #45#45#45#45' when not within topic');
  Sy := TopicEnd;
END;

FUNCTION GetTopicStart : BOOLEAN;
BEGIN
  GetTopicStart := FALSE;
  IF UCh <> '=' THEN Exit;
  IF Pos('====', St) <> 1 THEN Exit;
  Chi := Length(St) + 1;
  IF NOT EofInf THEN GetCh;
  GetTopicStart := TRUE;
  IF InTopic THEN
    Error(Chi, '==== when already within topic');
  Sy := TopicStart;
END;

FUNCTION Punctuation : BOOLEAN;
CONST
  Punct   : STRING[10] = ^M^I' :;[].';
  SyArray : ARRAY[1..8] OF Symb =
                (EolSy, TabSy, Space, Colon,
                 SemiColon, LBrack, RBrack, Dot);
VAR
  i : INTEGER;
BEGIN
  Punctuation := FALSE;
  i           := Pos(UCh, Punct);
  CASE i OF
    1..8: Sy   := SyArray[i];
    ELSE  IF UCh = ParaChar THEN Sy := ParaSy
                            ELSE Exit;
  END;
  Punctuation := TRUE;
  CASE Sy OF
    EolSy  : LcToken := ' ';
    ParaSy : LcToken := '';
    TabSy  : LcToken := '\tab ';
    ELSE     LcToken := LCh;
  END;
  GetCh;
END;

PROCEDURE Next; (* Gendert zur Vertrglichkeit mit HC 31 *)
CONST           (* Dieter Wagner, 19.9.93                 *)
  Hex : STRING [16] = '0123456789ABCDEF';

BEGIN
  IF EofInf THEN BEGIN
    MessageBox(0, 'Unexpected end of input file',
               'Error', mb_OK);
    Close(OutF);
    Close(Inf);
    Halt;        (* gendert *)
  END;
  IF IsPair             THEN { do nothing }
  ELSE IF GetCommand    THEN { do nothing }
  ELSE IF GetIdent      THEN { do nothing }
  ELSE IF GetNumber     THEN { do nothing }
  ELSE IF GetTopicEnd   THEN { do nothing }
  ELSE IF GetTopicStart THEN { do nothing }
  ELSE IF Punctuation   THEN { do nothing } ELSE BEGIN
    Sy      := OtherChar;
    (* LcToken := LCh;  gendert *)
    IF Ord(LCh) < $80 THEN    (* zugefgt *)
      LcToken := LCh
    ELSE
      LcToken := '\''' + Hex[(Ord(LCh) DIV 16) + 1] +
                         Hex[(Ord(LCh) MOD 16) + 1];
    IF NOT EofInf THEN GetCh;
  END;
END;

PROCEDURE SkipWhiteSpace;
BEGIN
  WHILE (UCh = ' ') OR (UCh = Tab) DO GetCh;
END;

PROCEDURE ParagraphText;

  PROCEDURE DoBitmap;
  CONST
    FileChars : SET OF CHAR =
         ['A'..'Z', 'a'..'z', '0'..'9', '!',
          '#'..'''', '@', '^'..'`', '~'];
  VAR
    s     : STRING[30];
    Count : INTEGER;
    Temp  : STRING;
  BEGIN
    OutFile('\{');
    CASE Sy OF
      BMCSy : s := 'bmc ';
      BMRSy : s := 'bmr ';
      BMLSy : s := 'bml ';
    END;
    SkipWhiteSpace;
    Count := 0;
    WHILE LCh IN FileChars DO BEGIN
      s := s + LCh;
      GetCh;
      Inc(Count);
    END;
    IF (Count > 8) OR (Count = 0) THEN
      Error(Chi, 'Filename Exp');
    IF LCh = '.' THEN BEGIN
      s := s + LCh;
      GetCh;
      Count  := 0;
      WHILE LCh IN FileChars DO BEGIN
        s := s + LCh;
        GetCh;
        Inc(Count);
      END;
      IF (Count > 3) THEN Error(Chi, 'Filename Exp');
    END;
    Next;
    Temp := Copy(s, 5, Length(s));
    WriteLn(HpjF, Temp);
    OutFile(s + '\}');
  END;

  PROCEDURE CrossRef;
  VAR
    SyWas : Symb;
  BEGIN
    SyWas := Sy;
    IF Sy = LBrack THEN OutFile('{\uldb ')
                   ELSE OutFile('{\ul ');
    SkipWhiteSpace;
    Next;
    CASE Sy OF
      BMCSy,
      BMLSy,
      BMRSy : BEGIN
                DoBitmap;
                WHILE Sy = Space DO Next;
              END;
      ELSE    WHILE (Sy <> Colon) AND (Sy <> EolSy) DO BEGIN
                OutFile(LcToken);
                Next;
              END;
    END;
    OutFile('}');
    IF Sy <> Colon THEN Error(Chi, 'Colon Exp');
    Next;
    WHILE Sy = Space DO Next;
    IF (Sy <> Ident) AND (Sy <> Dot) AND (Sy <> Number) THEN
      Error(Chi, 'Syntax Error in cross reference');
    OutFile('{\v ');
    REPEAT
      OutFile(LcToken);
      Next;
    UNTIL (Sy <> Ident) AND (Sy <> Dot) AND (Sy <> Number);
    OutFile('}');
    WHILE Sy = Space DO Next;
    IF SyWas = LBrack THEN BEGIN
      IF Sy <> RBrack THEN Error(Chi, '] Exp');
    END ELSE IF Sy <> RrBrack THEN Error(Chi, ']] Exp');
  END;

BEGIN
  WHILE (Sy <> ParaSy) AND (Sy <> TopicEnd) AND
        (Sy <> BlockStartSy) AND (Sy <> BlockEndSy) DO BEGIN
    CASE Sy OF
      EolSy           : BEGIN
                          OutFile(' ');
                          SkipWhiteSpace;
                        END;
      LBrack, LlBrack : CrossRef;
      BMCSy,  BMLSy,
      BMRSy           : DoBitmap;
      ELSE OutFile(LcToken);
    END;
    Next;
  END;
  IF Sy = ParaSy THEN BEGIN
    REPEAT
      Next;
    UNTIL Sy = EolSy;
    Next;
  END;
END;

PROCEDURE Paragraph;
VAR
  Count : INTEGER;
  s     : STRING[10];
BEGIN
  REPEAT
    WHILE Sy = EolSy DO BEGIN
      OutFile('\par');
      Next;
    END;
    Count := 0;
    WHILE (Sy = Space) OR (Sy = TabSy) DO BEGIN
      IF Sy = TabSy THEN
        Count := ((Count DIV 5) + 1) * 5 + 1
      ELSE
        Inc(Count);
      Next;
    END;
  UNTIL Sy <> EolSy;
  IF (Sy <> TopicEnd) AND (Sy <> BlockStartSy) AND
     (Sy <> BlockEndSy) THEN BEGIN
    IF Count > 0 THEN BEGIN
      Str(Count * TwipsPerSpace:-1, s);
      OutFile('\li' + s);
    END;
    IF BIndex > 0 THEN
      OutFile('{' + BlockHeader[BIndex])
    ELSE
      OutFile('{' + GlobalHeader + TopicHeader);
    ParagraphText;
    OutFile('}\par\pard');
    Flush;
  END;
END;

PROCEDURE DoTopic;
BEGIN
  OutFile('#{\footnote \pard\plain \sl240 \fs20 # ');
  SkipWhiteSpace;
  Next;
  WHILE (Sy = Ident) OR (Sy = Dot) OR (Sy = Number) DO BEGIN
    OutFile(LcToken);
    WriteLn(IncF, '#define ' + LcToken + ' ', IncCounter);
    Inc(IncCounter);
    Next;
  END;
  IF Sy <> ParaSy THEN Error(Chi, 'Paragraph mark Exp')
                  ELSE Next;
  OutFile('}');
  Flush;
END;

PROCEDURE DoBrowse;
VAR
  Err : BOOLEAN;
BEGIN
  OutFile('+{\footnote \pard\plain \sl240 \fs20 + ');
  SkipWhiteSpace;
  Next;
  REPEAT
    CASE Sy OF
        OtherChar,
        Comma,
        SemiColon,
        LBrack,
        RBrack,
        Dot,
        Slash,
        OtherPunct,
        Ident,
        Space,
        TabSy,
        Number    : Err := FALSE;
      ELSE          Err := TRUE;
    END;
    IF Err THEN Error(Chi, 'Syntax error in \Browse');
    OutFile(LcToken);
    Next;
  UNTIL (Sy = Colon) OR (Sy = ParaSy) OR (Sy = EolSy);
  IF Sy = Colon THEN BEGIN
    SkipWhiteSpace;
    Next;
    IF Sy <> Number THEN Error(Chi, 'Number Exp in Browse');
    OutFile(':' + LcToken);
    SkipWhiteSpace;
    Next;
  END ELSE Error(Chi, 'Colon Exp');
  IF Sy <> ParaSy THEN Error(Chi, 'Paragraph mark Exp');
  OutFile('}');
  Flush;
  Next;
END;

PROCEDURE DoKeyWord;
VAR
  Err : BOOLEAN;
  ch  : CHAR;
  s   : STRING[10];
BEGIN
  CASE Sy OF
    KeyWordSy  : ch := 'K';
    TitleSy    : ch := '$';
    BuildTagSy : ch := '*';
  END;
  s := LcToken;
  OutFile(ch + '{\footnote \pard\plain \sl240 \fs20 '
             + ch + ' ');
  SkipWhiteSpace;
  Next;
  REPEAT
    CASE Sy OF
      OtherChar,
      Comma,
      Colon,
      SemiColon,
      LBrack,
      RBrack,
      Dot,
      Slash,
      OtherPunct,
      Ident,
      Space,
      TabSy,
      Number : Err := FALSE;
      ELSE     Err := TRUE;
    END;
    IF Err THEN Error(Chi, 'Syntax error in ' + s);
    OutFile(LcToken);
    Next;
  UNTIL (Sy = ParaSy) OR (Sy = EolSy);
  IF Sy <> ParaSy THEN Error(Chi, 'Paragraph mark exp');
  OutFile('}');
  Flush;
  Next;
END;

PROCEDURE DoPage;
BEGIN
  InTopic := TRUE;
  Next;
  WHILE Sy <> TopicEnd DO
    IF Sy = BlockStartSy THEN BEGIN
      IF BIndex >= 4 THEN
        Error(Chi, 'Too many nested blocks')
      ELSE
        Inc(BIndex);
      BlockHeader[BIndex] := '';
      Next;
      WHILE (Sy <> ParaSy) AND (Sy <> EolSy) DO BEGIN
        IF Sy = CommandSy THEN
          BlockHeader[BIndex] := BlockHeader[BIndex]+LcToken
        ELSE IF Sy <> Space THEN
          Error(Chi, 'Command Expected');
        Next;
      END;
      IF Sy = ParaSy THEN Next;
      IF Sy = EolSy  THEN Next;
    END ELSE IF Sy = BlockEndSy THEN BEGIN
      IF BIndex < 1 THEN Error(Chi, 'Unmatched \blockend')
      ELSE
        Dec(BIndex);
      WHILE Sy <> EolSy DO Next;
      Next;
    END ELSE Paragraph;

  IF NOT EofInf THEN Next;
  OutFile('}\page');
  Flush;
  IF BIndex <> 0 THEN BEGIN
    Error(Chi, 'Unmatched \blockstart in previous topic');
    BIndex := 0;
  END;
  InTopic := FALSE;
  IF BrackCount <> 0 THEN BEGIN
    Error(Chi, '{..} imbalance in last topic');
    BrackCount := 0;
  END;
END;

PROCEDURE DoDocument;
BEGIN
  Flush;
  Next;
  IF Sy <> DocEndSy THEN OutFile('{');
  WHILE Sy <> DocEndSy DO
    CASE Sy OF
      TopicSy    : DoTopic;
      KeyWordSy,
      BuildTagSy,
      TitleSy     : DoKeyWord;
      BrowseSy    : DoBrowse;
      TopicStart  : BEGIN
                      DoPage;
                      TopicHeader := '';
                      WHILE (Sy = EolSy) OR (Sy = Space) OR
                            (Sy = TabSy) DO
                        Next;
                     IF Sy <> DocEndSy THEN OutFile('{');
                   END;
      EolSy       : Next;
      CommandSy   : BEGIN
                    TopicHeader := TopicHeader + LcToken;
                     Next;
                    END;
      FontCommand : BEGIN
                      OutFile(LcToken);
                      Next;
                    END;
      ELSE          Next;
    END;

  Flush;
  OutFile('}');
END;

PROCEDURE UpCaseStr(VAR St : STRING);
VAR
  i : INTEGER;
BEGIN
  FOR i := 1 TO Ord(St[0]) DO St[i] := UpCase(St[i]);
END;

PROCEDURE DefaultExtension(Extension    : Filestring;
                       VAR Infile, Name : Filestring);
VAR
 i, j : INTEGER;
 Temp : Filestring;
BEGIN
  i := Pos('..', Infile);
  IF i = 0 THEN Temp := Infile ELSE BEGIN
    Temp := Copy(Infile, i + 2, 64);
    i := i + 1;
  END;
  j := Pos('.', Temp);
  IF j = 0 THEN BEGIN
    Name   := Infile;
    Infile := Infile + '.' + Extension;
  END ELSE Name := Copy(Infile, 1, i + j - 1);
END;

FUNCTION Chk_IOError(s : Filestring) : INTEGER;
VAR
  IOErr : INTEGER;
BEGIN
  IOErr := IOResult;
  IF IOErr = 2 THEN
    MessageBox(0, 'Can''t find File', 'Error', mb_OK)
  ELSE IF IOErr <> 0 THEN
    MessageBox(0,'I/O Error ', 'Error', mb_OK);
  Chk_IOError := IOErr;
END;


PROCEDURE CommandInput(who :STRING);
VAR
  OutName, InName, Name : Filestring;
  i                     : INTEGER;
BEGIN
  InName := who;
  SourceName := InName;
  i := Pos('.', SourceName);
  IF i > 0 THEN SourceName[0] := Chr(i - 1);
  {$I-}
  Assign(Inf, InName);
  SetTextBuf(Inf, InBuff);
  Reset(Inf);
  IF Chk_IOError(InName) <> 0 THEN Halt(1);
  UpCaseStr(SourceName);
  InName := SourceName;
  DefaultExtension('RTF', InName, Name);
  OutName := InName;
  Assign(OutF, InName);
  SetTextBuf(OutF, OutBuff);
  Rewrite(OutF);
  IF Chk_IOError(InName) <> 0 THEN Halt(1);
  InName := SourceName;
  DefaultExtension('HPJ', InName, Name);
  Assign(HpjF, InName);
  Rewrite(HpjF);
  WriteLn(HpjF, '[OPTIONS]');
  WriteLn(HpjF, 'COMPRESS=FALSE');
  WriteLn(HpjF, 'ROOT=C:\TPW\EIGPROG\HILFE');
  WriteLn(HpjF, 'TITLE=DUMMY');
  WriteLn(HpjF);
  WriteLn(HpjF, '[FILES]');
  i := Length(OutName);
  REPEAT
    Dec(i);
  UNTIL OutName[i] = '\';
  OutName := Copy(OutName, i + 1, Length(OutName));
  WriteLn(HpjF,OutName);
  WriteLn(HpjF);
  WriteLn(HpjF, '[BITMAPS]');
  InName := SourceName;
  DefaultExtension('INC', InName, Name);
  i := Length(InName);
  REPEAT
    Dec(i);
  UNTIL InName[i] = '\';
  InName := Copy(InName, i + 1, Length(InName));
  IncFileName := InName;
  Assign(IncF, InName);
  Rewrite(IncF);
  WriteLn(IncF,
          '/* Include-Numbers for all found Topics */');
  WriteLn(IncF);
  IncCounter := 1;
  {$I+}
END;

PROCEDURE ChkEoF;
BEGIN
  IF EofInf THEN BEGIN
    MessageBox(0, 'Unexpected EOF found', 'Error', mb_OK);
    Close(OutF);
    Halt;
  END;
END;

PROCEDURE ReadHeader;
VAR
  i : BYTE;
CONST
  Header : ARRAY[1..9] OF STRING[80] = (
      '{\rtf1\ansi \deff0',
      '{\fonttbl{\f0\froman Tms Rmn;}{\f1\fdecor Symbol;}' +
        '{\f2\fswiss Helv;}',
      '{\f3\fmodern Courier;}',
      '}',
      '{\colortbl;',
      '\red0\green0\blue0;\red0\green0\blue255;\red0\'+
        'green255\blue255;',
      '\red0\green255\blue0;',
      '\red255\green0\blue255;\red255\green0\blue0;\' +
        'red255\green255\blue0;',
      '\red255\green255\blue255;}');
BEGIN
  FOR i := 1 TO 9 DO WriteLn(OutF, Header[i]);
END;

PROCEDURE DoIt(who : STRING);
BEGIN
  ErrCount      := 0;
  LineNo        := 0;
  BIndex        := 0;
  BrackCount    := 0;
  OutString     := '';
  GlobalHeader  := '';
  TopicHeader   := '';
  CommandInput(who);
  ReadHeader;
  EofInf        := FALSE;
  InTopic       := FALSE;
  ErrFlag       := FALSE;
  InInclude     := FALSE;
  OutFile('\f' + DefaultFont + '\fs' + DefaultFontSize);
  St[0]         := #0;
  Chi           := 1;
  GetCh;
  Next;
  WHILE NOT EofInf AND (Sy <> DocStartSy) DO BEGIN
    IF Sy = CommandSy THEN
      GlobalHeader := GlobalHeader + LcToken
    ELSE IF Sy = FontCommand THEN
      OutFile(LcToken);
    Next;
  END;
  IF Sy = DocStartSy THEN DoDocument;
  Flush;
  Close(Inf);
  Close(OutF);
  WriteLn(HpjF);
  WriteLn(HpjF, '[MAP]');
  WriteLn(HpjF, '#include <' + IncFileName + '>');
  Close(HpjF);
  Close(IncF);
  IF ErrFlag THEN Exit;
END;

END.

(*========================================================*)
(*                    Ende von RTFGEN.PAS                 *)

