{$A+,B-,D-,F-,G+,I-,K-,L-,N-,P-,Q-,R-,S-,T-,V-,W-,X+,Y-}
(* ====================================================== *)
(*                        NOTEBOOK.PAS                    *)
(*    Copyright  1993, 1994 Harald Gergits & toolbox     *)
(* Compiler: Turbo Pascal/Windows 1.5, Borland Pascal 7.0 *)
(* ====================================================== *)
{$A+,B-,D-,F-,G+,I-,K-,L-,N-,P-,Q-,R-,S-,T-,V-,W-,X+,Y-}
UNIT Notebook;

INTERFACE

USES
{$IFDEF Ver70}
  WinTypes, WinProcs, Objects, OWindows, Strings;
{$ELSE}
  WinTypes, WinProcs, WObjects, Strings;
{$ENDIF}

CONST
  (* Neue Nachricht, wird an Eltern-Fenster gesendet,     *)
  (* wenn ein Fhnchen angeklickt wird!                   *)
  (* HiWord(lParam)...Fhnchen-Nummer                     *)
  (* LoWord(lParam)...ID des Notebooks                    *)
  wm_NBSelChange        = wm_User + 1;

TYPE
  (* Notebook-Klasse: *)
  pNotebook  = ^tNotebook;
  tNotebook  = OBJECT(tWindow)
    CONSTRUCTOR Init(aParent        : pWindowsObject;
                     ID, x, y, w, h : INTEGER;
                     rgbActive,
                     rgbBackGround  : tColorRef;
                     RoundCorner    : INTEGER;
                     NotebookInfo   : pCollection);
    CONSTRUCTOR InitResource(aParent       : pWindowsObject;
                             ID            : INTEGER;
                             rgbBackGround : tColorRef;
                             NotebookInfo  : pCollection);
    PROCEDURE Paint(PaintDC       : hDC;
                    VAR PaintInfo : tPaintStruct); VIRTUAL;
    PROCEDURE wmLButtonDown(VAR Msg : tMessage);
      VIRTUAL wm_LButtonDown;
    PROCEDURE SelChange(p : INTEGER); VIRTUAL;
          (* SelChange wird aufgerufen, wenn ein Flag     *)
          (* angeklickt wurde. P enthlt die Flag-Nummer  *)
    PRIVATE
      nbID    : INTEGER;     (* ID des Controls           *)
      nbInfo  : pCollection; (* Zeiger auf die Descriptor-*)
                             (* Collection des Flags      *)
      nbBG    : tColorRef;   (* Hintergrundfarbe          *)
      nbActive: tColorRef;   (* Farbe des aktiven Flags   *)
      nbRC    : INTEGER; (* Radius der abgerundeten Ecken *)
    END;

  (* Flag-Klasse: *)
  pNotebookInfo  = ^tNotebookInfo;
  tNotebookInfo  = OBJECT(tObject)
    Name        : pChar;      (* Name des Flags           *)
    Active      : BOOLEAN;    (* Ist Flag aktiv           *)
    Color       : tColorRef;  (* Farbe des Flags, wenn es *)
                              (* nicht aktiv ist          *)
    CONSTRUCTOR Init(Title : pChar; State : BOOLEAN;
                     Col   : tColorRef);
    DESTRUCTOR Done; VIRTUAL;
  END;

IMPLEMENTATION

CONSTRUCTOR tNotebookInfo.Init;

BEGIN
  (* Speichern der einzelnen Eigenschaften *)
  Name := StrNew(Title);
  Active := State;
  Color  := Col;
END;

DESTRUCTOR tNotebookInfo.Done;
BEGIN
  StrDispose(Name);     (* Speichers des Namens freigeben *)
END;

CONSTRUCTOR tNotebook.Init;
BEGIN
  INHERITED Init(aParent, ''); (* tWindow.Init ... *)
  (* Speichern der einzelnen Eigenschaften *)
  nbID       := ID;
  nbInfo     := NotebookInfo;
  nbBG       := rgbBackGround;
  nbActive   := rgbActive;
  nbRC       := RoundCorner;
  Attr.Style := ws_Visible OR ws_ChildWindow;
  Attr.x     := x;
  Attr.y     := y;
  Attr.w     := w;
  Attr.h     := h;
END;

CONSTRUCTOR tNotebook.InitResource;
BEGIN
  INHERITED InitResource(aParent, ID);
            (* tWindow.InitResource ... *)
  (* Speichern der einzelnen Eigenschaften *)
  nbID   := ID;
  nbInfo := NotebookInfo;
  nbBG   := rgbBackGround;
END;


PROCEDURE tNotebook.Paint; (*Zeichnet das Notebook-Element*)

  PROCEDURE Notebook(x, y, w, h : INTEGER;
                     Name       : pChar;
                     Color      : tColorRef;
                     Active     : BOOLEAN);
    (* Notebook zeichnet ein Flag *)
    VAR
      BG : hBrush;
      RC : tRect;
      p  : hPen;
    BEGIN
      w := x + w;
      h := y + h;
      SaveDC(PaintDC);
      SelectObject(PaintDC, GetStockObject(Black_Pen));
      (* Umri zeichnen: *)
      MoveTo(PaintDC, x, y+ nbRC);
      LineTo(PaintDC, x, h);
      LineTo(PaintDC, w, h);
      LineTo(PaintDC, w, y + nbRC - 1);
      MoveTo(PaintDC, x + nbRC, y);
      LineTo(PaintDC, w - nbRC + 1, y);
      (* Ecken zeichnen: *)
      Arc(PaintDC, x, y + nbRC * 2, x + nbRC * 2, y,
                   x + nbRC, 0, 0, y + nbRC);
      Arc(PaintDC, w - nbRC * 2 + 1, y, w + 1, y + nbRC * 2,
                   w, y + nbRC, w - nbRC, 0);
      RestoreDC(PaintDC, -1);
      (* Wenn Flag aktiv, dann den unteren Rand lschen *)
      IF Active THEN BEGIN
        p := CreatePen(ps_Solid, 1, RGB(192, 192, 192));
        SaveDC(PaintDC);
        SelectObject(PaintDC, p);
        MoveTo(PaintDC, x + 1, h);
        LineTo(PaintDC, w, h);
        RestoreDC(PaintDC, -1);
        DeleteObject(p);
      END;
      (* Flag ausfllen: *)
      IF Active THEN BG := CreateSolidBrush(nbActive)
                ELSE BG := CreateSolidBrush(Color);
      SaveDC(PaintDC);
      SelectObject(PaintDC, BG);
      FloodFill(PaintDC, w - 2, h - 2, RGB(0, 0, 0));
      RestoreDC(PaintDC, -1);
      DeleteObject(BG);
      (* Titel des Flags schreiben *)
      SaveDC(PaintDC);
      SelectObject(PaintDC, GetStockObject(ANSI_Var_Font));
      SetBkMode(PaintDC, Transparent);
      RC.Left  := x; RC.Top    := y;
      RC.Right := w; RC.Bottom := h;
      DrawText(PaintDC, Name, StrLen(Name), RC,
               dt_Center OR dt_VCenter OR dt_SingleLine);
      RestoreDC(PaintDC, -1);
    END;

VAR
  Width  : INTEGER;
  Height : INTEGER;
  RC     : tRect;
  i,x    : INTEGER;
  BG     : hBrush;
BEGIN
  (* Gre des Notebooks ermittlen *)
  GetClientRect(hWindow, RC);
  Width  := RC.Right - 1;
  Height := RC.Bottom - 1;

  (* Hintergrund malen, damit Ecken "gut" aussehen *)
  BG := CreateSolidBrush(nbBG);
  SaveDC(PaintDC);
  SelectObject(PaintDC, GetStockObject(null_Pen));
  SelectObject(PaintDC, BG);
  Rectangle(PaintDC, RC.Left, RC.Top,
                     RC.Right + 1, RC.Bottom + 1);
  RestoreDC(PaintDC, -1);
  DeleteObject(BG);
  (* Flag zeichnen *)
  x := 0;
  FOR i := 0 TO nbInfo^.Count - 1 DO BEGIN
    IF i = nbInfo^.Count - 1 THEN BEGIN
                 (* Das letzte Element wird etwas grer, *)
                 (* Integer-Divisionen sind etwas ungenau *)
      Notebook(x, 0, Width - x, Height,
               pNotebookInfo(nbInfo^.At(i))^.Name,
               pNotebookInfo(nbInfo^.At(i))^.Color,
               pNotebookInfo(nbInfo^.At(i))^.Active);
    END ELSE BEGIN         (* Alle anderen Flags zeichnen *)
      Notebook(x, 0, Width DIV nbInfo^.Count, Height,
               pNotebookInfo(nbInfo^.At(i))^.Name,
               pNotebookInfo(nbInfo^.At(i))^.Color,
               pNotebookInfo(nbInfo^.At(i))^.Active);
    END;
     (* Startposition (x-Koordinate) berechnen *)
    Inc(x, Width DIV nbInfo^.Count);
  END;
END;

PROCEDURE tNotebook.wmLButtonDown;
(* Wertet Mausklicks der linken Taste aus *)
VAR
  x, p : INTEGER;
  s    : ARRAY[0..255] OF CHAR;
  RC   : tRect;
  Card : pNotebookInfo;
  c, i : LongInt;
BEGIN
  (* Gre des Notebooks ermittlen: *)
  GetClientRect(hWindow, RC);
  (* Die X-Koordinate wird im LoWord von lParam bei einem *)
  (* einem Mausklick gespeichert:                         *)
  x := LoWord(Msg.lParam);
  (* Flag-Nummer errechnen: *)
  p := x DIV ((RC.Right-1) DIV nbInfo^.Count);
  (* Sicherheitsabfrage, Flagnummer gltig(?): *)
  IF (p > nbInfo^.Count - 1) THEN Exit;
  (* Alle Flags inaktivieren *)
  FOR x := 0 TO nbInfo^.Count-1 DO BEGIN
    Card := nbInfo^.At(x);
    Card^.Active := FALSE;
  END;
  (* Entsprechendes Flag aktiv setzen: *)
  Card         := nbInfo^.At(p);
  Card^.Active := TRUE;
  nbInfo^.AtPut(p, Card);
  (* Notebook-Element neu zeichnen lassen: *)
  InvalidateRect(hWindow, NIL, FALSE);
  (* Nachricht an Eltern-Fenster schicken *)
  c := p;
  i := nbID;
  SendMessage(Parent^.hWindow, wm_NBSelChange, nbID,
              (c SHL 16) + i);
  SelChange(p);
END;


PROCEDURE tNotebook.SelChange;
(* Wird aufgerufen, wenn ein Flag selektiert wird *)
BEGIN
END;

END.

(* ====================================================== *)
(*                    Ende von NOTEBOOK.PAS               *)
