(* ====================================================== *)
(*                        NOTEDEMO.PAS                    *)
(*         Demoprogramm fr die Unit notebook.pas       *)
(*    Copyright  1993, 1994 Harald Gergits & toolbox     *)
(* Compiler: Turbo Pascal/Windows 1.5, Borland Pascal 7.0 *)
(* ====================================================== *)
{$A+,B-,D-,F-,G+,I-,K-,L-,N-,P-,Q-,R-,S-,T-,V-,W-,X+,Y-}
{$M 8192,8192}

PROGRAM DemoForNoteBookControls;

USES
  WinTypes, WinProcs, Strings, NoteBook, 
  {$IFDEF Ver70} Objects, OWindows, ODialogs;
  {$ELSE} WObjects; {$ENDIF}

(* Wird nur bentigt, wenn tWin von tDlgWindow abgeleitet *)
(* wird                                                   *)
(* {$R NOTEDEMO.RES}                                      *)
CONST
  AppName = 'Demo fr Notebook Controls';

TYPE
  pWin  = ^tWin;
  tWin  = OBJECT(tWindow)
    CONSTRUCTOR Init;
    PROCEDURE   SetupWindow; VIRTUAL;
    PROCEDURE   GetWindowClass(VAR aWndClass : tWndClass);
      VIRTUAL;
    (* Reagiert auf Notebook-Controls *)
    PROCEDURE   TestNB(VAR Msg : tMessage );
      VIRTUAL   wm_NBSELCHANGE;
  END;

  pApp  = ^tApp;
  tApp  = OBJECT(tApplication)
    CONSTRUCTOR Init;
    PROCEDURE   InitMainWindow; VIRTUAL;
  END;

CONSTRUCTOR tWin.Init;
BEGIN
  INHERITED Init(NIL, AppName);
END;

PROCEDURE tWin.SetupWindow;
VAR
  N  : pNotebook;
  P  : pCollection;
  rc : tRect;
  Po : tPoint;
BEGIN
  INHERITED SetupWindow;
  (* Collektion erzeugen *)
  P := New(pCollection, Init(32, 32));

  (* Flag zur Kollektion fgen *)
  P^.Insert(New(pNotebookInfo,
                Init('Tools', FALSE, RGB(128, 128, 128))));
  P^.Insert(New(pNotebookInfo,
                Init('Compiler', FALSE,
                     RGB(128, 128, 128))));
  P^.Insert(New(pNotebookInfo,
                Init('Linker', TRUE, RGB(128, 128, 128))));
  P^.Insert(New(pNotebookInfo,
                Init('Umgebung', FALSE,
                     RGB(128, 128, 128))));

  (* Notebook-Instanz erzeugen *)
  N := New(pNotebook, Init(@Self, 101, 10, 10, 594, 20,
                           RGB(192, 192, 192),
                           RGB(255, 255, 255), 8, P));
  (* Notebook anzeigen *)
  Application^.MakeWindow(N);
END;

PROCEDURE tWin.TestNB;
VAR
  S : ARRAY[0..255] OF CHAR;
BEGIN
  wvSprintF(S, 'Notebook=%d, Fhnchen=%d', Msg.lParam);
  MessageBox(hWindow, S, NIL, mb_OK);
END;

PROCEDURE tWin.GetWindowClass;
BEGIN
  INHERITED GetWindowClass(aWndClass);
END;

CONSTRUCTOR tApp.Init;
BEGIN
  INHERITED Init(AppName);
END;

PROCEDURE tApp.InitMainWindow;
BEGIN
  MainWindow := New(pWin, Init);
END;

VAR
  App   : tApp;
BEGIN
  App.Init;
  App.Run;
  App.Done;
END.

(* ====================================================== *)
(*                    Ende von NOTEDEMO.PAS               *)
