(* ====================================================== *)
(*                       FEIGE.PAS                        *)
(* Berechnung der Apfelmann-Grafik.                       *)
(* Aufruf mit 3 Parametern: 1.Breite der Grafik,          *)
(* 2.Offset der Grafik,     3.Name einer Datei,           *)
(* in die die Grafikinformationen eingetragen werden.     *)
(*      (c) 1993 Dr. Lothar Wenzel & toolbox              *)
(* ====================================================== *)
{$A-,B+,D-,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

PROGRAM Feige;

USES Dos;

CONST
  Dimension  = 240;          { Gre der Grafik            }

VAR
  Feld       : ARRAY [1..Dimension, 1..Dimension] OF BYTE;
                             { Speicher fr Apfelmann      }
  Code       : INTEGER;
  Botschaft  : FILE OF BYTE; { Ergebnis auf Platte         }
  Name       : STRING[12];
  Breite,
  Tiefe      : INTEGER;      { Ausschnitt aus Gesamtgrafik }
  Differenz  : INTEGER;
  i, j       : INTEGER;


  PROCEDURE Feigenbaum;
  CONST
    Grenze  = 100;
                { Divergenztiefe, bei der abgebrochen wird }
  VAR
    Skala, i, j        : INTEGER;
    x1, x2, y1, y2     : Double;
    x, y, xd, yd, a, b : Double;
    Farbe              : BYTE;
    Schranke, n        : INTEGER;
    m                  : Double;
  BEGIN
    Schranke := 20;
    Skala    :=  5;
    x1       :=  0.7;
    x2       :=  1;
    y1       := -0.3;
    y2       := -0.1;
    Tiefe    := 2 * Breite;
    xd       := (x2 - x1) / Breite;
    x        :=  x1 - xd;
    yd       := (y2 - y1) / Tiefe;
    FOR i := 1+Differenz TO Breite+Differenz DO BEGIN
      y := y1 - yd;
      x := x1 + i * xd;
      FOR j := 1 TO Tiefe DO BEGIN
        y := y + yd;  a := x;  b := y;
        Farbe := 7;
        FOR N := 1 TO Schranke DO BEGIN
          m := a * a - b * b - x;
          b := a * b;
          b := b + b - y;
          a := m;
          IF Abs(a) + Abs(b) > Grenze THEN BEGIN
            Farbe := Round(n - Skala * Int(n / Skala));
            n     := Schranke;
          END;
        END;
        Feld[i - Differenz, j] := Farbe;
      END;
    END;
  END;

BEGIN
  Val(ParamStr(1), Breite,    Code);
  Val(ParamStr(2), Differenz, Code);
  Name := ParamStr(3);
  Feigenbaum;
  Assign(Botschaft, Name);
  Rewrite(Botschaft);
  FOR i := 1 TO Breite DO
    FOR j := 1 TO Breite DO
      Write(Botschaft, Feld[i, j]);
  Close(Botschaft);
END.
(* ====================================================== *)
(*                  Ende von FEIGE.PAS                    *)
