(* ====================================================== *)
(*                      MASTER.PAS                        *)
(*  konkreten Fall wird FEIGE.EXE mit verschiedenen       *)
(*  Parametern auf dem Master und dem Slave aufgerufen.   *)
(*  Geringfgige Anpassungsarbeiten sind demnach          *)
(*  notwendig, falls andere Anwendungen ablaufen sollen.  *)
(*      (c) 1993 Dr. Lothar Wenzel & toolbox              *)
(* ====================================================== *)
{$A-,B+,D-,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M $4000,0,20000}

PROGRAM Master;

USES Crt, Dos, RS232, Graph;

CONST
  Com_Nr        =        1;
  Baud          =   115200;
  Parity        =        0;
  Datenbit      =        8;
  Stopbit       =        1;

  Menu_Punkte   =        4;
  Anzahl        =        3;
  Striche       =        5;

  Gross         =    30000;   { Puffergren RS232         }
  Klein         =    30000;

  Synchron_0    =      #00;   { dienen der Synchronisation }
  Synchron_1    =      253;
  Synchron_2    =      254;

VAR
  i              : INTEGER;
  Menu           : ARRAY [1..Menu_Punkte] OF STRING [20];
  Position       : INTEGER;
  Taste1, Taste2 : CHAR;

  Info           : FILE OF CHAR;
  ComIn, ComOut  : Text;

  Name           : STRING [12];

  Transfer,
  Transfer1      : CHAR;

  PufferGross    : ARRAY [1..Gross] OF CHAR;
  PufferKlein    : ARRAY [1..Klein] OF CHAR;

  Counter        : LongInt;

  Kennung        : CHAR;
  Slave_Info     : STRING;
  Master_Info    : STRING;

  Start, Ziel    : LongInt;
  Arbeit         : LongInt;
  Kommunikation  : LongInt;

  Gerechnet      : BOOLEAN;

  PROCEDURE Stoppuhr_Beginn;
  VAR
    Hour,  Minute,  Second,  Sec100  : WORD;
    LHour, LMinute, LSecond, LSec100 : LongInt;
  BEGIN
    GetTime(Hour, Minute, Second, Sec100);
    LSec100 := Sec100;
    LSecond := Second;
    LMinute := Minute;
    LHour   := Hour;
    Start   := LSec100 + 100 * LSecond +
               6000 * LMinute + 360000 * LHour;
  END;

  PROCEDURE Stoppuhr_Ende;
  VAR
    Hour,  Minute,  Second,  Sec100  : WORD;
    LHour, LMinute, LSecond, LSec100 : LongInt;
  BEGIN
    GetTime(Hour, Minute, Second, Sec100);
    LSec100 := Sec100;
    LSecond := Second;
    LMinute := Minute;
    LHour   := Hour;
    Ziel    := LSec100 + 100 * LSecond +
               6000 * LMinute + 360000 * LHour;
  END;

  PROCEDURE Oeffnen;
  BEGIN
    AssignAux(ComIn, Com_Nr, Baud, Parity,
              Datenbit, Stopbit);
    Reset(ComIn);
    SetTextBuf(ComIn, PufferKlein);
    AssignAux(ComOut, Com_Nr, Baud, Parity,
              Datenbit, Stopbit);
    Rewrite(ComOut);
    SetTextBuf(ComOut, PufferGross);
  END;

  PROCEDURE Schliessen;
  BEGIN
    Close(ComOut); Close(ComIn);
  END;

  PROCEDURE Doppelfenster(x1, y1, x2, y2 : INTEGER);
  CONST
    m1 = $C9;
    m2 = $CD;
    m3=  $BB;
    m4 = $BA;
    m5 = $BC;
    m6 = $C8;
  VAR
    i, j : INTEGER;
  BEGIN
    GotoXY(x1, y1); Write(Chr(m1));
    GotoXY(x2, y1); Write(Chr(m3));
    GotoXY(x2, y2); Write(Chr(m5));
    GotoXY(x1, y2); Write(Chr(m6));
    FOR i := y1+1 TO y2-1 DO BEGIN
      GotoXY(x1, i); Write(Chr(m4));
      GotoXY(x2, i); Write(Chr(m4));
    END;
    FOR j := x1+1 TO x2-1 DO BEGIN
      GotoXY(j, y1); Write(Chr(m2));
      GotoXY(j, y2); Write(Chr(m2));
    END;
  END;

  PROCEDURE Menu_Init;
  BEGIN
    Menu[1] := 'Start MASTER';
    Menu[2] := 'Statistik';
    Menu[3] := 'Endergebnis';
    Menu[4] := 'ENDE';
  END;

  PROCEDURE Cursor_Weg;
  VAR
    Regs : Registers;
  BEGIN
    WITH Regs DO BEGIN
      AX := $0100;
      CX := $0900;
      Intr($10, Regs);
    END;
  END;

  PROCEDURE Cursor_Holen;
  VAR
    Regs : Registers;
  BEGIN
    WITH Regs DO BEGIN
      AX := $0100;
      CX := $0708;
      Intr($10, Regs);
    END;
  END;

  PROCEDURE Abstimmung;
  VAR
    Index  : INTEGER;
    Wert   : CHAR;
  BEGIN
    GotoXY(40, 21);
    Write('ABSTIMMUNG LUFT!');
    Write(ComOut, Chr(Synchron_2));
    REPEAT
      Read(ComIn, Wert);
    UNTIL (Wert = Chr(Synchron_1));
    Write(ComOut, Chr(Synchron_2));
    GotoXY(40, 21);
    Write('                           ');
  END;

  PROCEDURE Master_Slave;
  VAR
    Index1, Index2  : INTEGER;
    Counter_Ende    : LongInt;
    w1, w2          : INTEGER;
    j               : INTEGER;
  BEGIN
    Counter      := 0;
    Counter_Ende := 0;
    Oeffnen;
    Abstimmung;
    IF Kennung = 'A' THEN BEGIN
      GotoXY(35, 18);
      GotoXY(35, 18);
      Write('                    ');
      Assign(Info, Name);
      Reset(Info);
      Counter_Ende := FileSize(Info);
      GotoXY(32, 17);
      Write('Datei: ', Name);
      GotoXY(32, 18);
      Write('Lnge: ', Counter_Ende:6);
      GotoXY(32, 19);
      Write('Stand: ');
    END;
    w1        := Counter_Ende DIV $100;
    w2        := Counter_Ende MOD $100;
    Transfer  := Chr(w1);
    Transfer1 := Chr(w2);
    TextColor(Blue + 16);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 10);
        Write('|');
      END;
      GotoXY(5 * Index1, Anzahl + 11);
      Write('V');
    END;
    TextColor(Blue);
    Write(ComOut, Synchron_0);
    Write(ComOut, Transfer);
    Write(ComOut, Transfer1);
    FOR j := 1 TO Length(Name) DO BEGIN
      Transfer := Name[j];
      Write(ComOut, Transfer);
    END;
    Write(ComOut, Synchron_0);
    Write(ComOut, Kennung);
    FOR j := 1 TO Length(Slave_Info) DO BEGIN
      Transfer := Slave_Info[j];
      Write(ComOut, Transfer);
    END;
    Write(ComOut, Synchron_0);
    IF Kennung = 'A' THEN BEGIN
      REPEAT
        Read(Info, Transfer);
        Write(ComOut, Transfer);
        GotoXY(39, 19);
        Inc(Counter);
        Write(Counter:6);
      UNTIL (Counter = Counter_Ende);
      Close(Info);
    END;
    Write(ComOut, Synchron_0);
    Schliessen;
    TextColor(White);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 10);
        Write(' ');
      END;
      GotoXY(5 * Index1, Anzahl + 11);
      Write(' ');
    END;
    TextColor(Blue);
    TextBackground(White);
    GotoXY(32, 17);
    Write('                   ');
    GotoXY(32, 18);
    Write('                   ');
    GotoXY(32, 19);
    Write('                   ');
  END;

  PROCEDURE Slave_Master;
  VAR
    Index1, Index2 : INTEGER;
    Counter_Ende   : LongInt;
    h, h1          : LongInt;
  BEGIN
    Counter    := 0;
    Oeffnen;
    Name       := '';
    Slave_Info := '';
    Abstimmung;
    REPEAT
      Read(ComIn, Transfer);
    UNTIL (Transfer = Synchron_0);
    Read(ComIn, Transfer);
    Read(ComIn, Transfer1);
    h  := Ord(Transfer);
    h1 := Ord(Transfer1);
    Counter_Ende := h1 + 256 * h;
    REPEAT
      Read(ComIn, Transfer);
      IF Ord(Transfer) > 0 THEN
        Name := Name + Transfer;
    UNTIL (Transfer = Synchron_0);
    Read(ComIn, Kennung);
    Kennung := 'A';
    REPEAT
      Read(ComIn, Transfer);
      IF Ord(Transfer) > 0 THEN
        Slave_Info := Slave_Info + Transfer;
    UNTIL (Transfer = Synchron_0);
    GotoXY(32, 17);
    Write('Datei  : ', Name);
    GotoXY(32, 18);
    Write('Lnge  : ', Counter_Ende:6);
    GotoXY(32, 19);
    Write('Stand  : ');
    GotoXY(32, 20);
    Write('Info   : ', Slave_Info);
    GotoXY(32, 21);
    Write('Kennung: ', Kennung);
    TextColor(Blue + 16);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 11);
        Write('|');
      END;
      GotoXY(5 * Index1, 11);
      Write('^');
    END;
    TextColor(Blue);
    IF Kennung = 'A' THEN BEGIN
      Assign(Info, Name);
      Rewrite(Info);
      REPEAT
        Read(ComIn, Transfer);
        Inc(Counter);
        Write(Info, Transfer);
        GotoXY(41, 19);
        Write(Counter:6);
      UNTIL (Counter = Counter_Ende);
      Close(Info);
    END;
    Schliessen;
    TextColor(White);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 11);
        Write(' ');
      END;
      GotoXY(5 * Index1, 11);
      Write(' ');
    END;
    TextColor(Blue);
    TextBackground(White);
    FOR i := 1 TO 5 DO BEGIN
      GotoXY(32, i + 16);
      Write('                      ');
    END;
  END;

  PROCEDURE Rechnung_Master;
  BEGIN
    GotoXY(40, 19);
    Write('PARALLELARBEIT LUFT!');
    Exec(Name, Master_Info);
    GotoXY(40, 19);
    Write('                     ');
  END;

  PROCEDURE Graph_Init;
  VAR
    gd, gm : INTEGER;
  BEGIN
    gd := Detect;
    InitGraph(gd, gm, GetEnv('BGIPATH'));
    IF GraphResult <> GrOk THEN Halt(1);
  END;

  PROCEDURE Endergebnis;
  VAR
    Botschaft  : FILE OF BYTE;
    L, m       : BYTE;
    Punkt      : BYTE;
    Dimension  : INTEGER;
  BEGIN
    Graph_Init;
    Assign(Botschaft, 'FEIG.MAS');
    Reset(Botschaft);
    Dimension := Round(Sqrt(FileSize(Botschaft)));
    Rectangle(10, 10, 12 + 2 * Dimension, 12 + Dimension);
    FOR L := 1 TO Dimension DO
      FOR m := 1 TO Dimension DO BEGIN
        Read(Botschaft, Punkt);
        PutPixel(11 + L, 11 + m, Punkt);
      END;
    Close(Botschaft);
    Assign(Botschaft, 'FEIG.SLA');
    Reset(Botschaft);
    FOR L := 1 TO Dimension DO
      FOR m := 1 TO Dimension DO BEGIN
        Read(Botschaft, Punkt);
        PutPixel(11 + L + Dimension, 11 + m, Punkt);
      END;
    Close(Botschaft);
    REPEAT UNTIL KeyPressed;
    CloseGraph;
    RestoreCrtMode;
  END;

BEGIN
  Gerechnet     := FALSE;
  Cursor_Weg;
  Kommunikation := 0;
  Arbeit        := 0;
  Menu_Init;
  Position      := 1;
  REPEAT
    TextColor(Blue); TextBackground(White);
    ClrScr;
    Doppelfenster(30, 16, 79, 16);
    Doppelfenster(30,  3, 30, 22);
    Doppelfenster( 1, 22, 79, 24);
    Doppelfenster( 1,  1, 79,  3);
    Doppelfenster( 1,  1, 79, 24);
    GotoXY(14, 2);
    Write('P A R A L L E L - M O N I T O R  (M A S T E R)');
    GotoXY(2, 23);
    Write('Status RS232:       ', Baud, '    ',
          Parity, '   ', Datenbit,'   ', Stopbit);
    Doppelfenster( 5,  6, 25, 10);
    GotoXY(10, 8);
    Write('M A S T E R');
    Doppelfenster( 5, 15, 25, 19);
    GotoXY(10, 17);
    Write(' S L A V E');
    FOR i := 1 TO Menu_Punkte DO BEGIN
      GotoXY(35, i+4);
      Write(i, ' ', Menu[i]);
    END;
    REPEAT
      TextBackground(Blue);
      TextColor(White);
      GotoXY(35, Position+4);
      Write(Position, ' ', Menu[Position]);
      Taste1 := ReadKey;
      IF Ord(Taste1) = 0 THEN Taste2 := ReadKey;
      IF Ord(Taste1) = 0 THEN BEGIN
        IF (Ord(Taste2) = 80) AND
           (Position < Menu_Punkte) THEN BEGIN
          TextBackground(White);
          TextColor(Blue);
          GotoXY(35, Position+4);
          Write(Position, ' ', Menu[Position]);
          Inc(Position);
        END;
        IF (Ord(Taste2) = 72) AND (Position > 1) THEN BEGIN
          TextBackground(White);
          TextColor(Blue);
          GotoXY(35, Position+4);
          Write(Position, ' ', Menu[Position]);
          Dec(Position);
        END;
      END;
    UNTIL (Taste1 = #13);
    TextColor(Blue);
    TextBackground(White);
    CASE Position OF
      1 : BEGIN
            Kennung     := 'A';
            (* abhngig von der Anwendung *)
            Name        := 'FEIGE.EXE';
            (* 3.Parameter MUSS DATEINAME sein! *)
            Slave_Info  := '80 80 FEIG.SLA';
            Master_Info := '80 0 FEIG.MAS';

            Stoppuhr_Beginn;
            Master_Slave;
            Stoppuhr_Ende;
            Kommunikation := (Ziel - Start);
            Stoppuhr_Beginn;
            Rechnung_Master;
            Stoppuhr_Ende;
            Arbeit  := (Ziel - Start);
            Kennung := 'A';
            Stoppuhr_Beginn;
            Slave_Master;
            Stoppuhr_Ende;
            Kommunikation := Kommunikation + (Ziel - Start);
            Gerechnet     := TRUE;
          END;
      2 : BEGIN
            GotoXY(35, 14);
            Write('Kommunikation:', Kommunikation/100:6:2);
            GotoXY(35, 15);
            Write('Arbeit       :', Arbeit/100:6:2);
            REPEAT UNTIL KeyPressed;
          END;
      3 : IF Gerechnet THEN Endergebnis;
      4 : BEGIN
            Kennung := 'E';
            Master_Slave;
            Cursor_Holen;
            NormVideo;
            ClrScr;
            Halt;
          END;
    END;
  UNTIL FALSE;
END.
(* ====================================================== *)
(*                Ende von MASTER.PAS                     *)
