(* ====================================================== *)
(*                        SLAVE.PAS                       *)
(*                   Slave-Betriebssystem                 *)
(*           (c) 1993 Dr. Lothar Wenzel & toolbox         *)
(* ====================================================== *)
{$A-,B+,D-,E-,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M $4000,0,20000}

PROGRAM Slave;

USES Crt,Dos, RS232;

CONST
  Com_Nr        =      2;
  Baud          = 115200;
  Parity        =      0;
  Datenbit      =      8;
  Stopbit       =      1;

  Anzahl        =      3;
  Striche       =      5;

  Gross         =  30000;     { Puffergren RS232         }
  Klein         =  30000;

  Synchron_0    =    #00;     { dienen der Synchronisation }
  Synchron_1    =    253;
  Synchron_2    =    254;

VAR
  i              : INTEGER;
  Position       : INTEGER;

  Info           : FILE OF CHAR;
  ComIn,ComOut   : Text;

  Name           : STRING [12];
  Ergebnis       : STRING [12];

  PufferGross    : ARRAY [1..Gross] OF CHAR;
  PufferKlein    : ARRAY [1..Klein] OF CHAR;

  Counter        : LongInt;
  Transfer,
  Transfer1      : CHAR;
  Kennung        : CHAR;
  Zusatz_Info    : STRING;
  Ende           : BOOLEAN;

  PROCEDURE Doppelfenster(x1, y1, x2, y2 : INTEGER);
  CONST
    m1 = $C9;
    m2 = $CD;
    m3=  $BB;
    m4 = $BA;
    m5 = $BC;
    m6 = $C8;
  VAR
    i, j : INTEGER;
  BEGIN
    GotoXY(x1, y1); Write(Chr(m1));
    GotoXY(x2, y1); Write(Chr(m3));
    GotoXY(x2, y2); Write(Chr(m5));
    GotoXY(x1, y2); Write(Chr(m6));
    FOR i := y1+1 TO y2-1 DO BEGIN
      GotoXY(x1, i); Write(Chr(m4));
      GotoXY(x2, i); Write(Chr(m4));
    END;
    FOR j := x1+1 TO x2-1 DO BEGIN
      GotoXY(j, y1); Write(Chr(m2));
      GotoXY(j, y2); Write(Chr(m2));
    END;
  END;

  PROCEDURE Cursor_Weg;
  VAR
    Regs : Registers;
  BEGIN
    WITH Regs DO BEGIN
      AX := $0100;
      CX := $0900;
      Intr($10, Regs);
    END;
  END;

  PROCEDURE Cursor_Holen;
  VAR
    Regs : Registers;
  BEGIN
    WITH Regs DO BEGIN
      AX := $0100;
      CX := $0708;
      Intr($10, Regs);
    END;
  END;

  PROCEDURE Oeffnen;
  BEGIN
    AssignAux(ComIn, Com_Nr, Baud, Parity,
              Datenbit, Stopbit);
    Reset(ComIn);
    SetTextBuf(ComIn, PufferKlein);
    AssignAux(ComOut, Com_Nr, Baud, Parity,
              Datenbit, Stopbit);
    Rewrite(ComOut);
    SetTextBuf(ComOut, PufferGross);
  END;

  PROCEDURE Schliessen;
  BEGIN
    Close(ComOut); Close(ComIn);
  END;

  PROCEDURE Abstimmung;
  VAR
    Index  : INTEGER;
    Wert   : CHAR;
  BEGIN
    GotoXY(40, 21);
    Write('ABSTIMMUNG LUFT!');
    Write(ComOut, Chr(Synchron_1));
    REPEAT
      Read(ComIn, Wert);
    UNTIL (Wert = Chr(Synchron_2));
    Write(ComOut, Chr(Synchron_1));
    GotoXY(40, 21);
    Write('                           ');
  END;

  PROCEDURE Master_Slave;
  VAR
    Index1, Index2 : INTEGER;
    Counter_Ende   : LongInt;
    w1, w2         : INTEGER;
    j              : INTEGER;
  BEGIN
    Counter     := 0;
    Zusatz_Info := ' ';
    Assign(Info, Ergebnis);
    Reset(Info);
    Oeffnen;
    Counter_Ende := FileSize(Info);
    GotoXY(32, 17);
    Write('Datei: ', Ergebnis);
    GotoXY(32, 18);
    Write('Lnge: ', Counter_Ende:6);
    GotoXY(32, 19);
    Write('Stand: ');
    w1        := Counter_Ende DIV $100;
    w2        := Counter_Ende MOD $100;
    Transfer  := Chr(w1);
    Transfer1 := Chr(w2);
    Abstimmung;
    TextColor(Blue + 16);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 10);
        Write('|');
      END;
      GotoXY(5 * Index1, Anzahl + 11);
      Write('V');
    END;
    TextColor(Blue);
    Write(ComOut, Synchron_0);
    Write(ComOut, Transfer);
    Write(ComOut, Transfer1);
    FOR j := 1 TO Length(Ergebnis) DO BEGIN
      Transfer := Ergebnis[j];
      Write(ComOut, Transfer);
    END;
    Write(ComOut, Synchron_0);
    Write(ComOut, Kennung);
    FOR j := 1 TO Length(Zusatz_Info) DO BEGIN
      Transfer := Zusatz_Info[j];
      Write(ComOut, Transfer);
    END;
    Write(ComOut, Synchron_0);
    REPEAT
      Read(Info, Transfer);
      Write(ComOut, Transfer);
      GotoXY(39, 19);
      Write(Counter:6);
      Inc(Counter);
    UNTIL EoF(Info);
    Write(ComOut, Synchron_0);
    Schliessen;
    Close(Info);
    TextColor(White);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 10);
        Write(' ');
      END;
      GotoXY(5 * Index1, Anzahl + 11);
      Write(' ');
    END;
    TextColor(Blue);
    TextBackground(White);
    GotoXY(32, 17);
    Write('                   ');
    GotoXY(32, 18);
    Write('                   ');
    GotoXY(32, 19);
    Write('                   ');
  END;

  PROCEDURE Kontakt;
  VAR
    Index1, Index2 : INTEGER;
    Counter_Ende   : LongInt;
    Zahl, Zahl1    : INTEGER;
    h, h1          : LongInt;
  BEGIN
    Counter := 0;
    Oeffnen;
    Name        := '';
    Zusatz_Info := '';
    Abstimmung;
    REPEAT
      Read(ComIn, Transfer);
    UNTIL(Ord(Transfer) = 0);
    Read(ComIn, Transfer);
    Read(ComIn, Transfer1);
    h1           := Ord(Transfer1);
    h            := Ord(Transfer);
    Counter_Ende := h1 + 256 * h;
    REPEAT
      Read(ComIn, Transfer);
      IF Ord(Transfer) > 0 THEN
        Name := Name + Transfer;
    UNTIL (Ord(Transfer) = 0);
    Read(ComIn, Kennung);
    REPEAT
      Read(ComIn, Transfer);
      IF Ord(Transfer) > 0 THEN
        Zusatz_Info := Zusatz_Info + Transfer;
    UNTIL (Ord(Transfer) = 0);
    GotoXY(32, 17);
    Write('Datei  : ', Name);
    GotoXY(32, 18);
    Write('Lnge  : ', Counter_Ende:6);
    GotoXY(32, 19);
    Write('Stand  : ');
    GotoXY(32, 20);
    Write('Info   : ', Zusatz_Info);
    GotoXY(32, 21);
    Write('Kennung: ', Kennung);
    TextColor(Blue + 16);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2+11);
        Write('|');
      END;
      GotoXY(5 * Index1, 11);
      Write('^');
    END;
    TextColor(Blue);
    IF Kennung = 'A' THEN BEGIN
      Assign(Info, Name);
      Rewrite(Info);
      REPEAT
        Read(ComIn, Transfer);
        Inc(Counter);
        Write(Info, Transfer);
        GotoXY(41, 19);
        Write(Counter:6);
      UNTIL (Counter = Counter_Ende);
      Close(Info);
    END;
    Schliessen;
    TextColor(White);
    FOR Index1 := 1 TO Striche DO BEGIN
      FOR Index2 := 1 TO Anzahl DO BEGIN
        GotoXY(5 * Index1, Index2 + 11);
        Write(' ');
      END;
      GotoXY(5 * Index1, 11);
      Write(' ');
    END;
    TextColor(Blue);
    TextBackground(White);
    FOR i := 1 TO 5 DO BEGIN
      GotoXY(32, i + 16);
      Write('                                ');
    END;
  END;

BEGIN
  Cursor_Weg;
  TextColor(Blue); TextBackground(White);
  ClrScr;
  Doppelfenster(30, 16, 79, 16);
  Doppelfenster(30,  3, 30, 22);
  Doppelfenster( 1, 22, 79, 24);
  Doppelfenster( 1,  1, 79,  3);
  Doppelfenster( 1,  1, 79, 24);
  GotoXY(14, 2);
  Write('P A R A L L E L - M O N I T O R   (S L A V E)');
  GotoXY(2, 23);
  Write('   Status RS232:       ', Baud, '    ',
        Parity, '   ', Datenbit, '   ', Stopbit);
  Doppelfenster( 5,  6, 25, 10);
  GotoXY(10, 8);
  Write(' S L A V E');
  Doppelfenster( 5, 15, 25, 19);
  GotoXY(10, 17);
  Write('M A S T E R');
  Ende := FALSE;
  REPEAT
    Kontakt;
    CASE Kennung OF
      'A' : BEGIN
              GotoXY(40, 19);
              Write('PARALLELARBEIT LUFT!');
              Exec(Name, Zusatz_Info);
              Ergebnis := '';
              i        := 0;
              REPEAT
                Inc(i);
              UNTIL Zusatz_Info[i] = ' ';
              REPEAT
                Inc(i);
              UNTIL Zusatz_Info[i] = ' ';
              Inc(i);
              WHILE ((Zusatz_Info[i] <> ' ') AND
                     (i <= Length(Zusatz_Info))) DO BEGIN
                Ergebnis := Ergebnis + Zusatz_Info[i];
                Inc(i);
              END;
              Kennung := 'A';
              GotoXY(40, 19);
              Write('                     ');
              Master_Slave;
            END;
      'E' : Ende := TRUE;
    END;
    GotoXY(40, 19);
    Write('                           ');
  UNTIL Ende;
  NormVideo;
  ClrScr;
  Cursor_Holen;
  WriteLn('Fertig!');
END.
(* ====================================================== *)
(*                   Ende von SLAVE.PAS                   *)

