(*========================================================*)
(*                     MAKERD.PAS v1.1                    *)
(* Erzeugt die Datei README.INC fr README.PAS. Die       *)
(* Quelldatei mu auf der Kommandozeile angegeben werden  *)
(* und darf nicht lnger als 700 Zeilen  80 Zeichen sein *)
(*========================================================*)
(* neu in Version 1.1: ReadLn fr die Infozeile           *)
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

PROGRAM MakeReadMeInclude;

CONST
  ScreenLines = 23;  (* identisch definiert in README.PAS *)

VAR
  t        : Text;
  a        : ARRAY[1..700] OF STRING[80]; 
                                  (* ^^ der Rest ist weg  *)
  j, i     : INTEGER;
  InfoLine : STRING;

BEGIN
  WriteLn('MAKE-README.INC v.1.1:');
  IF ParamCount < 1 THEN BEGIN
    WriteLn('Die Quelldatei mu mit Pfad und Endung auf');
    WriteLn('der Kommandozeile angegeben werden. Die');
    WriteLn('Zieldatei erhlt automatisch den Namen');
    WriteLn('README.INC.');
    ExitCode := 10;
  END ELSE BEGIN
    IF (Pos('?', ParamStr(1)) > 0) OR
       (Pos('*', ParamStr(1)) > 0) THEN
    BEGIN
      WriteLn('WildCards sind nicht erlaubt! '+
              'Programm wird abgebrochen.');
      ExitCode := 20;
    END ELSE BEGIN
      Assign(t, ParamStr(1));
      Reset(t);
      IF IOResult <> 0 THEN BEGIN
        WriteLn('Quelldatei ', ParamStr(1),
                ' konnte nicht geffnet werden!');
        ExitCode := 30;
      END ELSE BEGIN
        i := 0;
        WHILE NOT EoF(t) DO BEGIN
          Inc(i);
          ReadLn(t, a[i]);
          IF Pos(#39, a[i]) > 0 THEN
            (* aus ' ein '' machen *)
            IF Pos(#39#39, a[i]) <> Pos(#39, a[i]) THEN
              Insert(#39, a[i], Pos(#39, a[i]));
        END;
        Close(t);
        Assign(t, 'README.INC');
        Rewrite(t);
        WriteLn('Bitte den Namen fr den Header eingeben ',
              '(nur eine Zeile!), mit [Enter] abschlieen');
        Write('--> ');
        ReadLn(InfoLine);
        WriteLn(t, '(* ==================================' +
                   '============='
                 + '==================== *)');
        WriteLn(t, '(*                  README.INC fr RE' +
                   'ADME.PAS                          *)');
        WriteLn(t, '(*                     erzeugt von '   +
                   'MAKE-RD        '
                 + '                     *)');
        WriteLn(t, '(* =================================' +
                   '=============='
                 + '==================== *)');
        WriteLn(t, #13#10'CONST');
        WriteLn(t, '  InfoLine    = ''', InfoLine, ''';');
        WriteLn(t, '  NumOfLines  = ', i + ScreenLines, ';'
                 + #13#10);
        WriteLn(t, '  README_TEXT : ARRAY[1..NumOfLines] OF'
                 + ' pChar =(');
        FOR j := 1 TO i DO WriteLn(t, '   ''', a[j], +
                    '''#0,');
        Write(t, '   ');
        FOR j := i TO i + ScreenLines - 4 DO
          WriteLn(t, #39#39'#0, ');
        WriteLn(t, #39#39'#0, '#39#39'#0, '#39#39'#0);'+
                   #13#10#13#10);
        WriteLn(t, '(* ================================' +
                   '==============='
                 + '==================== *)'#13#10);
        Close(t);
        WriteLn('README.INC aus der Datei ', ParamStr(1),
                ' erzeugt.');
        ExitCode := 0;
      END;
    END;
  END;
END.

(*========================================================*)
(*                    Ende von MAKERD.PAS                 *)

