(* ====================================================== *)
(*                    README.PAS v2.2                     *)
(*    Copyright (C) 1993, 1994 J. Braun & DMV-Verlag      *)
(*      Compiler: Turbo Pascal/Borland Pascal 7.0         *)
(* ------------------------------------------------------ *)
(*  Lesen von Texten, die via README.INC eingelinkt     *)
(*  werden. README.INC wird mit MAKERD.PAS erzeugt und  *)
(*  darf nicht lnger als 700 Zeilen  79 Zeichen sein!   *)
(*  Das Programm darf nur im REAL-MODE compiliert werden, *)
(*  da direkte Speicherzugriffe verwendet werden.         *)
(* ====================================================== *)
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X+,P-,Q-,T-,Y-}
{$M $3FF1,0,$FFFF}
{$IFNDEF VER70}  Fehler: Falsche Compiler-Version   {$ENDIF}
{$IFDEF Windows} Fehler: Falsches Target!           {$ENDIF}
{$IFDEF DPMI}    Fehler: Falsches Target!           {$ENDIF}

PROGRAM ReadMe;

USES
  Crt, Dos, Strings, Printer, Cursor, ReadUnit;
(* Den Quellcode der Units ReadUnit und Cursor finden *)
(* Sie in: M. Starke (Hrsg.): Borland Pascal 7.0 - Das    *)
(* Buch; te-wi Verlag, 1993, ISBN 3-89362-288-8, DM 89,-- *)

TYPE
  tTextScreen = ARRAY[0..24, 0..79] OF RECORD
                  char: CHAR;
                  attr: BYTE;
                END;

CONST
  FirstPosition =  1; (* Anzahl der Spaces links vom Text *)
  ScreenLines   = 23; (* 23 BS-Zeilen sind nutzbar, erste *)
                      (* und letzte Zeile fallen weg      *)

  StatusColor : BYTE    = $70; (* schwarz auf wei        *)
  ErrorColor  : BYTE    = $74; (* rot auf wei            *)
  PrintColor  : BYTE    = $47; (* wei auf rot            *)
  SearchColor : BYTE    = $D0; (* schwarz auf Magenta und *)
                               (* zustzlich blinkend     *)
  HelpColor   : BYTE    = $30; (* schwarz auf Cyan        *)
  DosBoxColor : BYTE    = $1F; (* wei auf blau           *)
  NormColor   : BYTE    = $1E; (* gelb auf blau           *)

{$I README.INC}

VAR
  (* Es wird gnadenlos in den Bildschirmspeicher          *)
  (* geschrieben (Unterscheidung HGC/Color):              *)
  MonoScreen     : tTextScreen ABSOLUTE $B000:$0000;
  ColorScreen    : tTextScreen ABSOLUTE $B800:$0000;
  ActualColor    : BYTE;
  DoBeep,
  Monochrom      : BOOLEAN;

(* ------------------------------------------------------ *)

PROCEDURE Beep(CONST Wait : Word);
BEGIN
  IF DoBeep THEN BEGIN
    Sound(900);
    Delay(50);
    NoSound;
  END;
  IF Wait > 0 THEN Delay(Wait);
END;

(* ------------------------------------------------------ *)

PROCEDURE OutTextXY(CONST Str            : STRING;
                    CONST Attr           : BYTE;
                    CONST Line, FirstPos : INTEGER);

  PROCEDURE ClearMonoLine;
  VAR
    x: INTEGER;
  BEGIN
    FOR x := 0 TO 79 DO BEGIN
      (* direkt in den BS-Speicher, kein DPMI *)
      MonoScreen[Line - 1, x].attr := Attr;
      MonoScreen[Line - 1, x].char := #32;
    END;
  END;

  PROCEDURE ClearColorLine;
  VAR
    x: INTEGER;
  BEGIN
    FOR x := 0 TO 79 DO BEGIN
      (* direkt in den BS-Speicher, kein DPMI *)
      ColorScreen[Line - 1, x].attr := Attr;
      ColorScreen[Line - 1, x].char := #32;
    END;
  END;

VAR
  x: INTEGER;
BEGIN
  IF Monochrom THEN BEGIN
    ClearMonoLine;
    (* Display Text *)
    IF Length(Str) > 0 THEN
      FOR x := 1 TO Length(Str) DO
        IF x + FirstPos < 81 THEN
          MonoScreen[Line - 1, x - 1 + FirstPos].char :=
                    Str[x];
  END ELSE BEGIN
    ClearColorLine;
    (* Display Text *)
    IF Length(Str) > 0 THEN
      FOR x := 1 TO Length(Str) DO
        IF x + FirstPos < 81 THEN (* wg. berlauf! *)
          ColorScreen[Line - 1, x - 1 + FirstPos].char :=
                      Str[x];
  END;
END;

(* ------------------------------------------------------ *)

PROCEDURE DisplayFooter;
CONST
  StatusLine  = '['#24'] [Bild'#24'] ['#25'] ' +
                '[Bild'#25'] [Pos1] [Ende] '   +
                '[S]uchen e[X]it [D]ruck [T]o' +
                'n [F1]=Hilfe';
BEGIN
  OutTextXY(StatusLine, StatusColor, 25, 1);
END;

(* ------------------------------------------------------ *)

PROCEDURE DisplayHeader;
BEGIN
  OutTextXY(InfoLine, StatusColor, 1,
            40 - Length(InfoLine) DIV 2);
END;

(* ------------------------------------------------------ *)

PROCEDURE ScrollThruText(VAR Line : INTEGER);
VAR
  i, y   : INTEGER;
  OutStr : STRING;
BEGIN
  Window(1 + FirstPosition, 2, 80, Succ(ScreenLines));
  GotoXY(1, ScreenLines);
  IF Line < NumOfLines THEN y := Pred(Line)
                    ELSE y := 1;
  FOR i := y + Succ(ScreenLines) TO NumOfLines DO BEGIN
    Line := i - ScreenLines;
    OutStr := StrPas(README_TEXT[i - 1]);
    IF Length(OutStr) > 80 - FirstPosition THEN BEGIN
      OutStr[0] := Chr(80 - FirstPosition);   (* cut it ! *)
      Write(OutStr);
    END ELSE WriteLn(OutStr);
    OutTextXY(StrPas(README_TEXT[(i)]), TextAttr,
              Succ(ScreenLines), FirstPosition);
    IF KeyPressed THEN
      IF ReadKey = #32 THEN BEGIN
        Inc(Line);
        Exit;
      END;
    Delay(150);
  END;
  Inc(Line);
END;

(* ------------------------------------------------------ *)

PROCEDURE Help;
VAR
  ch  : CHAR;

  PROCEDURE WriteAt(CONST WhichLine : INTEGER;
                    CONST MsgStr    : STRING);
  BEGIN
    OutTextXY(MsgStr, HelpColor, WhichLine,
                                 40 - Length(MsgStr) DIV 2);
  END;

BEGIN
  WriteAt( 2, ''+
              'Ŀ');
  WriteAt( 3, '   H I L F E   Z U   D E N   T A S T E N ' +
              'F U N K T I O N E N    ');
  WriteAt( 4, ''+
              'Ĵ');
  WriteAt( 5, '                                          '+
              '                      ');
  WriteAt( 6, ' [CursorUp]/[CursorDown]   Scrollen nach ' +
              'oben und unten         ');
  WriteAt( 7, ' [Home]                    Zum Textanfang '+
              'springen              ');
  WriteAt( 8, ' [End]                     Zum Textende '  +
              'springen                ');
  WriteAt( 9, ' [PgDn]                    Eine Seite nach'+
              ' unten blttern       ');
  WriteAt(10, ' [PgUp]                    Eine Seite nach'+
              ' oben blttern        ');
  WriteAt(11, '                                         ' +
              '                       ');
  WriteAt(12, ' [ESC], [ALT]-[X], [F10]   Programm beend' +
              'en                     ');
  WriteAt(13, '                                          '+
              '                      ');
  WriteAt(14, ' [D]                       Text ausdrucken'+
              '                      ');
  WriteAt(15, ' [F2]                      Text in '       +
              '(anzugebender) Datei sichern ');
  WriteAt(16, ' [S]                       Text suchen    '+
              '                      ');
  WriteAt(17, ' [L]                       Text automatisc'+
              'h nach unten scrollen ');
  WriteAt(18, '                                          '+
              '                      ');
  WriteAt(19, ' [>]                       Farbattribut um'+
              ' 1 erhhen            ');
  WriteAt(20, ' [<]                       Farbattribut um'+
              ' 1 erniedrigen        ');
  WriteAt(21, ' [T]                       Fehlerton '     +
              '(falsche Taste) umschalten ');
  WriteAt(22, ' [O]                       Dos aufruf'     +
              'en (Zurck mit Exit      ');
  WriteAt(23, '                                        '  +
              '                        ');
  WriteAt(24, '' +
              '');
  OutTextXY('Hilfebildschirm - zurck mit beliebiger ' +
            'Taste ...', StatusColor, 25, 1);
  ch := ReadKey;
  IF ch = #0 THEN ch := ReadKey;
  DisplayFooter;
END;

(* ------------------------------------------------------ *)

PROCEDURE SaveToFile;
VAR
 test, i  : INTEGER;
 FileName : STRING;
 Attr     : BYTE;
 t        : Text;
BEGIN
  SetCursor(StartCursor);
  OutTextXY('Dateiname (mit Pfad) + '#17#196#196#217'):',
            StatusColor, 25, 1);
  GotoXY(32, 25);
  Attr     := TextAttr;
  TextAttr := StatusColor;
  FileName := ReadString(49, test);
  TextAttr := Attr;
  IF test = 27 {Es wurde ESC gedrckt} THEN FileName := '';
  HideCursor;
  IF FileName = '' THEN BEGIN
    IF DoBeep THEN Beep(0);
  END ELSE BEGIN
    FOR i := 1 TO Length(FileName) DO
      FileName[i] := UpCase(FileName[i]);
    OutTextXY('Speichere Text in ' + FileName,
              StatusColor, 25, 1);
    Delay(500);
    Assign(t, FileName);
    {$I-}
    Rewrite(t);
    IF IOResult <> 0 THEN BEGIN
      Close(t);
      OutTextXY('Fehler beim Speichern von ' +
                FileName + '!', ErrorColor, 25, 1);
      Beep(1000);
    END ELSE BEGIN
      (* Den Overhead in ScreenLines nicht sichern! *)
      FOR i := 1 TO NumOfLines - ScreenLines DO
        WriteLn(t, README_TEXT[i]);
      Close(t);
    END;
  END;
  DisplayFooter;
END;

(* ------------------------------------------------------ *)

PROCEDURE PrintText;
VAR
  i  : INTEGER;
  ch : CHAR;
BEGIN
  OutTextXY('Datei wird ausgedruckt, Abbruch mit <ESC> ' +
            'sonst bitte warten ...', PrintColor, 25, 1);
  Delay(1000);
  FOR i := 1 TO NumOfLines - ScreenLines DO BEGIN
    (* den Overhead in Screenlines nicht drucken! *)
    IF KeyPressed THEN BEGIN
      ch := ReadKey;
      IF ch = #27 THEN BEGIN
        OutTextXY('Ausdruck wird abgebrochen ...',
                  ErrorColor, 25, 1);
        Beep(500);
        DisplayFooter;
        Exit;
      END;
    END;
    WriteLn(Lst, StrPas(README_TEXT[i]));
  END;
  Write(Lst, ^L);            (* Seitenvorschub zum Schlu *)
  DisplayFooter;
END;

(* ------------------------------------------------------ *)

PROCEDURE ChangeColor(CONST b : BOOLEAN);
VAR
  ColStr : STRING[3];
  x, y   : BYTE;
BEGIN
  IF b THEN BEGIN  (* + *)
    TextAttr := Succ(TextAttr);
    IF ((TextAttr SHR 4) AND TextAttr = 1) OR
       (TextAttr = 0) THEN
      TextAttr := Succ(TextAttr);
  END ELSE BEGIN   (* - *)
    TextAttr := Pred(TextAttr);
    IF ((TextAttr SHR 4) AND TextAttr = 1) OR
       (TextAttr = 0) THEN
      TextAttr := Pred(TextAttr);
  END;
  Str(TextAttr: 3, ColStr);
  IF Monochrom THEN BEGIN
    MonoScreen[0, 76].char := ColStr[1];
    MonoScreen[0, 77].char := ColStr[2];
    MonoScreen[0, 78].char := ColStr[3];
    FOR y := 1 TO 23 DO
      FOR x := 0 TO 79 DO
        MonoScreen[y, x].attr := TextAttr;
    Delay(100);
    MonoScreen[0, 76].char := #32;
    MonoScreen[0, 77].char := #32;
    MonoScreen[0, 78].char := #32;
  END ELSE BEGIN
    ColorScreen[0, 76].char := ColStr[1];
    ColorScreen[0, 77].char := ColStr[2];
    ColorScreen[0, 78].char := ColStr[3];
    FOR y := 1 TO 23 DO
      FOR x := 0 TO 79 DO
        ColorScreen[y, x].attr := TextAttr;
    Delay(100);
    ColorScreen[0, 76].char := #32;
    ColorScreen[0, 77].char := #32;
    ColorScreen[0, 78].char := #32;
  END;
END;

(* ------------------------------------------------------ *)

FUNCTION SearchForString(VAR Line : INTEGER) : BYTE;
VAR
  ExitChar, i  : INTEGER;
  Attr         : BYTE;
  TextStr,
  SearchStr    : pChar;
  SearchString : STRING;
BEGIN
  SetCursor(StartCursor);
  Attr := TextAttr;
  TextAttr := StatusColor;
  OutTextXY('Text suchen: ', TextAttr, 25, 1);
  GotoXY(15, 25);
  SearchString := ReadString(49, ExitChar);
  HideCursor;
  TextAttr := Attr;
  IF ExitChar = 27 THEN BEGIN
    SearchForString := 2;
    Exit;
  END;
  IF Length(SearchString) > 0 THEN BEGIN
    GetMem(SearchStr, $100);
    GetMem(TextStr,   $100);
    StrPCopy(SearchStr, SearchString);
    StrCopy(SearchStr, StrUpper(SearchStr));
    IF Line >= NumOfLines - ScreenLines - 1 THEN Line := 1;
    FOR i := Line + 1 TO NumOfLines DO BEGIN
    { nicht die aktuelle erste sondern nchste Zeile am BS }
      StrCopy(TextStr, StrUpper(README_TEXT[i]));
      IF StrPos(TextStr, SearchStr) <> NIL THEN BEGIN
        Line            := i;
        SearchForString := 1;
        FreeMem(SearchStr, $100);
        FreeMem(TextStr,   $100);
        Exit;
      END;
    END;
    Line := NumOfLines;
  END ELSE BEGIN
    SearchForString := 2;
    Exit;
  END;
  Line := NumOfLines - ScreenLines;
  SearchForString := 0;
END;

(* ------------------------------------------------------ *)

FUNCTION DosShell(CONST Line : INTEGER) : INTEGER;
VAR
  Attr : BYTE;
  i, y : INTEGER;
BEGIN
  Attr     := TextAttr;
  TextAttr := DosBoxColor;
  ClrScr;
  WriteLn(^J'Zurck zum Programm mit Exit'
            + #17#196#196#217#10);
  BlockCursor;
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '');
  DosShell := DosError;
  SwapVectors;
  HideCursor;
  TextAttr := Attr;
  y        := 1;
  FOR i := Line TO Line + Pred(ScreenLines) DO BEGIN
    Inc(y);
    OutTextXY(StrPas(README_TEXT[i]), TextAttr, y,
              FirstPosition);
  END;
  DisplayHeader;
END;

(* ====================================================== *)

VAR
  Key, ch             : CHAR;
  LineCounter,
  y, OutPutLine       : INTEGER;
  DefaultColor, Found : BYTE;
  LineScroll, Done    : BOOLEAN;

BEGIN
  IF IOResult <> 0 THEN ;
  Monochrom    := Byte(Ptr(Seg0040, $0049)^) = 7; (* HGC  *)
  CheckBreak   := FALSE;                 (* kein Abbruch  *)
  DirectVideo  := TRUE;                  (* schneller     *)
  DoBeep       := TRUE; (* Falls Ton unerwnscht := FALSE *)
  DefaultColor := TextAttr;              (* Farben merken *)
  HideCursor;                            (* Unit Cursor   *)
  ClrScr;
  IF Monochrom OR (Byte(Ptr(Seg0040, $49)^) = 2) THEN BEGIN
    StatusColor := $70;          (* invertiert            *)
    ErrorColor  := $1F;          (* wei auf grau         *)
    PrintColor  := $10;          (* invertiert            *)
    SearchColor := $F0;          (* invertiert + blinkend *)
    HelpColor   := $0F;          (* hell                  *)
    DosBoxColor := $0F;          (* normal                *)
    NormColor   := $07;          (* normal                *)
  END;                           (* $01 = unterstrichen   *)
  DisplayHeader;
  DisplayFooter;
  TextAttr := NormColor;
  FOR y := 1 TO ScreenLines DO
    OutTextXY(StrPas(README_TEXT[y]), TextAttr, y + 1,
              FirstPosition);
  LineCounter := 1;
  REPEAT
    LineScroll := FALSE;
    Key        := ReadKey;
    CASE UpCase(Key) OF
      'T' : DoBeep := NOT DoBeep;           (* Umschalter *)
      'O' : BEGIN
              IF DosShell(LineCounter) <> 0 THEN BEGIN
                OutTextXY('Shell konnte nicht ausgefhrt' +
                          ' werden!', ErrorColor, 25, 1);
                Beep(1500);
              END;
              DisplayFooter;
            END;
      'S' : BEGIN
              Found       := SearchForString(LineCounter);
              ActualColor := TextAttr;
              OutPutLine  := 1;
              FOR y := LineCounter TO
                LineCounter + Pred(ScreenLines) DO BEGIN
                Inc(OutPutLine);
                OutTextXY(StrPas(README_TEXT[y]), TextAttr,
                          OutPutLine, FirstPosition);
              END;
              OutPutLine := 1;
              IF Found = 1 THEN BEGIN
                OutTextXY('Textstelle gefunden!',
                          StatusColor, 25, 1);
                IF Monochrom THEN
                  FOR y := 0 TO 79 DO
                    MonoScreen[1, y].attr := SearchColor
                ELSE
                  FOR y := 0 TO 79 DO
                    ColorScreen[1, y].attr := SearchColor;
                Delay(1000);
              END ELSE IF Found = 0 THEN BEGIN
                OutTextXY('Textstelle nicht gefunden!',
                          ErrorColor, 25, 1);
                Beep(1000);
              END ELSE BEGIN
                OutTextXY('Suche wurde abgebrochen',
                          ErrorColor, 25, 1);
                Beep(1000);
              END;
              TextAttr := ActualColor;
              IF Monochrom THEN
                FOR y := 0 TO 79 DO
                  MonoScreen[1, y].attr := ActualColor
              ELSE
                FOR y := 0 TO 79 DO
                  ColorScreen[1, y].attr := ActualColor;
              DisplayFooter;
            END;
       'D': PrintText;
       'L': BEGIN
              ActualColor := TextAttr;
              OutTextXY('Text wird bis zum Ende durchge' +
                        'scrollt, Ende mit <Leertaste> ' +
                        'oder warten ...', StatusColor, 25,
                        1);
              ScrollThruText(LineCounter);
              TextAttr := ActualColor;
              Window(1, 1, 80, 25);
              DisplayFooter;
              LineScroll := TRUE;
              OutPutLine := 1;
              FOR y := LineCounter TO
                LineCounter + Pred(ScreenLines) DO BEGIN
                Inc(OutPutLine);
                OutTextXY(StrPas(README_TEXT[y]), TextAttr,
                          OutPutLine, FirstPosition);
              END;
            END;
       '>': ChangeColor(TRUE);
       '<': ChangeColor(FALSE);
       'X': Key := #27;                           (* Ende *)
       #27: ;                   (* einfachste Mglichkeit *)
                                (* um Beep auszuschlieen *)
      ELSE IF Key <> #0 THEN Beep(0);
    END;

    IF Key = #0 THEN BEGIN
      Done := TRUE;
      IF NOT LineScroll THEN ch := ReadKey;
      CASE ch OF
        ';': Help;
        '<': SaveToFile;
        '-',
        'D': Key := #27;                          (* Ende *)
        'H': IF LineCounter > 1 THEN Dec(LineCounter)
                                ELSE Done := FALSE;
        'P': IF LineCounter <
                NumOfLines - Pred(ScreenLines) THEN
               Inc(LineCounter)
             ELSE
               Done := FALSE;
        'G': IF LineCounter > 1 THEN LineCounter:= 1
                                ELSE Done := FALSE;
        'O': IF LineCounter <
                NumOfLines - Pred(ScreenLines) THEN
               LineCounter := NumOfLines - Pred(ScreenLines)
             ELSE
               Done := FALSE;
        'Q': IF LineCounter < (NumOfLines -
                Pred(ScreenLines) SHL 1) THEN
               Inc(LineCounter, ScreenLines)
             ELSE IF LineCounter = (NumOfLines -
                     Pred(ScreenLines) SHL 1) THEN
               Done := FALSE
             ELSE
               LineCounter := NumOfLines - Pred(ScreenLines);
        'I': IF LineCounter > (ScreenLines SHL 1) THEN
               Dec(LineCounter, ScreenLines)
             ELSE IF LineCounter = 1 THEN
               Done := FALSE
             ELSE
               LineCounter := 1;
        ELSE Beep(0);
             Done := FALSE;
      END;
      IF Done THEN BEGIN
        OutPutLine := 1;
        FOR y := LineCounter TO
                 LineCounter + ScreenLines - 1 DO BEGIN
          Inc(OutPutLine);
          OutTextXY(StrPas(README_TEXT[y]), TextAttr,
                    OutPutLine, FirstPosition);
        END;
      END;
    END;
  UNTIL Key = #27;
  SetCursor(StartCursor);
  TextAttr := DefaultColor;
  ClrScr;
END.

(* ====================================================== *)
(*                 Ende von README.PAS                    *)
