/* ====================================================== */
/*                      HELLO.CPP                         */
/*     Turbo Vision Hello World Demo Source File          */
/*                 (leicht modifiziert)                   */
/*                                                        */
/* gadgets.cpp, tscrgrp.cpp, tlevlvwr.cpp und             */
/* tinstdlg.cpp mssen ins Projekt !                      */
/* ====================================================== */
#define Uses_TKeys
#define Uses_TApplication
#define Uses_TEvent
#define Uses_TRect
#define Uses_TDialog
#define Uses_TStaticText
#define Uses_TButton
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
// #define Uses_TVMemMgr
#define Uses_TWindow
#define Uses_TDeskTop

#define Uses_ofpstream
#define Uses_ifpstream
#define Uses_TInstDialog
#define Uses_THeapView

#include "tinstdlg.h"
#include <gadgets.h>

// man feiert wahre Linkorgien, will man einen etwas
// komplexeren Dialog speichern und laden - und wehe dem,
// der RStringCollection vergit, wenn er wagt,
// TCheckBoxes speichern zu wollen!

__link (RFrame)
__link (RInstDialog)
__link (RButton)
__link (RInstViewer)
__link (RCheckBoxes)
__link (RInputLine)
__link (RLabel)
__link (RScrollGroup)
__link (RScrollBar)
__link (RStringCollection)
__link (RVDCollection)

const GreetThemCmd = 100;     // das bliche...
const cmNewWindow  = 101;     // Fenster in Desktop einfgen
const cmLoadDialog = 102;     // Dialog laden,
const cmSaveDialog = 103;     // speichern
const cmInstDialog = 104;     // und ausfhren

class THelloApp : public TApplication
{
  THeapView* heap;

public:
  THelloApp();
  virtual void        getEvent(TEvent& event);
          void        executeInstDialog
                                   (TDialog *dialog = NULL);
          void        greetingBox ();
  virtual void        idle (void);
  static  TMenuBar    *initMenuBar(TRect);
  static  TStatusLine *initStatusLine(TRect);
  virtual void        handleEvent(TEvent& event);

public:
  static  const char * const name;

private:
  virtual const char *streamableName (void) const
        { return name; }
};


THelloApp::THelloApp() :
  TProgInit (&THelloApp::initStatusLine,
             &THelloApp::initMenuBar,
             &THelloApp::initDeskTop)
{
  heap = new THeapView(TRect (66, 24, 80, 25));
  insert (heap);
//  TVMemMgr::resizeSafetyPool(8192);
}

// executeInstDialog bernimmt die Ausfhrung des
// bergebenen Dialogs dialog, per Voreinstellung NULL,
// so da in diesem Fall ein TInstDialog erstellt wird;
// es wird auf validView geprft und der Dialog am Ende
// freigegeben, so da dies der Aufrufer nicht tun darf.

void THelloApp::executeInstDialog(TDialog *dialog)
{
  // falls der Dialog auf Applikationsebene eingefgt werden
  // soll, mu theDialogOwner auf application gesetzt
  // werden. theDialogOwner wird der statischen Methode
  // TInstDialog::sayNoNo bergeben, damit diese
  // entscheiden kann, ob er eine Messagebox
  // anzeigen kann oder nur piepsen darf.

  TGroup *theDialogOwner = deskTop;

  if (!dialog)
    dialog = new TInstDialog ();

  if (validView(dialog))
  {
    theDialogOwner->execView(dialog);
    destroy(dialog);
  }
  else
    TInstDialog::sayNoNo
      ("Nicht gengend Speicher !", theDialogOwner);
}

// Damit ein TInstDialog auch ausgefhrt werden kann, wenn
// gerade ein anderer Dialog aktiv ist (dafr ist er
// schlielich da), fngt getEvent (und nicht
// handleEvent) den Befehl cmInstDialog ab. Damit diese
// Message berhaupt whrend der Ausfhrung eines modalen
// Dialogs verschickt werden kann, fgt man am besten einen
// entsprechenden Eintrag in die Statuszeile ein.

void THelloApp::getEvent(TEvent& event)
{
  TApplication::getEvent(event);

  if (event.what == evCommand &&
      event.message.command == cmInstDialog)
  {
    executeInstDialog();
    clearEvent(event);
  }
}

void THelloApp::greetingBox ()
{
  TDialog *d = new TDialog(TRect(25, 5, 55, 16),
                           "Hello, World!");

  d->insert (new TStaticText(TRect(3, 5, 15, 6),
                             "How are you?"));
  d->insert (new TButton(TRect(16, 2, 28, 4), "Terrific",
                         cmCancel, bfNormal));
  d->insert (new TButton (TRect (16, 4, 28, 6), "Ok",
                          cmCancel, bfNormal+bfDefault));
  d->insert (new TButton (TRect (16, 6, 28, 8), "Lousy",
                          cmCancel, bfNormal));
  d->insert (new TButton (TRect (16, 8, 28, 10), "Cancel",
                          cmCancel, bfNormal));

  deskTop->execView(d);
  destroy(d);
}

void THelloApp::idle (void)
{
  TApplication::idle();
  heap->update();
}

TMenuBar *THelloApp::initMenuBar(TRect r)
{
  r.b.y = r.a.y+1;
  return new TMenuBar(r,
    *new TSubMenu("~H~ello - Instance Dialog", kbAltH) +
      *new TMenuItem("Just the usual ~g~reeting...",
                     GreetThemCmd, kbAltG) +
       newLine() +
      *new TMenuItem("~E~xecute Instance Dialog",
                     cmInstDialog, kbAltE) +
      *new TMenuItem("~S~ave Instance Dialog",
                     cmSaveDialog, kbAltS) +
      *new TMenuItem("~L~oad Instance Dialog",
                     cmLoadDialog, kbAltL) +
       newLine() +
      *new TMenuItem("Insert ~N~ew Window",
                     cmNewWindow, kbAltN) +
       newLine() +
      *new TMenuItem("E~x~it", cmQuit, cmQuit,
                     hcNoContext, "Alt-X"));
}

TStatusLine *THelloApp::initStatusLine(TRect r)
{
  r.a.y = r.b.y-1;
  return new TStatusLine(r,
    *new TStatusDef(0, 0xFFFF) +
      *new TStatusItem("~Alt-X~ Exit   ", kbAltX, cmQuit) +
      *new TStatusItem("~Alt-I~ Instance Dialog",
                       kbAltI, cmInstDialog)+
      *new TStatusItem(0, kbF10, cmMenu));
}

void THelloApp::handleEvent(TEvent& event)
{
  TApplication::handleEvent(event);

  if (event.what == evCommand)
  {
    switch (event.message.command)
    {
      case GreetThemCmd:
        greetingBox();
        clearEvent(event);
        break;
      case cmNewWindow:
        deskTop->insert(new TWindow(TRect(10, 10, 70, 18),
                            " just an empty window ", 0));
        clearEvent(event);
        break;
      case cmSaveDialog:
        TInstDialog *sd = new TInstDialog();
        ofpstream s("hello.dlg");
        s << sd;
        s.close();
        destroy(sd);
        clearEvent(event);
        break;
      case cmLoadDialog:
        TInstDialog *ld = new TInstDialog();
        ifpstream l("hello.dlg");
        l >> ld;
        l.close();
        executeInstDialog(ld);
        clearEvent(event);
        break;

      default:
        break;
    }
  }
}

// Damit das Kind auch einen Namen hat:
const char * const THelloApp::name = "THelloApp";

int main()
{
  THelloApp helloWorld;
  helloWorld.run();
  return 0;
}
/* ====================================================== */
/*                 Ende von HELLO.CPP                     */
