/* ====================================================== */
/*                       HELLO2.CPP                       */
/*                                                        */
/* hello2 demonstriert den Einsatz von abreibaren      */
/* Mens, das Speichern des Desktop in Streams unter      */
/* Bercksichtigung verschiedener, von Turbo Vision nicht */
/* standardmig vorgesehener Bildschirmmodi (hier        */
/* exemplarisch fr die ET4000). Zu diesem Zweck mu      */
/* darauf geachtet werden, da die Objekte, die in den    */
/* Desktop eingefgt werden, auch mit Grennderungen    */
/* des Besitzers, also des Desktops, zurechtzukommen      */
/* wissen. Dialoge spendiert man daher am einfachsten     */
/* das Attribut ofCentered in options, bei Fenstern   */
/* ist gfGrowAll+gfGrowRel schon korrekt gesetzt, und   */
/* bei neuen Objekten wie etwa TPinMenuBox, die ihre    */
/* Gre nicht wie Fenster ndern knnen, gfGrowAll     */
/* gesetzt werden, so da sie einen konstanten Abstand    */
/* zur rechten unteren Bildschirmecke wahren.             */
/* hello2 zeigt nur, wie beliebige Bildschirmmodi       */
/* direkt gesetzt werden, und knnte problemlos erweitert */
/* werden, um vom Benutzer spezifizierte Modi ansteuern   */
/* zu knnen.                                             */
/*                                                        */
/* ripmenu.cpp, msgbox.cpp und gadgets.cpp mssen ins     */
/* Projekt aufgenommen werden !                           */
/*                                                        */
/*     (c) 1993 Raimond Reichert & toolbox                */
/* ====================================================== */
#define Uses_ifpstream
#define Uses_MsgBox
#define Uses_ofpstream
#define Uses_TApplication
#define Uses_TButton
#define Uses_TDeskTop
#define Uses_TDialog
#define Uses_TEvent
#define Uses_THeapView
#define Uses_TKeys
#define Uses_TMenuItem
#define Uses_TRect
#define Uses_TRipMenuBar
#define Uses_TScreen
#define Uses_TStatusDef
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStaticText
#define Uses_TStreamableClass
#define Uses_TSubMenu
#define Uses_TWindow

#include <ripmenu.h>
#include <gadgets.h>

#if !defined (__ASSERT_H)
#include <assert.h>
#endif

__link (RWindow)      // dem Streammanager mitteilen, welche
__link (RStatusLine)  // Objekte wir schreiben oder lesen
__link (RBackground)  // wollen
__link (RDeskTop)
__link (RRipMenuBar)
__link (RPinMenuBox)

const cmGreetDialog = 100;
const cmNewWindow   = 101;
const cmEnableWin   = 103;
const cmSaveDesktop = 104;
const cmLoadDesktop = 105;
const cmScreen0x23  = 106;
const cmScreen0x22  = 107;
const cmScreen0x24  = 108;
const cmScreen0x03  = 109;
const cmScreen0x26  = 110;

class THelloApp : public TApplication
{
protected:
  THeapView *heap;
  ushort screenMode;

public:
  THelloApp(void);

  virtual void changeScreenMode(ushort mode, TRect& bounds);
          void getScreenBounds(ushort mode, TRect& bounds);
          void greetingBox(void);
  virtual void idle(void);
  static       TMenuBar *initMenuBar(TRect);
  static       TStatusLine *initStatusLine(TRect);
  virtual void handleEvent(TEvent& event);
};

// Neu ist hier nur, da das Objekt THeapView eingefgt
// wird. Dabei wird die Position relativ zum Besitzer,
// der Applikation, errechnet und in hape->growMode
// gfGrowAll gesetzt, damit das Objekt bei einem
// Bildschirm-Moduswechsel auch an seinem angestammten
// Platz bleibt, zumindest relativ  gesehen.

THelloApp::THelloApp (void) :
    TProgInit (&THelloApp::initStatusLine,
               &THelloApp::initMenuBar,
               &THelloApp::initDeskTop)
{
  TRect hr = getBounds ();
  hr.a.y = hr.b.y-1;
  hr.a.x = hr.b.x-14;
  heap = new THeapView (hr);
  heap->growMode |= gfGrowAll;
  insert (heap);
}

// changeScreenMode bernimmt die Aufgabe, in den Modus
// mode zu schalten, dessen Bildschirmausdehnungen in
// bounds anzugeben sind. Die Maus wird versteckt und die
// Methode TScreen::setCrtMode (mode) aufgerufen. Da
// nicht TProgram::setVideoMode aufgerufen wird, liegt
// daran, da durch diese Methode TScreen::fixCrtMode
// aufgerufen wird, eine Methode, die alle anderen als die
// von Turbo Vision vorgesehenen Modi wegfiltert.
// Die neue Gre mu durch changeBounds auch ausgefllt
// werden, und der Maus mu mitgeteilt werden, da sie von
// nun an greren (oder kleineren Bewegungsraum) hat.

void THelloApp::changeScreenMode(ushort mode, TRect& bounds)
{
  if (mode != TScreen::screenMode)
  {
    TScreen::screenMode = mode;
    TMouse::hide ();
    TScreen::setCrtMode (mode);
    changeBounds (bounds);
    TMouse::setRange (bounds.b.x-1, bounds.b.y-1);
    TMouse::show ();
  }
}

void assign (TRect& bounds, int ax, int ay, int bx, int by)
{
  bounds.a.x = ax; bounds.a.y = ay;
  bounds.b.x = bx; bounds.b.y = by;
}

// Diese Methode wird von handleEvent aufgerufen, falls
// der Desktop mit zugehrigem Bildschirmmodus geladen
// werden soll und daher die Ausdehnung dieses Modus
// bentigt wird.
// ACHTUNG: Ein unbekannter Modus kann nicht gesetzt
// werden, daher bricht das Programm mit assert(False); ab!

void THelloApp::getScreenBounds(ushort mode, TRect& bounds)
{
  switch (mode)
  {
    case 0x03:
      assign (bounds, 0, 0, 80, 25);
      break;
    case 0x22:
      assign (bounds, 0, 0, 132, 44);
      break;
    case 0x23:
      assign (bounds, 0, 0, 132, 25);
      break;
    case 0x24:
      assign (bounds, 0, 0, 132, 28);
      break;
    case 0x26:
      assign (bounds, 0, 0, 80, 60);
      break;
    default:
      assert (False);
      break;
  }
}

void THelloApp::greetingBox (void)
{
  TDialog *d = new TDialog(TRect(25, 5, 55, 16),
                           "Hello, World!");

  d->insert (new TStaticText(TRect(3, 5, 15, 6),
                           "How are you?"));
  d->insert (new TButton(TRect(16, 2, 28, 4), "Terrific",
                         cmCancel, bfNormal));
  d->insert (new TButton(TRect(16, 4, 28, 6), "Ok",
                         cmCancel, bfNormal));
  d->insert (new TButton(TRect(16, 6, 28, 8), "Lousy",
                         cmCancel, bfNormal));
  d->insert (new TButton(TRect(16, 8, 28, 10), "Cancel",
                         cmCancel, bfNormal));
  d->options |= ofCentered;
  deskTop->execView (d);
  destroy (d);
}

// handleEvent reagiert auf diverse Menbefehle wie
// cmGreetDialog, cmNewWindow oder cmEnableWin, das
// eigentlich nur dem Testen diente, ob eingelesene
// Pinmenboxen sich auch korrekt zu prsentieren wissen,
// cmSave/LoadDesktop und cmScreen0xyy. Beim Speichern
// des Desktop wird der aktive Bildschirmmodus auch
// gesichert, und beim Laden wird er gesetzt, damit sich
// dem Benutzer das gleiche Bild wie zum Zeitpunkt des
// Speicherns bietet.

void THelloApp::handleEvent(TEvent& event)
{
  TApplication::handleEvent (event);
  if (event.what == evCommand)
  {
    switch (event.message.command)
    {
      case cmGreetDialog:
        greetingBox ();
        clearEvent (event);
        drawView ();
        break;
      case cmNewWindow:
        TWindow *win = new TWindow(TRect(10, 10, 70, 15),
                               "just for fun", wnNoNumber);
        TProgram::deskTop->insert (win);
        break;
      case cmEnableWin:
        if (commandEnabled (cmNewWindow))
          disableCommand (cmNewWindow);
        else
          enableCommand (cmNewWindow);
        break;
      case cmSaveDesktop:
        ofpstream saveDesk ("hello-2.dsk");
        saveDesk << TScreen::screenMode << deskTop;
        saveDesk.close ();
        break;
      case cmLoadDesktop:
        ifpstream loadDesk ("hello-2.dsk");
        if (loadDesk.good ())
        {
          ushort mode;
          destroy (deskTop);
          loadDesk >> mode >> deskTop;
          loadDesk.close ();
          TRect newBounds;
          getScreenBounds (mode, newBounds);
          changeScreenMode (mode, newBounds);
          insert (deskTop);
        }
          else
            messageBox
              ("Fehler beim ffnen des Streams aufgetreten",
               mfOKButton);
            break;
      case cmScreen0x03:
        changeScreenMode (0x03, TRect (0, 0, 80, 25));
        break;
      case cmScreen0x22:
        changeScreenMode (0x22, TRect (0, 0, 132, 44));
        break;
      case cmScreen0x23:
        changeScreenMode (0x23, TRect (0, 0, 132, 25));
        break;
      case cmScreen0x24:
        changeScreenMode (0x24, TRect (0, 0, 132, 28));
        break;
      case cmScreen0x26:
        changeScreenMode (0x26, TRect (0, 0, 80, 60));
        break;
      default:
        break;
    }
  }
}

void THelloApp::idle (void)
{
  TApplication::idle ();
  heap->update ();
}

TMenuBar *THelloApp::initMenuBar(TRect r)
{
  r.b.y = r.a.y+1;
  TRipMenuBar *menu = new TRipMenuBar (r,
    *new TSubMenu ("~H~ello Menu", kbAltH) +
      *new TMenuItem("~G~reeting Dialog ...",
                     cmGreetDialog, kbAltG) +
      *new TMenuItem("Insert ~W~indow",
                     cmNewWindow, kbAltW) +
      *new TMenuItem("~S~ave Desktop",
                     cmSaveDesktop, kbNoKey)+
      *new TMenuItem("~L~oad Desktop",
                     cmLoadDesktop, kbNoKey)+
      *new TMenuItem("~E~nable/Disable Window",
                     cmEnableWin, kbNoKey)+
       newLine () +
      *new TMenuItem("Screen ~M~odes", 0,
        new TMenu (
          *new TMenuItem("Mode 0x03  (80x25)", cmScreen0x03,
                         kbNoKey, hcNoContext, "",
           new TMenuItem("Mode 0x22 (132x44)", cmScreen0x22,
                         kbNoKey, hcNoContext, "",
           new TMenuItem("Mode 0x23 (132x25)", cmScreen0x23,
                         kbNoKey, hcNoContext, "",
           new TMenuItem("Mode 0x24 (132x28)", cmScreen0x24,
                         kbNoKey, hcNoContext, "",
           new TMenuItem("Mode 0x26  (80x60)", cmScreen0x26,
                         kbNoKey, hcNoContext, "")))))))+
       newLine () +
      *new TMenuItem("E~x~it", cmQuit, cmQuit,
                     hcNoContext, "Alt-X"));
    return menu;
}


TStatusLine *THelloApp::initStatusLine( TRect r )
{
  r.a.y = r.b.y-1;
  return new TStatusLine (r,
   *new TStatusDef (0, 0xFFFF) +
      *new TStatusItem ("~Alt-X~ Exit", kbAltX, cmQuit) +
      *new TStatusItem (0, kbF10, cmMenu));
}

int main (void)
{
  THelloApp helloWorld;
  helloWorld.run ();
  return 0;
}
/* ====================================================== */
/*                  Ende von HELLO2.CPP                   */
