/* ----------------------------------------------------------------------- */
/*                              sg-hello.cpp                               */
/*                                                                         */
/*                Turbo Vision Hello World Demo Source File -              */
/*                           slightly modified                             */
/*                                                                         */
/* tscrgrp.cpp und gadgets.cpp mssen ins Projekt aufgenommen werden !     */
/*                                                                         */
/* ----------------------------------------------------------------------- */
#define Uses_TApplication
#define Uses_TEvent
#define Uses_TRect
#define Uses_TDialog
#define Uses_TKeys
#define Uses_TStaticText
#define Uses_TButton
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
#define Uses_TDeskTop

#define Uses_TScrollGroup
#define Uses_TScrollBar
#define Uses_THeapView
#define Uses_ofpstream
#define Uses_ifpstream

#include <tscrgrp.h>
#include <gadgets.h>

__link (RDialog)
__link (RScrollGroup)
__link (RButton)
__link (RStaticText)
__link (RScrollBar)

const GreetThemCmd = 100;
const saveDialog   = 101;
const loadDialog   = 102;

class THelloApp : public TApplication
{
    THeapView* heap;

public:
    THelloApp ();
    virtual void idle (void);
    virtual void handleEvent (TEvent& event);
    static TMenuBar *initMenuBar (TRect);
    static TStatusLine *initStatusLine (TRect);

private:
    void greetingBox ();
};

THelloApp::THelloApp () :
    TProgInit (&THelloApp::initStatusLine,
               &THelloApp::initMenuBar,
               &THelloApp::initDeskTop)
{
    TRect hr = getBounds ();
    hr.a.y = hr.b.y-1;
    hr.a.x = hr.b.x-14;
    heap = new THeapView (hr);
    heap->growMode |= gfGrowAll;
    insert (heap);
}

void THelloApp::idle (void)
{
    TApplication::idle ();
    heap->update ();
}

static TDialog* getGreetingBox (void)
{
    TDialog *d = new TDialog (TRect (10, 2, 55, 20), "Hello, World!");
    d->options |= ofCentered;
    d->insert (new TButton (TRect (16, 2, 28, 4), "Terrific",
                            cmCancel, bfNormal));

    TPoint virtualSize;
    virtualSize.x = 64; virtualSize.y = 18;
    TScrollGroup *sg = new TScrollGroup (TRect (4, 5, 41, 15),
                                         virtualSize, d);
    sg->insert (new TStaticText (TRect (2, 4, 15, 5), "How are you ?"));
    sg->insert (new TButton (TRect (16, 1, 28, 3), "Terrific",
                             cmCancel, bfNormal));
    sg->insert (new TButton (TRect (16, 3, 28, 5), "Ok",
                             cmCancel, bfNormal+bfDefault));
    sg->insert (new TButton (TRect (16, 5, 28, 7), "Lousy",
                             cmCancel, bfNormal));
    sg->insert (new TButton (TRect (16, 7, 28, 9), "Cancel",
                             cmCancel, bfNormal));

    sg->selectNext (False);
    d->insert (sg);
    d->selectNext (False);

    return d;
}

void THelloApp::greetingBox ()
{
    TDialog *d = getGreetingBox ();
    deskTop->execView (d);
    destroy (d);
}

void THelloApp::handleEvent (TEvent& event)
{
    TApplication::handleEvent (event);
    if (event.what == evCommand)
    {
        switch (event.message.command)
        {
            case saveDialog:
                TDialog *sd = getGreetingBox ();
                ofpstream sf ("sg-hello.dlg");
                sf << sd;
                sf.close ();
                destroy (sd);
                break;
            case loadDialog:
                TDialog *ld;
                ifpstream lf ("sg-hello.dlg");
                lf >> ld;
                lf.close ();
                deskTop->execView (ld);
                destroy (ld);
                break;
            case GreetThemCmd:
                greetingBox ();
                clearEvent (event);
                break;
            default:
                break;
        }
    }
}

TMenuBar *THelloApp::initMenuBar (TRect r)
{
    r.b.y = r.a.y+1;
    return new TMenuBar (r,
      *new TSubMenu ("~H~ello", kbAltH) +
        *new TMenuItem ("~G~reeting...", GreetThemCmd, kbAltG) +
         newLine () +
        *new TMenuItem ("~L~oad Dialog", loadDialog, kbAltL) +
        *new TMenuItem ("~S~ave Dialog", saveDialog, kbAltS) +
         newLine () +
        *new TMenuItem ("E~x~it", cmQuit, cmQuit, hcNoContext, "Alt-X"));
}

TStatusLine *THelloApp::initStatusLine (TRect r)
{
    r.a.y = r.b.y-1;
    return new TStatusLine (r,
        *new TStatusDef (0, 0xFFFF) +
            *new TStatusItem ("~Alt-X~ Exit", kbAltX, cmQuit) +
            *new TStatusItem (0, kbF10, cmMenu));
}

int main ()
{
    THelloApp helloWorld;
    helloWorld.run ();
    return 0;
}
