/* ------------------------------------------------------ */
/*                        tscrgrp.h                       */
/*                                                        */
/*                 (c) Raimond Reichert                   */
/*                                                        */
/* Was tun, wenn in einem Dialog nicht alles auf dem Bild-*/
/* schirm Platz findet, was dort hin gehrt? TScrollGroup */
/* lst dieses Problem. Vorgehensweise: Man erstelle eine */
/* TScrollGroup mit den Ausdehnungen, die alle die Views  */
/* im Dialog (oder eigentlich auch sonst wo) belegen      */
/* drfen, und der "virtuellen" Grsse, die alle Views    */
/* belegen. Dann fge man in diese Gruppe die Views ein,  */
/* und anschliessend schicke man die Gruppe in den Dialog.*/
/* Die Gruppe ist mitsamt den Scrollbars, die das Ver-    */
/* schieben der Views in der Gruppe ermglichen, entweder */
/* mit der Maus oder mit CtrlLeft/Right und CtrlPgUp/Dn , */
/* streambar, es braucht nur RSrollGroup dazu gelinkt zu  */
/* werden.                                                */
/* Siehe auch sg-hello.cpp als Demonstration.             */
/*                                                        */
/* ------------------------------------------------------ */
#define Uses_TGroup
#define Uses_TScrollBar

#if !defined (__TV_H)
#include <tv.h>
#endif

#if defined (Uses_TScrollGroup) && !defined (__TScrollGroup)
#define __TScrollGroup

class TScrollGroup: public TGroup
{
protected:
    int hValue;
    int vValue;
    TPoint maxSize;
    TScrollBar *hScrollBar;
    TScrollBar *vScrollBar;

public:
    TScrollGroup (TRect& bounds,
                  TPoint& aMaxSize,
                  TGroup* aOwner);
    TScrollGroup (StreamableInit) :
        TGroup (streamableInit) {}

    virtual void draw ();
    virtual void handleEvent (TEvent& event);
    virtual void makeViewVisible (TView* view);

    virtual void* read (ipstream& is);
    virtual void write (opstream& os);
    static const char * const name;
    static TStreamable *build (void);

private:
    virtual const char *streamableName (void) const
        { return name; }
};

#endif // __TScrollGroup

