(* ====================================================== *)
(*                       MRT.PAS                          *)
(*             Menue-Resource-Translator                  *)
(*  Erzeugt aus Borlands Resource-Workshop for Windows    *)
(*  unter Turbo/Borland Pascal 6/7 und Turbo Pascal fr   *)
(*  Windows compilierbaren Turbo Vision-Code.             *)
(*            (c) 1993 Thomas Mai & toolbox               *)
(* ====================================================== *)
{$X+,I-,V-,B-,T-}

PROGRAM MRT;

USES
{$IFDEF Windows}
  WinCRT, WinDOS, Strings;
{$ELSE}
  Dos;
{$ENDIF}

CONST
  msg_Title      = 'MRT - Menue-Resource-Translator, ' +
                   '(c) 1993 Thomas Mai & toolbox';
  err_Param      = 'Ungueltiger Parameter: ';
  err_NDef       = 'Fehler: Mehrere Definitionen '+
                   'oder unausgewogene BEGIN-END';
  err_Depth      = 'Fehler: Zu tief verschachtelte Mens';

  NBeginEnd      : INTEGER = 0;
  NMenus         : INTEGER = 0;
  NMenuDepth     : INTEGER = 0;
  kboSaveParm    : BOOLEAN = FALSE;
  boNil          : BOOLEAN = FALSE;
  kMenuDepth     = 30;  { mgliche Verschachtelungstiefe }

TYPE
  { Konfigurations - Record }

  tCfg           = RECORD
    kboText      : BOOLEAN;
    kboKeyCode   : BOOLEAN;
    kboAddSpace  : BOOLEAN;
    kboMenuPtr   : BOOLEAN;
    kboHelpCode  : BOOLEAN;
    kboDefHlpCtx : BOOLEAN;
    ksAppName    : STRING[40];
    ksSuffix     : STRING[3];
  END;

  tDefTypeSet    = (dtNOTHING, dtBEGIN,
                    dtEND, dtPOPUP,
                    dtMENUITEM, dtSEPARATOR);

VAR
  Cfg            : tCfg;
  MenuItems      : ARRAY[ 0..kMenuDepth] OF WORD;
  sLine,
  sText,
  sConst,
  sCmd,
  sHelpCtx,
  sKeyCode,
  sHotkey        : STRING;
  tDefType       : tDefTypeSet;


  PROCEDURE Trim(VAR s : STRING);
    (* Fhrende und nachfolgende Leerzeichen und Tabs     *)
    (* entfernen.                                         *)
  BEGIN
    WHILE (Length(s) > 0) AND
          (s[1] IN [' ', #9]) DO Delete(s, 1, 1);

    WHILE (Length(s) > 0) AND
          (s[ Length(s)]  IN [' ', #9]) DO Dec(s[0]);
  END;

  FUNCTION LCase(s : STRING): STRING;
    (* s in Kleinbuchstaben wandeln.                      *)
  VAR
    w : WORD;
  BEGIN
    FOR w := 1 TO Length(s) DO
      IF (s[w] <= 'Z') AND (s[w] >= 'A') THEN
        s[w] := Chr(Ord(s[w]) + 32);
    LCase := s;
  END;

  PROCEDURE CnvANSI(VAR s: STRING);
    (* s von ANSI nach ASCII wandeln.                     *)
  CONST
    Tab : ARRAY[1..7, 1..2] OF CHAR = (
          ('', #$C4),
          ('', #$E4),
          ('', #$DC),
          ('', #$FC),
          ('', #$D6),
          ('', #$F6),
          ('', #$DF));
  VAR
    w, n : WORD;
  BEGIN
    FOR w := 1 TO Length(s) DO
      FOR n := 1 TO 7 DO
        IF s[w] = Tab[n][2] THEN BEGIN
          s[w] := Tab[n][1];
          Continue;
        END;
  END;

  FUNCTION RFill(s : STRING; n : WORD) : STRING;
    (* Hngt Leerzeichen an s an, bis s die Lnge n hat.  *)
  BEGIN
    WHILE Length(s) < n DO s := s + ' ';
    RFill := s;
  END;

  FUNCTION Space(n : WORD) : STRING;
    (* Erzeugt einen String der Lnge n, gefuellt mit     *)
    (* Leerzeichen                                        *)
  VAR
    s : STRING;
  BEGIN
    s[0] := Chr(n);
    FillChar(s[1], n, ' ');
    Space := s;
  END;

  FUNCTION NewName(s : STRING) : STRING;
    (* Erzeugt den Dateinamen der Ziel-Datei.             *)
  BEGIN
    IF Pos('.', s) > 0 THEN Delete(s, Pos('.', s), 4);
    NewName := s + '.' + Cfg.ksSuffix;
  END;

  PROCEDURE GetKeyCode;
    (* Tastaturcode von sHotkey finden und in sKeyCode    *)
    (* bergeben.                                         *)
    (* Macht z.B. aus "Strg+Pos1" ein "kbCtrlHome"        *)
  CONST
    NSubst = 11;
    Subst  : ARRAY [1..NSubst, 1..2] OF STRING [10] = (
             ('strg',      'Ctrl'),
             ('einfg',     'Ins'),
             ('entf',      'Del'),
             ('return',    'Enter'),
             ('backspace', 'Back'),
             ('umsch',     'Shift'),
             ('=',         'Equal'),
             ('leer',      'Space'),
             ('pos1',      'Home'),
             ('ende',      'End'),
             ('grau',      'Gray'));
  VAR
    i, n  : INTEGER;
    s, s1 : STRING;
  BEGIN
    sKeyCode := 'kb';

    s1 := sHotKey;
    s := '';

    FOR n := 1 TO Length(s1) DO
      IF s1[n] IN ['0'..'9', 'a'..'z', 'A'..'Z'] THEN
        s := s + s1[n];

    FOR i := 1 TO NSubst DO
      IF Pos(Subst[i][1], LCase(s)) > 0 THEN BEGIN
        n := Pos(Subst[i][1], LCase(s));
        Delete(s, n, Length(Subst[i][1]));
        Insert(Subst[i][2], s, n);
      END;

    sKeyCode := 'kb' + s;
  END;

  PROCEDURE Strip;
    (* Drselt den eingelesenen String sLine in           *)
    (* Text, Hotkey, Befehl und Typ auf.                  *)
  VAR
    wTitleStart, w, wPos   : WORD;
    sType                  : STRING;
    i                      : INTEGER;
    boCmd, boType, boTitle : BOOLEAN;
  BEGIN
    IF Cfg.kboText THEN BEGIN
      sHelpCtx := 'hcNoContext';
      sKeyCode := 'kbNoKey';
    END ELSE BEGIN
      sHelpCtx := '0';
      sKeyCode := '0';
    END;
    sCmd     := '';
    sText    := '';
    sHotkey  := '';
    sType    := '';
    boTitle  := FALSE;
    boCmd    := FALSE;
    boType   := TRUE;
    tDefType := dtNOTHING;

    FOR w := 1 TO Length(sLine) DO
      CASE sLine[ w] OF
        '"' : IF boTitle THEN BEGIN
                  (* Text auslesen *)
                sText := Copy(sLine, wTitleStart,
                              w - wTitleStart);
                CnvANSI(sText);
                wTitleStart := 0;
                boTitle     := FALSE;

                i := Pos('&', sText);
                IF i > 0 THEN BEGIN
                  sText[i] := '~';
                  System.Insert('~', sText, i + 2);
                END;
                (* Hotkey aus sText auslesen *)
                wPos := Pos('\t', sText);
                IF wPos > 0 THEN BEGIN
                  sHotKey := Copy(sText, wPos + 2, 20);
                  sText[0] := Chr(wPos - 1);
                END;
              END ELSE BEGIN
                boType      := FALSE;
                boTitle     := TRUE;
                wTitleStart := Succ(w);
              END;
        ',' : IF boTitle = FALSE THEN boCmd := TRUE;

      ELSE
        IF boCmd AND NOT (sLine[w] IN [' ', #9]) THEN
          sCmd := sCmd + sLine[w]
        ELSE IF boType AND NOT (sLine[w] IN [ ' ', #9]) THEN
          sType := sType + sLine[w];
      END;

    IF sCmd = '' THEN
      IF Cfg.kboText THEN sCmd := 'cmNew'
                     ELSE sCmd := '100';

    (* KeyCode ermitteln *)

    IF (sHotKey <> '') AND (Cfg.kboKeyCode) THEN GetKeyCode;

    (* Help-Context ggf. bilden *)

    IF Cfg.kboHelpCode THEN
      IF (LCase(sCmd[1]) = 'c') AND
         (LCase(sCmd[2]) = 'm') THEN
        sHelpCtx := 'hc' + Copy(sCmd, 3, 40)
      ELSE
        sHelpCtx := 'hc' + sCmd;

    (* Art des Eintrags bestimmen *)

    sType := LCase(sType);

    IF sType = 'menuitem' THEN
      tDefType := dtMENUITEM
    ELSE IF sType = 'popup' THEN
      tDefType := dtPOPUP
    ELSE IF sType = 'begin' THEN
      tDefType := dtBEGIN
    ELSE IF sType = 'end' THEN
      tDefType := dtEND
    ELSE IF Pos('separator', sType) = 9 THEN
      tDefType := dtSEPARATOR;
  END;

  FUNCTION ReadMenuDef(aRCFile: STRING): INTEGER;
  VAR
    fi, fo         : TEXT;
    i              : INTEGER;
    s, sNewName    : STRING;
    boFirst,
    boConst,
    boHeader       : BOOLEAN;

    PROCEDURE GetConst;
      (* Konstanten-Definition aufdrseln *)
    VAR
      w : WORD;
    BEGIN
      sConst := '';
      sCmd   := '';

      Delete(sLine, 1, Pos(' ', sLine));
      Trim(sLine);

      FOR w := 1 TO Length(sLine) DO
        IF NOT(sLine[w] IN [ ' ', #9]) THEN
          sConst := sConst + sLine[w]
        ELSE
          Break;
      sCmd := Copy(sLine, w + 1, 80);
      Trim(sCmd);
    END;

    PROCEDURE WriteHeader;
    BEGIN
      IF Cfg.kboMenuPtr THEN BEGIN
        WriteLn(fo, 'FUNCTION ', Cfg.ksAppName, ': pMenu;');
        WriteLn(fo, '  BEGIN');
        WriteLn(fo, '    ', Cfg.ksAppName, ' := NewMenu(');
      END ELSE BEGIN
        WriteLn(fo, 'PROCEDURE ', Cfg.ksAppName,
                    '.InitMenuBar;');
        WriteLn(fo, '  VAR');
        WriteLn(fo, '    R            : tRect;');
        WriteLn(fo, '  BEGIN');
        WriteLn(fo, '    GetExtent(R);');
        WriteLn(fo, '    R.B.Y := R.A.Y + 1;');
        WriteLn(fo, '');
        WriteLn(fo, '    MenuBar := New(pMenuBar,' +
                    ' Init(R, NewMenu(');
      END;
    END;

    PROCEDURE WriteFooter;
    BEGIN
      IF Cfg.kboMenuPtr THEN
        WriteLn(fo, '  END;  { f.', Cfg.ksAppName, ' }')
      ELSE
        WriteLn(fo, '  END;  { p.', Cfg.ksAppName,
                    '.InitMenuBar }');
    END;

    PROCEDURE Write_NewSubMenu;
    BEGIN
      WriteLn(fo, Space(4 + NMenuDepth * 2),
                  'NewSubMenu(''', sText, ''', ',
                  sHelpCtx, ', NewMenu(');
    END;

    PROCEDURE Write_NewLine;
    BEGIN
      WriteLn(fo, Space(6 + NMenuDepth * 2), 'NewLine(');
    END;

    PROCEDURE Write_NewItem;
    BEGIN
      WriteLn(fo, Space(6 + NMenuDepth * 2),
                  'NewItem(''',    sText, ''', ''',
                  sHotKey, ''', ', sKeyCode, ', ',
                  sCmd, ', ',      sHelpCtx, ', ');
    END;

  BEGIN
    FillChar(MenuItems, SizeOf(MenuItems), 0);
    boHeader := TRUE;
    boConst  := TRUE;
    boFirst  := TRUE;

    (* Quelle ffnen *)
    Assign(fi, aRCFile);
    Reset(fi);
    i := IOResult;

    ReadMenuDef := i;
    IF i <> 0 THEN BEGIN
      Writeln('Fehler beim ffnen von ', aRCFile,
              ': DOS-Error #', i);
      Exit;
    END;

    (* Ziel anlegen *)
    sNewName := NewName(aRCFile);
    Assign(fo, sNewName);
    Rewrite(fo);
    i := IOResult;

    ReadMenuDef := i;
    IF i <> 0 THEN BEGIN
      Writeln('Fehler beim Anlegen von ', sNewName,
              ': DOS-Error #', i);
      Close(fi);
      Exit;
    END;

    (* und los... *)
    WHILE NOT Eof(fi) DO BEGIN
      ReadLn(fi, sLine);
      Trim(sLine);
      IF sLine = '' THEN Continue;
      IF Pos('#define', sLine) > 0 THEN BEGIN
        (* Konstanten-Definitionsteil schreiben *)
        IF boConst THEN BEGIN
          boConst := FALSE;
          Writeln(fo, 'CONST');
          Writeln(fo, '');
          Writeln(fo, '  { Befehlskonstanten }');
          Writeln(fo, '');
        END;
        GetConst;
        IF Cfg.kboHelpCode AND Cfg.kboDefHlpCtx THEN BEGIN
          (* Hilfe-Konstanten schreiben *)
          IF (sConst[1] = 'c') AND (sConst[2] = 'm') THEN
            s := 'hc' + Copy(sConst, 3, 40)
          ELSE
            s := 'hc' + sConst;
          WriteLn(fo, '  ', RFill(sConst, 20),
                      '= ', RFill(sCmd + ';', 10),
                  RFill(s, 20), '= ', sCmd, ';');
        END ELSE  (* Befehlskonstanten schreiben *)
          WriteLn(fo, '  ', RFill(sConst, 20),
                      '= ', sCmd, ';');
        Continue;
      END ELSE IF boFirst THEN BEGIN
        (* 2 Leerzeilen nach Definitionsblock *)
        WriteLn(fo, #13#10);
        boFirst := FALSE;
      END;
      (* Ggf. den Funktions-Kopf schreiben *)
      IF boHeader THEN BEGIN
        WriteHeader;
        boHeader := FALSE;
      END;
      (* Text, Hotkey, Command und Typ aus sLine auslesen *)
      Strip;

      CASE tDefType OF
        dtPOPUP     : BEGIN
                       IF NMenuDepth < 0 THEN BEGIN
                         WriteLn(err_NDef);
                         Halt(1);
                       END;
                       IF NMenuDepth > kMenuDepth THEN BEGIN
                         WriteLn(err_Depth);
                         Halt(1);
                       END;
                       Inc(MenuItems[NMenuDepth]);
                       boNIL := FALSE;
                       Inc(NMenuDepth);
                       MenuItems[NMenuDepth] := 0;
                       Inc(NMenus);
                       IF Cfg.kboAddSpace THEN
                         WriteLn(fo, ' ');
                       Write_NewSubMenu;
                      END;
        dtBEGIN     : Inc(NBeginEnd);
        dtEND       : BEGIN
                        (* NILs schreiben *)
                        boNil := TRUE;
                        Write(fo, Space(4 + NMenuDepth * 2),
                                  'NIL');
                        FOR i := 1 TO
                            MenuItems[NMenuDepth] + 1 DO
                          Write(fo, ')');
                        IF NBeginEnd = 1 THEN BEGIN
                          IF Cfg.kboMenuPtr THEN
                            WriteLn(fo, ';')
                          ELSE
                            Writeln(fo, '));');
                        END ELSE Writeln(fo, ',');
                        Dec(NMenuDepth);
                        Dec(NBeginEnd);
                        IF NMenus > 1 THEN Dec(NMenus);
                      END;
        dtMENUITEM,
        dtSEPARATOR : BEGIN
                        IF boNil AND
                           Cfg.kboAddSpace THEN BEGIN
                          WriteLn(fo, '');
                          boNil := FALSE;
                        END;
                        IF tDefType = dtSEPARATOR THEN
                          Write_NewLine
                        ELSE
                          Write_NewItem;
                        Inc(MenuItems[NMenuDepth]);
                      END;
      END;
    END;
    WriteFooter;
    Close(fo);
    Close(fi);
  END;

  PROCEDURE LoadCfg;
    (* Default-Einstellungen vornehmen und                *)
    (* Konfigurationsdatei einlesen.                      *)
  VAR
    fc : FILE OF tCfg;
  BEGIN
    WITH Cfg DO BEGIN
      kboText      := TRUE;
      kboKeyCode   := TRUE;
      kboAddSpace  := TRUE;
      kboMenuPtr   := FALSE;
      kboHelpCode  := FALSE;
      kboDefHlpCtx := FALSE;
      ksAppName    := '';
      ksSuffix     := 'INC';
    END;

    Assign(fc, 'MT.CFG');
    Reset(fc);
    IF IOResult = 0 THEN BEGIN
      Read(fc, Cfg);
      Close(fc);
    END;
  END;

  PROCEDURE SaveCfg;
    (* Konfigurationsdatei schreiben. *)
  VAR
    fc : FILE OF tCfg;
  BEGIN
    Assign(fc, 'MT.CFG');
    Rewrite(fc);
    IF IOResult = 0 THEN BEGIN
      Write(fc, Cfg);
      Close(fc);
    END;
  END;

  PROCEDURE Inform;
  BEGIN
    WriteLn;
    WriteLn('MRT erzeugt aus einer Windows-Resource-' +
             'Datei fr Mens');
    WriteLn('- wie Sie z.B. mit dem Whitewater Resource' +
            ' Toolkit oder');
    WriteLn('dem Borland Resourcen-Editor angelegt ' +
            'werden kann -');
    WriteLn('einen mit Turbo Vision compilierbaren' +
            ' Quellcode.');
    WriteLn;
    WriteLn('Die Datei bekommt den Resourcen-Namen mit' +
            ' der Endung ".INC"');
    WriteLn('(sofern ber den Schalter /s nicht'+
            ' umdefiniert).');
    WriteLn;
    WriteLn('Aufruf: MRT <dateiname.rc> [/parameter]',
             #13#10);
    WriteLn('/t     Kurzform ("0") statt "kbNoKey" und '+
            '"hcNoContext" schreiben');
    WriteLn('/k     Keine KeyCodes zu den Hotkeys '+
            'ermitteln');
    WriteLn('/l     Keine Leerzeile vor NewSubMenu()'+
            ' einfgen');
    WriteLn('/axxx  Objektname (Vorgabe: tMyApp)');
    WriteLn('/sxxx  Suffix fuer Source-Datei '+
            '(Vorgabe: INC)');
    WriteLn('/c     Parameter speichern');
    WriteLn('/p     Funktion statt InitMenuBar()-'+
            'Prozedur erzeugen');
    WriteLn('/i     Befehlskonstante auch fr Help-'+
             'Context benutzen');
    WriteLn('/u     Hilfe-Context-Konstanten schreiben');
{$IFNDEF Windows}
    Halt(1);
{$ENDIF}
  END;

VAR
  s, sName : STRING;
  i        : INTEGER;

BEGIN
{$IFDEF Windows}
    StrCopy(WindowTitle, msg_Title);
    WindowSize.X := 700;
    WindowSize.Y := 510;
    AutoTracking := FALSE;
  {$else}
    Writeln(msg_Title);
  {$endif}

  IF ParamCount = 0 THEN Inform;
  LoadCfg;

  s := '';
  FOR i := 1 TO ParamCount DO
    s := s + ParamStr(i);

  {$ifdef WINDOWS}
  Write(#13#10'Name der Resource-Script-Datei: ');
  ReadLn(sName);
  IF sName = '' THEN Halt(1);
  s := sName + s;
  {$endif}

  IF Pos('/', s) = 0 THEN sName := s
  ELSE
  BEGIN
    sName := Copy(s, 1, Pos('/', s) - 1);
    Delete(s, 1, Pos('/', s) - 1);

    WHILE Pos('/', s) > 0 DO BEGIN
      Delete(s, 1, 1);

      CASE s[1] OF
        '?',
        'h', 'H' : Inform;
        't', 'T' : Cfg.kboText    := FALSE;
        'k', 'K' : Cfg.kboKeyCode := FALSE;
        'a', 'A' : IF Pos('/', s) > 0 THEN
                     Cfg.ksAppName :=
                                 Copy(s, 2, Pos('/', s) - 2)
                   ELSE
                     Cfg.ksAppName := Copy(s, 2, 40);
        's', 'S' : IF Pos('/', s) > 0 THEN
                     Cfg.ksSuffix :=
                                 Copy(s, 2, Pos('/', s) - 2)
                   ELSE
                     Cfg.ksSuffix := Copy(s, 2, 40);
        'l', 'L' : Cfg.kboAddSpace  := FALSE;
        'c', 'C' : kboSaveParm      := TRUE;
        'p', 'P' : Cfg.kboMenuPtr   := TRUE;
        'i', 'I' : Cfg.kboHelpCode  := TRUE;
        'u', 'U' : Cfg.kboDefHlpCtx := TRUE;
      ELSE
        Writeln(err_Param, s);
        Halt(1);
      END;
      Delete(s, 1, Pos('/', s) - 1);
    END;
  END;

  IF Pos('.', sName) = 0 THEN
    sName := sName + '.RC'
  ELSE IF sName[ Length(sName)] = '.' THEN Dec(sName[0]);

  WITH Cfg DO
    IF ksAppName = '' THEN
      IF kboMenuPtr THEN ksAppName := 'MenuPtr'
                    ELSE ksAppName := 'tMyApp';
  ReadMenuDef(sName);

  IF kboSaveParm THEN SaveCfg;
  WriteLn('OK.');
END.
(* ====================================================== *)
(*                  Ende von MRT.PAS                      *)
