/* ====================================================== */
/*                         MANDC.C                        */
/*              Berechnung der Mandelbrod-Menge           */
/*            (c) 1993 Stefan Grner & toolbox            */
/* ====================================================== */
#include <graphics.h>
#include <conio.h>

float max, xmin, ymin, deltax, deltay;

int iterate(float cx, float cy, int maxiter)
{
  float x2 = .0;
  float y2 = .0;
  float  x = .0;
  float  y = .0;

  while ((maxiter) && (x2+y2 < max))
  {
    y  = 2 * x * y + cy;
    x  = x2 - y2 + cx;
    x2 = x * x;
    y2 = y * y;
    maxiter--;
  }
  return ++maxiter;
}

void calculate(int x1, int y1, int x2, int y2, int maxiter)
{
  float cx1, cy1, c_1;
  int   h[8];
  int   i, j, samecolor, color, oldcolor;

  samecolor = 1;
  if (y2 - y1 < 3)
  {
    for (i = x1; i < x2; i++)
    {
      for(j = y1; j < y2; j++)
      {
        cx1   = xmin + deltax * i;
        cy1   = ymin + deltay * j;
        color = iterate(cx1, cy1, maxiter);
        putpixel(i, j, color);
      }
    }
  }
  else
  {
    for(i = x1; i < x2; i++)
    {
      cx1   = xmin + deltax * i;
      cy1   = ymin + deltay * y1;
      c_1   = ymin + deltay * y2;
      color = iterate(cx1, cy1, maxiter);
      if (i == x1) oldcolor = color;
      if (color != oldcolor) samecolor = 0;
      putpixel(i, y1, color);
      color = iterate(cx1, c_1, maxiter);
      if (color != oldcolor) samecolor = 0;
      putpixel(i, y2, color);
    }
    for (i = y1; i < y2-1; i++)
    {
      cy1   = ymin + deltay * i;
      cx1   = xmin + deltax * x1;
      c_1   = xmin + deltax * x2;
      color = iterate(cx1, cy1, maxiter);
      if (color != oldcolor) samecolor = 0;
      putpixel(x1, i, color);
      color = iterate(c_1, cy1, maxiter);
      if (color != oldcolor) samecolor = 0;
      putpixel(x2, i, color);
    }
    if (!samecolor)
    {
      calculate(x1, y1, (x1+x2)/2, (y1+y2)/2, maxiter);
      calculate((x1+x2)/2, y1, x2, (y1+y2)/2, maxiter);
      calculate(x1, (y1+y2)/2, (x1+x2)/2, y2, maxiter);
      calculate((x1+x2)/2, (y1+y2)/2, x2, y2, maxiter);
    }
    else
    {
      setfillstyle(1, color);
      setcolor(color);
      h[0] = h[2] = x1;
      h[1] = h[7] = y1;
      h[3] = h[5] = y2;
      h[6] = h[4] = x2;
      fillpoly(4, h);
    }
  }
}

void main()
{
  int graphdriver, graphmode;

  xmin        = -3;
  ymin        = -2;
  deltax      = 6./640;
  deltay      = 4./480;
  graphdriver = DETECT;
  max         = 9.;
  initgraph(&graphdriver, &graphmode,"");
  calculate(0, 0, getmaxx(), getmaxy(), 400);
  getch();
  closegraph();
}
/* ====================================================== */
/*                    Ende von MANDC.C                    */
