(* ====================================================== *)
(*                      MANDPAS.PAS                       *)
(*           Berechnung der Mandelbrod-Menge              *)
(*                 (c) 1993 toolbox                       *)
(* ====================================================== *)
{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,$FFFF}

PROGRAM MandLang;

USES Graph;

VAR
  xMin, yMin, Max,
  DeltaX, DeltaY   : Single;

  FUNCTION Iterate(cx, cy  : Single;
                   MaxIter : INTEGER) : INTEGER;
  VAR
    X, Y, x2, y2      : Single;
  BEGIN
    x2 := 0.0;
    y2 := 0.0;
    X  := 0.0;
    Y  := 0.0;
    WHILE (MaxIter <> 0) AND (x2+y2 < Max) DO BEGIN
      Y  := 2 * X * Y + cy;
      X  := x2 - y2 + cx;
      x2 := X * X;
      y2 := Y * Y;
      Dec(MaxIter);
    END;
    Iterate := MaxIter + 1;
  END;

  PROCEDURE Calculate(x1, y1, x2, y2, MaxIter : INTEGER);
  VAR
    i, j              : INTEGER;
    SameColor, Color  : INTEGER;
    OldColor          : INTEGER;
    H                 : ARRAY [0..7] OF INTEGER;
    cx1, cy1, c_1     : Single;
  BEGIN
    SameColor := 1;
    IF (y2 - y1) < 3 THEN BEGIN
      i := x1;
      WHILE i < x2 DO BEGIN
        j := y1;
        WHILE j < y2 DO BEGIN
          cx1   := xMin + DeltaX * i;
          cy1   := yMin + DeltaY * j;
          Color := Iterate(cx1, cy1, MaxIter);
          PutPixel(i, j, Color);
          Inc(j);
        END;
        Inc(i);
      END;
    END ELSE BEGIN
      i := x1;
      WHILE i < x2 DO BEGIN
        cx1   := xMin + DeltaX * i;
        cy1   := yMin + DeltaY * y1;
        c_1   := yMin + DeltaY * y2;
        Color := Iterate(cx1, cy1, MaxIter);
        IF i = x1 THEN OldColor := Color;
        IF Color <> OldColor THEN SameColor := 0;
        PutPixel(i, y1, Color);
        Color := Iterate(cx1, c_1, MaxIter);
        IF Color <> OldColor THEN SameColor := 0;
        PutPixel(i, y2, Color);
        Inc(i);
      END;
      i := y1;
      WHILE i < (y2-1) DO BEGIN
        cy1   := yMin + DeltaY * i;
        cx1   := xMin + DeltaX * x1;
        c_1   := xMin + DeltaX * x2;
        Color := Iterate(cx1, cy1, MaxIter);
        IF Color <> OldColor THEN SameColor := 0;
        PutPixel(x1, i, Color);
        Color := Iterate(c_1, cy1, MaxIter);
        IF Color <> OldColor THEN SameColor := 0;
        PutPixel(x2, i, Color);
        Inc(i);
      END;
      IF SameColor = 0 THEN BEGIN
        Calculate(x1, y1, (x1+x2) DIV 2, (y1+y2) DIV 2,
                  MaxIter);
        Calculate((x1+x2) DIV 2, y1, x2, (y1+y2) DIV 2,
                  MaxIter);
        Calculate(x1, (y1+y2) DIV 2, (x1+x2) DIV 2, y2,
                  MaxIter);
        Calculate((x1+x2) DIV 2, (y1+y2) DIV 2, x2, y2,
                  MaxIter);
      END ELSE BEGIN
        SetFillStyle(1, Color);
        SetColor(Color);
        H[0] := x1;
        H[2] := x1;
        H[1] := y1;
        H[7] := y1;
        H[3] := y2;
        H[5] := y2;
        H[6] := x2;
        H[4] := x2;
        FillPoly(4, H);
      END;
    END;
  END;

VAR
  GraphDriver, GraphMode : INTEGER;
  Depth, Code            : WORD;

BEGIN
  Depth := $40;
  IF ParamCount = 1 THEN BEGIN
    Val(ParamStr(1), Depth, Code);
    IF Code <> 0 THEN Depth := $40;
  END;
  Max    := 9.0;
  xMin   := -3;
  yMin   := -2;
  DetectGraph(GraphDriver, GraphMode);
  InitGraph(GraphDriver, GraphMode, '');
  DeltaX := 6.0 / (GetMaxX + 1);
  DeltaY := 4.0 / (GetMaxY + 1);
  Calculate(0, 0, GetMaxX, GetMaxY, $40);
  ReadLn;
  CloseGraph;
END.
(* ====================================================== *)
(*                 Ende von MANDPAS.PAS                   *)
