(* ====================================================== *)
(*                      FLICK.PAS                         *)
(*              Patience "Flickenteppich"                 *)
(*         (c) 1993 Eberhard Krause & toolbox             *)
(* ====================================================== *)

PROGRAM Flick;

USES
  {$IFNDEF Ver70}
  WinTypes, WinProcs, WObjects, Strings, CommDlg, Ctl3d,
  StdDlgs, Flicktep;
  {$ELSE}
  Objects, WinTypes, WinProcs, oWindows, Strings, CommDlg,
  Ctl3d, oStdDlgs, oDialogs, Flicktep;
  {$ENDIF}

(* ====================================================== *)
(* Einbinden der Ressource-Datei (in Unit )               *)
(* ====================================================== *)

{$R TEST3d.RES}

CONST
  zMenuName = 'Pati_Menu';

TYPE
  Family    = ARRAY [0..13, 0..7] OF INTEGER;

(* ====================================================== *)
(* Vereinbarung der Objekttypen.                          *)
(* ====================================================== *)

TYPE
  tAnwendung = OBJECT (tApplication)
    PROCEDURE InitMainWindow;  VIRTUAL;
    PROCEDURE InitInstance;    VIRTUAL;
  END;

  pFenster = ^tFenster;
  tFenster = OBJECT (tWindow)
    fLinks,     fKontur,
    fLeicht1,   fLeicht2,
    fschwierig, fSpiel    : BOOLEAN;
    Reihe1,     Spalte1,
    Reihe2,     Spalte2,
    x_Kontur,   y_Kontur,
    KonturZahl,
    KonturAbstand         : INTEGER;
    Talon                 : ARRAY [0..103] OF INTEGER;
    Familien, Familien1   : Family;
    Abstand               : ARRAY [0..9] OF INTEGER;
    Points                : pCollection;
    FileName              : ARRAY [0..60] OF CHAR;
    IstVeraendert,
    IstNeuDatei           : BOOLEAN;

    { berschreibende Methoden }

    CONSTRUCTOR Init(MutterFenster : pWindowsObject;
                     zTitel        : pChar);
    PROCEDURE   GetWindowClass
                (VAR Fensterklasse : tWndClass);    VIRTUAL;
    PROCEDURE   Paint(hPaintDC     : hDC;
                      VAR PaintInfo: tPaintStruct); VIRTUAL;
    PROCEDURE   WMRButtonDown(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_RButtonDown;
    PROCEDURE   WMLButtonDown (VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_LButtonDown;
    PROCEDURE   WMLButtonUp (VAR Ereignis: tMessage);
                VIRTUAL wm_First + wm_LButtonUp;
    PROCEDURE   WMMouseMove (VAR Ereignis: tMessage);
                VIRTUAL wm_First + wm_MouseMove;
    PROCEDURE   Destroy;                            VIRTUAL;
    FUNCTION    CanClose : BOOLEAN;                 VIRTUAL;
    DESTRUCTOR  Done;                               VIRTUAL;

    { neue Methoden }
    PROCEDURE   LoadFile;
    PROCEDURE   SaveFile;
    PROCEDURE   Mischen;
    PROCEDURE   Auslegen;
    PROCEDURE   Restaurieren;
    FUNCTION    Auswahl(x_Koord, y_Koord: INTEGER): BOOLEAN;
    PROCEDURE   BildAendern(R1, S1, R2, S2 : INTEGER);
    PROCEDURE   Konturmachen;
    PROCEDURE   KartSpringen(R1, S1 : INTEGER);
    PROCEDURE   Animation;

    { Methoden fr Spiel-Men }

    PROCEDURE   SpielNeu  (VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SNeu;
    PROCEDURE   FileOpen(VAR Msg : tMessage);
                VIRTUAL cm_First + cm_Open;
    PROCEDURE   FileSave(VAR Msg : tMessage);
                VIRTUAL cm_First + cm_Save;
    PROCEDURE   FileSaveAs(VAR Msg : tMessage);
                VIRTUAL cm_First + cm_SaveAs;
    PROCEDURE   SpielBeenden(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SBeenden;

   { Methoden fr Optionen-Men }

   PROCEDURE    OptionenZugZurueck(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_OZug_Zurueck;
   PROCEDURE    OptionenSpielWiederholen
                                  (VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_OSpiel_Wieder;

   { Methoden fr Schwierigkeit-Men }

   PROCEDURE    SSchwierig(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SSchwierig;
   PROCEDURE    SMittel   (VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SMittel;
   PROCEDURE    SLeicht1  (VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SLeicht1;
   PROCEDURE    SLeicht2  (VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SLeicht2;

   { Methoden fr Karten-Men }

   PROCEDURE    KSuchen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_KSuchen;

   { Methoden fr Hilfe_Men }

   PROCEDURE    HilfeHolen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_HHilfe;
   PROCEDURE    InfoZeigen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_HInfo;
  END;

TYPE
  PDPoint = ^TDPoint;
  TDPoint = OBJECT (tObject)
    X : INTEGER;
    CONSTRUCTOR Init(AX : INTEGER);
    CONSTRUCTOR Load(VAR S : tStream);
    PROCEDURE   Store(VAR S : tStream);
  END;

  pDialogBox = ^tDialogBox;
  tDialogBox = OBJECT (tDialog)
    KartNum, FarbNum           : INTEGER;
    Strg                       : ARRAY [0..60] OF CHAR;
    Strg1, Strg2, Strg3, Strg4 : STRING [50];

    { berschreibende Methoden }

    CONSTRUCTOR Init(MutterFenster : pWindowsObject;
                     zTitel        : pChar);
    PROCEDURE   Suchen(VAR Ereignis : tMessage);
                VIRTUAL id_First + id_Suchen;
    PROCEDURE   Ende(VAR Ereignis : tMessage);
                VIRTUAL id_First + id_Ende;

    { neue Methoden }

    PROCEDURE  As(VAR Ereignis : tMessage);
               VIRTUAL id_First + 104;
    PROCEDURE  Zwei(VAR Ereignis : tMessage);
               VIRTUAL id_First + 105;
    PROCEDURE  Drei(VAR Ereignis : tMessage);
               VIRTUAL id_First + 106;
    PROCEDURE  Vier(VAR Ereignis : tMessage);
               VIRTUAL id_First + 107;
    PROCEDURE  Fuenf(VAR Ereignis : tMessage);
               VIRTUAL id_First + 108;
    PROCEDURE  Sechs(VAR Ereignis : tMessage);
               VIRTUAL id_First + 109;
    PROCEDURE  Sieben(VAR Ereignis : tMessage);
               VIRTUAL id_First + 110;
    PROCEDURE  Acht(VAR Ereignis : tMessage);
               VIRTUAL id_First + 111;
    PROCEDURE  Neun(VAR Ereignis : tMessage);
               VIRTUAL id_First + 112;
    PROCEDURE  Zehn(VAR Ereignis : tMessage);
               VIRTUAL id_First + 113;
    PROCEDURE  Bube(VAR Ereignis : tMessage);
               VIRTUAL id_First + 114;
    PROCEDURE  Dame(VAR Ereignis : tMessage);
               VIRTUAL id_First + 115;
    PROCEDURE  Koenig(VAR Ereignis : tMessage);
               VIRTUAL id_First + 116;
    PROCEDURE  Kreuz(VAR Ereignis : tMessage);
               VIRTUAL id_First + 118;
    PROCEDURE  Pik(VAR Ereignis : tMessage);
               VIRTUAL id_First + 120;
    PROCEDURE  Herz(VAR Ereignis : tMessage);
               VIRTUAL id_First + 117;
    PROCEDURE  Karo(VAR Ereignis : tMessage);
               VIRTUAL id_First + 119;
  END;

CONST
  rDPoint: tStreamRec = (
    ObjType : 200;
    VMTLink : Ofs(TypeOf(TDPoint)^);
    Load    : @TDPoint.Load;
    Store   : @TDPoint.Store);

  PROCEDURE StreamRegistration;
  BEGIN
    RegisterType(rCollection);
    RegisterType(rDPoint);
  END;

(* ====================================================== *)
(* Definition der Methoden von tAnwendung.                *)
(* ====================================================== *)

  PROCEDURE tAnwendung.InitMainWindow;
  BEGIN
    MainWindow := New(pFenster,
                      Init(NIL, 'Patience Flickenteppich'));
  END;

  PROCEDURE tAnwendung.InitInstance;
  BEGIN
    tApplication.InitInstance;
    hAccTable := LoadAccelerators(hInstance, 'Tasten');
  END;

(* ====================================================== *)
(* Definition der Methoden von tFenster.                  *)
(* ====================================================== *)

  CONSTRUCTOR tFenster.Init(MutterFenster : pWindowsObject;
                            zTitel        : pChar);
  VAR
    i, j : INTEGER;
  BEGIN
    tWindow.Init(MutterFenster, zTitel);
    Attr.X        :=  10;
    Attr.Y        :=  10;
    Attr.W        := 620;
    Attr.H        := 450;
    Attr.Menu     := LoadMenu(hInstance, zMenuName);
    Points        := New(pCollection, Init(300, 50));
    IstVeraendert := FALSE;
    IstNeuDatei   := TRUE;
    fKontur       := FALSE;
    fLeicht1      := FALSE;
    fLeicht2      := FALSE;
    fLinks        := FALSE;
    fschwierig    := FALSE;
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SMittel, 'Mittel');
    StreamRegistration;
    Mischen;
    Auslegen;
  END;

  PROCEDURE tFenster.GetWindowClass
            (VAR Fensterklasse : tWndClass);
  BEGIN
    tWindow.GetWindowClass(Fensterklasse);
    Fensterklasse.hbrBackground :=
      GetStockObject(Gray_Brush);
    Fensterklasse.hIcon := LoadIcon(hInstance, 'PAT2_ICON');
  END;

  PROCEDURE tFenster.Paint(    hPaintDC  : hDC;
                           VAR PaintInfo : tPaintStruct);
  VAR
    i, j              : INTEGER;
    MDC               : hDC;
    MemObject, Stift,
    StiftObject       : tHandle;
  BEGIN
    tWindow.Paint(hPaintDC, PaintInfo);
    Stift := CreatePen(ps_DashDotDot, 4, $000000FF);
    StiftObject:= SelectObject(hPaintDC, Stift);
    MoveTo(hPaintDC, 488,   1);
    LineTo(hPaintDC, 488, 104);
    LineTo(hPaintDC, 630, 104);
    MDC := CreateCompatibleDC(hPaintDC);
    MemObject := SelectObject(MDC, Rand);
    FOR i := 0 TO 7 DO
      IF Familien[0, i] = 0 THEN BEGIN
        SelectObject(MDC, Rand);
        BitBlt(hPaintDC, 12 + i*60, 18, 54, 72,
               MDC, 0, 0, SrcCopy)
      END ELSE BEGIN
        SelectObject(MDC,
                     NeuKarte[Familien[Familien[0, i], i]]);
        BitBlt(hPaintDC, 12 + i*60, 18, 54, 72,
               MDC, 0, 0, SrcCopy);
      END;
    FOR j := 8 TO 9 DO
      FOR i := -1 DOWNTO -2 DO
        IF Prison[i, j] = 0 THEN BEGIN
          SelectObject(MDC, Rand);
          BitBlt(hPaintDC, 12 + J*60, 5 - (i+1)*46, 54, 48,
                 MDC, 0, 0, SrcCopy)
        END ELSE BEGIN
          SelectObject(MDC, NeuKarte[Prison[i, j]]);
          BitBlt(hPaintDC, 12 + j*60,5 - (i+1)*46, 54, 48,
                 MDC, 0, 0, SrcCopy);
        END;
    FOR j := 0 TO 9 DO BEGIN
      IF Tisch[0, j] < 11 THEN
        Abstand[j] := 22
      ELSE
        Abstand[J] := 220 DIV (Tisch[0, j]);
        IF Tisch[0,J] = 0 THEN BEGIN
          SelectObject(MDC, Rand);
          BitBlt(hPaintDC, 12 + J*60, 110, 54, 72,
                 MDC, 0, 0, SrcCopy);
        END ELSE BEGIN
          FOR i := 0 TO Tisch[0, j] - 2 DO BEGIN
            SelectObject(MDC, NeuKarte[Tisch[i+1, j]]);
            BitBlt(hPaintDC, 12 + J*60, 110 + i*Abstand[j],
                   54, Abstand[j], MDC, 0, 0, SrcCopy);
          END;
          SelectObject(MDC, NeuKarte[Tisch[Tisch[0, j], j]]);
          BitBlt(hPaintDC, 12 + J*60,
                 110 + (Tisch[0, j]-1)*Abstand[j], 54, 72,
                 MDC, 0, 0, SrcCopy);
        END;
    END;
    SelectObject(hPaintDC, StiftObject);
    DeleteObject(Stift);
    SelectObject(MDC, MemObject);
    DeleteDC(MDC);
  END;

  PROCEDURE tFenster.WMLButtonDown(VAR Ereignis : tMessage);
  BEGIN
    IF fKontur THEN BEGIN
      Konturmachen;
      fKontur := FALSE;
    END;
    Tisch1    := Tisch;
    Familien1 := Familien;
    Prison1   := Prison;
    EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
    IF NOT Auswahl(Ereignis.lParamLo,Ereignis.lParamHi) THEN
      Exit;
    Reihe1  := Reihe2;
    Spalte1 := Spalte2;
    IF Reihe1 < 0 THEN
      IF Prison[Reihe1, Spalte1] = 0 THEN BEGIN
        MessageBox(hWindow,
                   ' An der Stelle liegt keine Karte !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
    IF Reihe1 = 0 THEN BEGIN
      IF Familien[0, Spalte1] = 0 THEN BEGIN
        MessageBox(hWindow,
                   'An der Stelle liegt keine Karte !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
      IF fschwierig THEN BEGIN
        MessageBox(hWindow,
            'Diese Karte darf nicht zurckgelegt werden  !',
            'Unerlaubter Zug !!!', mb_OK);
        Exit;
      END;
    END;
    IF (Reihe1 > 0) AND (Tisch[0, Spalte1] = 0) THEN BEGIN
     MessageBox(hWindow,'An der Stelle liegt keine Karte !',
                        'Unmglicher Zug !!!', mb_OK);
     Exit;
    END;
    x_Kontur      := 12 + Spalte1*60;
    KonturZahl    := 1;
    KonturAbstand := Abstand[Spalte1];
    CASE Reihe1 OF
      -2     : y_Kontur    := 28;
      -1     : y_Kontur    :=  5;
       0     : y_Kontur    := 18;
       1..22 : BEGIN
               y_Kontur := 110 + (Reihe1-1)*KonturAbstand;
               KonturZahl := Tisch[0, Spalte1] - Reihe1 + 1;
               END;
    END;
    fKontur := TRUE;
    Konturmachen;
    fLinks := TRUE;
    IstVeraendert := TRUE;
  END;

  PROCEDURE tFenster.WMLButtonUp(VAR Ereignis : tMessage);
  VAR
    a, b, i, j : INTEGER;
  BEGIN
    IF fKontur THEN BEGIN
      Konturmachen;
      fKontur := FALSE;
    END;
    IF NOT fLinks THEN Exit;
    fLinks := FALSE;
    IF NOT Auswahl(Ereignis.lParamLo,Ereignis.lParamHi) THEN
      Exit;
    IF (Reihe1 = Reihe2) AND (Spalte1 = Spalte2) THEN BEGIN
      KartSpringen(Reihe1, Spalte1);
      Exit;
    END;
    IF Reihe2 < 0 THEN BEGIN
      IF Prison[Reihe2, Spalte2] >0 THEN BEGIN
        MessageBox(hWindow, '     Stelle ist nicht frei !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
      IF Reihe1 < 0 THEN BEGIN
        Prison[Reihe2, Spalte2] := Prison[Reihe1, Spalte1];
        Prison[Reihe1, Spalte1] := 0;
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END;
      IF Reihe1 = 0 THEN BEGIN
        MessageBox(hWindow,
        'Von den Familien darf keine Karte in die Ablage !',
        'Unerlaubter Zug !!!', mb_OK);
        Exit;
      END;
      IF Reihe1 < Tisch[0, Spalte1] THEN BEGIN
        MessageBox(hWindow,
              '   Es darf nur eine Karte abgelegt werden !',
              'Unmglicher Zug !!!', mb_OK);
        Exit;
      END ELSE BEGIN
        Prison[Reihe2, Spalte2] := Tisch[Reihe1, Spalte1];
        Tisch[Reihe1, Spalte1]  := 0;
        Dec(Tisch[0, Spalte1]);
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END;
    END;
    IF Reihe2 = 0 THEN BEGIN
      IF Familien[0, Spalte2] = 13 THEN BEGIN
        MessageBox(hWindow,
                   '      Diese Familie ist voll belegt !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
      B := Familien[Familien[0, Spalte2], Spalte2];
      IF Reihe1 < 0 THEN BEGIN
        IF Familien[0, Spalte2] = 0 THEN BEGIN
          IF (Prison[Reihe1, Spalte1] MOD 13) = 1 THEN BEGIN
            Inc(Familien[0, Spalte2]);
            Familien[Familien[0, Spalte2], Spalte2] :=
              Prison[Reihe1, Spalte1];
            Prison[Reihe1, Spalte1] := 0;
            BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
            Exit;
          END ELSE BEGIN
            MessageBox(hWindow,
                       '    Diese Karte mu ein As sein !',
                       'Unmglicher Zug !!!', mb_OK);
            Exit;
          END;
        END ELSE BEGIN
          A := Prison[Reihe1, Spalte1];
          IF (fLeicht2 AND
             ((A-1 = B) OR (A-27 = B) OR (A+25 = B))) OR
             (NOT fLeicht2 AND (A-1 = B)) THEN BEGIN
            Inc(Familien[0, Spalte2]);
            Familien[Familien[0, Spalte2], Spalte2] :=
              Prison[Reihe1, Spalte1];
            Prison[Reihe1, Spalte1] := 0;
            BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
            Exit;
          END ELSE BEGIN
            MessageBox(hWindow,
                   '  Diese Karte pat nicht zum Anlegen !',
                   'Unmglicher Zug !!!', mb_OK);
            Exit;
          END;
        END;
      END;
      IF (Reihe1 = 0) AND
         (Familien[0, Spalte2] = 0) THEN BEGIN
        FOR i := 0 TO Familien[0, Spalte1] DO BEGIN
          Familien[i, Spalte2] := Familien[i, Spalte1];
          Familien[i, Spalte1] := 0;
        END;
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END;
      IF (Reihe1 = 0) AND
         (Familien[0, Spalte2] > 0) THEN BEGIN
        MessageBox(hWindow,
           'Es kann nur auf leere Stellen umgelegt werden.',
           'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
      IF Familien[0, Spalte2] = 0 THEN BEGIN
        IF (Tisch[Reihe1, Spalte1] MOD 13) = 1 THEN BEGIN
          Inc(Familien[0, Spalte2]);
          Familien[Familien[0, Spalte2], Spalte2] :=
            Tisch[Reihe1, Spalte1];
          Tisch[Reihe1, Spalte1] := 0;
          Dec(Tisch[0, Spalte1]);
          BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
          Exit;
        END ELSE BEGIN
          MessageBox(hWindow,
                     '  Diese Karte  mu ein As sein !',
                     'Unmglicher Zug !!!', mb_OK);
          Exit;
        END;
      END ELSE BEGIN
        A := Tisch[Tisch[0, Spalte1], Spalte1];
        IF (fLeicht2 AND
           ((A-1 = B) OR (A-27 = B) OR (A+25 = B))) OR
           (NOT fLeicht2 AND (A-1 = B)) THEN BEGIN
          Inc(Familien[0, Spalte2]);
          Familien[Familien[0, Spalte2], Spalte2] :=
            Tisch[Reihe1, Spalte1];
          Tisch[Reihe1, Spalte1] := 0;
          Dec(Tisch[0, Spalte1]);
          BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
          Exit;
        END ELSE BEGIN
          MessageBox(hWindow,
                   '  Diese Karte pat nicht zum Anlegen !',
                   'Unmglicher Zug !!!', mb_OK);
          Exit;
        END;
      END;
    END;
    IF Reihe2 < Tisch[0, Spalte2] THEN BEGIN
      MessageBox(hWindow,
      'Es darf nur an die unterste Karte angelegt werden !',
      'Unmglicher Zug !!!', mb_OK);
      Exit;
    END;
    IF (Reihe2 = 1) AND (Tisch[0, Spalte2] = 0) THEN BEGIN
      IF Reihe1 < 0 THEN
        IF (Prison[Reihe1, Spalte1] MOD 13) = 0 THEN BEGIN
          Inc(Tisch[0, Spalte2]);
          Tisch[Reihe2, Spalte2] := Prison[Reihe1, Spalte1];
          Prison[Reihe1, Spalte1] := 0;
          BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
          Exit;
        END ELSE BEGIN
          MessageBox(hWindow,
                     '  Diese Karte mu ein Knig sein!',
                     'Unerlaubter Zug !!!', mb_OK);
          Exit;
        END;
      IF Reihe1 = 0 THEN Exit;
      IF (Tisch[Reihe1, Spalte1] <> 0) AND
         (Tisch[Reihe1, Spalte1] MOD 13 = 0) THEN BEGIN
        FOR i := 0 TO (Tisch[0, Spalte1]-Reihe1) DO BEGIN
          Inc(Tisch[0, Spalte2]);
          Tisch[Reihe2+i, Spalte2] :=
            Tisch[Reihe1+i, Spalte1];
          Tisch[Reihe1+i, Spalte1] := 0;
          Dec(Tisch[0, Spalte1]);
        END;
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END ELSE BEGIN
        MessageBox(hWindow,
                   '  Diese Karte mu ein Knig sein !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
    END;
    B := Tisch[Reihe2, Spalte2];
    IF Reihe1 < 0 THEN BEGIN
      A := Prison[Reihe1, Spalte1];
      IF (NOT fLeicht1 AND
         ((A+14=B) OR (A+40=B) OR (A-38=B) OR (A-12=B))) OR
         (fLeicht1 AND
         (((B MOD 13 -1)=A MOD 13) OR
           ((B MOD 13 +12)=A MOD 13))) THEN BEGIN
        Inc(Tisch[0, Spalte2]);
        Tisch[Reihe2+1, Spalte2] := Prison[Reihe1, Spalte1];
        Prison[Reihe1,Spalte1] := 0;
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END ELSE BEGIN
        MessageBox(hWindow,
                   '  Die Karte pat nicht zum Anlegen !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
    END;
    IF Reihe1 > 0 THEN BEGIN
      A := Tisch[Reihe1, Spalte1];
      IF (NOT fLeicht1 AND
         ((A+14=B) OR (A+40=B) OR (A-38=B) OR (A-12=B))) OR
         (fLeicht1 AND
         (((B MOD 13 -1)=A MOD 13) OR
         ((B MOD 13 +12)=A MOD 13))) THEN BEGIN
        FOR i := 0 TO Tisch[0, Spalte1]-Reihe1 DO BEGIN
          Inc(Tisch[0, Spalte2]);
          Tisch[Reihe2+i+1, Spalte2] :=
            Tisch[Reihe1+i, Spalte1];
          Tisch[Reihe1+i, Spalte1] := 0;
          Dec(Tisch[0, Spalte1]);
        END;
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END ELSE BEGIN
        MessageBox(hWindow,
                   '  Die Karte pat nicht zum Anlegen !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
    END;
    IF Reihe1 = 0 THEN BEGIN
      A := Familien[Familien[0, Spalte1], Spalte1];
      IF (NOT fLeicht1 AND
         ((A+14=B) OR (A+40=B) OR (A-38=B) OR (A-12=B))) OR
         (fLeicht1 AND
         (((B MOD 13 -1)=A MOD 13) OR
          ((B MOD 13 +12)=A MOD 13))) THEN BEGIN
        Inc(Tisch[0, Spalte2]);
        Tisch[Reihe2+1, Spalte2] :=
          Familien[Familien[0, Spalte1], Spalte1];
        Familien[Familien[0, Spalte1], Spalte1] := 0;
        Dec(Familien[0, Spalte1]);
        BildAendern(Reihe1, Spalte1, Reihe2, Spalte2);
        Exit;
      END ELSE BEGIN
        MessageBox(hWindow,
                   '  Die Karte pat nicht zum Anlegen !',
                   'Unmglicher Zug !!!', mb_OK);
        Exit;
      END;
    END;
  END;

  PROCEDURE tFenster.WMRButtonDown(VAR Ereignis : tMessage);
  VAR
    SpaltWnd : pWindow;
    i        : INTEGER;
  BEGIN
    IF Ereignis.lParamHi < 110  THEN Exit;
    Auswahl(Ereignis.lParamLo, Ereignis.lParamHi);
    IF Spalte2 > 9 THEN Exit;
    FOR i := 0 TO 22 DO
      SBild[i] := Tisch[i, Spalte2];
    SpaltWnd := New(pSpaltWindow,
                    Init(@Self, 'Spaltenbild'));
    Application^.MakeWindow(SpaltWnd);
  END;

  PROCEDURE tFenster.WMMouseMove(VAR Ereignis : tMessage);
  BEGIN
    IF NOT fKontur THEN Exit;
    IF (Ereignis.wParam <> mk_LButton) THEN Exit;
    Konturmachen;
    x_Kontur := Ereignis.lParamLo - 27;
    y_Kontur := Ereignis.lParamHi -  8;
    Konturmachen;
  END;

  PROCEDURE tFenster.Destroy;
  BEGIN
    WinHelp(hWindow, 'Flick.hlp', Help_Quit, 0);
    tWindow.Destroy;
  END;

  FUNCTION tFenster.CanClose : BOOLEAN;
  VAR
    Ende : INTEGER;
    Msg  : tMessage;
  BEGIN
    CanClose := TRUE;
    IF IstVeraendert OR IstNeuDatei THEN BEGIN
      Ende := MessageBox(hWindow,
                   '      Wollen Sie das Spiel speichern ?',
                   'Ende des Spiels',
                   mb_YesNoCancel OR mb_IconQuestion);
      IF Ende = id_Yes THEN FileSave(Msg);
      IF Ende = id_Cancel THEN CanClose := FALSE;
    END;
  END;

  DESTRUCTOR tFenster.Done;
  VAR
    i : INTEGER;
  BEGIN
    Dispose(Points, Done);
    DeleteObject(Rand);
    DeleteObject(Kontur);
    DeleteObject(Hintergr);
    FOR i := 1 TO 52 DO
      IF NeuKarte[i] <> 0 THEN DeleteObject(NeuKarte[i]);
    tWindow.Done;
  END;

  PROCEDURE tFenster.Mischen;
  VAR
    Frei    : ARRAY [0..103] OF BOOLEAN;
    a, i, j : INTEGER;
  BEGIN
    FOR i := 0 TO 103 DO
      Frei[i] := TRUE;
    FOR i := 0 TO 103 DO BEGIN
      REPEAT
        a := Random(104);
      UNTIL Frei[a];
      Frei[a]  := FALSE;
      Talon[i] := Succ(a MOD 52);
    END;
  END;

  PROCEDURE tFenster.Auslegen;
  VAR
    i, j : INTEGER;

    PROCEDURE SpielMachen(X : INTEGER);
    BEGIN
      CASE i OF
        0..99 : Tisch[Succ(i DIV 10), i MOD 10] := X;
        100   : Prison[-1, 9] := X;
        101   : Prison[-2, 9] := X;
        102   : Prison[-1, 8] := X;
        103   : Prison[-2, 8] := X;
      END;
    END;

  BEGIN
    FOR i := 0 TO 9 DO
      Tisch[0, i] := 10;
    FOR i := 0 TO 9 DO
      Abstand[i] := 22;
    FOR i := 11 TO 22 DO
      FOR j := 0 TO 9 DO
        Tisch[i, j] := 0;
    FOR i := 0 TO 13 DO
      FOR j := 0 TO 7 DO
        Familien[i, j] := 0;
    FOR i := 0 TO 103 DO
      SpielMachen(Talon[i]);
    fSpiel := TRUE;
    EnableMenuItem(Attr.Menu, cm_SSchwierig, mf_Enabled);
    EnableMenuItem(Attr.Menu, cm_SMittel,    mf_Enabled);
    EnableMenuItem(Attr.Menu, cm_SLeicht1,   mf_Enabled);
    EnableMenuItem(Attr.Menu, cm_SLeicht2,   mf_Enabled);
  END;

  FUNCTION tFenster.Auswahl(x_Koord,
                            y_Koord : INTEGER) : BOOLEAN;
  VAR
    Oben, a, b : INTEGER;
  BEGIN
    Auswahl := FALSE;
    Spalte2 := 20;
    CASE x_Koord OF
      13..64   : Spalte2 := 0;
      73..124  : Spalte2 := 1;
      133..184 : Spalte2 := 2;
      193..244 : Spalte2 := 3;
      253..304 : Spalte2 := 4;
      313..364 : Spalte2 := 5;
      373..424 : Spalte2 := 6;
      433..484 : Spalte2 := 7;
      493..544 : Spalte2 := 8;
      553..604 : Spalte2 := 9;
    ELSE
      Exit;
    END;
    IF (Spalte2 < 8) AND
       (y_Koord > 18) AND (y_Koord < 90) THEN BEGIN
      Reihe2  := 0;
      Auswahl := TRUE;
      Exit;
    END;
    IF (Spalte2 > 7) AND
       (y_Koord > 5) AND (y_Koord < 51) THEN BEGIN
      Reihe2  := -1;
      Auswahl := TRUE;
      Exit;
    END;
    IF (Spalte2 > 7) AND
       (y_Koord > 50) AND (y_Koord < 100) THEN BEGIN
      Reihe2  := -2;
      Auswahl := TRUE;
      Exit;
    END;
    IF (y_Koord < 110) OR (y_Koord > Oben) THEN Exit;
    IF Tisch[0, Spalte2] > 0 THEN
      Oben := 110 + Abstand[Spalte2] * (Tisch[0,Spalte2]-1)
    ELSE
      Oben := 110;
    IF (y_Koord < 110) OR (y_Koord > Oben+72) THEN Exit;
    Reihe2 := Tisch[0, Spalte2];
    IF Tisch[0, Spalte2] = 0 THEN BEGIN
      Inc(Reihe2);
      Auswahl := TRUE;
      Exit;
    END;
    REPEAT
      IF y_Koord > Oben THEN BEGIN
        Auswahl := TRUE;
        Exit;
      END;
      A := Tisch[Reihe2,   Spalte2];
      B := Tisch[Reihe2-1, Spalte2];
      IF (NOT fLeicht1 AND
         ((A+14=B) OR (A+40=B) OR (A-38=B) OR (A-12=B))) OR
         (fLeicht1 AND
         (((B MOD 13 -1)=A MOD 13) OR
          ((B MOD 13 +12)=A MOD 13))) THEN BEGIN
        Dec(Reihe2);
        Dec(Oben, Abstand[Spalte2]);
      END ELSE Exit;
    UNTIL Reihe2 = 0 ;           { Dummy }
  END;

  PROCEDURE tFenster.BildAendern(R1, S1, R2, S2 : INTEGER);
  VAR
    i, j         : INTEGER;
    hBildDC, MDC : hDC;
    MemObject    : tHandle;
    Gewinn       : BOOLEAN;
    Spruch       : pChar;
  BEGIN
    IF fSpiel THEN BEGIN
      EnableMenuItem(Attr.Menu, cm_SLeicht2,   mf_Grayed);
      EnableMenuItem(Attr.Menu, cm_SLeicht1,   mf_Grayed);
      EnableMenuItem(Attr.Menu, cm_SMittel,    mf_Grayed);
      EnableMenuItem(Attr.Menu, cm_SSchwierig, mf_Grayed);
      fSpiel := FALSE;
    END;
    hBildDC := GetDC(hWindow);
    MDC := CreateCompatibleDC(hBildDC);
    MemObject := SelectObject(MDC,Rand);
    IF R1 < 0 THEN
      FOR i := -1 DOWNTO -2 DO
        IF Prison[i, S1] = 0 THEN BEGIN
          SelectObject(MDC, Rand);
          BitBlt(hBildDC, 12 + S1*60, 5-(i+1)*46, 54, 48,
                 MDC, 0, 0, SrcCopy);
        END ELSE BEGIN
          SelectObject(MDC, NeuKarte[Prison[i, S1]]);
          BitBlt(hBildDC, 12 + S1*60, 5-(i+1)*46, 54, 48,
                 MDC, 0, 0, SrcCopy);
        END;
    IF R1 = 0 THEN
      IF Familien[0, S1] = 0 THEN BEGIN
        SelectObject(MDC, Rand);
        BitBlt(hBildDC, 12 + S1*60, 18, 54, 72,
               MDC, 0, 0, SrcCopy);
      END ELSE BEGIN
        SelectObject(MDC,
                   NeuKarte[Familien[Familien[0, S1], S1]]);
        BitBlt(hBildDC, 12 + S1*60, 18, 54, 72,
               MDC, 0, 0, SrcCopy);
      END;
    IF R1 > 0 THEN BEGIN
      SelectObject(MDC, Hintergr);
      BitBlt(hBildDC, 12 + S1*60, 110, 54, 350,
             MDC, 0, 0, SrcCopy);
      IF Tisch[0, S1] < 11 THEN
        Abstand[S1] := 22
      ELSE
        Abstand[S1] := 220 DIV (Tisch[0, S1]);
      IF Tisch[0, S1] = 0 THEN BEGIN
        SelectObject(MDC, Rand);
        BitBlt(hBildDC, 12 + S1*60, 110, 54, 72,
               MDC, 0, 0, SrcCopy);
      END ELSE BEGIN
        FOR i := 0 TO Tisch[0, S1]-2 DO BEGIN
          SelectObject(MDC, NeuKarte[Tisch[i+1, S1]]);
          BitBlt(hBildDC, 12 + S1*60, 110 + i*Abstand[S1],
                 54, Abstand[S1], MDC, 0, 0, SrcCopy);
        END;
        SelectObject(MDC,
                     NeuKarte[Tisch[Tisch[0, S1], S1]]);
        BitBlt(hBildDC, 12 + S1*60,
               110 + (Tisch[0, S1]-1)*Abstand[S1], 54, 72,
               MDC, 0, 0, SrcCopy);
      END;
    END;
    IF R2 < 0 THEN
      FOR i := -1 DOWNTO -2 DO
        IF Prison[i, S2] = 0 THEN BEGIN
          SelectObject(MDC, Rand);
          BitBlt(hBildDC, 12 + S2*60, 5 - (i+1)*46, 54, 48,
                 MDC, 0, 0, SrcCopy);
        END ELSE BEGIN
          SelectObject(MDC, NeuKarte[Prison[i, S2]]);
          BitBlt(hBildDC, 12 + S2*60, 5 - (I+1)*46, 54, 48,
                 MDC, 0, 0, SrcCopy);
        END;
    IF R2 = 0 THEN
      IF Familien[0, S2] = 0 THEN BEGIN
        SelectObject(MDC, Rand);
        BitBlt(hBildDC, 12 + S2*60, 18, 54, 72,
               MDC, 0, 0, SrcCopy);
      END ELSE BEGIN
        SelectObject(MDC,
                     NeuKarte[Familien[Familien[0,S2],S2]]);
        BitBlt(hBildDC, 12 + S2*60, 18, 54, 72,
               MDC, 0, 0, SrcCopy);
      END;
    IF R2 > 0 THEN BEGIN
      SelectObject(MDC, Hintergr);
      BitBlt(hBildDC, 12 + S2*60, 110, 54, 350,
             MDC, 0, 0, SrcCopy);
      IF Tisch[0, S2] < 11 THEN
        Abstand[S2] := 22
      ELSE
        Abstand[S2] := 220 DIV (Tisch[0, S2]);
      IF Tisch[0, S2] = 0 THEN BEGIN
        SelectObject(MDC, Rand);
        BitBlt(hBildDC, 12 + S2*60, 110, 54, 72,
               MDC, 0, 0, SrcCopy);
      END ELSE BEGIN
        FOR i := 0 TO Tisch[0, S2]-2 DO BEGIN
          SelectObject(MDC, NeuKarte[Tisch[i+1, S2]]);
          BitBlt(hBildDC, 12 + S2*60, 110 + i*Abstand[S2],
                 54, Abstand[S2], MDC, 0, 0, SrcCopy);
        END;
        SelectObject(MDC, NeuKarte[Tisch[Tisch[0,S2],S2]]);
        BitBlt(hBildDC, 12 + S2*60,
               110+(Tisch[0, S2]-1)*Abstand[S2], 54, 72,
               MDC, 0, 0, SrcCopy);
      END;
    END;
    SelectObject(MDC, MemObject);
    DeleteDC(MDC);
    ReleaseDC(hWindow, hBildDC);
    EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Enabled);
    Gewinn := TRUE;
    FOR i := 0 TO 7 DO
      IF Familien[0, i] <> 13 THEN Gewinn := FALSE;
    IF Gewinn THEN BEGIN
      Animation;
      Spruch := SpruchGewinn[Random(5)];
      MessageBox(hWindow, Spruch,
                 'Aufgegangen !!!', mb_OK);
      FOR j := 0 TO 7 DO
        FOR i := 0 TO 13 DO
          Familien[i, j] := 0;
      InvalidateRect(hWindow, NIL, TRUE);
    END;
  END;

  PROCEDURE tFenster.Konturmachen;
  VAR
    i            : INTEGER;
    hBildDC, MDC : hDC;
    MemObject    : tHandle;
  BEGIN
    hBildDC := GetDC(hWindow);
    MDC := CreateCompatibleDC(hBildDC);
    MemObject := SelectObject(MDC, Kontur);
    FOR i := 1 TO KonturZahl-1 DO
      BitBlt(hBildDC, x_Kontur,
             y_Kontur + (i-1)*KonturAbstand, 54,
             KonturAbstand, MDC, 0, 0, SrcInvert);
    BitBlt(hBildDC, x_Kontur,
           y_Kontur + (KonturZahl-1)*KonturAbstand, 54,
           72, MDC, 0, 0, SrcInvert);
    SelectObject(MDC, Rand);
    DeleteDC(MDC);
    ReleaseDC(hWindow, hBildDC);
  END;

  PROCEDURE tFenster.KartSpringen(R1, S1 : INTEGER);
  VAR
    a, b, i, j, R2, S2 : INTEGER;

    FUNCTION FamilienTest(a : INTEGER) : BOOLEAN;
    VAR
      i : INTEGER;
    BEGIN
      FamilienTest := FALSE;
      FOR i := 0 TO 7 DO BEGIN
        IF Familien[0, i] < 13 THEN BEGIN
          B := Familien[Familien[0, i], i];
          IF (NOT fLeicht2 AND (B = A-1)) OR
             (fLeicht2 AND
             ((B = A-1) OR (B = A-27) OR (B = A+25))) OR
             ((B = 0) AND (A MOD 13 = 1)) THEN BEGIN
            Inc(Familien[0, i]);
            Familien[Familien[0, i], i] := a;
            FamilienTest := TRUE;
            R2 := 0;
            S2 := i;
            Exit;
          END;
        END;
      END;
    END;

    FUNCTION TischTest(a, k : INTEGER) : BOOLEAN;
    VAR
      i : INTEGER;
    BEGIN
      TischTest := FALSE;
      i := -1;
      REPEAT
        Inc(i);
        IF i = k THEN Inc(i);
        IF i < 10 THEN BEGIN
          b := Tisch[Tisch[0, i], i];
          IF (b = 0) AND (a MOD 13 = 0) THEN BEGIN
            R2 := 1;
            Inc(Tisch[0, i]);
            Tisch[Tisch[0, i], i] := a;
            S2 := i;
            TischTest := TRUE;
            Exit;
          END;
          IF (b MOD 13 <> 1) AND (b <> 0) THEN BEGIN
            IF (NOT fLeicht1 AND
               (a MOD 13 <>0) AND ((b = a-12) OR
               (b = a-38) OR (b = a+40) OR (b = a+14))) OR
               (fLeicht1 AND
               (b MOD 13 = (a MOD 13+1) MOD 13)) THEN BEGIN
              R2 := Tisch[0, i];
              Inc(Tisch[0, i]);
              Tisch[Tisch[0, i], i] := a;
              S2 := i;
              TischTest := TRUE;
              Exit;
            END;
          END;
        END;
      UNTIL i = 10;
    END;

    FUNCTION PrisonTest(a : INTEGER) : BOOLEAN;
    VAR
      i, j : INTEGER;
    BEGIN
      PrisonTest := FALSE;
      FOR i := -1 DOWNTO -2 DO
        FOR j := 8 TO 9 DO
          IF Prison[i, j] = 0 THEN BEGIN
            Prison[i, j] := a;
            R2 := i;
            S2 := j;
            PrisonTest := TRUE;
            Exit;
          END;
    END;

  BEGIN
    IF R1 < 0 THEN BEGIN
      a := Prison[R1, S1];
      IF FamilienTest(a) THEN BEGIN
        Prison[R1, S1] := 0;
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
      IF TischTest(a, 20) THEN BEGIN
        Prison[R1, S1] := 0;
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
    END;
    IF R1 = 0 THEN BEGIN
      a := Familien[Familien[0, S1], S1];
      IF TischTest(a, 20) THEN BEGIN
        Familien[Familien[0, S1], S1] := 0;
        Dec(Familien[0, S1]);
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
    END;
    IF (R1 > 0) AND (Tisch[0, S1] > R1) THEN BEGIN
      a := Tisch[R1, S1];
      IF TischTest(a, S1) THEN BEGIN
        b := Tisch[0, S2] - 1;
        Tisch[R1, S1] := 0;
        Dec(Tisch[0, S1]);
        FOR i := 0 TO (Tisch[0, S1] - R1) DO BEGIN
          Inc(Tisch[0, S2]);
          Tisch[Tisch[0, S2], S2] := Tisch[R1 + i + 1, S1];
          Tisch[R1 + i + 1, S1] := 0;
          Dec(Tisch[0, S1])
        END;
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
    END;
    IF (R1 > 0) AND (Tisch[0, S1] = R1) THEN BEGIN
      a := Tisch[R1, S1];
      IF FamilienTest(a) THEN BEGIN
        Tisch[R1, S1] := 0;
        Dec(Tisch[0, S1]);
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
      IF TischTest(a, S1) THEN BEGIN
        Tisch[R1, S1] := 0;
        Dec(Tisch[0, S1]);
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
      IF PrisonTest(a) THEN BEGIN
        Tisch[R1, S1] := 0;
        Dec(Tisch[0, S1]);
        BildAendern(R1, S1, R2, S2);
        Exit;
      END;
    END;
    MessageBox(hWindow,
               '  Die Karte pat nicht zum Anlegen !',
               'Unmglicher Zug !!!', mb_OK);
  END;

  PROCEDURE tFenster.Animation;
  VAR
    g, h, i, j, k : INTEGER;
    hBildDC, MDC  : hDC;
    MemObject     : tHandle;
    Strg          : pChar;
    Msg           : tMsg;
  BEGIN
    hBildDC := GetDC(hWindow);
    MDC := CreateCompatibleDC(hBildDC);
    MemObject := SelectObject(MDC, Rand);
    SelectObject(MDC, Hintergr);
    FOR i := 0 TO 9 DO
      BitBlt(hBildDC, 12 + i*60, 110, 54, 300,
             MDC, 0, 0, SrcCopy);
    BitBlt(hBildDC, 484, 1, 54, 150, MDC, 0, 0, SrcCopy);
    BitBlt(hBildDC, 538, 1, 54, 150, MDC, 0, 0, SrcCopy);
    BitBlt(hBildDC, 590, 1, 54, 150, MDC, 0, 0, SrcCopy);
    TextOut(hBildDC, 234, 370,
            '  Ende mit Mausklick !  ', 24);
    FOR k := 0 TO 7 DO
      FOR j := 1 TO 12 DO
        FOR i := 0 TO j DO BEGIN
          IF PeekMessage(Msg, hWindow, wm_LButtonDown,
                        wm_MouseLast,pm_Remove) THEN BEGIN
            SelectObject(MDC, MemObject);
            DeleteDC(MDC);
            ReleaseDC(hWindow, hBildDC);
            Exit;
          END;
          SelectObject(MDC, NeuKarte[Familien[13-j+i, k]]);
          BitBlt(hBildDC, 12 + K*60 + i*10, 18 + i*22, 54,
                 72, MDC, 0, 0, SrcCopy);
          FOR g := 1 TO 8000 DO
            h := g;
        END;
    SelectObject(MDC, MemObject);
    DeleteDC(MDC);
    ReleaseDC(hWindow, hBildDC);
  END;

  PROCEDURE tFenster.Restaurieren;
  VAR
    i, j : INTEGER;

    PROCEDURE SpielOeffnen(P : PDPoint); FAR;
    BEGIN
      CASE i OF
        0..103   : Talon[I] := P^.X;
        104..215 : Familien[(i-104) DIV 8,
                            (i-104) MOD 8] := P^.X;
        216..435 : Tisch[(i-216) DIV 10,
                         (i-216) MOD 10] := P^.X;
        436      : Prison[-2, 8] := P^.X;
        437      : Prison[-2, 9] := P^.X;
        438      : Prison[-1, 8] := P^.X;
        439      : Prison[-1, 9] := P^.X;
        440      : j := P^.X;
      END;
      Inc(i);
    END;

  BEGIN
    i := 0;
    fSpiel     := FALSE;
    fKontur    := FALSE;
    fLeicht1   := FALSE;
    fLeicht2   := FALSE;
    fLinks     := FALSE;
    fschwierig := FALSE;
    Points^.ForEach(@SpielOeffnen);
    IF j = 1 THEN fschwierig := TRUE;
    IF j = 2 THEN fLeicht1   := TRUE;
    IF j = 3 THEN fLeicht2   := TRUE;
    EnableMenuItem(Attr.Menu, cm_SLeicht2,   mf_Grayed);
    EnableMenuItem(Attr.Menu, cm_SLeicht1,   mf_Grayed);
    EnableMenuItem(Attr.Menu, cm_SMittel,    mf_Grayed);
    EnableMenuItem(Attr.Menu, cm_SSchwierig, mf_Grayed);
    MessageBox(hWindow, Meldung[j], 'Schwierigkeit', mb_OK);
  END;

  PROCEDURE tFenster.LoadFile;
  VAR
    TempColl : pCollection;
    TheFile  : tBufStream;
  BEGIN
    TheFile.Init(FileName, stOpen, 1024);
    TempColl := pCollection(TheFile.Get);
    TheFile.Done;
    IF TempColl <> NIL THEN BEGIN
      Dispose(Points, Done);
      Points := TempColl;
      InvalidateRect(hWindow, NIL, TRUE);
    END;
    IstVeraendert := FALSE;
    IstNeuDatei := FALSE;
    Restaurieren;
  END;

  PROCEDURE tFenster.SaveFile;
  VAR
    TheFile : tBufStream;
    i, j    : INTEGER;
  BEGIN
    Points^.FreeAll;
    FOR i := 0 TO 103 DO
      Points^.Insert(New(PDPoint, Init(Talon[i])));
    FOR i := 0 TO 13 DO
      FOR j := 0 TO 7 DO
        Points^.Insert(New(PDPoint, Init(Familien[i, j])));
    FOR i := 0 TO 21 DO
      FOR j := 0 TO 9 DO
        Points^.Insert(New(PDPoint, Init(Tisch[i, j])));
    FOR i := -2 TO -1 DO
      FOR j := 8 TO 9 DO
        Points^.Insert(New(PDPoint, Init(Prison[i, j])));
    i := 0;
    IF fschwierig THEN i := 1;
    IF fLeicht1   THEN i := 2;
    IF fLeicht2   THEN i := 3;
    Points^.Insert(New(PDPoint, Init(i)));
    TheFile.Init(FileName, stCreate, 1024);
    TheFile.Put(Points);
    TheFile.Done;
    IstNeuDatei   := FALSE;
    IstVeraendert := FALSE;
  END;

  { Methoden fr Spiel_Men }

  PROCEDURE tFenster.SpielNeu(VAR Ereignis : tMessage);
  VAR
    Ende : INTEGER;
    Msg  : tMessage;
  BEGIN
    IF IstVeraendert THEN
      Ende := MessageBox(hWindow,
               '         Wollen Sie das Spiel speichern ?',
               'Ende des Spiels',
                mb_YesNoCancel OR mb_IconQuestion);
    IF Ende = id_Yes THEN FileSave(Msg);
    IF Ende = id_Cancel THEN Exit;
    Mischen;
    Auslegen;
    IstNeuDatei := TRUE;
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  PROCEDURE tFenster.FileOpen(VAR Msg : tMessage);
  BEGIN
    IF CanClose THEN
      IF Application^.ExecDialog(New(pFileDialog,
                             Init(@Self, pChar(sd_FileOpen),
             StrCopy(FileName,'*.ptc')))) = id_Ok THEN BEGIN
       LoadFile;
      END;
  END;

  PROCEDURE tFenster.FileSave(VAR Msg : tMessage);
  BEGIN
    IF IstNeuDatei THEN FileSaveAs(Msg)
                   ELSE SaveFile;
  END;

  PROCEDURE tFenster.FileSaveAs(VAR Msg : tMessage);
  VAR
    FileDlg : pFileDialog;
  BEGIN
    IF IstNeuDatei THEN StrCopy(FileName, '*.ptc');
    IF Application^.ExecDialog(New(pFileDialog,
           Init(@Self, pChar(sd_FileSave),
           FileName))) = id_Ok THEN SaveFile;
  END;

  PROCEDURE tFenster.SpielBeenden(VAR Ereignis : tMessage);
  BEGIN
    SendMessage(hWindow, wm_close, 0, 0);
  END;

  { Methoden fr Optionen-Men }

  PROCEDURE tFenster.OptionenZugZurueck
            (VAR Ereignis : tMessage);
  BEGIN
    Tisch    := Tisch1;
    Familien := Familien1;
    Prison   := Prison1;
    EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  PROCEDURE tFenster.OptionenSpielWiederholen
            (VAR Ereignis : tMessage);
  BEGIN
    Auslegen;
    EnableMenuItem(Attr.Menu, cm_SSchwierig, mf_Enabled);
    EnableMenuItem(Attr.Menu, cm_SMittel,    mf_Enabled);
    EnableMenuItem(Attr.Menu, cm_SLeicht1,   mf_Enabled);
    EnableMenuItem(Attr.Menu, cm_SLeicht2,   mf_Enabled);
    fSpiel := TRUE;
    EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  { Methoden fr Varianten-Men }

  PROCEDURE tFenster.SSchwierig(VAR Ereignis : tMessage);
  BEGIN
    fLeicht1   := FALSE;
    ModifyMenu(Attr.Menu, cm_SLeicht1,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht1, 'Sehr_Leicht');
    fLeicht2   := FALSE;
    ModifyMenu(Attr.Menu, cm_SLeicht2,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht2, 'Leicht');
    fschwierig := TRUE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SMittel, 'Mittel');
  END;

  PROCEDURE tFenster.SMittel(VAR Ereignis : tMessage);
  BEGIN
    fLeicht1   := FALSE;
    ModifyMenu(Attr.Menu, cm_SLeicht1,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht1, 'Sehr_Leicht');
    fLeicht2   := FALSE;
    ModifyMenu(Attr.Menu, cm_SLeicht2,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht2, 'Leicht');
    fschwierig := FALSE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SMittel, 'Mittel');
  END;

  PROCEDURE tFenster.SLeicht1(VAR Ereignis : tMessage);
  BEGIN
    fLeicht1   := TRUE;
    ModifyMenu(Attr.Menu, cm_SLeicht1,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SLeicht1, 'Sehr_Leicht');
    fLeicht2   := FALSE;
    ModifyMenu(Attr.Menu, cm_SLeicht2,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht2, 'Leicht');
    fschwierig := FALSE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SMittel, 'Mittel');
  END;

  PROCEDURE tFenster. SLeicht2(VAR Ereignis : tMessage);
  BEGIN
    fLeicht1   := FALSE;
    ModifyMenu(Attr.Menu, cm_SLeicht1,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht1, 'Sehr_Leicht');
    fLeicht2   := TRUE;
    ModifyMenu(Attr.Menu, cm_SLeicht2,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SLeicht2, 'Leicht');
    fschwierig := FALSE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SMittel, 'Mittel');
  END;

  { Methoden fr Karten-Men }

  PROCEDURE tFenster.KSuchen(VAR Ereignis : tMessage);
  BEGIN
    Application^.ExecDialog(New(pDialogBox,
                            Init(@Self, 'Suche_Karte')));
  END;

  { Methoden fr Hilfe-Men }

  PROCEDURE tFenster.HilfeHolen(VAR Ereignis : tMessage);
  BEGIN
    WinHelp(hWindow, 'Flick.hlp', Help_Index, 0);
  END;

  PROCEDURE tFenster.InfoZeigen(VAR Ereignis : tMessage);
  BEGIN
    MessageBox(hWindow,
              ' (c) 1993 Eberhard Krause & DMV-Verlag' +
              #13#10 +
              'Turbo Pascal fr Windows 1.5',
              'Information', mb_OK OR mb_IconExclamation);
  END;

(* ====================================================== *)
(* Definition der Methoden von tDialogBox.                *)
(* ====================================================== *)

  CONSTRUCTOR tDialogBox.Init(MutterFenster: pWindowsObject;
                              zTitel       : pChar);
  BEGIN
    tDialog.Init(MutterFenster,zTitel);
    KartNum := 1;
    FarbNum := 0;
    Strg1   := 'Kreuz ';
    Strg2   := 'As ';
  END;

  PROCEDURE tDialogBox.Suchen(VAR Ereignis : tMessage);
  VAR
    i, j : INTEGER;
    Flg  : BOOLEAN;
  BEGIN
    Flg := TRUE;
    KartNum := KartNum + FarbNum;
    FOR j := 0 TO 9 DO
      FOR i := 1 TO 22 DO
        IF KartNum = Tisch[i, j] THEN BEGIN
          Flg   := FALSE;
          Strg3 := Strg1 + Strg2;
          Strg4 := 'liegt an Stelle ';
          Strg3 := Strg3 + Strg4;
          Str(i:2, Strg4);
          Strg3 := Strg3 + Strg4 + ' ';
          Strg4 := 'in Spalte ';
          Strg3 := Strg3 + Strg4;
          Str((j+1):2, Strg4);
          Strg3 := Strg3 + Strg4 + '.';
          StrPCopy(Strg, Strg3);
          MessageBox(hWindow, Strg, 'Kartenlage', mb_OK);
        END;
    FOR j := 8 TO 9 DO
      FOR i := -1 DOWNTO -2 DO
        IF KartNum = Prison[i, j] THEN BEGIN
          Flg := FALSE;
          Strg3 := Strg1 + Strg2;
          Strg4 := 'liegt in der Ablage.';
          Strg3 := Strg3 + Strg4;
          StrPCopy(Strg, Strg3);
          MessageBox(hWindow, Strg, 'Kartenlage', mb_OK);
        END;
    IF Flg THEN BEGIN
      Strg3 := Strg1 + Strg2;
      Strg4 := 'ist schon verbraucht.';
      Strg3 := Strg3 + Strg4;
      StrPCopy(Strg, Strg3);
      MessageBox(hWindow, Strg, 'Kartenlage', mb_OK);
    END;
    Ende(Ereignis);
  END;

  PROCEDURE tDialogBox.Ende(VAR Ereignis : tMessage);
  BEGIN
    tDialog.Cancel(Ereignis);
  END;

  PROCEDURE tDialogBox.As(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 1;
    Strg2   := 'As ';
  END;

  PROCEDURE tDialogBox.Zwei(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 2;
    Strg2   := 'Zwei ';
  END;

  PROCEDURE tDialogBox.Drei(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 3;
    Strg2   := 'Drei ';
  END;

  PROCEDURE tDialogBox.Vier(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 4;
    Strg2   := 'Vier ';
  END;

  PROCEDURE tDialogBox.Fuenf(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 5;
    Strg2   := 'Fnf ';
  END;

  PROCEDURE tDialogBox.Sechs(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 6;
    Strg2   := 'Sechs ';
  END;

  PROCEDURE tDialogBox.Sieben(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 7;
    Strg2   := 'Sieben ';
  END;

  PROCEDURE tDialogBox.Acht(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 8;
    Strg2   := 'Acht ';
  END;

  PROCEDURE tDialogBox.Neun(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 9;
    Strg2   := 'Neun ';
  END;

  PROCEDURE tDialogBox.Zehn(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 10;
    Strg2   := 'Zehn ';
  END;

  PROCEDURE tDialogBox.Bube(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 11;
    Strg2   := 'Bube ';
  END;

  PROCEDURE tDialogBox.Dame(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 12;
    Strg2   := 'Dame ';
  END;

  PROCEDURE tDialogBox.Koenig(VAR Ereignis : tMessage);
  BEGIN
    KartNum := 13;
    Strg2   := 'Knig ';
  END;

  PROCEDURE tDialogBox.Kreuz(VAR Ereignis : tMessage);
  BEGIN
    FarbNum := 13;
    Strg1   := 'Kreuz ';
  END;

  PROCEDURE tDialogBox.Pik(VAR Ereignis : tMessage);
  BEGIN
    FarbNum := 39;
    Strg1   := 'Pik ';
  END;

  PROCEDURE tDialogBox.Herz(VAR Ereignis : tMessage);
  BEGIN
    FarbNum := 0;
    Strg1   := 'Herz ';
  END;

  PROCEDURE tDialogBox.Karo(VAR Ereignis : tMessage);
  BEGIN
    FarbNum := 26;
    Strg1   := 'Karo ';
  END;

(* ====================================================== *)
(* Die Methoden von TDPoints                              *)
(* ====================================================== *)

  CONSTRUCTOR TDPoint.Init(AX : INTEGER);
  BEGIN
    X := AX;
  END;

  CONSTRUCTOR TDPoint.Load(VAR S : tStream);
  BEGIN
    S.Read(X, SizeOf(X));
  END;

  PROCEDURE TDPoint.Store(VAR S : tStream);
  BEGIN
    S.Write(X, SizeOf(X));
  END;

(* ====================================================== *)
(* Vereinbarung des Applikations-Objekts.                 *)
(* ====================================================== *)

VAR
  Appl : tAnwendung;

BEGIN
  Ctl3dRegister(hInstance);
  Ctl3dAutoSubclass(hInstance);
  Appl.Init('Patience');
  Appl.Run;
  Appl.Done;
  Ctl3dUnregister(hInstance);
END.
(* ====================================================== *)
(*                 Ende von FLICK.PAS                     *)

