(* ====================================================== *)
(*                    FLICKTEP.PAS                        *)
(*              Patience Flickenteppich                 *)
(*         (c) 1993 Eberhard Krause & toolbox             *)
(* ====================================================== *)

UNIT Flicktep;

INTERFACE

USES
  Strings,
{$IFNDEF Ver70}
  WObjects,
{$ELSE}
  oWindows, oStdDlgs, oDialogs,
{$ENDIF}
  WinTypes, WinProcs;

{$R Patien2.RES}

CONST
  id_LB1           = 201;
  id_BN1           = 202;
  id_BN2           = 203;
  id_EC1           = 204;
  id_ST1           = 205;
  id_BN3           = 206;
  id_Suchen        = 502;
  id_Ende          = 503;

  cm_SNeu          = 101;
  cm_Open          = 102;
  cm_Save          = 103;
  cm_SaveAs        = 104;
  cm_SBeenden      = 105;

  cm_OZug_Zurueck  = 201;
  cm_OSpiel_Wieder = 202;

  cm_SSchwierig    = 301;
  cm_SMittel       = 302;
  cm_SLeicht1      = 304;
  cm_SLeicht2      = 303;

  cm_KSuchen       = 501;

  cm_HHilfe        = 901;
  cm_HInfo         = 902;

  Meldung : ARRAY [0..3] OF pChar  = (
             'Gewhlte Schwierigkeit war "Mittel" !',
             'Gewhlte Schwierigkeit war "Schwierig" !',
             'Gewhlte Schwierigkeit war "Sehr leicht" !',
             'Gewhlte Schwierigkeit war "Leicht" !');

  SpruchGewinn : ARRAY [0..4] OF pChar = (
                      '       Gratuliere !',
                      '     Clever gespielt !',
                      'Heute lagen die Karten gut !',
                      '      Nur weiter so !',
                      '   Na wer sagt''s denn !');
TYPE
  Tische     = ARRAY [0..22,  0..9] OF INTEGER;
  Ablagen    = ARRAY [-2..-1, 8..9] OF INTEGER;

  pSpaltWindow = ^tSpaltWindow;
  tSpaltWindow = OBJECT (tWindow)
    Rand : hBitmap;

    CONSTRUCTOR Init(aParent : pWindowsObject;
                     aTitle  : pChar);
    PROCEDURE   SetupWindow; VIRTUAL;
    PROCEDURE   Paint(hPaintDC : hDC;
                      VAR PaintInfo : tPaintStruct);
              VIRTUAL;
    PROCEDURE IDBN3(VAR Msg: tMessage);
              VIRTUAL id_First + id_BN3;
  END;

VAR
  Tisch, Tisch1   : Tische;
  Prison, Prison1 : Ablagen;
  SBild           : ARRAY [0..22] OF INTEGER;
  Rand, Hintergr,
  Kontur          : hBitmap;
  NeuKarte        : ARRAY [1..52] OF hBitmap;
  hLib, Taste     : tHandle;

IMPLEMENTATION

VAR
  i : INTEGER;

  CONSTRUCTOR tSpaltWindow.Init(aParent : pWindowsObject;
                                aTitle  : pChar);
  VAR
    TempBtn : pButton;
  BEGIN
    tWindow.Init(aParent, aTitle);
    DisableAutoCreate;
    Rand       := LoadBitmap(hInstance, 'Rahmen');
    Attr.Style := ws_PopupWindow OR
                  ws_Caption OR ws_Visible;
    Attr.X  :=  10;
    Attr.Y  :=  10;
    Attr.W  := 600;
    Attr.H  := 150;
    TempBtn := New(pButton, Init(@Self, id_BN3,
                      'Abbruch', 270, 100, 60, 30, FALSE));
  END;

  PROCEDURE tSpaltWindow.SetupWindow;
  BEGIN
    tWindow.SetupWindow;
  END;

  PROCEDURE tSpaltWindow.Paint(hPaintDC : hDC;
                               VAR PaintInfo: tPaintStruct);
  VAR
    i           : INTEGER;
    MDC         : hDC;
    MemObject   : tHandle;
    Hintergrund : tHandle;
  BEGIN
    tWindow.Paint(hPaintDC, PaintInfo);
    Hintergrund := CreateSolidBrush(White_Brush);
    Rectangle(hPaintDC, 1, 1, 62 + (SBild[0]-1)*27, 92);
    MDC := CreateCompatibleDC(hPaintDC);
    MemObject := SelectObject(MDC,Rand);
    FOR i := 1 TO SBild[0] DO BEGIN
      SelectObject(MDC, NeuKarte[SBild[i]]);
      BitBlt(hPaintDC, 5+(i-1)*27, 10, 54, 72,
             MDC, 0, 0, SrcCopy);
    END;
    DeleteObject(Hintergrund);
    SelectObject(MDC, MemObject);
    DeleteDC(MDC);
  END;

  PROCEDURE tSpaltWindow.IDBN3(VAR Msg : tMessage);
  BEGIN
    CloseWindow;
  END;

BEGIN
  hLib         := LoadLibrary('KARTEN.DLL');
  Rand         := LoadBitmap(hInstance, 'Rahmen');
  Hintergr     := LoadBitmap(hInstance, 'Grund');
  Kontur       := LoadBitmap(hInstance, 'Kontur');
  FOR i := 1 TO 52 DO
    NeuKarte[i] := LoadBitmap(hLib, MakeIntResource(i));
  FreeLibrary(hLib);
  Randomize;
END.
(* ====================================================== *)
(*               Ende von FLICKTEP.PAS                    *)

