(* ====================================================== *)
(*                      NEHMEN.PAS                        *)
(*             Turbo Pascal fr Windows 1.5               *)
(*                       Nim-Spiel                        *)
(*      (c) 1993 Eberhard Krause & toolbox                *)
(* ====================================================== *)
UNIT Nehmen;

INTERFACE

TYPE
  Feld      = ARRAY [0..4]        OF INTEGER;
  Spielfeld = ARRAY [0..4, 0..14] OF INTEGER;

CONST
  x_Start =  5;
  y_Start = 20;
  x_Diff  = 40;
  y_Diff  = 50;

  { Spiel-Men }
  cm_SStart       = 101;
  cm_SZurueck     = 102;
  cm_SEnde        = 103;

  { Reihen-Men }
  cm_RDrei        = 111;
  cm_RVier        = 112;
  cm_RFuenf       = 113;

  { Elemente-Men }
  cm_EFuenf       = 122;
  cm_ESieben      = 123;
  cm_ENeun        = 124;
  cm_EElf         = 125;
  cm_EDreizehn    = 126;
  cm_EFuenfzehn   = 127;

  { Maximum-Men }
  cm_MZwei        = 131;
  cm_MDrei        = 132;
  cm_MVier        = 133;
  cm_MFuenf       = 134;
  cm_MSechs       = 135;
  cm_MSieben      = 136;

  { Beginn-Men }
  cm_BSpieler     = 141;
  cm_BComputer    = 142;

  { Gewinn-Men }
  cm_GLetGewinnt  = 151;
  cm_GLetVerliert = 152;

  { Hilfe-Men }
  cm_HHilfe       = 901;
  cm_HInfo        = 902;

VAR
  Typ                      : ARRAY [0..4] OF Feld;
  Vierer, Zweier, Einer,
  ReihenZahl, ElementZahl,
  MaxZahl                  : INTEGER;
  Spiel, Zug               : Feld;
  VorZug, NachZug          : Spielfeld;
  fZug                     : BOOLEAN;

  PROCEDURE  SetSpiel(VAR Spiel : Feld;
                          A, B, C, D, E : INTEGER);
  FUNCTION   ZeroTest : BOOLEAN;
  PROCEDURE  Antwort(Zufallreihe, Zufallzahl : INTEGER;
                     fEnd                    : BOOLEAN);
  PROCEDURE  SetSpielStand;
  FUNCTION   Zugtest(x_Click, y_Click : INTEGER) : BOOLEAN;

IMPLEMENTATION

  PROCEDURE SetSpielStand;
  VAR
    i, j, Anfang, Minimum : INTEGER;
  BEGIN
    Anfang := (15 - ElementZahl) DIV 2;
    FOR j := 0 TO 4 DO
      FOR i := 0 TO 14 DO
        VorZug[j, i] := 0;
    FOR j := 0 TO 4 DO
      FOR i := Anfang TO Anfang + Spiel[j] - 1 DO
        VorZug[j, i] := 1;
    IF NOT fZug THEN
      FOR j := 0 TO 4 DO BEGIN
        IF MaxZahl < Spiel[j] THEN Minimum := MaxZahl
                              ELSE Minimum := Spiel[j];
        FOR i := (Anfang + Spiel[j] - Minimum) TO
                 (Anfang + Spiel[j] - 1) DO
          VorZug[j, i] := 2;
      END;
    NachZug := VorZug;
  END;

  PROCEDURE SetSpiel(VAR Spiel : Feld;
                     A, B, C, D, E : INTEGER);
  BEGIN
    Spiel[0] := A;
    Spiel[1] := B;
    Spiel[2] := C;
    Spiel[3] := D;
    Spiel[4] := E;
  END;

  PROCEDURE ZugVorbereiten(Reihe, Spalte : INTEGER);
  VAR
    i, j : INTEGER;
  BEGIN
    SetSpiel(Zug, 0, 0, 0, 0, 0);
    WHILE (NachZug[Reihe, Spalte] = 2) AND
          (Spalte < 15) DO BEGIN
      Inc(NachZug[Reihe, Spalte]);
      Inc(Spalte);
      Inc(Zug[Reihe]);
    END;
    FOR j := 0 TO 4 DO
      FOR i := 0 TO 14 DO
        IF NachZug[j, i] = 2 THEN Dec(NachZug[j, i]);
  END;

  FUNCTION Zugtest(x_Click, y_Click : INTEGER) : BOOLEAN;
  VAR
    Reihe, Spalte : INTEGER;
  BEGIN
    Zugtest := FALSE;
    IF (y_Click > 20) AND (y_Click < 270) THEN
      Reihe := (y_Click-20) DIV 50
    ELSE Exit;
    IF x_Click < 599 THEN
      Spalte := x_Click DIV 40
    ELSE Exit;
    IF NachZug[Reihe, Spalte] = 2 THEN BEGIN
      ZugVorbereiten(Reihe, Spalte);
      Zugtest := TRUE;
    END;
  END;

  FUNCTION ZeroTest : BOOLEAN;
  VAR
    i : INTEGER;
  BEGIN
    ZeroTest := TRUE;
    FOR i := 0 TO 4 DO
      IF Spiel[i] > 0 THEN ZeroTest := FALSE;
  END;

  PROCEDURE MachTyp(VAR fTest : BOOLEAN);
  VAR
    i : BYTE;
  BEGIN
    Vierer := 0;
    Zweier := 0;
    Einer  := 0;
    fTest := FALSE;
    FOR i := 0 TO 4 DO BEGIN
      Typ[i][0] := Spiel[i];
      Typ[i][2] := Spiel[i] DIV (MaxZahl+1);
      Typ[i][1] := (Spiel[i] MOD (MaxZahl+1)) DIV 4;
      Vierer    := Vierer + Typ[i][1];
      Typ[i][3] := ((Spiel[i] MOD (MaxZahl+1)) MOD 4) DIV 2;
      Zweier    := Zweier + Typ[i][3];
      Typ[i][4] := ((Spiel[i] MOD (MaxZahl+1)) MOD 4) MOD 2;
      Einer     := Einer + Typ[i][4];
      IF (Typ[i][1] = 1) AND (Typ[i][3] = 1) THEN
        fTest := TRUE;
    END;
  END;

  PROCEDURE weg(Zufallreihe, Zufallzahl : INTEGER);
  VAR
    i : INTEGER;
  BEGIN
    FOR i := Zufallreihe TO 4 DO
      IF Typ[i][0] > 0 THEN
        IF Typ[i][0] >= Zufallzahl THEN BEGIN
          Dec(Spiel[i], Zufallzahl);
          Exit;
        END ELSE BEGIN
          Dec(Spiel[i]);
          Exit;
        END;
    FOR i := 0 TO Zufallreihe-1 DO
      IF Typ[i][0] >= Zufallzahl THEN BEGIN
        Dec(Spiel[i], Zufallzahl);
        Exit;
      END ELSE BEGIN
        Dec(Spiel[i]);
        Exit;
      END;
  END;

  PROCEDURE weg1(Zufallreihe, NimmZahl : INTEGER);
  VAR
    i : INTEGER;
  BEGIN
    FOR i := Zufallreihe TO 4 DO
      IF Typ[i][5-NimmZahl] = 1 THEN BEGIN
        Dec(Spiel[i], NimmZahl);
        Exit;
      END;
    FOR i := 0 TO Zufallreihe-1 DO
      IF Typ[i][5-NimmZahl] = 1 THEN BEGIN
        Dec(Spiel[i], NimmZahl);
        Exit;
      END;
    FOR i := Zufallreihe TO 4 DO
      IF Typ[i][2] > 0 THEN BEGIN
        Dec(Spiel[i], MaxZahl);
        Exit;
      END;
    FOR i := 0 TO Zufallreihe-1 DO
      IF Typ[i][2] > 0 THEN BEGIN
        Dec(Spiel[i], MaxZahl);
        Exit;
      END;
  END;

  PROCEDURE weg2(Zufallreihe,
                 NimmZahl1, NimmZahl2 : INTEGER);
  VAR
    i : INTEGER;
  BEGIN
    FOR i := Zufallreihe TO 4 DO
      IF Typ[i][5-NimmZahl1] = 1 THEN
        IF Typ[i][5-NimmZahl2] = 1 THEN BEGIN
          Dec(Spiel[i], (NimmZahl1+NimmZahl2));
          Exit;
        END ELSE BEGIN
          Dec(Spiel[i], (NimmZahl1-NimmZahl2));
          Exit;
        END;
    FOR i := 0 TO Zufallreihe-1 DO
      IF Typ[i][5-NimmZahl1] = 1 THEN
        IF Typ[i][5-NimmZahl2] = 1 THEN BEGIN
          Dec(Spiel[i], (NimmZahl1+NimmZahl2));
          Exit;
        END ELSE BEGIN
          Dec(Spiel[i], (NimmZahl1-NimmZahl2));
          Exit;
        END;
  END;

  PROCEDURE weg3(Zufallreihe : INTEGER);
  VAR
    i : INTEGER;
  BEGIN
    FOR i := Zufallreihe TO 4 DO
      IF Typ[i][1] = 1 THEN
        IF Typ[i][3] = 1 THEN BEGIN
          IF Typ[i][4] = 1 THEN BEGIN
            Dec(Spiel[i], 7);
            Exit;
          END ELSE BEGIN
            Dec(Spiel[i], 5);
            Exit;
          END;
        END ELSE BEGIN
          IF Typ[i][4] = 1 THEN BEGIN
            Dec(Spiel[i], 3);
            Exit;
          END ELSE BEGIN
            Dec(Spiel[i]);
            Exit;
          END;
        END;
    FOR i := 0 TO (Zufallreihe-1) DO
      IF Typ[i][1] = 1 THEN
        IF Typ[i][3] = 1 THEN BEGIN
          IF Typ[i][4] = 1 THEN BEGIN
            Dec(Spiel[i], 7);
            Exit;
          END ELSE BEGIN
            Dec(Spiel[i], 5);
            Exit;
          END;
        END ELSE BEGIN
          IF Typ[i][4] = 1 THEN BEGIN
            Dec(Spiel[i], 3);
            Exit;
          END ELSE BEGIN
            Dec(Spiel[i]);
            Exit;
          END;
        END;
  END;

  PROCEDURE Antwort(Zufallreihe, Zufallzahl : INTEGER;
                    fEnd                    : BOOLEAN);
  VAR
    i          : BYTE;
    fTest      : BOOLEAN;
    GewinnZahl : INTEGER;
  BEGIN
    MachTyp(fTest);
    IF NOT fEnd THEN BEGIN
      IF ((Vierer <= 1) AND (Zweier =  0)) OR
         ((Vierer =  0) AND (Zweier <= 1)) THEN Inc(Einer);
      IF (Vierer  =  1) AND (Zweier =  1) AND fTest THEN
        Inc(Einer);
    END;
    Vierer     := Vierer MOD 2;
    Zweier     := Zweier MOD 2;
    Einer      := Einer  MOD 2;
    GewinnZahl := Vierer*4 + Zweier*2 + Einer;
    CASE GewinnZahl OF
      0   : weg(Zufallreihe, Zufallzahl);
      1   : weg1(Zufallreihe, 1);
      2   : weg1(Zufallreihe, 2);
      3   : weg2(Zufallreihe, 2, 1);
      4   : weg1(Zufallreihe, 4);
      5   : weg2(Zufallreihe, 4, 1);
      6   : weg2(Zufallreihe, 4, 2);
      7   : weg3(Zufallreihe);
    END;
  END;

BEGIN
  Randomize;
END.
(* ====================================================== *)
(*                 Ende von NEHMEN.PAS                    *)

