(* ====================================================== *)
(*                      NIM.PAS                           *)
(*             Turbo Pascal fr Windows 1.5               *)
(*                       Nim-Spiel                        *)
(*      (c) 1993 Eberhard Krause & toolbox                *)
(* ====================================================== *)

PROGRAM Nim;

USES
{$IFNDEF Ver70}
  WinTypes, WinProcs, WObjects, Strings, Nehmen, StdDlgs;
{$ELSE}
  WinTypes, WinProcs, oWindows, Strings, Nehmen, oDialogs;
{$ENDIF}

{$R NIM.RES}

CONST
  zMenuName = 'NIM_Menu';

TYPE
  tAnwendung = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
    PROCEDURE InitInstance;   VIRTUAL;
  END;

  pFenster = ^tFenster;
  tFenster = OBJECT (tWindow)
    SpielSteine,
    Gewinn, Verlust,
    SteinKreuz,
    SteinAktiv  : hBitmap;
    fFertig,
    fSpieler,
    fSpiel,
    fEnd        : BOOLEAN;
    Zufallreihe,
    Zufallzahl  : INTEGER;

   { berschreibende Methoden }

    CONSTRUCTOR Init(MutterFenster : pWindowsObject;
                     zTitel        : pChar);
    PROCEDURE   Paint(hPaintDC : hDC;
                      VAR PaintInfo : tPaintStruct);
                VIRTUAL;
    FUNCTION    CanClose : BOOLEAN;                 VIRTUAL;
    PROCEDURE   GetWindowClass
                (VAR Fensterklasse : tWndClass);    VIRTUAL;
    PROCEDURE   WMLButtonDown(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_LButtonDown;
    PROCEDURE   WMRButtonDown(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_RButtonDown;
    PROCEDURE   Destroy;                            VIRTUAL;
    DESTRUCTOR  Done;                               VIRTUAL;

    { fr Spiel_Men }

    PROCEDURE   SpielStart(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SStart;
    PROCEDURE   SpielZurueck(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SZurueck;
    PROCEDURE   SpielEnde(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SEnde;

    { Methoden fr Reihen_Men }

    PROCEDURE   ReihenDrei(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_RDrei;
    PROCEDURE   ReihenVier(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_RVier;
    PROCEDURE   ReihenFuenf(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_RFuenf;

    { Methoden fr Elementzahl_Men }

    PROCEDURE   ElementFuenf(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_EFuenf;
    PROCEDURE   ElementSieben(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_ESieben;
    PROCEDURE   ElementNeun(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_ENeun;
    PROCEDURE   ElementElf(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_EElf;
    PROCEDURE   ElementDreizehn(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_EDreizehn;
    PROCEDURE   ElementFuenfzehn(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_EFuenfzehn;

    { Methoden fr Maximum-Men }

    PROCEDURE   MaxZwei(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_MZwei;
    PROCEDURE   MaxDrei(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_MDrei;
    PROCEDURE   MaxVier(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_MVier;
    PROCEDURE   MaxFuenf(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_MFuenf;
    PROCEDURE   MaxSechs(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_MSechs;
    PROCEDURE   MaxSieben(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_MSieben;

    { Methoden fr Beginn_Men }

    PROCEDURE   BeginnSpieler(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_BSpieler;
    PROCEDURE   BeginnComputer(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_BComputer;

    { Methoden fr Gewinn_Men }

    PROCEDURE   GewinnLetGewinnt(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_GLetGewinnt;
    PROCEDURE   GewinnLetVerliert(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_GLetVerliert;

    { Methoden fr Hilfe_Men }

    PROCEDURE   HilfeHolen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_HHilfe;
    PROCEDURE   InfoZeigen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_HInfo;
  END;

(* ====================================================== *)
(* Definition der Methoden von tAnwendung.                *)
(* ====================================================== *)

  PROCEDURE tAnwendung.InitMainWindow;
  BEGIN
    MainWindow := New(pFenster, Init(NIL, 'NIM-Spiel'));
  END;

  PROCEDURE tAnwendung.InitInstance;
  BEGIN
    tApplication.InitInstance;
    hAccTable := LoadAccelerators(hInstance, 'NIM_Tasten');
  END;

(* ====================================================== *)
(* Definition der Methoden von tFenster.                  *)
(* ====================================================== *)

  CONSTRUCTOR tFenster.Init(MutterFenster : pWindowsObject;
                            zTitel        : pChar);
  BEGIN
    tWindow.Init(MutterFenster, zTitel);
    Attr.X      :=  20;
    Attr.Y      :=  20;
    Attr.W      := 610;
    Attr.H      := 330;
    Attr.Menu   := LoadMenu(hInstance, zMenuName);
    SetSpiel(Spiel, 0, 0, 0, 0, 0);
    ElementZahl := 7;
    ReihenZahl  := 3;
    MaxZahl     := 3;
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_RDrei,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_RDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MDrei, 'Drei');
    fSpieler    := FALSE;
    fSpiel      := FALSE;
    fEnd        := TRUE ;
    ModifyMenu(Attr.Menu, cm_BComputer,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_BComputer, 'Computer');
    ModifyMenu(Attr.Menu, cm_GLetGewinnt,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_GLetGewinnt, 'gewinnt');
    fFertig     := FALSE;
    SpielSteine := LoadBitmap(hInstance, 'Punkt');
    SteinKreuz  := LoadBitmap(hInstance, 'Kreuz');
    SteinAktiv  := LoadBitmap(hInstance, 'PunktAktiv');
    Gewinn      := LoadBitmap(hInstance, 'Gewinn');
    Verlust     := LoadBitmap(hInstance, 'Verlust');
  END;

  PROCEDURE tFenster.WMLButtonDown(VAR Ereignis : tMessage);
  BEGIN
    IF Zugtest(Ereignis.lParamLo,
               Ereignis.lParamHi) THEN BEGIN
      EnableMenuItem(Attr.Menu, cm_SZurueck, mf_Enabled);
      InvalidateRect(hWindow, NIL, TRUE);
      fFertig := TRUE;
    END;
  END;

  PROCEDURE tFenster.WMRButtonDown(VAR Ereignis : tMessage);
  VAR
    i : INTEGER;
  BEGIN
    IF fSpiel THEN BEGIN
      IF NOT fZug THEN BEGIN
        IF fFertig THEN BEGIN
          FOR i := 0 TO 4 DO
            Spiel[i] := Spiel[i] - Zug[i];
          fZug    := TRUE;
          fFertig := FALSE;
          EnableMenuItem(Attr.Menu, cm_SZurueck, mf_Grayed);
        END;
      END ELSE BEGIN
        IF NOT fFertig THEN BEGIN
          Zufallreihe := Random(ReihenZahl);
          Zufallzahl  := Succ(Random(MaxZahl));
          Antwort(Zufallreihe, Zufallzahl, fEnd);
          fZug := FALSE;
        END;
      END;
      SetSpielStand;
      InvalidateRect(hWindow, NIL, TRUE);
      IF ZeroTest THEN BEGIN
        UpdateWindow(hWindow);
        IF (fZug AND fEnd) OR (NOT fZug AND NOT fEnd) THEN
          MessageBox(hWindow, '        Gratuliere !!',
                              'Gewinn fr Sie !!!', mb_OK)
        ELSE MessageBox(hWindow,
                        'Viel Glck im nchsten Spiel!',
                        'Leider Verlust fr Sie!', mb_OK);
        fSpiel := FALSE;
      END;
    END;
  END;

  PROCEDURE tFenster.Paint(hPaintDC : hDC;
                           VAR PaintInfo : tPaintStruct);
  VAR
    i, j, h   : INTEGER;
    MemDC     : hDC;
    MemObject : tHandle;
  BEGIN
    tWindow.Paint(hPaintDC, PaintInfo);
    MemDC := CreateCompatibleDC(hPaintDC);
    SelectObject(MemDC, SpielSteine);
    FOR j := 0 TO 4 DO BEGIN
      FOR i := 0 TO 14 DO
        CASE NachZug[j, i] OF
          1 : BitBlt(hPaintDC,  5 + i*x_Diff,
                               20 + j*y_Diff,
                     30, 30, MemDC, 0, 0, SrcCopy);
          2 : BEGIN
                SelectObject(MemDC, SteinAktiv);
                BitBlt(hPaintDC,  5 + i*x_Diff,
                                 20 + j*y_Diff,
                       30, 30, MemDC, 0, 0, SrcCopy);
                SelectObject(MemDC, SpielSteine);
              END;
          3 : BEGIN
                SelectObject(MemDC, SteinKreuz);
                BitBlt(hPaintDC,  5 + i*x_Diff,
                                 20 + j*y_Diff,
                       30, 30, MemDC, 0, 0, SrcCopy);
                SelectObject(MemDC, SpielSteine);
              END;
        END;
    END;
    IF fEnd THEN BEGIN
      SelectObject(MemDC, Gewinn);
      BitBlt(hPaintDC, 265, 260, 80, 15,
             MemDC, 0, 0, SrcCopy);
    END ELSE BEGIN
      SelectObject(MemDC, Verlust);
      BitBlt(hPaintDC, 265, 260, 80, 15,
             MemDC, 0, 0, SrcCopy);
    END;
    DeleteDC(MemDC);
  END;

  PROCEDURE tFenster.Destroy;
  BEGIN
    WinHelp(hWindow, 'NIM.hlp', Help_Quit, 0);
    tWindow.Destroy;
  END;

  FUNCTION tFenster.CanClose;
  VAR
    nKontrolle : INTEGER;
  BEGIN
    CanClose := TRUE;
    nKontrolle := MessageBox(hWindow,
                             '   Soll schon Schlu sein?',
                             'Programmende',
                             mb_YesNo OR mb_IconQuestion);
    IF nKontrolle = id_No THEN CanClose := FALSE;
  END;

  PROCEDURE tFenster.GetWindowClass
            (VAR Fensterklasse : tWndClass);
  BEGIN
    tWindow.GetWindowClass(Fensterklasse);
    Fensterklasse.hbrBackground :=
      GetStockObject(LTGray_Brush);
    Fensterklasse.hIcon := LoadIcon(hInstance, 'NIM_ICON');
  END;

  DESTRUCTOR tFenster.Done;
  BEGIN
    DeleteObject(SpielSteine);
    DeleteObject(SteinKreuz);
    DeleteObject(SteinAktiv);
    DeleteObject(Gewinn);
    DeleteObject(Verlust);
    tWindow.Done;
  END;

  PROCEDURE tFenster.SpielStart(VAR Ereignis : tMessage);
  BEGIN
    CASE ReihenZahl OF
      3 : SetSpiel(Spiel, 0,    ElementZahl,
                   ElementZahl, ElementZahl, 0);
      4 : SetSpiel(Spiel, ElementZahl, ElementZahl,
                   ElementZahl, ElementZahl, 0);
      5 : SetSpiel(Spiel, ElementZahl, ElementZahl,
                   ElementZahl, ElementZahl, ElementZahl);
    END;
    fZug := fSpieler;
    SetSpielStand;
    fSpiel := TRUE;
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  PROCEDURE tFenster.SpielZurueck(VAR Ereignis : tMessage);
  BEGIN
    NachZug := VorZug;
    fFertig := FALSE;
    EnableMenuItem(Attr.Menu, cm_SZurueck, mf_Grayed);
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  PROCEDURE tFenster.SpielEnde(VAR Ereignis : tMessage);
  BEGIN
    SendMessage(hWindow, wm_close, 0, 0);
  END;

  PROCEDURE tFenster.HilfeHolen(VAR Ereignis : tMessage);
  VAR
    HelpWnd : pWindow;
  BEGIN
    WinHelp(hWindow, 'NIM.hlp', Help_Index, 0);
  END;

  PROCEDURE tFenster.InfoZeigen(VAR Ereignis : tMessage);
  BEGIN
    MessageBox(hWindow,
               '(c) 1993 Eberhard Krause & DMV-Verlag'+
               #13#10 +
               'Turbo Pascal fr Windows 1.5',
               'Information', mb_OK OR mb_IconExclamation);
  END;

  PROCEDURE tFenster.ReihenDrei(VAR Ereignis : tMessage);
  BEGIN
    ReihenZahl := 3;
    ModifyMenu(Attr.Menu, cm_RDrei,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_RDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_RVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_RVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_RFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_RFuenf, 'Fuenf');
  END;

  PROCEDURE tFenster.ReihenVier(VAR Ereignis : tMessage);
  BEGIN
    ReihenZahl := 4;
    ModifyMenu(Attr.Menu, cm_RDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_RDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_RVier,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_RVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_RFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_RFuenf, 'Fuenf');
  END;

  PROCEDURE tFenster.ReihenFuenf(VAR Ereignis : tMessage);
  BEGIN
    ReihenZahl := 5;
    ModifyMenu(Attr.Menu, cm_RDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_RDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_RVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_RVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_RFuenf,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_RFuenf, 'Fnf');
  END;

  PROCEDURE tFenster.ElementFuenf(VAR Ereignis : tMessage);
  BEGIN
    ElementZahl := 5;
    ModifyMenu(Attr.Menu, cm_EFuenf,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_EFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_ENeun,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ENeun, 'Neun');
    ModifyMenu(Attr.Menu, cm_EElf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EElf, 'Elf');
    ModifyMenu(Attr.Menu, cm_EDreizehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EDreizehn, 'Dreizehn');
    ModifyMenu(Attr.Menu, cm_EFuenfzehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenfzehn, 'Fnfzehn');
  END;

  PROCEDURE tFenster.ElementSieben(VAR Ereignis : tMessage);
  BEGIN
    ElementZahl := 7;
    ModifyMenu(Attr.Menu, cm_EFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_ENeun,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ENeun, 'Neun');
    ModifyMenu(Attr.Menu, cm_EElf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EElf, 'Elf');
    ModifyMenu(Attr.Menu, cm_EDreizehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EDreizehn, 'Dreizehn');
    ModifyMenu(Attr.Menu, cm_EFuenfzehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenfzehn, 'Fnfzehn');
  END;

  PROCEDURE tFenster.ElementNeun(VAR Ereignis : tMessage);
  BEGIN
    ElementZahl := 9;
    ModifyMenu(Attr.Menu, cm_EFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_ENeun,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_ENeun, 'Neun');
    ModifyMenu(Attr.Menu, cm_EElf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EElf, 'Elf');
    ModifyMenu(Attr.Menu, cm_EDreizehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EDreizehn, 'Dreizehn');
    ModifyMenu(Attr.Menu, cm_EFuenfzehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenfzehn, 'Fnfzehn');
  END;

  PROCEDURE tFenster.ElementElf(VAR Ereignis : tMessage);
  BEGIN
    ElementZahl := 11;
    ModifyMenu(Attr.Menu, cm_EFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_ENeun,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ENeun, 'Neun');
    ModifyMenu(Attr.Menu, cm_EElf,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_EElf, 'Elf');
    ModifyMenu(Attr.Menu, cm_EDreizehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EDreizehn, 'Dreizehn');
    ModifyMenu(Attr.Menu, cm_EFuenfzehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenfzehn, 'Fnfzehn');
  END;

  PROCEDURE tFenster.ElementDreizehn(VAR Ereignis:tMessage);
  BEGIN
    ElementZahl := 13;
    ModifyMenu(Attr.Menu, cm_EFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_ENeun,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ENeun, 'Neun');
    ModifyMenu(Attr.Menu, cm_EElf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EElf, 'Elf');
    ModifyMenu(Attr.Menu, cm_EDreizehn,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_EDreizehn, 'Dreizehn');
    ModifyMenu(Attr.Menu, cm_EFuenfzehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenfzehn, 'Fnfzehn');
  END;

  PROCEDURE tFenster.ElementFuenfzehn(VAR Ereignis:tMessage);
  BEGIN
    ElementZahl := 15;
    ModifyMenu(Attr.Menu, cm_EFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_ESieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ESieben, 'Sieben');
    ModifyMenu(Attr.Menu, cm_ENeun,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_ENeun, 'Neun');
    ModifyMenu(Attr.Menu, cm_EElf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EElf, 'Elf');
    ModifyMenu(Attr.Menu, cm_EDreizehn,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_EDreizehn, 'Dreizehn');
    ModifyMenu(Attr.Menu, cm_EFuenfzehn,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_EFuenfzehn, 'Fnfzehn');
  END;

  { Methoden fr Maximum-Men }

  PROCEDURE tFenster.MaxZwei(VAR Ereignis : tMessage);
  BEGIN
    MaxZahl := 2;
    ModifyMenu(Attr.Menu, cm_MZwei,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MZwei, 'Zwei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_MFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_MSechs,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSechs, 'Sechs');
    ModifyMenu(Attr.Menu, cm_MSieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSieben, 'Sieben');
  END;

  PROCEDURE tFenster.MaxDrei(VAR Ereignis : tMessage);
  BEGIN
    MaxZahl := 3;
    ModifyMenu(Attr.Menu, cm_MZwei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MZwei, 'Zwei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_MFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_MSechs,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSechs, 'Sechs');
    ModifyMenu(Attr.Menu, cm_MSieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSieben, 'Sieben');
  END;

  PROCEDURE tFenster.MaxVier(VAR Ereignis : tMessage);
  BEGIN
    MaxZahl := 4;
    ModifyMenu(Attr.Menu, cm_MZwei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MZwei, 'Zwei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MVier,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_MFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_MSechs,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSechs, 'Sechs');
    ModifyMenu(Attr.Menu, cm_MSieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSieben, 'Sieben');
  END;

  PROCEDURE tFenster.MaxFuenf(VAR Ereignis : tMessage);
  BEGIN
    MaxZahl := 5;
    ModifyMenu(Attr.Menu, cm_MZwei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MZwei, 'Zwei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_MFuenf,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_MSechs,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSechs, 'Sechs');
    ModifyMenu(Attr.Menu, cm_MSieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSieben, 'Sieben');
  END;

  PROCEDURE tFenster.MaxSechs(VAR Ereignis : tMessage);
  BEGIN
    MaxZahl := 6;
    ModifyMenu(Attr.Menu, cm_MZwei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MZwei, 'Zwei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_MFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_MSechs,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MSechs, 'Sechs');
    ModifyMenu(Attr.Menu, cm_MSieben,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSieben, 'Sieben');
  END;

  PROCEDURE tFenster.MaxSieben(VAR Ereignis : tMessage);
  BEGIN
    MaxZahl := 7;
    ModifyMenu(Attr.Menu, cm_MZwei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MZwei, 'Zwei');
    ModifyMenu(Attr.Menu, cm_MDrei,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MDrei, 'Drei');
    ModifyMenu(Attr.Menu, cm_MVier,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MVier, 'Vier');
    ModifyMenu(Attr.Menu, cm_MFuenf,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MFuenf, 'Fnf');
    ModifyMenu(Attr.Menu, cm_MSechs,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_MSechs, 'Sechs');
    ModifyMenu(Attr.Menu, cm_MSieben,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_MSieben, 'Sieben');
  END;

  { Methoden fr Beginn_Men }

  PROCEDURE tFenster.BeginnSpieler(VAR Ereignis : tMessage);
  BEGIN
    fSpieler := FALSE;
    ModifyMenu(Attr.Menu, cm_BSpieler,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_BSpieler, 'Spieler');
    ModifyMenu(Attr.Menu, cm_BComputer,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_BComputer, 'Computer');
  END;

  PROCEDURE tFenster.BeginnComputer(VAR Ereignis: tMessage);
  BEGIN
    fSpieler := TRUE;
    ModifyMenu(Attr.Menu, cm_BSpieler,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_BSpieler, 'Spieler');
    ModifyMenu(Attr.Menu, cm_BComputer,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_BComputer, 'Computer');
  END;

  { Methoden fr Gewinn_Men }

  PROCEDURE tFenster.GewinnLetGewinnt(VAR Ereignis:tMessage);
  BEGIN
    fEnd := TRUE;
    ModifyMenu(Attr.Menu, cm_GLetGewinnt,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_GLetGewinnt, 'gewinnt');
    ModifyMenu(Attr.Menu, cm_GLetVerliert,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_GLetVerliert, 'verliert');
  END;

  PROCEDURE tFenster.GewinnLetVerliert(VAR Ereignis:tMessage);
  BEGIN
    fEnd := FALSE;
    ModifyMenu(Attr.Menu, cm_GLetGewinnt,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_GLetGewinnt, 'gewinnt');
    ModifyMenu(Attr.Menu, cm_GLetVerliert,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_GLetVerliert, 'verliert');
  END;

(* ====================================================== *)
(* Vereinbarung des Applikations-Objekts.                 *)
(* ====================================================== *)

VAR
  Appl : tAnwendung;

BEGIN
  Appl.Init('Nim');
  Appl.Run;
  Appl.Done;
END.
(* ====================================================== *)
(*                 Ende von NIM.PAS                       *)
