(* ====================================================== *)
(*                        PAT.PAS                         *)
(*             Turbo Pascal fr Windows 1.5               *)
(*                       Patience                         *)
(*      (c) 1993 Eberhard Krause & toolbox                *)
(* ====================================================== *)

PROGRAM Pat;

USES
{$IFNDEF Ver70}
  WinTypes, WinProcs, WObjects, Patience, StdDlgs;
{$ELSE}
  WinTypes, WinProcs, oWindows, oDialogs,
  Objects, Patience, oStdDlgs;
{$ENDIF}

(* ====================================================== *)
(* Einbinden der Ressource-Datei .                        *)
(* ====================================================== *)

{$R Pat.RES}

CONST
  zMenuName = 'Pati_Menu';

(* ====================================================== *)
(* Vereinbarung der Objekttypen.                          *)
(* ====================================================== *)

TYPE
  Auswahl = RECORD
    i, j    : INTEGER;
    Wert    : INTEGER;
    Gesetzt : BOOLEAN;
  END;

  tAnwendung = OBJECT (tApplication)
    PROCEDURE InitMainWindow;  VIRTUAL;
    PROCEDURE InitInstance;    VIRTUAL;
  END;

  pFenster = ^tFenster;
  tFenster = OBJECT (tWindow)
    NeuKarte, Rand,
    Leer, Hinten,
    Oben, Striche,
    KlHinten            : hBitmap;
    hLib                : tHandle;
    Prison, Sonderrecht,
    Zeiger, Anzahl      : INTEGER;
    fVario, fLeicht,
    fLinks, fRechts     : BOOLEAN;
    Wahl1, Wahl2        : Auswahl;
    Talon               : ARRAY [1..52]      OF INTEGER;
    Tisch               : ARRAY [0..3, 0..3] OF INTEGER;
    Ablage              : ARRAY [1..7]       OF INTEGER;

    { berschreibende Methoden }

    CONSTRUCTOR Init(MutterFenster : pWindowsObject;
                     zTitel        : pChar);
    PROCEDURE   GetWindowClass
                (VAR Fensterklasse : tWndClass);    VIRTUAL;
    PROCEDURE   Paint(hPaintDC : hDC;
                      VAR PaintInfo: tPaintStruct); VIRTUAL;
    PROCEDURE   WMLButtonDown(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_LButtonDown;
    PROCEDURE   WMLButtonUp(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_LButtonUp;
    PROCEDURE   WMRButtonDown(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_RButtonDown;
    PROCEDURE   WMRButtonUp(VAR Ereignis : tMessage);
                VIRTUAL wm_First + wm_RButtonUp;
    FUNCTION    CanClose : BOOLEAN;                 VIRTUAL;
    PROCEDURE   Destroy;                            VIRTUAL;
    DESTRUCTOR  Done;                               VIRTUAL;
    FUNCTION    VerlustTest1 : BOOLEAN;
    FUNCTION    VerlustTest2 : BOOLEAN;

    { Methoden fr Spiel_Men }

   PROCEDURE    SpielNeu(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SNeu;
   PROCEDURE    SpielBeenden(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SBeenden;

   { Methoden fr Optionen_Men }

   PROCEDURE    OptionenZugZurueck(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_OZug_Zurueck;
   PROCEDURE    OptionenSpielWiederholen
                (VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_OSpiel_Wieder;

   { Methoden fr Schwierigkeit_Men }

   PROCEDURE    SSchwierig(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SSchwierig ;
   PROCEDURE    SMittel(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SMittel ;
   PROCEDURE    SLeicht(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_SLeicht ;

   { Methoden fr Hilfe_Men }

   PROCEDURE    HilfeHolen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_HHilfe;
   PROCEDURE    InfoZeigen(VAR Ereignis : tMessage);
                VIRTUAL cm_First + cm_HInfo;
   PROCEDURE    GibKart(SetKarte : hBitmap; x, y : INTEGER;
                        Modus : LongInt);           VIRTUAL;
  END;

(* ====================================================== *)
(* Definition der Methoden von tAnwendung.                *)
(* ====================================================== *)

  PROCEDURE tAnwendung.InitMainWindow;
  BEGIN
    MainWindow := New(pFenster, Init (NIL,'Patience "14"'));
  END;

  PROCEDURE tAnwendung.InitInstance;
  BEGIN
    tApplication.InitInstance;
    hAccTable := LoadAccelerators(hInstance, 'PATI_TASTE');
  END;

(* ====================================================== *)
(* Definition der Methoden von tFenster.                  *)
(* ====================================================== *)

  CONSTRUCTOR tFenster.Init(MutterFenster : pWindowsObject;
                            zTitel        : pChar);
  VAR
    i, j : INTEGER;
  BEGIN
    tWindow.Init(MutterFenster, zTitel);
    Attr.X    :=  10;
    Attr.Y    :=  10;
    Attr.W    := 620;
    Attr.H    := 440;
    Attr.Menu := LoadMenu(hInstance, zMenuName);
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SMittel, 'Mittel');
    hLib      := LoadLibrary('KARTEN.DLL');
    Striche   := LoadBitmap(hInstance, 'Kreuz');
    Leer      := LoadBitmap(hInstance, 'Blanko');
    Hinten    := LoadBitmap(hInstance, 'Ruecken');
    Rand      := LoadBitmap(hInstance, 'Rahmen');
    KlHinten  := LoadBitmap(hInstance, 'KlRuecken');
    Oben      := LoadBitmap(hInstance, 'Rand_Oben');
    Prison    := 0;
    FOR i := 1 TO 7 DO
      Ablage[i] := 0;
    FOR i := 0 TO 3 DO
      FOR j := 0 TO 3 DO
        Tisch[i, j] := 0;
    Zeiger        := 55;
    fVario        := FALSE;
    fLeicht       := FALSE;
    Wahl1.Gesetzt := FALSE;
    Wahl2.Gesetzt := FALSE;
    Sonderrecht   := 10;
    Randomize;
  END;

  PROCEDURE tFenster.GetWindowClass
            (VAR Fensterklasse : tWndClass);
  BEGIN
    tWindow.GetWindowClass(Fensterklasse);
    Fensterklasse.hbrBackground :=
      GetStockObject(Gray_Brush);
    Fensterklasse.hIcon :=  LoadIcon(hInstance, 'PAT_ICON');
  END;

  PROCEDURE tFenster.Paint(hPaintDC : hDC;
                           VAR PaintInfo : tPaintStruct);
  VAR
    i, j      : INTEGER;
    MDC       : hDC;
    MemObject,
    SavObject : tHandle;
  BEGIN
    tWindow.Paint(hPaintDC, PaintInfo);
    FOR i := 0 TO 4 DO BEGIN
      MoveTo(hPaintDC, 112, 15 + i*80);
      LineTo(hPaintDC, 392, 15 + i*80);
    END;
    FOR i := 0 TO 4 DO BEGIN
      MoveTo(hPaintDC, 112 + i*70,  15);
      LineTo(hPaintDC, 112 + i*70, 335);
    END;
    MDC := CreateCompatibleDC(hPaintDC);
    MemObject := SelectObject(MDC, Rand);
    IF Zeiger > 52 THEN
      BitBlt(hPaintDC, 30, 20, 54, 72, MDC, 0, 0, SrcCopy)
    ELSE BEGIN
      SelectObject(MDC, Oben);
      FOR i := 1 TO ((52-Zeiger) DIV 2) DO
        BitBlt(hPaintDC, 30, 18 + i*2, 54, 72,
               MDC, 0, 0, SrcCopy);
      SelectObject(MDC, Hinten);
      BitBlt(hPaintDC, 30, 20 + ((52-Zeiger)DIV 2)*2, 54,
             72, MDC, 0, 0, SrcCopy);
    END;
    SelectObject(MDC, Rand);
    IF Prison = 0 THEN
      BitBlt(hPaintDC, 30, 140, 54, 72, MDC, 0, 0, SrcCopy)
    ELSE BEGIN
      NeuKarte := LoadBitmap(hLib, MakeIntResource(Prison));
      SavObject := SelectObject(MDC, NeuKarte);
      BitBlt(hPaintDC, 30, 140, 54, 72, MDC, 0, 0, SrcCopy);
      SelectObject(MDC, SavObject);
      DeleteObject(NeuKarte);
    END;
    FOR i := 0 TO 3 DO
      FOR j := 0 TO 3 DO
        IF (Tisch[i, j] <>   0) AND
           (Tisch[i, j] <> 100) THEN BEGIN
          NeuKarte := LoadBitmap(hLib,
                             MakeIntResource(Tisch[i, j]));
          SavObject := SelectObject(MDC, NeuKarte);
          BitBlt(hPaintDC, 120 + j*70, 20 + i*80, 54, 72,
                 MDC, 0, 0, SrcCopy);
          SelectObject(MDC, SavObject);
          DeleteObject(NeuKarte);
        END ELSE IF Tisch[i, j] = 100 THEN BEGIN
          SavObject := SelectObject(MDC, Striche);
          BitBlt(hPaintDC, 120 + j*70, 20 + i*80, 54, 72,
                 MDC, 0, 0, SrcCopy);
          SelectObject(MDC, SavObject);
        END;
    IF Wahl1.Gesetzt THEN BEGIN
      NeuKarte := LoadBitmap(hLib, MakeIntResource
                             (Tisch[Wahl1.i, Wahl1.j]));
      SavObject := SelectObject(MDC, NeuKarte);
      BitBlt(hPaintDC, 120 + Wahl1.j*70, 20 + Wahl1.i*80,
             54, 72, MDC, 0, 0, NotSrcCopy);
      SelectObject(MDC, SavObject);
      DeleteObject(NeuKarte);
    END;
    SelectObject(MDC, KlHinten);
    FOR i := 1 TO 7 DO BEGIN
      IF Ablage[i] > 0 THEN
        FOR j := 1 TO Ablage[i] DO
          BitBlt(hPaintDC, 425 + j*5, 20 + (i-1)*45, 30,
                 40, MDC, 0, 0, SrcCopy);
      TextOut(hPaintDC, 500, 30 + (i-1)*45, Schrift[i], 4);
    END;
    SelectObject(MDC, MemObject);
    DeleteDC(MDC);
  END;

  PROCEDURE tFenster.WMLButtonDown(VAR Ereignis : tMessage);
  VAR
    Wahl : Auswahl;
  BEGIN
    IF fLinks THEN BEGIN
      IF ((Ereignis.lParamLo > 112) AND
          (Ereignis.lParamLo < 408)) THEN
        Wahl.j := (Ereignis.lParamLo - 112) DIV 70
      ELSE Exit;
      IF ((Ereignis.lParamHi >  16) AND
          (Ereignis.lParamHi < 334)) THEN
        Wahl.i := (Ereignis.lParamHi - 16) DIV 80
      ELSE Exit;
      IF (Tisch[Wahl.i, Wahl.j] =   0) OR
         (Tisch[Wahl.i, Wahl.j] = 100) THEN BEGIN
        MessageBox(hWindow,
                   'Auf dem Feld ist keine Karte !',
                   'Unerlaubter Zug !!!', mb_OK);
        InvalidateRect(hWindow, NIL, TRUE);
        Exit;
      END;
      EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
      Wahl.Wert := (Tisch[Wahl.i, Wahl.j]);
      WHILE  Wahl.Wert > 13 DO
        Dec(Wahl.Wert, 13);
      Wahl.Gesetzt := TRUE;
      IF NOT Wahl1.Gesetzt THEN BEGIN
        Wahl1 := Wahl;
        NeuKarte := LoadBitmap(hLib, MakeIntResource
                               (Tisch[Wahl.i, Wahl.j]));
        GibKart(NeuKarte, 120 + Wahl.j*70,20 + Wahl.i*80,
                NotSrcCopy);
        DeleteObject(NeuKarte);
      END ELSE BEGIN
        IF (Wahl1.i = Wahl.i) AND
           (Wahl1.j = Wahl.j) THEN BEGIN
          NeuKarte := LoadBitmap(hLib, MakeIntResource
                                 (Tisch[Wahl.i, Wahl.j]));
          GibKart(NeuKarte, 120 + Wahl.j*70, 20 + Wahl.i*80,
                  SrcCopy);
          DeleteObject(NeuKarte);
          Wahl1.Gesetzt := FALSE;
        END ELSE BEGIN
          IF NOT fVario THEN BEGIN
            IF (Wahl1.i <> Wahl.i) AND
               (Wahl1.j <> Wahl.j) THEN BEGIN
              MessageBox(hWindow,
                         'Reihe und Spalte ungleich !',
                         'Unerlaubter Zug !!!', mb_OK);
              InvalidateRect(hWindow, NIL, TRUE);
              Exit;
            END;
          END ELSE IF NOT (((Wahl1.i = 3) AND
                            (Wahl1.j = 3)) OR
                           ((Wahl.i = 3)
                        AND (Wahl.j = 3))) THEN
            IF (Wahl1.I <> Wahl.i) AND
               (Wahl1.j <> Wahl.j) THEN BEGIN
              MessageBox(hWindow,
                         'Reihe und Spalte ungleich !',
                         'Unerlaubter Zug !!!', mb_OK);
              InvalidateRect(hWindow, NIL, TRUE);
              Exit;
            END;
          IF (Wahl1.Wert + Wahl.Wert) <> 14 THEN BEGIN
            MessageBox(hWindow,
                       'Kartensumme ist ungleich 14 !',
                       'Unerlaubter Zug !!!', mb_OK);
            InvalidateRect(hWindow, NIL, TRUE);
            Exit;
          END;
          Wahl2 := Wahl;
          NeuKarte := LoadBitmap(hLib, MakeIntResource
                                 (Tisch[Wahl.i, Wahl.j]));
          GibKart(NeuKarte, 120 + Wahl2.j*70,
                  20 + Wahl2.i*80, NotSrcCopy);
          DeleteObject(NeuKarte);
        END;
      END;
    END;
  END;

  PROCEDURE tFenster.WMLButtonUp(VAR Ereignis : tMessage);
  VAR
    Spruch : pChar;
    i, j   : INTEGER;
  BEGIN
    IF Wahl2.Gesetzt THEN BEGIN
      Wahl2.Gesetzt := FALSE;
      Wahl1.Gesetzt := FALSE;
      Tisch[Wahl1.i, Wahl1.j] := 0;
      Tisch[Wahl2.i, Wahl2.j] := 0;
      GibKart(Leer, 120 + Wahl1.j*70, 20 + Wahl1.i*80,
              SrcCopy);
      GibKart(Leer, 120 + Wahl2.j*70, 20 + Wahl2.i*80,
              SrcCopy);
      IF Wahl1.Wert > Wahl2.Wert THEN
        Wahl1.Wert := Wahl2.Wert;
      Inc(Ablage[Wahl1.Wert]);
      GibKart(KlHinten, 425 + (Ablage[Wahl1.Wert]*5),
              20 + (Wahl1.Wert-1)*45, SrcCopy);
      fRechts := TRUE;
      Inc(Sonderrecht);
      IF (Sonderrecht = 1) AND
         (Anzahl < 16) AND (Zeiger < 53) THEN
        fLinks := FALSE;
      Dec(Anzahl, 2);
      IF NOT fVario  AND
         (Zeiger > 52) AND (Anzahl > 0) AND
         VerlustTest1 THEN BEGIN
        Spruch := SpruchVerlust[Random(5)];
        MessageBox(hWindow, Spruch,
                   'Nicht aufgegangen', mb_OK);
        Prison := 0;
        FOR i := 1 TO 7 DO
          Ablage[i] := 0;
        FOR i := 0 TO 3 DO
          FOR j := 0 TO 3 DO
            Tisch[i, j] := 0;
        Zeiger := 53;
        InvalidateRect(hWindow, NIL, TRUE);
        Exit;
      END;
      IF fVario  AND
         (Zeiger > 52) AND (Anzahl > 0) AND
         VerlustTest2 THEN BEGIN
        Spruch := SpruchVerlust[Random(5)];
        MessageBox(hWindow, Spruch,
                   'Nicht aufgegangen', mb_OK);
        Prison := 0;
        FOR i := 1 TO 7 DO
          Ablage[i] := 0;
        FOR i := 0 TO 2 DO
          FOR j := 0 TO 2 DO
            Tisch[i, j] := 0;
        Tisch[3, 3] := 0;
        Zeiger      := 53;
        InvalidateRect(hWindow, NIL, TRUE);
        Exit;
      END;
      IF (Anzahl = 0) AND (Zeiger > 52) THEN BEGIN
        Spruch := SpruchGewinn[Random(5)];
        MessageBox(hWindow, Spruch,
                   'Aufgegangen   !!!', mb_OK);
      END;
    END;
  END;

  PROCEDURE tFenster.WMRButtonDown(VAR Ereignis : tMessage);
  VAR
    Spruch : pChar;
    i, j   : INTEGER;
  BEGIN
    IF (fRechts AND (Ereignis.lParamLo >  30) AND
                    (Ereignis.lParamLo <  84) AND
                    (Ereignis.lParamHi > 140) AND
                    (Ereignis.lParamHi < 212)) THEN BEGIN
      IF Wahl1.Gesetzt THEN BEGIN
        Wahl1.Gesetzt := FALSE;
        InvalidateRect(hWindow, NIL, TRUE);
      END;
      IF fLeicht AND (Sonderrecht > 1) THEN
        Sonderrecht := 0;
      EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
      fLinks   := FALSE;
      fRechts  := FALSE;
      Prison   := Talon[Zeiger];
      NeuKarte := LoadBitmap(hLib, MakeIntResource(Prison));
      GibKart(Leer, 30, 22+((53-Zeiger) DIV 2)*2, SrcCopy);
      GibKart(Hinten, 30, 20+((53-Zeiger) DIV 2)*2,SrcCopy);
      GibKart(NeuKarte, 30, 140, SrcCopy);
      DeleteObject(NeuKarte);
      IF Zeiger > 51 THEN GibKart(Rand, 30, 20, SrcCopy);
    END;
  END;

  PROCEDURE tFenster.WMRButtonUp(VAR Ereignis : tMessage);
  VAR
    Spruch : pChar;
    i, j   : INTEGER;
  BEGIN
    IF NOT fLinks AND NOT fRechts THEN BEGIN
      IF ((Ereignis.lParamLo > 112) AND
          (Ereignis.lParamLo < 408)) THEN
        Wahl2.j := (Ereignis.lParamLo - 112) DIV 70
      ELSE Exit;
      IF ((Ereignis.lParamHi >  16) AND
          (Ereignis.lParamHi < 334)) THEN
        Wahl2.i := (Ereignis.lParamHi - 16) DIV 80
      ELSE Exit;
      IF Tisch[Wahl2.i, Wahl2.j] <> 0 THEN BEGIN
        MessageBox(hWindow, 'Stelle ist noch nicht leer !',
                            'Unerlaubter Zug !!!', mb_OK);
        InvalidateRect(hWindow, NIL, TRUE);
        Exit;
      END;
      EnableMenuItem(Attr.Menu, cm_OZug_Zurueck,
                     mf_Enabled);
      Tisch[Wahl2.i, Wahl2.j] := Prison;
      NeuKarte := LoadBitmap(hLib, MakeIntResource(Prison));
      GibKart(NeuKarte, 120 + Wahl2.j*70, 20 + Wahl2.i*80,
              SrcCopy);
      DeleteObject(NeuKarte);
      Prison := 0;
      Inc(Zeiger);
      Inc(Anzahl);
      GibKart(Rand, 30, 140, SrcCopy);
      fRechts := TRUE;
      IF fLeicht AND (Sonderrecht = 0) THEN fLinks := TRUE;
      IF NOT fVario AND
         ((Anzahl = 16) OR (Zeiger > 52)) THEN BEGIN
        IF (Anzahl = 16) THEN
          EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
        fRechts := FALSE;
        fLinks  := TRUE;
        IF VerlustTest1 THEN BEGIN
          Spruch := SpruchVerlust[Random(5)];
          MessageBox(hWindow, Spruch,
                     'Nicht aufgegangen', mb_OK);
          Prison := 0;
          FOR i := 1 TO 7 DO
            Ablage[i] := 0;
          FOR i := 0 TO 3 DO
            FOR j := 0 TO 3 DO
              Tisch[i, j] := 0;
          Zeiger := 55;
          EnableMenuItem(Attr.Menu, cm_OZug_Zurueck,
                         mf_Grayed);
          InvalidateRect(hWindow, NIL, TRUE);
          Exit;
        END;
      END;
      IF fVario AND
         ((Anzahl = 10) OR (Zeiger > 52)) THEN BEGIN
        IF (Anzahl = 10) THEN
          EnableMenuItem(Attr.Menu, cm_OZug_Zurueck,
                         mf_Grayed);
        fRechts := FALSE;
        fLinks  := TRUE;
        IF VerlustTest2 THEN BEGIN
          Spruch := SpruchVerlust[Random(5)];
          MessageBox(hWindow, Spruch,
                     'Nicht aufgegangen', mb_OK);
          Prison := 0;
          FOR i := 1 TO 7 DO
            Ablage[i] := 0;
          FOR i := 0 TO 2 DO
            FOR j := 0 TO 2 DO
              Tisch[i, j] := 0;
          Tisch[3, 3] := 0;
          Zeiger := 55;
          EnableMenuItem(Attr.Menu, cm_OZug_Zurueck,
                         mf_Grayed);
          InvalidateRect(hWindow, NIL, TRUE);
          Exit;
        END;
      END;
    END;
  END;

  PROCEDURE tFenster.Destroy;
  BEGIN
    WinHelp(hWindow, 'PAT.HLP', Help_Quit, 0);
    tWindow.Destroy;
  END;

  FUNCTION tFenster.CanClose : BOOLEAN;
  VAR
    Ende : INTEGER;
  BEGIN
    CanClose := TRUE;
    Ende := MessageBox(hWindow,
                       'Mssen wir uns schon trennen ?',
                       'Programmende',
                       mb_YesNo OR mb_IconQuestion);
    IF Ende = id_No THEN BEGIN
      CanClose := FALSE;
      InvalidateRect(hWindow, NIL, TRUE);
    END;
  END;

  DESTRUCTOR tFenster.Done;
  BEGIN
    DeleteObject(Leer);
    DeleteObject(Rand);
    DeleteObject(Hinten);
    DeleteObject(KlHinten);
    DeleteObject(Oben);
    DeleteObject(Striche);
    IF NeuKarte <> 0 THEN DeleteObject(NeuKarte);
    FreeLibrary(hLib);
    tWindow.Done;
  END;

  FUNCTION tFenster.VerlustTest1 : BOOLEAN;
  VAR
    i, j, k : INTEGER;
  BEGIN
    VerlustTest1 := TRUE;
    FOR i := 0 TO 3 DO
      FOR j := 0 TO 2 DO
        FOR k := j+1 TO 3 DO BEGIN
          IF (Tisch[i, j] <> 0) AND (Tisch[i, k] <> 0) AND
             (((Tisch[i, j] + Tisch[i, k]) MOD 13) = 1) THEN
            VerlustTest1 := FALSE;
          IF (Tisch[j, i] <> 0) AND (Tisch[k, i] <> 0) AND
             (((Tisch[j, i] + Tisch[k, i]) MOD 13) = 1) THEN
            VerlustTest1 := FALSE;
        END;
  END;

  FUNCTION tFenster.VerlustTest2 : BOOLEAN;
  VAR
    i, j, k : INTEGER;
  BEGIN
    VerlustTest2 := TRUE;
    FOR i := 0 TO 2 DO
      FOR j := 0 TO 1 DO
        FOR k := j+1 TO 2 DO BEGIN
          IF (Tisch[i, j] <> 0) AND (Tisch[i, k] <> 0) AND
             (((Tisch[i, j] + Tisch[i, k]) MOD 13) = 1) THEN
            VerlustTest2 := FALSE;
          IF (Tisch[j, i] <> 0) AND (Tisch[k, i] <> 0) AND
             (((Tisch[j, i] + Tisch[k, i]) MOD 13) = 1) THEN
            VerlustTest2 := FALSE;
        END;
    FOR i := 0 TO 2 DO
      FOR j := 0 TO 2 DO
        IF (Tisch[i, j] <> 0) AND (Tisch[3, 3] <> 0) AND
           (((Tisch[i, j] + Tisch[3, 3]) MOD 13) = 1) THEN
          VerlustTest2 := FALSE;
  END;

  { Methoden fr Spiel_Men }

  PROCEDURE tFenster.SpielNeu(VAR Ereignis : tMessage);
  VAR
    Voll : ARRAY [1..52] OF BOOLEAN;
    i    : INTEGER;
    Msg  : tMessage;
  BEGIN
    FOR i := 1 TO 52 DO
      Voll[i] := TRUE;
    FOR i := 1 TO 52 DO BEGIN
      REPEAT
        Talon[i] := Succ(Random(52));
      UNTIL Voll[Talon[i]];
      Voll[Talon[i]] := FALSE;
    END;
    EnableMenuItem(Attr.Menu, cm_OSpiel_Wieder, mf_Enabled);
    OptionenSpielWiederholen(Msg);
  END;

  PROCEDURE tFenster.SpielBeenden(VAR Ereignis : tMessage);
  BEGIN
    SendMessage(hWindow, wm_close, 0, 0);
  END;

  { Methoden fr Optionen_Men }

  PROCEDURE tFenster.OptionenZugZurueck
            (VAR Ereignis : tMessage);
  BEGIN
    Prison := Tisch[Wahl2.i, Wahl2.j];
    Tisch[Wahl2.i, Wahl2.j] := 0;
    EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
    fLinks  := FALSE;
    fRechts := FALSE;
    Dec(Anzahl);
    IF (Zeiger < 53) THEN Dec(Zeiger);
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  PROCEDURE tFenster.OptionenSpielWiederholen
            (VAR Ereignis : tMessage);
  VAR
    i, j   : INTEGER;
    Spruch : pChar;
  BEGIN
    Prison := 0;
    EnableMenuItem(Attr.Menu, cm_OZug_Zurueck, mf_Grayed);
    Sonderrecht := 10;
    FOR i := 1 TO 7 DO
      Ablage[i] := 0;
    IF NOT fVario THEN BEGIN
      FOR i := 0 TO 15 DO
        Tisch[i DIV 4, i MOD 4] := Talon[i+1];
      Zeiger := 17;
    END ELSE BEGIN
      FOR i := 0 TO 8 DO
        Tisch[i DIV 3, i MOD 3] := Talon[i+1];
      Tisch[3,3] := Talon[10];
      FOR i := 0 TO 2 DO BEGIN
        Tisch[i, 3] := 100;
        Tisch[3, i] := 100;
        Zeiger      :=  11;
      END;
    END;
    IF NOT fVario AND VerlustTest1 THEN BEGIN
      Spruch := SpruchVerlust[5];
      MessageBox(hWindow, Spruch,
                 'Nicht aufgegangen', mb_OK);
      Prison := 0;
      FOR i := 1 TO 7 DO
        Ablage[i] := 0;
      FOR i := 0 TO 3 DO
        FOR j := 0 TO 3 DO
          Tisch[i, j] := 0;
      Zeiger := 55;
      InvalidateRect(hWindow, NIL, TRUE);
      Exit;
    END;
    IF fVario AND VerlustTest2 THEN BEGIN
      Spruch := SpruchVerlust[5];
      MessageBox(hWindow, Spruch,
                 'Nicht aufgegangen', mb_OK);
      Prison := 0;
      FOR i := 1 TO 7 DO
        Ablage[i] := 0;
      FOR i := 0 TO 2 DO
        FOR j := 0 TO 2 DO
          Tisch[i, j] := 0;
      Tisch[3, 3] := 0;
      Zeiger := 55;
      InvalidateRect(hWindow, NIL, TRUE);
      Exit;
    END;
    fLinks  := TRUE;
    fRechts := FALSE;
    Wahl1.Gesetzt := FALSE;
    Wahl2.Gesetzt := FALSE;
    IF fVario THEN Anzahl := 10
              ELSE Anzahl := 16;
    InvalidateRect(hWindow, NIL, TRUE);
  END;

  { Methoden fr Varianten_Men }

  PROCEDURE tFenster.SSchwierig(VAR Ereignis : tMessage);
  BEGIN
    fVario  := TRUE;
    fLeicht := FALSE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SMittel, 'Mittel');
    ModifyMenu(Attr.Menu, cm_SLeicht,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht, 'Leicht');
  END;

  PROCEDURE tFenster.SMittel(VAR Ereignis : tMessage);
  BEGIN
    fVario  := FALSE;
    fLeicht := FALSE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SMittel, 'Mittel');
    ModifyMenu(Attr.Menu, cm_SLeicht,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SLeicht, 'Leicht');

  END;

  PROCEDURE tFenster.SLeicht(VAR Ereignis : tMessage);
  BEGIN
    fVario  := FALSE;
    fLeicht := TRUE;
    ModifyMenu(Attr.Menu, cm_SSchwierig,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SSchwierig, 'Schwierig');
    ModifyMenu(Attr.Menu, cm_SMittel,
               mf_ByCommand OR mf_String OR mf_UnChecked,
               cm_SMittel, 'Mittel');
    ModifyMenu(Attr.Menu, cm_SLeicht,
               mf_ByCommand OR mf_String OR mf_Checked,
               cm_SLeicht, 'Leicht');

  END;

  { Methoden fr Hilfe_Men }

  PROCEDURE tFenster.HilfeHolen(VAR Ereignis : tMessage);
  BEGIN
    WinHelp(hWindow, 'PAT.HLP', Help_Index, 0);
  END;

  PROCEDURE tFenster.InfoZeigen(VAR Ereignis : tMessage);
  BEGIN
    MessageBox(hWindow,
               '(c) 1993 Eberhard Krause & DMV-Verlag' +
               #13#10 +
               'Turbo Pascal fr Windows 1.5',
               'Information', mb_OK OR mb_IconExclamation);
  END;

  PROCEDURE tFenster.GibKart(SetKarte : hBitmap;
                             x, y     : INTEGER;
                             Modus    : LongInt);
  VAR
    MemDC, hSchreibDC : hDC;
    MemObject         : tHandle;
  BEGIN
    hSchreibDC := GetDC(hWindow);
    MemDC := CreateCompatibleDC(hSchreibDC);
    MemObject := SelectObject(MemDC, SetKarte);
    BitBlt(hSchreibDC, x, y, 54, 72, MemDC, 0, 0, Modus);
    SelectObject(MemDC, MemObject);
    DeleteDC(MemDC);
    ReleaseDC(hWindow, hSchreibDC);
  END;

(* ====================================================== *)
(* Vereinbarung des Applikations-Objekts.                 *)
(* ====================================================== *)

VAR
  Appl : tAnwendung;

BEGIN
  Appl.Init('Patience');
  Appl.Run;
  Appl.Done;
END.
(* ====================================================== *)
(*                   Ende von PAT.PAS                     *)

