/* ====================================================== */
/*                       MESSAGE.CXX                     */
/*              (C) 1993 Jrg Braun & DMV-Verlag          */
/*         Implementation der Funktion DosMessage         */
/* ====================================================== */
/* Um in den Genu der C++-Bibliotheken zu gelangen, mu  */
/* die Datei in MESSAGE.CPP umbenannt werden.             */
/* ====================================================== */
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#define NOERROR    0      /* Ausfhrung war fehlerfrei    */
#define WRONGDOS   0xFFF0 /* Es wird DOS ab 3.x bentigt  */
#define PARAMERROR 0xFFF1 /* Kommandozeilen-Fehler        */
#define NOTFOUND   0xFFF2 /* Quelldatei nicht vorhanden   */
#define SAMENAMES  0xFFF3 /* Quelle = Ziel                */

unsigned int DosMessage(unsigned int num,
                        char *Source,
                        char *Target)
/* Smtliche Ausgaben des Programms laufen ber diese     */
/* Prozedur.                                              */
{
  char MsgStr[255];
  char s[5];
  int   i, length;

  length = strlen(Source);
  if (length > 0)
    for (i = 0; i < length; i++)
      if ((Source[i] >= 'A') & (Source[i] <= 'Z'))
        Source[i] += 32;

  length = strlen(Target);
  if (length > 0)
    for (i = 0; i < length; i++)
      if ((Target[i] >= 'A') & (Target[i] <= 'Z'))
        Target[i] += 32;

  strcpy(MsgStr, "Fehler: ");

  switch(num)
  {
  case NOERROR:
    strcpy(MsgStr, "Eintrag ");
    strcat(MsgStr, Source);
    strcat(MsgStr, " nach ");
    strcat(MsgStr, Target);
    strcat(MsgStr, " umbenannt.");
    break;
/* Liste der erweiterten DOS-Fehler-Nummern:              */
  case 2:
    strcat(MsgStr, "Datei nicht gefunden");
    break;
  case 3:
    strcat(MsgStr, "Verzeichnis nicht gefunden");
    break;
  case 5:
    strcat(MsgStr, "Zugriff verweigert");
    break;
  case 6:
    strcat(MsgStr, "Ungltiger Handle");
    break;
  case 8:
    strcat(MsgStr, "Zu wenig freier Speicher");
    break;
  case 15:
    strcat(MsgStr, "Ungltiges Laufwerk");
    break;
  case 16:
    strcat(MsgStr, "Versuch, das aktive Verzeichnis zu ");
    strcat(MsgStr, "lschen");
    break;
  case 18:
    strcat(MsgStr, "Keine weiteren Dateien");
    break;
  case 19:
    strcat(MsgStr, "Diskette ist schreibgeschtzt");
    break;
  case 20:
    strcat(MsgStr, "Falsche Disketteneinheit");
    break;
  case 21:
    strcat(MsgStr, "Laufwerk nicht bereit");
    break;
  case 23:
    strcat(MsgStr, "CRC-Fehler");
    break;
  case 25:
    strcat(MsgStr, "Suchfehler");
    break;
  case 27:
    strcat(MsgStr, "Sektor nicht gefunden");
    break;
  case 31:
    strcat(MsgStr, "Allgemeiner Fehler");
    break;
/* Benutzerdefinierte Fehler:                             */
  case WRONGDOS :
    strcpy(MsgStr, "Falsche DOS-Version\n");
    strcat(MsgStr, "XREN bentigt DOS 3.x oder hher");
  case PARAMERROR :
    strcpy(MsgStr, "\nXREN Version 1.0\n");
    strcat(MsgStr, "Aufruf: XREN Quelle Ziel\n\n");
    strcat(MsgStr, "XREN benennt Verzeichnisse und");
    strcat(MsgStr, " Dateien um und verschiebt\n");
    strcat(MsgStr, "sie bei Angabe zweier Pfade.\n");
    strcat(MsgStr, "Die Wildcards * und  ? ");
    strcat(MsgStr, "drfen nicht angegeben werden.\n");
    strcat(MsgStr, "Verschieben ber verschiedene ");
    strcat(MsgStr, "Laufwerke ist nicht mglich");
    break;
  case SAMENAMES :
    strcat(MsgStr, "Gleicher Quell- und Zielnamen: ");
    strcat(MsgStr, Source);
    strcat(MsgStr, " = ");
    strcat(MsgStr, Target);
    strcat(MsgStr, "");
    break;
  case NOTFOUND :
    strcat(MsgStr, "Dateieintrag ");
    strcat(MsgStr, Source);
    strcat(MsgStr, " nicht gefunden");
    break;
  default:
    strcat(MsgStr, "Unerwarteter Fehler (");     /* Huch? */
    itoa(num, s, 4);
    strcat(MsgStr, s);
    strcat(MsgStr, ")");
  }
  if (num != NOERROR) strcat(MsgStr, "!");
  strcat(MsgStr, "\n");
  printf(MsgStr);     /* <-- nur hier erfolgt die Ausgabe */
  return num;
};

/* ====================================================== */
/*                     Ende von MESSAGE.CXX               */
