/* ====================================================== */
/*                        XRENAME.CXX                     */
/*              (C) 1993 Jrg Braun & DMV-Verlag          */
/*          Implementation der Funktion XRename           */
/* ====================================================== */
/* um in den Genu der C++-Biblithek zu gelangen, mu die */
/* Datei in XRENAME.CPP umbenannt werden                  */
/*========================================================*/

#include <dos.h>

#ifndef cplusplus
#define NOERROR    0      /* Ausfhrung war fehlerfrei    */
#endif

unsigned int XRename(char *Source, char *Target)
#ifdef cplusplus
{
  REGPACK Regs;

  Regs.r_ds = FP_SEG(Source);
  Regs.r_dx = FP_OFF(Source);     // DS:DX := Quelldateiname
  Regs.r_es = FP_SEG(Target);
  Regs.r_di = FP_OFF(Target);     // ES:DI := Zieldateiname
  Regs.r_ax = 0x5600;             // AH    := 56h
  intr(0x21, &Regs);
  if (Regs.r_flags & 1) return Regs.r_ax;
  return NOERROR;
}
#else
{
  union  REGS  Regs;
  struct SREGS sRegs;

  sRegs.ds  = FP_SEG(Source);
  Regs.x.dx = FP_OFF(Source);  /* DS:DX := Quelldateiname */
  sRegs.es  = FP_SEG(Target);
  Regs.x.di = FP_OFF(Target);  /* ES:DI := Zieldateiname  */
  Regs.x.ax = 0x5600;          /* AH    := 56h            */
  int86x(0x21, &Regs, &Regs, &sRegs);
  if (Regs.x.flags & 1) return Regs.x.ax;
  return NOERROR;
}
#endif

/* ====================================================== */
/*                  Ende von XRENAME.CXX                  */
