'* ======================================================= *
'*                          XREN.BAS                       *
'*              (C) 1993 Jrg Braun & DMV-Verlag           *
'*    Umbenennen und Verschieben von Verzeichnissen und    *
'*     Dateien auf einem Laufwerk via DOS-Funktion 56h     *
'* ------------------------------------------------------- *
'*                Compiler: Power-Basic 2.0                *
'* ======================================================= *
'* ------------------------------------------------------- *
'*     Power-Basic-Compilerdirektiven: (minimaler Code)    *
$COMPILE          EXE              '* Exe-Datei		   *
$STACK            &H600	           '* minimaler Stack      *
$DEBUG   MAP      -		   '* keine MAP-Datei      *
$LIB     ALL      -	           '* alle LIBS aus        *
$LIB     IPRINT   +                '* IPRINT mu an sein!  *
$OPTION  AUTODIM  -                '* DIM manuell          *
$COM              0                '* kein COM-Puffer      *
$ERROR   ALL      -	           '* Fehlercheck aus      *
$SOUND            0                '* Soundpuffer aus      *
$EVENT            -                '* keine Events         *
$FLOAT            EMULATE          '* Floating-Point	   *
$CPU	          8086	           '* alle CPUS		   *
$DYNAMIC                           '* dynamische Variablen *

'* ------------------------------------------------------- *
'*                     Registerkonstanten:                 *
%Flags = 0
%AX    = 1
%BX    = 2
%CX    = 3
%DX    = 4
%SI    = 5
%DI    = 6
%BP    = 7
%DS    = 8
%ES    = 9

'* ------------------------------------------------------- *
'*                      Fehlerkonstanten:                  *
%NOERROR    = 0            '* Ausfhrung war fehlerfrei    *
%WRONGDOS   = &HFFF0       '* Es wird DOS ab 3.x bentigt  *
%PARAMERROR = &HFFF1       '* Kommandozeilen-Fehler        *
%NOTFOUND   = &HFFF2       '* Quelldatei nicht vorhanden   *
%SAMENAMES  = &HFFF3       '* Quelle = Ziel                *

SHARED DosError%
'* ------------------------------------------------------- *

SUB DosMessage(ErrNum%, Source$, Target$)
'* Smtliche Ausgaben des Programms laufen ber diese      *
'* Prozedur.                                               *
LOCAL MsgStr$
  MsgStr$ = "Fehler: "
  SELECT CASE ErrNum%
  CASE %NOERROR
  '* Ausfhrung fehlerfrei: Erfolgsmeldung
    MsgStr$ = "Eintrag " + Source$ + " nach " _
            + Target$ + " umbenannt."
  '* Liste der erweiterten DOS-Fehler-Nummern:
  CASE 1:  MsgStr$ = MsgStr$ + "Unerlaubte Funktion"
  CASE 2:  MsgStr$ = MsgStr$ + "Datei nicht gefunden"
  CASE 3:  MsgStr$ = MsgStr$ + "Verzeichnis nicht gefunden"
  CASE 5:  MsgStr$ = MsgStr$ + "Zugriff verweigert"
  CASE 6:  MsgStr$ = MsgStr$ + "Ungltiger Handle"
  CASE 8:  MsgStr$ = MsgStr$ + "Zu wenig freier Speicher"
  CASE 15: MsgStr$ = MsgStr$ + "Ungltiges Laufwerk"
  CASE 16: MsgStr$ = MsgStr$ + "Versuch, das aktive " _
                             + " Verzeichnis zu lschen"
  CASE 18: MsgStr$ = MsgStr$ + "Keine weiteren Dateien"
  CASE 19:
         MsgStr$ = MsgStr$ + "Diskette ist schreibgeschtzt"
  CASE 20: MsgStr$ = MsgStr$ + "Falsche Disketteneinheit"
  CASE 21: MsgStr$ = MsgStr$ + "Laufwerk nicht bereit"
  CASE 23: MsgStr$ = MsgStr$ + "CRC-Fehler"
  CASE 25: MsgStr$ = MsgStr$ + "Suchfehler"
  CASE 27: MsgStr$ = MsgStr$ + "Sektor nicht gefunden"
  CASE 31: MsgStr$ = MsgStr$ + "Allgemeiner Fehler"
  '* Benutzerdefinierte Fehler: *
  CASE %WRONGDOS
    MsgStr$ = MsgStr$ + "Falsche DOS-Version" + CHR$(13)   _
            + "XREN bentigt DOS 3.x oder hher"
  CASE %PARAMERROR
    MsgStr$ = CHR$(13) + "XREN Version 1.0" + CHR$(13)     _
            + "Aufruf: XREN Quelle Ziel" + CHR$(13)        _
            + CHR$(13) + "XREN benennt Verzeichnisse und"  _
            + " Dateien um und verschiebt" + CHR$(13)      _
            + "sie bei Angabe zweier Pfade." + CHR$(13)    _
            + "Die Wildcards * und  ? "                _
            + "drfen nicht angegeben werden." + CHR$(13)  _
            + "Verschieben ber verschiedene "             _
            + "Laufwerke ist nicht mglich"
  CASE %SAMENAMES
    MsgStr$ = MsgStr$ + "Gleicher Quell- und Zielnamen: " _
            + Source$ + " = " + Target$ + ""
  CASE %NOTFOUND
    MsgStr$ = MsgStr$ + "Dateieintrag " + Source$         _
            + " nicht gefunden"
  CASE ELSE
    MsgStr$ = MsgStr$ + "Unerwarteter Fehler (Nummer "     _
            + STR$(ErrNum%) + ")"
  END SELECT
  IF ErrNum% <> %NOERROR THEN MsgStr$ = MsgStr$ + "!"
  PRINT MsgStr$        '* <-- nur hier erfolgt die Ausgabe *
END SUB

FUNCTION DosVersion%
'* liefert die DOS-Hauptversionsnummer zurck              *
  REG %AX, &H3000
  CALL INTERRUPT &H21
  DosVersion% = REG(%AX) AND &HFF
END FUNCTION

SUB ParsCmdLine(ParamStr1$, ParamStr2$, ParamCount%)
'* Splitten der Kommandozeile in den ersten und zweiten    *
'* Parameter                                               *
  ParamStr1$ = ""
  ParamStr2$ = ""
  IF COMMAND$   = "" THEN
    ParamCount% = 0
  ELSE
    IF INSTR(COMMAND$, " ") > 0 THEN
      ParamStr1$ = LEFT$(COMMAND$, INSTR(COMMAND$, " ") - 1)
      ParamStr1$ = RTRIM$(ParamStr1$)
      ParamStr2$ = MID$(COMMAND$, _
                       INSTR(COMMAND$, " ") + 1, _
                       LEN(COMMAND$) - INSTR(COMMAND$, " "))
      ParamStr2$ = LTRIM$(ParamStr2$)
      ParamCount% = 2
    ELSE
      ParamStr1$ = COMMAND$
      ParamStr1$ = RTRIM$(ParamStr1$)
      ParamCount% = 1
    END IF
  END IF
END SUB

FUNCTION XRename% (Source$, Target$)
'* Umbennen einer Quelldatei Source$ nach Target$ per  *
'* DOS-Aufruf (Rename_by_Name)                             *
LOCAL t$, s$
  s$ = Source$ + CHR$(0)
  t$ = Target$ + CHR$(0)
  REG %DS, STRSEG(s$)
  REG %DX, STRPTR(s$)           '* DS:DX  = Quelldateiname *
  REG %ES, STRSEG(t$)
  REG %DI, STRPTR(t$)           '* ES:DI  = Zieldateiname  *
  REG %AX, &H5600               '* AH     = 56h            *
  CALL INTERRUPT &H21
  IF (REG(%Flags) AND 1) = 1 THEN
      IF REG(%AX) = 3 THEN
	XRename% = 5  '* Path not found --> Access denied *
      ELSE
	XRename% = REG(%AX) AND &HFF
      END IF
  ELSE
    XRename% = %NOERROR
  END IF
END FUNCTION

'* ------------------------------------------------------- *

SUB FindFirst (Pattern$, Attr%, DTA$)
LOCAL Path$, DTASeg%, DTAOfs%
  Path$   = Pattern$ + CHR$(0)
  REG %AX, &H2F00
  CALL INTERRUPT &H21
  DTASeg% = REG(%ES)
  DTAOfs% = REG(%BX)
  DTA$    = SPACE$(43)
  REG %AX, &H1A00
  REG %DS, STRSEG(DTA$)
  REG %DX, STRPTR(DTA$)
  CALL INTERRUPT &H21
  REG %AX, &H4E00
  REG %CX, Attr%
  REG %DS, STRSEG(Path$)
  REG %DX, STRPTR(Path$)
  CALL INTERRUPT &H21
  IF (REG(%Flags) AND 1) THEN
    DosError% = REG(%AX)
  ELSE
    DosError% = %NOERROR
  END IF
  REG %AX, &H1A00
  REG %DS, DTASeg%
  REG %DX, DTAOfs%
  CALL INTERRUPT &H21
END SUB

'* ======================================================= *

IF DosVersion% < 3 THEN
  CALL DosMessage(%WRONGDOS, "", "")
ELSE
  CALL ParsCmdLine(Source$, Target$, ParamCount%)
  IF ParamCount% < 2 THEN
    CALL DosMessage(%PARAMERROR, "", "")
  ELSE
    IF INSTR(Source$, "?") OR INSTR(Target$, "?") OR       _
       INSTR(Source$, "H") OR INSTR(Target$, "/H") OR      _
       INSTR(Source$, "*") OR INSTR(Target$, "*") THEN
      CALL DosMessage(%PARAMERROR, "", "")
    ELSE
      IF Source$ = Target$ THEN
        CALL DosMessage(%SAMENAMES, LCASE$(Source$),       _
                        LCASE$(Target$))
      ELSE
	CALL FindFirst(Source$, &H37, DTA$)
	IF DosError% = %NOERROR THEN
	  CALL DosMessage(XRename%(Source$, Target$),      _
			  LCASE$(Source$), LCASE$(Target$))
	ELSE
	  CALL DosMessage(%NOTFOUND, Source$, "")
	END IF
      END IF
    END IF
  END IF
END IF
SYSTEM

'* ======================================================= *
'*                     Ende von XREN.BAS                   *

