'* ======================================================= *
'*                          XREN.BAS                       *
'*              (C) 1993 Jrg Braun & DMV-Verlag           *
'*    Umbenennen und Verschieben von Verzeichnissen und    *
'*     Dateien auf einem Laufwerk via DOS-Funktion 56h     *
'* ------------------------------------------------------- *
'* Compiler: Quick-Basic 4.5 - QB.QLB mu eingelinkt sein  *
'* ======================================================= *

'$INCLUDE: 'QB.BI'

DECLARE SUB DosMessage (ErrNum%, Source$, Target$)
DECLARE FUNCTION DosVersion% ()
DECLARE SUB FindFirst (Pattern AS STRING, Attr AS INTEGER, _
		       DTA AS STRING)
DECLARE SUB ParsCmdLine (ParamStr1$, ParamStr2$, Count%)
DECLARE FUNCTION XRename% (Source$, ParamStr2$)

CONST NOERROR = 0             '* Ausfhrung war fehlerfrei
CONST WRONGDOS = &HFFF0       '* ES wird DOS ab 3.x bentigt
CONST PARAMERROR = &HFFF1     '* Kommandozeilen-Fehler
CONST NOTFOUND = &HFFF2       '* Quelldatei nicht vorhanden
CONST SAMENAMES = &HFFF3      '* Quelle = Ziel

ErrNum% = NOERROR
IF DosVersion% < 3 THEN
  DosMessage WRONGDOS, "", ""
ELSE
  ParsCmdLine Source$, Target$, Count%
  IF Count% < 2 THEN
    DosMessage PARAMERROR, "", ""
  ELSE
    IF INSTR(Source$, "?") OR INSTR(Target$, "?") OR _
       INSTR(Source$, "H") OR INSTR(Target$, "/H") OR _
       INSTR(Source$, "*") OR INSTR(Target$, "*") THEN
      DosMessage PARAMERROR, "", ""
    ELSE
      IF Source$ = Target$ THEN
	DosMessage SAMENAMES, LCASE$(Source$), _
		   LCASE$(Target$)
      ELSE
	FindFirst Source$, &H37, DTA$    '* &H37 = Files + *
	IF DosError% = NOERROR THEN      '* Directories    *
	  DosMessage XRename(Source$, Target$), _
		     LCASE$(Source$), LCASE$(Target$)
	ELSE
	  DosMessage NOTFOUND, LCASE$(Source$), ""
	END IF
      END IF
    END IF
  END IF
END IF
SYSTEM

'* ======================================================= *

SUB DosMessage (ErrNum%, Source$, Target$)
'* Smtliche Ausgaben des Programms laufen ber diese      *
'* Prozedur.                                               *
'* LOCAL MsgStr$, NumStr$                                  *
  MsgStr$ = "Fehler: "
  SELECT CASE ErrNum%
  CASE IS = NOERROR
  '* Ausfhrung fehlerfrei: Erfolgsmeldung
    MsgStr$ = "Eintrag " + Source$
    MsgStr$ = MsgStr$ + " nach " + Target$
    MsgStr$ = MsgStr$ + " umbenannt."
  '* Liste der erweiterten DOS-Fehler-Nummern:
  CASE IS = 1
    MsgStr$ = MsgStr$ + "Unerlaubte Funktion"
  CASE IS = 2
    MsgStr$ = MsgStr$ + "Datei nicht gefunden"
  CASE IS = 3
    MsgStr$ = MsgStr$ + "Verzeichnis nicht gefunden"
  CASE IS = 5
    MsgStr$ = MsgStr$ + "Zugriff verweigert"
  CASE IS = 6
    MsgStr$ = MsgStr$ + "Ungltiger Handle"
  CASE IS = 8
    MsgStr$ = MsgStr$ + "Zu wenig freier Speicher"
  CASE IS = 15
    MsgStr$ = MsgStr$ + "Ungltiges Laufwerk"
  CASE IS = 16
    MsgStr$ = MsgStr$ + "Versuch, das aktive Verzeichnis zu"
    MsgStr$ = MsgStr$ + " lschen"
  CASE IS = 18
    MsgStr$ = MsgStr$ + "Keine weiteren Dateien"
  CASE IS = 19
    MsgStr$ = MsgStr$ + "Diskette ist schreibgeschtzt"
  CASE IS = 20
    MsgStr$ = MsgStr$ + "Falsche Disketteneinheit"
  CASE IS = 21
    MsgStr$ = MsgStr$ + "Laufwerk nicht bereit"
  CASE IS = 23
    MsgStr$ = MsgStr$ + "CRC-Fehler"
  CASE IS = 25
    MsgStr$ = MsgStr$ + "Suchfehler"
  CASE IS = 27
    MsgStr$ = MsgStr$ + "Sektor nicht gefunden"
  CASE IS = 31
    MsgStr$ = MsgStr$ + "Allgemeiner Fehler"
  '* Benutzerdefinierte Fehler: *
  CASE IS = WRONGDOS
    MsgStr$ = MsgStr$ + "Falsche DOS-Version" + CHR$(13)
    MsgStr$ = MsgStr$ + "XREN bentigt DOS 3.x oder hher"
  CASE IS = PARAMERROR
    MsgStr$ = CHR$(13) + "XREN Version 1.0" + CHR$(13)
    MsgStr$ = MsgStr$ + "Aufruf: XREN Quelle Ziel"
    MsgStr$ = MsgStr$ + CHR$(13) + CHR$(13)
    MsgStr$ = MsgStr$ + "XREN benennt Verzeichnisse und"
    MsgStr$ = MsgStr$ + " Dateien um und verschiebt"
    MsgStr$ = MsgStr$ + CHR$(13)
    MsgStr$ = MsgStr$ + "sie bei Angabe zweier Pfade."
    MsgStr$ = MsgStr$ + CHR$(13)
    MsgStr$ = MsgStr$ + "Die Wildcards * und  ? "
    MsgStr$ = MsgStr$ + "drfen nicht angegeben werden."
    MsgStr$ = MsgStr$ + CHR$(13)
    MsgStr$ = MsgStr$ + "Verschieben ber verschiedene "
    MsgStr$ = MsgStr$ + "Laufwerke ist nicht mglich"
  CASE IS = SAMENAMES
    MsgStr$ = MsgStr$ + "Gleicher Quell- und Zielnamen: "
    MsgStr$ = MsgStr$ + Source$ + " = " + Target$ + ""
  CASE IS = NOTFOUND
    MsgStr$ = MsgStr$ + "Dateieintrag " + Source$
    MsgStr$ = MsgStr$ + " nicht gefunden"
  CASE ELSE
    NumStr$ = STR$(ErrNum%)
    MsgStr$ = MsgStr$ + "Unerwarteter Fehler (Nummer "
    MsgStr$ = MsgStr$ + NumStr$ + ")"
  END SELECT
  IF ErrNum% <> NOERROR THEN MsgStr$ = MsgStr$ + "!"
  PRINT MsgStr$        '* <-- nur hier erfolgt die Ausgabe *
END SUB

FUNCTION DosVersion%
'* Ermitteln der DOS-Hauptversionsnummer                   *
'* LOCAL Regs                                              *
DIM Regs AS RegType
  Regs.AX = &H3000
  INTERRUPT &H21, Regs, Regs
  DosVersion% = Regs.AX AND &HFF
END FUNCTION

SUB FindFirst (Pattern AS STRING, Attr AS INTEGER, _
	       DTA AS STRING)
'* aus toolbox 11'89                                       *
SHARED DosError%
'* LOCAL Path$, DTASeg%, DTAOfs%                           *
DIM Regs AS RegTypeX
  Path$ = Pattern + CHR$(0)
  Regs.AX = &H2F00
  INTERRUPTX &H21, Regs, Regs
  DTASeg% = Regs.ES
  DTAOfs% = Regs.BX
  DTA = SPACE$(43)
  Regs.AX = &H1A00
  Regs.DS = VARSEG(DTA)
  Regs.DX = SADD(DTA)
  INTERRUPTX &H21, Regs, Regs
  Regs.AX = &H4E00
  Regs.CX = Attr
  Regs.DS = VARSEG(Path$)
  Regs.DX = SADD(Path$)
  INTERRUPTX &H21, Regs, Regs
  IF (Regs.Flags AND 1) = 1 THEN
    DosError% = Regs.AX
  ELSE
    DosError% = NOERROR
  END IF
  Regs.AX = &H1A00
  Regs.DS = DTASeg%
  Regs.DX = DTAOfs%
  INTERRUPTX &H21, Regs, Regs
END SUB

SUB ParsCmdLine (ParamStr1$, ParamStr2$, Count%)
'* Splitten der Kommandzeile in ersten und zweiten         *
'* Parameter                                               *
  ParamStr1$ = ""
  ParamStr2$ = ""
  IF COMMAND$ = "" THEN
    Count% = 0
  ELSE
    IF INSTR(COMMAND$, " ") > 0 THEN
      ParamStr1$ = LEFT$(COMMAND$, INSTR(COMMAND$, " ") - 1)
      ParamStr1$ = RTRIM$(ParamStr1$)
      ParamStr2$ = MID$(COMMAND$, INSTR(COMMAND$, " ") + _
		   1, LEN(COMMAND$) - INSTR(COMMAND$, " "))
      ParamStr2$ = LTRIM$(ParamStr2$)
      Count% = 2
    ELSE
      ParamStr1$ = COMMAND$
      ParamStr1$ = RTRIM$(ParamStr1$)
      Count% = 1
    END IF
  END IF
END SUB

FUNCTION XRename% (Source$, Target$)
'* Umbennen der Datei oder des Verzeichnis Source nach   *
'* Target (Rename_by_Name)                               *
'* LOCAL Regs, t$, s$                                      *
DIM Regs AS RegTypeX
  s$ = Source$
  s$ = s$ + CHR$(0)             '* Nullbyte anhngen       *
  t$ = Target$
  t$ = t$ + CHR$(0)             '* Nullbyte anhngen       *
  Regs.DS = VARSEG(s$)
  Regs.DX = SADD(s$)            '* DS:DX  = Quelldateiname *
  Regs.ES = VARSEG(t$)
  Regs.DI = SADD(t$)            '* ES:DI  = Zieldateiname  *
  Regs.AX = &H5600              '* AH     = 56h            *
  INTERRUPTX &H21, Regs, Regs
  IF Regs.Flags AND 1 THEN
    Regs.AX = Regs.AX AND &HFF
    IF Regs.AX = 3 THEN Regs.AX = 5
		       '* Path not found --> Access denied *
    XRename% = Regs.AX
  ELSE
    XRename% = NOERROR
  END IF
END FUNCTION

