(* ====================================================== *)
(*                          XREN.PAS                      *)
(*                        Version 1.01                    *)
(*              (C) 1993 Jrg Braun & DMV-Verlag          *)
(*    Umbenennen und Verschieben von Verzeichnissen und   *)
(*     Dateien auf einem Laufwerk via DOS-Funktion 56h    *)
(*  Es wird nicht die Unit DOS sondern WinDOS verwendet!  *)
(* ------------------------------------------------------ *)
(*  Compiler: Turbo/Borland Pascal 7.0, Real-Mode-Target  *)
(* ====================================================== *)
{$IFDEF DEBUG} {$UNDEF DEBUG} {$ENDIF}
{$IFNDEF Ver70}  ERROR: Erst ab Turbo Pascal 7.0!   {$ENDIF}
{$IFDEF Windows} ERROR: Falsches Zielsystem!        {$ENDIF}
{$IFDEF DPMI}    ERROR: Falsches Speichermodell!    {$ENDIF}

{.$DEFINE DEBUG}

{$A+,B-,E-,F+,I-,O-,P+,T-,V-,X+,M $FFF1,0,$1000}
{$IFDEF CPU286}  {$G+}  {$ELSE}  {$G-}  {$ENDIF}
{$IFDEF DEBUG}
  {$D+,L+,Y+,S+,R+,Q+}
{$ELSE}
  {$D-,S-,R-,Q-}
{$ENDIF}

PROGRAM XRenW;

USES WinDos, Strings;

CONST
  NOERROR     = 0;        (* Ausfhrung war fehlerfrei    *)
  WRONGDOS    = $FFF0;    (* Es wird DOS ab 3.x bentigt  *)
  PARAMERROR  = $FFF1;    (* Kommandozeilen-Fehler        *)
  NOTFOUND    = $FFF2;    (* Quelldatei nicht vorhanden   *)
  SAMENAMES   = $FFF3;    (* Quelle = Ziel                *)

FUNCTION DosMessage(CONST ErrNum        : WORD;
                    CONST Source, Target: pChar): WORD;
(* Smtliche Ausgaben des Programms laufen ber diese     *)
(* Prozedur.                                              *)
VAR
  MsgStr : pChar;
  NumStr: STRING[6];
  NumP  : pChar;
BEGIN
  GetMem(MsgStr, $100);
  StrCopy(MsgStr, 'Fehler: ');
  CASE ErrNum OF
    NOERROR:
       BEGIN     (* Ausfhrung fehlerfrei: Erfolgsmeldung *)
         StrCopy(MsgStr, 'Eintrag ');
         StrCat(MsgStr, Source);
         StrCat(MsgStr, ' nach ');
         StrCat(MsgStr, Target);
         StrCat(MsgStr, ' umbenannt.');
       END;
              (* Liste der erweiterten DOS-Fehler-Nummern *)
    1: StrCat(MsgStr, 'Unerlaubte Funktion');
    2: StrCat(MsgStr, 'Datei nicht gefunden');
    3: StrCat(MsgStr, 'Verzeichnis nicht gefunden');
    5: StrCat(MsgStr, 'Zugriff verweigert');
    6: StrCat(MsgStr, 'Ungltiger Handle');
    8: StrCat(MsgStr, 'Zu wenig freier Speicher');
   15: StrCat(MsgStr, 'Ungltiges Laufwerk');
   16: StrCat(MsgStr, 'Versuch, das aktive Verzeichnis zu' +
                      ' lschen');
   18: StrCat(MsgStr, 'Keine weiteren Dateien');
   19: StrCat(MsgStr, 'Diskette ist schreibgeschtzt');
   20: StrCat(MsgStr, 'Falsche Disketteneinheit');
   21: StrCat(MsgStr, 'Laufwerk nicht bereit');
   23: StrCat(MsgStr, 'CRC-Fehler');
   25: StrCat(MsgStr, 'Suchfehler');
   27: StrCat(MsgStr, 'Sektor nicht gefunden');
   31: StrCat(MsgStr, 'Allgemeiner Fehler');
                            (* Benutzerdefinierte Fehler: *)
    WRONGDOS:
       BEGIN
         StrCopy(MsgStr, 'Falsche DOS-Version'^M^J);
         StrCat(MsgStr, 'XREN bentigt DOS 3.x oder hher');
       END;
    PARAMERROR:
       BEGIN
         StrCopy(MsgStr, ^M^J'XREN Version 1.0'^M^J);
         StrCat(MsgStr, 'Aufruf: XREN Quelle Ziel'^M^J);
         StrCat(MsgStr, ^J'XREN benennt Verzeichnisse und');
         StrCat(MsgStr, ' Dateien um und verschiebt');
         StrCat(MsgStr, ^M^J'sie bei Angabe zweier Pfade.');
         StrCat(MsgStr, ^M^J'Die Wildcards * und  ? ');
         StrCat(MsgStr, 'drfen nicht angegeben werden.'^M);
         StrCat(MsgStr, ^J'Verschieben ber verschiedene ');
         StrCat(MsgStr, 'Laufwerke ist nicht mglich');
       END;
    SAMENAMES:
       BEGIN
         StrCat(MsgStr, 'Gleicher Quell- und Zielnamen: ');
         StrCat(MsgStr, Source);
         StrCat(MsgStr, ' = ');
         StrCat(MsgStr, Target);
         StrCat(MsgStr, '');
       END;
    NOTFOUND:
       BEGIN
         StrCat(MsgStr, 'Dateieintrag ');
         StrCat(MsgStr, Source);
         StrCat(MsgStr, ' nicht gefunden');
       END;
  ELSE
    StrCat(MsgStr, 'Unerwarteter Fehler (Nummer ');(*Huch?*)
    GetMem(NumP, 6);
    Str(ErrNum, NumStr);
    StrPCopy(NumP, NumStr);
    StrCat(MsgStr, NumP);
    StrCat(MsgStr, ')');
    FreeMem(NumP, 6);
  END;
  IF ErrNum <> NOERROR THEN StrCat(MsgStr, '!');
  WriteLn(MsgStr);    (* <-- nur hier erfolgt die Ausgabe *)
  FreeMem(MsgStr, $100);
  DosMessage := ErrNum;
END;

FUNCTION XRename(CONST Source, Target: pChar): WORD;
(* Umbenennen eines nicht mit Wildcards (* und ?)     *)
(* versehenen Dateieintrags (Datei und Verzeichnis)       *)
VAR
 Regs: tRegisters;
BEGIN
  XRename := NOERROR;
  WITH Regs DO BEGIN         (* DOS-Funktion 56h: Rename  *)
    DS    := Seg(Source^);
    DX    := Ofs(Source^);   (* DS:DX  := Quelldateiname  *)
    ES    := Seg(Target^);
    DI    := Ofs(Target^);   (* ES:DI  := Zieldateiname   *)
    AH    := $56;            (* AH     := 56h             *)
    MsDos(Regs);
    IF Odd(Flags) THEN BEGIN
       IF AX = 3 THEN AX := 5;
                      (* Path not found --> Access denied *)
       XRename := AX;
    END;
  END;        (* Fehler := AX falls CarryFlag gesetzt ist *)
END;

VAR
  SearchRec      : tSearchRec;
  Source, Target : pChar;
  ErrNum         : WORD;
BEGIN
  ErrNum := NOERROR;
  GetMem(Source, Succ(fsPathName));
  GetMem(Target, Succ(fsPathName));
  IF Lo(DOSVersion) < 3 THEN BEGIN
    ErrNum := DosMessage(WRONGDOS, '','');
  END ELSE BEGIN
    IF ParamCount < 2 THEN
      ErrNum := DosMessage(PARAMERROR, '','')
    ELSE BEGIN
      StrPCopy(Source, ParamStr(1));
      StrCopy(Source, StrUpper(Source));
      StrPCopy(Target, ParamStr(2));
      StrCopy(Target, StrUpper(Target));
      IF (StrPos(Source, '?' ) <> NIL) OR
         (StrPos(Target, '?' ) <> NIL) OR
         (StrPos(Source, '/H') <> NIL) OR
         (StrPos(Target, '/H') <> NIL) OR
         (StrPos(Source, '*' ) <> NIL) OR
         (StrPos( Target,'*' ) <> NIL) THEN
        ErrNum := DosMessage(PARAMERROR, '', '')
      ELSE BEGIN
        IF StrComp(Source, Target) = 0 THEN
          ErrNum := DosMessage(SAMENAMES, StrLower(Source),
                                          StrLower(Target))
        ELSE BEGIN
           FindFirst(Source, faAnyFile - faVolumeID,
                     SearchRec);
          IF DOSError = 0 THEN
            ErrNum := DosMessage(XRename(Source, Target),
                                 StrLower(Source),
                                 StrLower(Target))
          ELSE
            ErrNum := DosMessage(NOTFOUND,
                                 StrLower(Source), '');
        END;
      END;
      FreeMem(Source, Succ(fsPathName));
      FreeMem(Target, Succ(fsPathName));
    END;
  END;
  Halt(ErrNum);
END.

(*========================================================*)
(*                    Ende von XREN.PAS                   *)
